import { MultiCall } from '@indexed-finance/multicall';
import { ethers as ethers$1, BigNumber as BigNumber$1 } from 'ethers';
import axios$1 from 'axios';
import { Program, web3, utils as utils$1, BN } from '@project-serum/anchor';
import { PublicKey, Transaction, SYSVAR_RENT_PUBKEY, LAMPORTS_PER_SOL } from '@solana/web3.js';
import { Buffer as Buffer$1 } from 'buffer';
import { TokenListProvider } from '@solana/spl-token-registry';
import { TOKEN_PROGRAM_ID, getAssociatedTokenAddress, ASSOCIATED_TOKEN_PROGRAM_ID, getMint, AccountLayout } from '@solana/spl-token';
import { programs, ChainId as ChainId$1 } from '@metaplex/js';
import { Metaplex } from '@metaplex-foundation/js';
import { arrayify } from 'ethers/lib/utils';
import { MetadataProgram } from '@metaplex-foundation/mpl-token-metadata';

function _regeneratorRuntime() {
  _regeneratorRuntime = function () {
    return exports;
  };
  var exports = {},
    Op = Object.prototype,
    hasOwn = Op.hasOwnProperty,
    defineProperty = Object.defineProperty || function (obj, key, desc) {
      obj[key] = desc.value;
    },
    $Symbol = "function" == typeof Symbol ? Symbol : {},
    iteratorSymbol = $Symbol.iterator || "@@iterator",
    asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator",
    toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";
  function define(obj, key, value) {
    return Object.defineProperty(obj, key, {
      value: value,
      enumerable: !0,
      configurable: !0,
      writable: !0
    }), obj[key];
  }
  try {
    define({}, "");
  } catch (err) {
    define = function (obj, key, value) {
      return obj[key] = value;
    };
  }
  function wrap(innerFn, outerFn, self, tryLocsList) {
    var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator,
      generator = Object.create(protoGenerator.prototype),
      context = new Context(tryLocsList || []);
    return defineProperty(generator, "_invoke", {
      value: makeInvokeMethod(innerFn, self, context)
    }), generator;
  }
  function tryCatch(fn, obj, arg) {
    try {
      return {
        type: "normal",
        arg: fn.call(obj, arg)
      };
    } catch (err) {
      return {
        type: "throw",
        arg: err
      };
    }
  }
  exports.wrap = wrap;
  var ContinueSentinel = {};
  function Generator() {}
  function GeneratorFunction() {}
  function GeneratorFunctionPrototype() {}
  var IteratorPrototype = {};
  define(IteratorPrototype, iteratorSymbol, function () {
    return this;
  });
  var getProto = Object.getPrototypeOf,
    NativeIteratorPrototype = getProto && getProto(getProto(values([])));
  NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol) && (IteratorPrototype = NativeIteratorPrototype);
  var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype);
  function defineIteratorMethods(prototype) {
    ["next", "throw", "return"].forEach(function (method) {
      define(prototype, method, function (arg) {
        return this._invoke(method, arg);
      });
    });
  }
  function AsyncIterator(generator, PromiseImpl) {
    function invoke(method, arg, resolve, reject) {
      var record = tryCatch(generator[method], generator, arg);
      if ("throw" !== record.type) {
        var result = record.arg,
          value = result.value;
        return value && "object" == typeof value && hasOwn.call(value, "__await") ? PromiseImpl.resolve(value.__await).then(function (value) {
          invoke("next", value, resolve, reject);
        }, function (err) {
          invoke("throw", err, resolve, reject);
        }) : PromiseImpl.resolve(value).then(function (unwrapped) {
          result.value = unwrapped, resolve(result);
        }, function (error) {
          return invoke("throw", error, resolve, reject);
        });
      }
      reject(record.arg);
    }
    var previousPromise;
    defineProperty(this, "_invoke", {
      value: function (method, arg) {
        function callInvokeWithMethodAndArg() {
          return new PromiseImpl(function (resolve, reject) {
            invoke(method, arg, resolve, reject);
          });
        }
        return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
      }
    });
  }
  function makeInvokeMethod(innerFn, self, context) {
    var state = "suspendedStart";
    return function (method, arg) {
      if ("executing" === state) throw new Error("Generator is already running");
      if ("completed" === state) {
        if ("throw" === method) throw arg;
        return doneResult();
      }
      for (context.method = method, context.arg = arg;;) {
        var delegate = context.delegate;
        if (delegate) {
          var delegateResult = maybeInvokeDelegate(delegate, context);
          if (delegateResult) {
            if (delegateResult === ContinueSentinel) continue;
            return delegateResult;
          }
        }
        if ("next" === context.method) context.sent = context._sent = context.arg;else if ("throw" === context.method) {
          if ("suspendedStart" === state) throw state = "completed", context.arg;
          context.dispatchException(context.arg);
        } else "return" === context.method && context.abrupt("return", context.arg);
        state = "executing";
        var record = tryCatch(innerFn, self, context);
        if ("normal" === record.type) {
          if (state = context.done ? "completed" : "suspendedYield", record.arg === ContinueSentinel) continue;
          return {
            value: record.arg,
            done: context.done
          };
        }
        "throw" === record.type && (state = "completed", context.method = "throw", context.arg = record.arg);
      }
    };
  }
  function maybeInvokeDelegate(delegate, context) {
    var methodName = context.method,
      method = delegate.iterator[methodName];
    if (undefined === method) return context.delegate = null, "throw" === methodName && delegate.iterator.return && (context.method = "return", context.arg = undefined, maybeInvokeDelegate(delegate, context), "throw" === context.method) || "return" !== methodName && (context.method = "throw", context.arg = new TypeError("The iterator does not provide a '" + methodName + "' method")), ContinueSentinel;
    var record = tryCatch(method, delegate.iterator, context.arg);
    if ("throw" === record.type) return context.method = "throw", context.arg = record.arg, context.delegate = null, ContinueSentinel;
    var info = record.arg;
    return info ? info.done ? (context[delegate.resultName] = info.value, context.next = delegate.nextLoc, "return" !== context.method && (context.method = "next", context.arg = undefined), context.delegate = null, ContinueSentinel) : info : (context.method = "throw", context.arg = new TypeError("iterator result is not an object"), context.delegate = null, ContinueSentinel);
  }
  function pushTryEntry(locs) {
    var entry = {
      tryLoc: locs[0]
    };
    1 in locs && (entry.catchLoc = locs[1]), 2 in locs && (entry.finallyLoc = locs[2], entry.afterLoc = locs[3]), this.tryEntries.push(entry);
  }
  function resetTryEntry(entry) {
    var record = entry.completion || {};
    record.type = "normal", delete record.arg, entry.completion = record;
  }
  function Context(tryLocsList) {
    this.tryEntries = [{
      tryLoc: "root"
    }], tryLocsList.forEach(pushTryEntry, this), this.reset(!0);
  }
  function values(iterable) {
    if (iterable) {
      var iteratorMethod = iterable[iteratorSymbol];
      if (iteratorMethod) return iteratorMethod.call(iterable);
      if ("function" == typeof iterable.next) return iterable;
      if (!isNaN(iterable.length)) {
        var i = -1,
          next = function next() {
            for (; ++i < iterable.length;) if (hasOwn.call(iterable, i)) return next.value = iterable[i], next.done = !1, next;
            return next.value = undefined, next.done = !0, next;
          };
        return next.next = next;
      }
    }
    return {
      next: doneResult
    };
  }
  function doneResult() {
    return {
      value: undefined,
      done: !0
    };
  }
  return GeneratorFunction.prototype = GeneratorFunctionPrototype, defineProperty(Gp, "constructor", {
    value: GeneratorFunctionPrototype,
    configurable: !0
  }), defineProperty(GeneratorFunctionPrototype, "constructor", {
    value: GeneratorFunction,
    configurable: !0
  }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction"), exports.isGeneratorFunction = function (genFun) {
    var ctor = "function" == typeof genFun && genFun.constructor;
    return !!ctor && (ctor === GeneratorFunction || "GeneratorFunction" === (ctor.displayName || ctor.name));
  }, exports.mark = function (genFun) {
    return Object.setPrototypeOf ? Object.setPrototypeOf(genFun, GeneratorFunctionPrototype) : (genFun.__proto__ = GeneratorFunctionPrototype, define(genFun, toStringTagSymbol, "GeneratorFunction")), genFun.prototype = Object.create(Gp), genFun;
  }, exports.awrap = function (arg) {
    return {
      __await: arg
    };
  }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, asyncIteratorSymbol, function () {
    return this;
  }), exports.AsyncIterator = AsyncIterator, exports.async = function (innerFn, outerFn, self, tryLocsList, PromiseImpl) {
    void 0 === PromiseImpl && (PromiseImpl = Promise);
    var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList), PromiseImpl);
    return exports.isGeneratorFunction(outerFn) ? iter : iter.next().then(function (result) {
      return result.done ? result.value : iter.next();
    });
  }, defineIteratorMethods(Gp), define(Gp, toStringTagSymbol, "Generator"), define(Gp, iteratorSymbol, function () {
    return this;
  }), define(Gp, "toString", function () {
    return "[object Generator]";
  }), exports.keys = function (val) {
    var object = Object(val),
      keys = [];
    for (var key in object) keys.push(key);
    return keys.reverse(), function next() {
      for (; keys.length;) {
        var key = keys.pop();
        if (key in object) return next.value = key, next.done = !1, next;
      }
      return next.done = !0, next;
    };
  }, exports.values = values, Context.prototype = {
    constructor: Context,
    reset: function (skipTempReset) {
      if (this.prev = 0, this.next = 0, this.sent = this._sent = undefined, this.done = !1, this.delegate = null, this.method = "next", this.arg = undefined, this.tryEntries.forEach(resetTryEntry), !skipTempReset) for (var name in this) "t" === name.charAt(0) && hasOwn.call(this, name) && !isNaN(+name.slice(1)) && (this[name] = undefined);
    },
    stop: function () {
      this.done = !0;
      var rootRecord = this.tryEntries[0].completion;
      if ("throw" === rootRecord.type) throw rootRecord.arg;
      return this.rval;
    },
    dispatchException: function (exception) {
      if (this.done) throw exception;
      var context = this;
      function handle(loc, caught) {
        return record.type = "throw", record.arg = exception, context.next = loc, caught && (context.method = "next", context.arg = undefined), !!caught;
      }
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i],
          record = entry.completion;
        if ("root" === entry.tryLoc) return handle("end");
        if (entry.tryLoc <= this.prev) {
          var hasCatch = hasOwn.call(entry, "catchLoc"),
            hasFinally = hasOwn.call(entry, "finallyLoc");
          if (hasCatch && hasFinally) {
            if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
            if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
          } else if (hasCatch) {
            if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
          } else {
            if (!hasFinally) throw new Error("try statement without catch or finally");
            if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
          }
        }
      }
    },
    abrupt: function (type, arg) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) {
          var finallyEntry = entry;
          break;
        }
      }
      finallyEntry && ("break" === type || "continue" === type) && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc && (finallyEntry = null);
      var record = finallyEntry ? finallyEntry.completion : {};
      return record.type = type, record.arg = arg, finallyEntry ? (this.method = "next", this.next = finallyEntry.finallyLoc, ContinueSentinel) : this.complete(record);
    },
    complete: function (record, afterLoc) {
      if ("throw" === record.type) throw record.arg;
      return "break" === record.type || "continue" === record.type ? this.next = record.arg : "return" === record.type ? (this.rval = this.arg = record.arg, this.method = "return", this.next = "end") : "normal" === record.type && afterLoc && (this.next = afterLoc), ContinueSentinel;
    },
    finish: function (finallyLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.finallyLoc === finallyLoc) return this.complete(entry.completion, entry.afterLoc), resetTryEntry(entry), ContinueSentinel;
      }
    },
    catch: function (tryLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc === tryLoc) {
          var record = entry.completion;
          if ("throw" === record.type) {
            var thrown = record.arg;
            resetTryEntry(entry);
          }
          return thrown;
        }
      }
      throw new Error("illegal catch attempt");
    },
    delegateYield: function (iterable, resultName, nextLoc) {
      return this.delegate = {
        iterator: values(iterable),
        resultName: resultName,
        nextLoc: nextLoc
      }, "next" === this.method && (this.arg = undefined), ContinueSentinel;
    }
  }, exports;
}
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }
  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}
function _asyncToGenerator(fn) {
  return function () {
    var self = this,
      args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);
      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }
      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }
      _next(undefined);
    });
  };
}
function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
function _inheritsLoose(subClass, superClass) {
  subClass.prototype = Object.create(superClass.prototype);
  subClass.prototype.constructor = subClass;
  _setPrototypeOf(subClass, superClass);
}
function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}
function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };
  return _setPrototypeOf(o, p);
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct) return false;
  if (Reflect.construct.sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
function _construct(Parent, args, Class) {
  if (_isNativeReflectConstruct()) {
    _construct = Reflect.construct.bind();
  } else {
    _construct = function _construct(Parent, args, Class) {
      var a = [null];
      a.push.apply(a, args);
      var Constructor = Function.bind.apply(Parent, a);
      var instance = new Constructor();
      if (Class) _setPrototypeOf(instance, Class.prototype);
      return instance;
    };
  }
  return _construct.apply(null, arguments);
}
function _isNativeFunction(fn) {
  return Function.toString.call(fn).indexOf("[native code]") !== -1;
}
function _wrapNativeSuper(Class) {
  var _cache = typeof Map === "function" ? new Map() : undefined;
  _wrapNativeSuper = function _wrapNativeSuper(Class) {
    if (Class === null || !_isNativeFunction(Class)) return Class;
    if (typeof Class !== "function") {
      throw new TypeError("Super expression must either be null or a function");
    }
    if (typeof _cache !== "undefined") {
      if (_cache.has(Class)) return _cache.get(Class);
      _cache.set(Class, Wrapper);
    }
    function Wrapper() {
      return _construct(Class, arguments, _getPrototypeOf(this).constructor);
    }
    Wrapper.prototype = Object.create(Class.prototype, {
      constructor: {
        value: Wrapper,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    return _setPrototypeOf(Wrapper, Class);
  };
  return _wrapNativeSuper(Class);
}
function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}
function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];
  return arr2;
}
function _createForOfIteratorHelperLoose(o, allowArrayLike) {
  var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];
  if (it) return (it = it.call(o)).next.bind(it);
  if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
    if (it) o = it;
    var i = 0;
    return function () {
      if (i >= o.length) return {
        done: true
      };
      return {
        done: false,
        value: o[i++]
      };
    };
  }
  throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

var LegacyRouterAbi = [{
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "address",
    "name": "token",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "uint256",
    "name": "amount",
    "type": "uint256"
  }, {
    "indexed": false,
    "internalType": "bytes",
    "name": "receiver",
    "type": "bytes"
  }],
  "name": "Burn",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "uint8",
    "name": "targetChain",
    "type": "uint8"
  }, {
    "indexed": false,
    "internalType": "address",
    "name": "token",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "uint256",
    "name": "amount",
    "type": "uint256"
  }, {
    "indexed": false,
    "internalType": "bytes",
    "name": "receiver",
    "type": "bytes"
  }],
  "name": "BurnAndTransfer",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "address",
    "name": "member",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "uint256",
    "name": "amount",
    "type": "uint256"
  }],
  "name": "Claim",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "components": [{
      "internalType": "address",
      "name": "facetAddress",
      "type": "address"
    }, {
      "internalType": "enum IDiamondCut.FacetCutAction",
      "name": "action",
      "type": "uint8"
    }, {
      "internalType": "bytes4[]",
      "name": "functionSelectors",
      "type": "bytes4[]"
    }],
    "indexed": false,
    "internalType": "struct IDiamondCut.FacetCut[]",
    "name": "_diamondCut",
    "type": "tuple[]"
  }, {
    "indexed": false,
    "internalType": "address",
    "name": "_init",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "bytes",
    "name": "_calldata",
    "type": "bytes"
  }],
  "name": "DiamondCut",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "address",
    "name": "account",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "address",
    "name": "newExternalFeeAddress",
    "type": "address"
  }],
  "name": "ExternalFeeAddressSet",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "address",
    "name": "account",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "uint256",
    "name": "newExternalFee",
    "type": "uint256"
  }],
  "name": "ExternalFeeSet",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "uint256",
    "name": "serviceFee",
    "type": "uint256"
  }, {
    "indexed": false,
    "internalType": "uint256",
    "name": "externalFee",
    "type": "uint256"
  }],
  "name": "Fees",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "uint8",
    "name": "targetChain",
    "type": "uint8"
  }, {
    "indexed": false,
    "internalType": "address",
    "name": "token",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "bytes",
    "name": "receiver",
    "type": "bytes"
  }, {
    "indexed": false,
    "internalType": "uint256",
    "name": "amount",
    "type": "uint256"
  }, {
    "indexed": false,
    "internalType": "uint256",
    "name": "serviceFee",
    "type": "uint256"
  }],
  "name": "Lock",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "address",
    "name": "member",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "bool",
    "name": "status",
    "type": "bool"
  }],
  "name": "MemberUpdated",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "address",
    "name": "token",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "uint256",
    "name": "amount",
    "type": "uint256"
  }, {
    "indexed": false,
    "internalType": "address",
    "name": "receiver",
    "type": "address"
  }],
  "name": "Mint",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "address",
    "name": "account",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "uint256",
    "name": "newServiceFee",
    "type": "uint256"
  }],
  "name": "ServiceFeeSet",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "address",
    "name": "token",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "uint256",
    "name": "amount",
    "type": "uint256"
  }, {
    "indexed": false,
    "internalType": "address",
    "name": "receiver",
    "type": "address"
  }],
  "name": "Unlock",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "uint8",
    "name": "sourceChain",
    "type": "uint8"
  }, {
    "indexed": false,
    "internalType": "bytes",
    "name": "nativeToken",
    "type": "bytes"
  }, {
    "indexed": false,
    "internalType": "address",
    "name": "wrappedToken",
    "type": "address"
  }],
  "name": "WrappedTokenDeployed",
  "type": "event"
}, {
  "inputs": [],
  "name": "accumulator",
  "outputs": [{
    "internalType": "uint256",
    "name": "",
    "type": "uint256"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [],
  "name": "administrativeNonce",
  "outputs": [{
    "internalType": "uint256",
    "name": "",
    "type": "uint256"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [],
  "name": "albtToken",
  "outputs": [{
    "internalType": "address",
    "name": "",
    "type": "address"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "_wrappedToken",
    "type": "address"
  }, {
    "internalType": "uint256",
    "name": "_amount",
    "type": "uint256"
  }, {
    "internalType": "bytes",
    "name": "_receiver",
    "type": "bytes"
  }],
  "name": "burn",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "uint8",
    "name": "_targetChain",
    "type": "uint8"
  }, {
    "internalType": "address",
    "name": "_wrappedToken",
    "type": "address"
  }, {
    "internalType": "uint256",
    "name": "_amount",
    "type": "uint256"
  }, {
    "internalType": "bytes",
    "name": "_receiver",
    "type": "bytes"
  }],
  "name": "burnAndTransfer",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "uint8",
    "name": "_targetChain",
    "type": "uint8"
  }, {
    "internalType": "address",
    "name": "_wrappedToken",
    "type": "address"
  }, {
    "internalType": "uint256",
    "name": "_amount",
    "type": "uint256"
  }, {
    "internalType": "bytes",
    "name": "_receiver",
    "type": "bytes"
  }, {
    "internalType": "uint256",
    "name": "_deadline",
    "type": "uint256"
  }, {
    "internalType": "uint8",
    "name": "_v",
    "type": "uint8"
  }, {
    "internalType": "bytes32",
    "name": "_r",
    "type": "bytes32"
  }, {
    "internalType": "bytes32",
    "name": "_s",
    "type": "bytes32"
  }],
  "name": "burnAndTransferWithPermit",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "_wrappedToken",
    "type": "address"
  }, {
    "internalType": "uint256",
    "name": "_amount",
    "type": "uint256"
  }, {
    "internalType": "bytes",
    "name": "_receiver",
    "type": "bytes"
  }, {
    "internalType": "uint256",
    "name": "_deadline",
    "type": "uint256"
  }, {
    "internalType": "uint8",
    "name": "_v",
    "type": "uint8"
  }, {
    "internalType": "bytes32",
    "name": "_r",
    "type": "bytes32"
  }, {
    "internalType": "bytes32",
    "name": "_s",
    "type": "bytes32"
  }],
  "name": "burnWithPermit",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [],
  "name": "claim",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "_account",
    "type": "address"
  }],
  "name": "claimedRewardsPerAccount",
  "outputs": [{
    "internalType": "uint256",
    "name": "",
    "type": "uint256"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "components": [{
      "internalType": "address",
      "name": "facetAddress",
      "type": "address"
    }, {
      "internalType": "enum IDiamondCut.FacetCutAction",
      "name": "action",
      "type": "uint8"
    }, {
      "internalType": "bytes4[]",
      "name": "functionSelectors",
      "type": "bytes4[]"
    }],
    "internalType": "struct IDiamondCut.FacetCut[]",
    "name": "_diamondCut",
    "type": "tuple[]"
  }, {
    "internalType": "address",
    "name": "_init",
    "type": "address"
  }, {
    "internalType": "bytes",
    "name": "_calldata",
    "type": "bytes"
  }, {
    "internalType": "bytes[]",
    "name": "_signatures",
    "type": "bytes[]"
  }],
  "name": "diamondCut",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [],
  "name": "externalFee",
  "outputs": [{
    "internalType": "uint256",
    "name": "",
    "type": "uint256"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [],
  "name": "externalFeeAddress",
  "outputs": [{
    "internalType": "address",
    "name": "",
    "type": "address"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "bytes4",
    "name": "_functionSelector",
    "type": "bytes4"
  }],
  "name": "facetAddress",
  "outputs": [{
    "internalType": "address",
    "name": "facetAddress_",
    "type": "address"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [],
  "name": "facetAddresses",
  "outputs": [{
    "internalType": "address[]",
    "name": "facetAddresses_",
    "type": "address[]"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "_facet",
    "type": "address"
  }],
  "name": "facetFunctionSelectors",
  "outputs": [{
    "internalType": "bytes4[]",
    "name": "facetFunctionSelectors_",
    "type": "bytes4[]"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [],
  "name": "facets",
  "outputs": [{
    "components": [{
      "internalType": "address",
      "name": "facetAddress",
      "type": "address"
    }, {
      "internalType": "bytes4[]",
      "name": "functionSelectors",
      "type": "bytes4[]"
    }],
    "internalType": "struct IDiamondLoupe.Facet[]",
    "name": "facets_",
    "type": "tuple[]"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [],
  "name": "feesAccrued",
  "outputs": [{
    "internalType": "uint256",
    "name": "",
    "type": "uint256"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "uint8",
    "name": "_chainId",
    "type": "uint8"
  }, {
    "internalType": "bytes32",
    "name": "_ethHash",
    "type": "bytes32"
  }],
  "name": "hashesUsed",
  "outputs": [{
    "internalType": "bool",
    "name": "",
    "type": "bool"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "uint256",
    "name": "_serviceFee",
    "type": "uint256"
  }],
  "name": "initFeeCalculator",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "uint256",
    "name": "_externalFee",
    "type": "uint256"
  }, {
    "internalType": "address",
    "name": "_externalFeeAddress",
    "type": "address"
  }],
  "name": "initFeeExternal",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address[]",
    "name": "_members",
    "type": "address[]"
  }],
  "name": "initGovernance",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "uint8",
    "name": "_chainId",
    "type": "uint8"
  }, {
    "internalType": "address",
    "name": "_albtToken",
    "type": "address"
  }],
  "name": "initRouter",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "_member",
    "type": "address"
  }],
  "name": "isMember",
  "outputs": [{
    "internalType": "bool",
    "name": "",
    "type": "bool"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "uint8",
    "name": "_targetChain",
    "type": "uint8"
  }, {
    "internalType": "address",
    "name": "_nativeToken",
    "type": "address"
  }, {
    "internalType": "uint256",
    "name": "_amount",
    "type": "uint256"
  }, {
    "internalType": "bytes",
    "name": "_receiver",
    "type": "bytes"
  }],
  "name": "lock",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "uint8",
    "name": "_targetChain",
    "type": "uint8"
  }, {
    "internalType": "address",
    "name": "_nativeToken",
    "type": "address"
  }, {
    "internalType": "uint256",
    "name": "_amount",
    "type": "uint256"
  }, {
    "internalType": "bytes",
    "name": "_receiver",
    "type": "bytes"
  }, {
    "internalType": "uint256",
    "name": "_deadline",
    "type": "uint256"
  }, {
    "internalType": "uint8",
    "name": "_v",
    "type": "uint8"
  }, {
    "internalType": "bytes32",
    "name": "_r",
    "type": "bytes32"
  }, {
    "internalType": "bytes32",
    "name": "_s",
    "type": "bytes32"
  }],
  "name": "lockWithPermit",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "uint256",
    "name": "_index",
    "type": "uint256"
  }],
  "name": "memberAt",
  "outputs": [{
    "internalType": "address",
    "name": "",
    "type": "address"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [],
  "name": "membersCount",
  "outputs": [{
    "internalType": "uint256",
    "name": "",
    "type": "uint256"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "uint8",
    "name": "_nativeChain",
    "type": "uint8"
  }, {
    "internalType": "bytes",
    "name": "_nativeToken",
    "type": "bytes"
  }, {
    "internalType": "bytes",
    "name": "_transactionId",
    "type": "bytes"
  }, {
    "internalType": "uint256",
    "name": "_amount",
    "type": "uint256"
  }, {
    "internalType": "address",
    "name": "_receiver",
    "type": "address"
  }, {
    "internalType": "bytes[]",
    "name": "_signatures",
    "type": "bytes[]"
  }, {
    "components": [{
      "internalType": "string",
      "name": "name",
      "type": "string"
    }, {
      "internalType": "string",
      "name": "symbol",
      "type": "string"
    }, {
      "internalType": "uint8",
      "name": "decimals",
      "type": "uint8"
    }],
    "internalType": "struct WrappedTokenParams",
    "name": "_tokenParams",
    "type": "tuple"
  }],
  "name": "mint",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "uint8",
    "name": "_chainId",
    "type": "uint8"
  }, {
    "internalType": "bytes",
    "name": "_nativeToken",
    "type": "bytes"
  }],
  "name": "nativeToWrappedToken",
  "outputs": [{
    "internalType": "address",
    "name": "",
    "type": "address"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [],
  "name": "previousAccrued",
  "outputs": [{
    "internalType": "uint256",
    "name": "",
    "type": "uint256"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [],
  "name": "serviceFee",
  "outputs": [{
    "internalType": "uint256",
    "name": "",
    "type": "uint256"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "uint256",
    "name": "_externalFee",
    "type": "uint256"
  }, {
    "internalType": "bytes[]",
    "name": "_signatures",
    "type": "bytes[]"
  }],
  "name": "setExternalFee",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "_externalFeeAddress",
    "type": "address"
  }, {
    "internalType": "bytes[]",
    "name": "_signatures",
    "type": "bytes[]"
  }],
  "name": "setExternalFeeAddress",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "uint256",
    "name": "_serviceFee",
    "type": "uint256"
  }, {
    "internalType": "bytes[]",
    "name": "_signatures",
    "type": "bytes[]"
  }],
  "name": "setServiceFee",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "uint8",
    "name": "_sourceChain",
    "type": "uint8"
  }, {
    "internalType": "bytes",
    "name": "_transactionId",
    "type": "bytes"
  }, {
    "internalType": "address",
    "name": "_nativeToken",
    "type": "address"
  }, {
    "internalType": "uint256",
    "name": "_amount",
    "type": "uint256"
  }, {
    "internalType": "address",
    "name": "_receiver",
    "type": "address"
  }, {
    "internalType": "bytes[]",
    "name": "_signatures",
    "type": "bytes[]"
  }],
  "name": "unlock",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "_account",
    "type": "address"
  }, {
    "internalType": "bool",
    "name": "_status",
    "type": "bool"
  }, {
    "internalType": "bytes[]",
    "name": "_signatures",
    "type": "bytes[]"
  }],
  "name": "updateMember",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "_wrappedToken",
    "type": "address"
  }],
  "name": "wrappedToNativeToken",
  "outputs": [{
    "components": [{
      "internalType": "uint8",
      "name": "chainId",
      "type": "uint8"
    }, {
      "internalType": "bytes",
      "name": "token",
      "type": "bytes"
    }],
    "internalType": "struct LibRouter.NativeTokenWithChainId",
    "name": "",
    "type": "tuple"
  }],
  "stateMutability": "view",
  "type": "function"
}];

var LegacyRouterProxyAbi = [{
  "inputs": [{
    "internalType": "address",
    "name": "routerAddress_",
    "type": "address"
  }, {
    "internalType": "address",
    "name": "albtToken_",
    "type": "address"
  }, {
    "internalType": "string",
    "name": "tokenName_",
    "type": "string"
  }, {
    "internalType": "string",
    "name": "tokenSymbol_",
    "type": "string"
  }, {
    "internalType": "uint8",
    "name": "decimals_",
    "type": "uint8"
  }],
  "stateMutability": "nonpayable",
  "type": "constructor"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "address",
    "name": "oldAlbt_",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "address",
    "name": "newAlbt_",
    "type": "address"
  }],
  "name": "AlbtAddressSet",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": true,
    "internalType": "address",
    "name": "owner",
    "type": "address"
  }, {
    "indexed": true,
    "internalType": "address",
    "name": "spender",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "uint256",
    "name": "value",
    "type": "uint256"
  }],
  "name": "Approval",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "uint256",
    "name": "amount_",
    "type": "uint256"
  }],
  "name": "BridgeAirdrop",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "uint256",
    "name": "amount",
    "type": "uint256"
  }],
  "name": "CurrencyClaimed",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "address",
    "name": "token_",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "uint256",
    "name": "amount_",
    "type": "uint256"
  }],
  "name": "FeeCollected",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "address",
    "name": "token_",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "uint256",
    "name": "oldFee_",
    "type": "uint256"
  }, {
    "indexed": false,
    "internalType": "uint256",
    "name": "newFee_",
    "type": "uint256"
  }],
  "name": "FeeSet",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": true,
    "internalType": "address",
    "name": "previousOwner",
    "type": "address"
  }, {
    "indexed": true,
    "internalType": "address",
    "name": "newOwner",
    "type": "address"
  }],
  "name": "OwnershipTransferred",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "address",
    "name": "feeToken_",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "address",
    "name": "wrappedToken_",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "uint256",
    "name": "amount_",
    "type": "uint256"
  }, {
    "indexed": false,
    "internalType": "bytes",
    "name": "receiver_",
    "type": "bytes"
  }],
  "name": "ProxyBurn",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "address",
    "name": "feeToken_",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "uint8",
    "name": "targetChain_",
    "type": "uint8"
  }, {
    "indexed": false,
    "internalType": "address",
    "name": "wrappedToken_",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "uint256",
    "name": "amount_",
    "type": "uint256"
  }, {
    "indexed": false,
    "internalType": "bytes",
    "name": "receiver_",
    "type": "bytes"
  }],
  "name": "ProxyBurnAndTransfer",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "address",
    "name": "feeToken_",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "uint8",
    "name": "targetChain_",
    "type": "uint8"
  }, {
    "indexed": false,
    "internalType": "address",
    "name": "nativeToken_",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "uint256",
    "name": "amount_",
    "type": "uint256"
  }, {
    "indexed": false,
    "internalType": "bytes",
    "name": "receiver_",
    "type": "bytes"
  }],
  "name": "ProxyLock",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "address",
    "name": "oldRouter_",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "address",
    "name": "newRouter_",
    "type": "address"
  }],
  "name": "RouterAddressSet",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "address",
    "name": "token_",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "uint256",
    "name": "amount_",
    "type": "uint256"
  }],
  "name": "TokensClaimed",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": true,
    "internalType": "address",
    "name": "from",
    "type": "address"
  }, {
    "indexed": true,
    "internalType": "address",
    "name": "to",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "uint256",
    "name": "value",
    "type": "uint256"
  }],
  "name": "Transfer",
  "type": "event"
}, {
  "inputs": [],
  "name": "albtToken",
  "outputs": [{
    "internalType": "address",
    "name": "",
    "type": "address"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "owner",
    "type": "address"
  }, {
    "internalType": "address",
    "name": "spender",
    "type": "address"
  }],
  "name": "allowance",
  "outputs": [{
    "internalType": "uint256",
    "name": "",
    "type": "uint256"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "spender",
    "type": "address"
  }, {
    "internalType": "uint256",
    "name": "amount",
    "type": "uint256"
  }],
  "name": "approve",
  "outputs": [{
    "internalType": "bool",
    "name": "",
    "type": "bool"
  }],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "account",
    "type": "address"
  }],
  "name": "balanceOf",
  "outputs": [{
    "internalType": "uint256",
    "name": "",
    "type": "uint256"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [],
  "name": "bridgeAirdrop",
  "outputs": [],
  "stateMutability": "payable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "feeToken_",
    "type": "address"
  }, {
    "internalType": "address",
    "name": "wrappedToken_",
    "type": "address"
  }, {
    "internalType": "uint256",
    "name": "amount_",
    "type": "uint256"
  }, {
    "internalType": "bytes",
    "name": "receiver_",
    "type": "bytes"
  }],
  "name": "burn",
  "outputs": [],
  "stateMutability": "payable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "feeToken_",
    "type": "address"
  }, {
    "internalType": "uint8",
    "name": "targetChain_",
    "type": "uint8"
  }, {
    "internalType": "address",
    "name": "wrappedToken_",
    "type": "address"
  }, {
    "internalType": "uint256",
    "name": "amount_",
    "type": "uint256"
  }, {
    "internalType": "bytes",
    "name": "receiver_",
    "type": "bytes"
  }],
  "name": "burnAndTransfer",
  "outputs": [],
  "stateMutability": "payable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "feeToken_",
    "type": "address"
  }, {
    "internalType": "uint8",
    "name": "targetChain_",
    "type": "uint8"
  }, {
    "internalType": "address",
    "name": "wrappedToken_",
    "type": "address"
  }, {
    "internalType": "uint256",
    "name": "amount_",
    "type": "uint256"
  }, {
    "internalType": "bytes",
    "name": "receiver_",
    "type": "bytes"
  }, {
    "internalType": "uint256",
    "name": "deadline_",
    "type": "uint256"
  }, {
    "internalType": "uint8",
    "name": "v_",
    "type": "uint8"
  }, {
    "internalType": "bytes32",
    "name": "r_",
    "type": "bytes32"
  }, {
    "internalType": "bytes32",
    "name": "s_",
    "type": "bytes32"
  }],
  "name": "burnAndTransferWithPermit",
  "outputs": [],
  "stateMutability": "payable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "feeToken_",
    "type": "address"
  }, {
    "internalType": "address",
    "name": "wrappedToken_",
    "type": "address"
  }, {
    "internalType": "uint256",
    "name": "amount_",
    "type": "uint256"
  }, {
    "internalType": "bytes",
    "name": "receiver_",
    "type": "bytes"
  }, {
    "internalType": "uint256",
    "name": "deadline_",
    "type": "uint256"
  }, {
    "internalType": "uint8",
    "name": "v_",
    "type": "uint8"
  }, {
    "internalType": "bytes32",
    "name": "r_",
    "type": "bytes32"
  }, {
    "internalType": "bytes32",
    "name": "s_",
    "type": "bytes32"
  }],
  "name": "burnWithPermit",
  "outputs": [],
  "stateMutability": "payable",
  "type": "function"
}, {
  "inputs": [],
  "name": "claimCurrency",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "tokenAddress_",
    "type": "address"
  }],
  "name": "claimTokens",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [],
  "name": "decimals",
  "outputs": [{
    "internalType": "uint8",
    "name": "",
    "type": "uint8"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "spender",
    "type": "address"
  }, {
    "internalType": "uint256",
    "name": "subtractedValue",
    "type": "uint256"
  }],
  "name": "decreaseAllowance",
  "outputs": [{
    "internalType": "bool",
    "name": "",
    "type": "bool"
  }],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "",
    "type": "address"
  }],
  "name": "feeAmountByToken",
  "outputs": [{
    "internalType": "uint256",
    "name": "",
    "type": "uint256"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "spender",
    "type": "address"
  }, {
    "internalType": "uint256",
    "name": "addedValue",
    "type": "uint256"
  }],
  "name": "increaseAllowance",
  "outputs": [{
    "internalType": "bool",
    "name": "",
    "type": "bool"
  }],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "feeToken_",
    "type": "address"
  }, {
    "internalType": "uint8",
    "name": "targetChain_",
    "type": "uint8"
  }, {
    "internalType": "address",
    "name": "nativeToken_",
    "type": "address"
  }, {
    "internalType": "uint256",
    "name": "amount_",
    "type": "uint256"
  }, {
    "internalType": "bytes",
    "name": "receiver_",
    "type": "bytes"
  }],
  "name": "lock",
  "outputs": [],
  "stateMutability": "payable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "feeToken_",
    "type": "address"
  }, {
    "internalType": "uint8",
    "name": "targetChain_",
    "type": "uint8"
  }, {
    "internalType": "address",
    "name": "nativeToken_",
    "type": "address"
  }, {
    "internalType": "uint256",
    "name": "amount_",
    "type": "uint256"
  }, {
    "internalType": "bytes",
    "name": "receiver_",
    "type": "bytes"
  }, {
    "internalType": "uint256",
    "name": "deadline_",
    "type": "uint256"
  }, {
    "internalType": "uint8",
    "name": "v_",
    "type": "uint8"
  }, {
    "internalType": "bytes32",
    "name": "r_",
    "type": "bytes32"
  }, {
    "internalType": "bytes32",
    "name": "s_",
    "type": "bytes32"
  }],
  "name": "lockWithPermit",
  "outputs": [],
  "stateMutability": "payable",
  "type": "function"
}, {
  "inputs": [],
  "name": "name",
  "outputs": [{
    "internalType": "string",
    "name": "",
    "type": "string"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [],
  "name": "owner",
  "outputs": [{
    "internalType": "address",
    "name": "",
    "type": "address"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [],
  "name": "renounceOwnership",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [],
  "name": "routerAddress",
  "outputs": [{
    "internalType": "address",
    "name": "",
    "type": "address"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "albtToken_",
    "type": "address"
  }],
  "name": "setAlbtToken",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "tokenAddress_",
    "type": "address"
  }, {
    "internalType": "uint256",
    "name": "fee_",
    "type": "uint256"
  }],
  "name": "setFee",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "routerAddress_",
    "type": "address"
  }],
  "name": "setRouterAddress",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [],
  "name": "symbol",
  "outputs": [{
    "internalType": "string",
    "name": "",
    "type": "string"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [],
  "name": "totalSupply",
  "outputs": [{
    "internalType": "uint256",
    "name": "",
    "type": "uint256"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "recipient_",
    "type": "address"
  }, {
    "internalType": "uint256",
    "name": "amount_",
    "type": "uint256"
  }],
  "name": "transfer",
  "outputs": [{
    "internalType": "bool",
    "name": "",
    "type": "bool"
  }],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "sender",
    "type": "address"
  }, {
    "internalType": "address",
    "name": "recipient",
    "type": "address"
  }, {
    "internalType": "uint256",
    "name": "amount",
    "type": "uint256"
  }],
  "name": "transferFrom",
  "outputs": [{
    "internalType": "bool",
    "name": "",
    "type": "bool"
  }],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "newOwner",
    "type": "address"
  }],
  "name": "transferOwnership",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}];

var MulticallAbi = [{
  "inputs": [{
    "components": [{
      "internalType": "address",
      "name": "target",
      "type": "address"
    }, {
      "internalType": "bytes",
      "name": "callData",
      "type": "bytes"
    }],
    "internalType": "struct Multicall.Call[]",
    "name": "calls",
    "type": "tuple[]"
  }],
  "name": "aggregate",
  "outputs": [{
    "internalType": "uint256",
    "name": "blockNumber",
    "type": "uint256"
  }, {
    "internalType": "bytes[]",
    "name": "returnData",
    "type": "bytes[]"
  }],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "components": [{
      "internalType": "address",
      "name": "target",
      "type": "address"
    }, {
      "internalType": "bytes",
      "name": "callData",
      "type": "bytes"
    }],
    "internalType": "struct Multicall.Call[]",
    "name": "calls",
    "type": "tuple[]"
  }],
  "name": "blockAndAggregate",
  "outputs": [{
    "internalType": "uint256",
    "name": "blockNumber",
    "type": "uint256"
  }, {
    "internalType": "bytes32",
    "name": "blockHash",
    "type": "bytes32"
  }, {
    "components": [{
      "internalType": "bool",
      "name": "success",
      "type": "bool"
    }, {
      "internalType": "bytes",
      "name": "returnData",
      "type": "bytes"
    }],
    "internalType": "struct Multicall.Result[]",
    "name": "returnData",
    "type": "tuple[]"
  }],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "uint256",
    "name": "blockNumber",
    "type": "uint256"
  }],
  "name": "getBlockHash",
  "outputs": [{
    "internalType": "bytes32",
    "name": "blockHash",
    "type": "bytes32"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [],
  "name": "getBlockNumber",
  "outputs": [{
    "internalType": "uint256",
    "name": "blockNumber",
    "type": "uint256"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [],
  "name": "getCurrentBlockCoinbase",
  "outputs": [{
    "internalType": "address",
    "name": "coinbase",
    "type": "address"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [],
  "name": "getCurrentBlockDifficulty",
  "outputs": [{
    "internalType": "uint256",
    "name": "difficulty",
    "type": "uint256"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [],
  "name": "getCurrentBlockGasLimit",
  "outputs": [{
    "internalType": "uint256",
    "name": "gaslimit",
    "type": "uint256"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [],
  "name": "getCurrentBlockTimestamp",
  "outputs": [{
    "internalType": "uint256",
    "name": "timestamp",
    "type": "uint256"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "addr",
    "type": "address"
  }],
  "name": "getEthBalance",
  "outputs": [{
    "internalType": "uint256",
    "name": "balance",
    "type": "uint256"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [],
  "name": "getLastBlockHash",
  "outputs": [{
    "internalType": "bytes32",
    "name": "blockHash",
    "type": "bytes32"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "bool",
    "name": "requireSuccess",
    "type": "bool"
  }, {
    "components": [{
      "internalType": "address",
      "name": "target",
      "type": "address"
    }, {
      "internalType": "bytes",
      "name": "callData",
      "type": "bytes"
    }],
    "internalType": "struct Multicall.Call[]",
    "name": "calls",
    "type": "tuple[]"
  }],
  "name": "tryAggregate",
  "outputs": [{
    "components": [{
      "internalType": "bool",
      "name": "success",
      "type": "bool"
    }, {
      "internalType": "bytes",
      "name": "returnData",
      "type": "bytes"
    }],
    "internalType": "struct Multicall.Result[]",
    "name": "returnData",
    "type": "tuple[]"
  }],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "bool",
    "name": "requireSuccess",
    "type": "bool"
  }, {
    "components": [{
      "internalType": "address",
      "name": "target",
      "type": "address"
    }, {
      "internalType": "bytes",
      "name": "callData",
      "type": "bytes"
    }],
    "internalType": "struct Multicall.Call[]",
    "name": "calls",
    "type": "tuple[]"
  }],
  "name": "tryBlockAndAggregate",
  "outputs": [{
    "internalType": "uint256",
    "name": "blockNumber",
    "type": "uint256"
  }, {
    "internalType": "bytes32",
    "name": "blockHash",
    "type": "bytes32"
  }, {
    "components": [{
      "internalType": "bool",
      "name": "success",
      "type": "bool"
    }, {
      "internalType": "bytes",
      "name": "returnData",
      "type": "bytes"
    }],
    "internalType": "struct Multicall.Result[]",
    "name": "returnData",
    "type": "tuple[]"
  }],
  "stateMutability": "nonpayable",
  "type": "function"
}];

var WrappedERC721Abi = [{
  "inputs": [{
    "internalType": "string",
    "name": "collectionName_",
    "type": "string"
  }, {
    "internalType": "string",
    "name": "collectionSymbol_",
    "type": "string"
  }],
  "stateMutability": "nonpayable",
  "type": "constructor"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": true,
    "internalType": "address",
    "name": "owner",
    "type": "address"
  }, {
    "indexed": true,
    "internalType": "address",
    "name": "approved",
    "type": "address"
  }, {
    "indexed": true,
    "internalType": "uint256",
    "name": "tokenId",
    "type": "uint256"
  }],
  "name": "Approval",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": true,
    "internalType": "address",
    "name": "owner",
    "type": "address"
  }, {
    "indexed": true,
    "internalType": "address",
    "name": "operator",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "bool",
    "name": "approved",
    "type": "bool"
  }],
  "name": "ApprovalForAll",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": true,
    "internalType": "address",
    "name": "previousOwner",
    "type": "address"
  }, {
    "indexed": true,
    "internalType": "address",
    "name": "newOwner",
    "type": "address"
  }],
  "name": "OwnershipTransferred",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "address",
    "name": "account",
    "type": "address"
  }],
  "name": "Paused",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": true,
    "internalType": "address",
    "name": "from",
    "type": "address"
  }, {
    "indexed": true,
    "internalType": "address",
    "name": "to",
    "type": "address"
  }, {
    "indexed": true,
    "internalType": "uint256",
    "name": "tokenId",
    "type": "uint256"
  }],
  "name": "Transfer",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "address",
    "name": "account",
    "type": "address"
  }],
  "name": "Unpaused",
  "type": "event"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "to",
    "type": "address"
  }, {
    "internalType": "uint256",
    "name": "tokenId",
    "type": "uint256"
  }],
  "name": "approve",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "owner",
    "type": "address"
  }],
  "name": "balanceOf",
  "outputs": [{
    "internalType": "uint256",
    "name": "",
    "type": "uint256"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "owner_",
    "type": "address"
  }, {
    "internalType": "uint256[]",
    "name": "tokenIds_",
    "type": "uint256[]"
  }],
  "name": "batchBurnFrom",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "to_",
    "type": "address"
  }, {
    "internalType": "uint256[]",
    "name": "tokenIds_",
    "type": "uint256[]"
  }, {
    "internalType": "string[]",
    "name": "tokenURIs_",
    "type": "string[]"
  }],
  "name": "batchMint",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "uint256[]",
    "name": "tokenIds_",
    "type": "uint256[]"
  }, {
    "internalType": "string[]",
    "name": "tokenURIs_",
    "type": "string[]"
  }],
  "name": "batchUpdateTokenURI",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "uint256",
    "name": "tokenId",
    "type": "uint256"
  }],
  "name": "getApproved",
  "outputs": [{
    "internalType": "address",
    "name": "",
    "type": "address"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "owner",
    "type": "address"
  }, {
    "internalType": "address",
    "name": "operator",
    "type": "address"
  }],
  "name": "isApprovedForAll",
  "outputs": [{
    "internalType": "bool",
    "name": "",
    "type": "bool"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [],
  "name": "name",
  "outputs": [{
    "internalType": "string",
    "name": "",
    "type": "string"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [],
  "name": "owner",
  "outputs": [{
    "internalType": "address",
    "name": "",
    "type": "address"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "uint256",
    "name": "tokenId",
    "type": "uint256"
  }],
  "name": "ownerOf",
  "outputs": [{
    "internalType": "address",
    "name": "",
    "type": "address"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [],
  "name": "pause",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [],
  "name": "paused",
  "outputs": [{
    "internalType": "bool",
    "name": "",
    "type": "bool"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [],
  "name": "renounceOwnership",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "from",
    "type": "address"
  }, {
    "internalType": "address",
    "name": "to",
    "type": "address"
  }, {
    "internalType": "uint256",
    "name": "tokenId",
    "type": "uint256"
  }],
  "name": "safeTransferFrom",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "from",
    "type": "address"
  }, {
    "internalType": "address",
    "name": "to",
    "type": "address"
  }, {
    "internalType": "uint256",
    "name": "tokenId",
    "type": "uint256"
  }, {
    "internalType": "bytes",
    "name": "_data",
    "type": "bytes"
  }],
  "name": "safeTransferFrom",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "operator",
    "type": "address"
  }, {
    "internalType": "bool",
    "name": "approved",
    "type": "bool"
  }],
  "name": "setApprovalForAll",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "bytes4",
    "name": "interfaceId",
    "type": "bytes4"
  }],
  "name": "supportsInterface",
  "outputs": [{
    "internalType": "bool",
    "name": "",
    "type": "bool"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [],
  "name": "symbol",
  "outputs": [{
    "internalType": "string",
    "name": "",
    "type": "string"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "uint256",
    "name": "index",
    "type": "uint256"
  }],
  "name": "tokenByIndex",
  "outputs": [{
    "internalType": "uint256",
    "name": "",
    "type": "uint256"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "owner",
    "type": "address"
  }, {
    "internalType": "uint256",
    "name": "index",
    "type": "uint256"
  }],
  "name": "tokenOfOwnerByIndex",
  "outputs": [{
    "internalType": "uint256",
    "name": "",
    "type": "uint256"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "uint256",
    "name": "tokenId_",
    "type": "uint256"
  }],
  "name": "tokenURI",
  "outputs": [{
    "internalType": "string",
    "name": "",
    "type": "string"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [],
  "name": "totalSupply",
  "outputs": [{
    "internalType": "uint256",
    "name": "",
    "type": "uint256"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "from",
    "type": "address"
  }, {
    "internalType": "address",
    "name": "to",
    "type": "address"
  }, {
    "internalType": "uint256",
    "name": "tokenId",
    "type": "uint256"
  }],
  "name": "transferFrom",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "newOwner",
    "type": "address"
  }],
  "name": "transferOwnership",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [],
  "name": "unpause",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}];

var ITeleportAbi = [{
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "bytes32",
    "name": "transmissionId",
    "type": "bytes32"
  }],
  "name": "Delivery",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "bytes",
    "name": "transmissionSender",
    "type": "bytes"
  }, {
    "indexed": false,
    "internalType": "uint8",
    "name": "targetChainId",
    "type": "uint8"
  }, {
    "indexed": false,
    "internalType": "bytes",
    "name": "transmissionReceiver",
    "type": "bytes"
  }, {
    "indexed": false,
    "internalType": "bytes32",
    "name": "dAppId",
    "type": "bytes32"
  }, {
    "indexed": false,
    "internalType": "bytes",
    "name": "payload",
    "type": "bytes"
  }],
  "name": "Transmission",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "uint256",
    "name": "serviceFee",
    "type": "uint256"
  }],
  "name": "TransmissionFees",
  "type": "event"
}, {
  "inputs": [{
    "internalType": "bytes32",
    "name": "transmissionId",
    "type": "bytes32"
  }, {
    "internalType": "uint8",
    "name": "sourceChainId",
    "type": "uint8"
  }, {
    "internalType": "bytes",
    "name": "transmissionSender",
    "type": "bytes"
  }, {
    "internalType": "address",
    "name": "transmissionReceiver",
    "type": "address"
  }, {
    "internalType": "bytes32",
    "name": "dAppId",
    "type": "bytes32"
  }, {
    "internalType": "bytes",
    "name": "payload",
    "type": "bytes"
  }, {
    "internalType": "bytes[]",
    "name": "signatures",
    "type": "bytes[]"
  }],
  "name": "deliver",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [],
  "name": "serviceFee",
  "outputs": [{
    "internalType": "uint256",
    "name": "",
    "type": "uint256"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "uint8",
    "name": "targetChainId",
    "type": "uint8"
  }, {
    "internalType": "bytes",
    "name": "transmissionReceiver",
    "type": "bytes"
  }, {
    "internalType": "bytes32",
    "name": "dAppId",
    "type": "bytes32"
  }, {
    "internalType": "bytes",
    "name": "payload",
    "type": "bytes"
  }],
  "name": "transmit",
  "outputs": [],
  "stateMutability": "payable",
  "type": "function"
}];

var NFTRouterAbi = [{
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "uint8",
    "name": "targetChain",
    "type": "uint8"
  }, {
    "indexed": false,
    "internalType": "address",
    "name": "collection",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "uint256[]",
    "name": "tokenIds",
    "type": "uint256[]"
  }, {
    "indexed": false,
    "internalType": "bytes",
    "name": "receiver",
    "type": "bytes"
  }],
  "name": "BurnMint",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "uint8",
    "name": "targetChain",
    "type": "uint8"
  }, {
    "indexed": false,
    "internalType": "address",
    "name": "collection",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "uint256[]",
    "name": "tokenIds",
    "type": "uint256[]"
  }, {
    "indexed": false,
    "internalType": "bytes",
    "name": "receiver",
    "type": "bytes"
  }],
  "name": "BurnUnlock",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "address",
    "name": "account_",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "address",
    "name": "collection_",
    "type": "address"
  }],
  "name": "CollectionPaused",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "address",
    "name": "account_",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "address",
    "name": "collection_",
    "type": "address"
  }],
  "name": "CollectionUnpaused",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "components": [{
      "internalType": "address",
      "name": "facetAddress",
      "type": "address"
    }, {
      "internalType": "enum IDiamondCut.FacetCutAction",
      "name": "action",
      "type": "uint8"
    }, {
      "internalType": "bytes4[]",
      "name": "functionSelectors",
      "type": "bytes4[]"
    }],
    "indexed": false,
    "internalType": "struct IDiamondCut.FacetCut[]",
    "name": "_diamondCut",
    "type": "tuple[]"
  }, {
    "indexed": false,
    "internalType": "address",
    "name": "_init",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "bytes",
    "name": "_calldata",
    "type": "bytes"
  }],
  "name": "DiamondCut",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "uint8",
    "name": "targetChain",
    "type": "uint8"
  }, {
    "indexed": false,
    "internalType": "address",
    "name": "collection",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "uint256[]",
    "name": "tokenIds",
    "type": "uint256[]"
  }, {
    "indexed": false,
    "internalType": "bytes",
    "name": "receiver",
    "type": "bytes"
  }],
  "name": "LockMint",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "address",
    "name": "member",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "bool",
    "name": "status",
    "type": "bool"
  }],
  "name": "MemberUpdated",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "address",
    "name": "collection",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "uint256[]",
    "name": "tokenIds",
    "type": "uint256[]"
  }, {
    "indexed": false,
    "internalType": "address",
    "name": "receiver",
    "type": "address"
  }],
  "name": "Mint",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "address",
    "name": "teleportAddress",
    "type": "address"
  }],
  "name": "TeleportAddressSet",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "components": [{
      "internalType": "uint8",
      "name": "chainId",
      "type": "uint8"
    }, {
      "internalType": "bytes",
      "name": "senderAddress",
      "type": "bytes"
    }],
    "indexed": false,
    "internalType": "struct IUtility.TeleportSender[]",
    "name": "senders_",
    "type": "tuple[]"
  }],
  "name": "TeleportSenderSet",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "address",
    "name": "collection",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "uint256[]",
    "name": "tokenIds",
    "type": "uint256[]"
  }, {
    "indexed": false,
    "internalType": "address",
    "name": "receiver",
    "type": "address"
  }],
  "name": "Unlock",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "uint8",
    "name": "sourceChain",
    "type": "uint8"
  }, {
    "indexed": false,
    "internalType": "bytes",
    "name": "nativeColllection",
    "type": "bytes"
  }, {
    "indexed": false,
    "internalType": "address",
    "name": "wrappedColllection",
    "type": "address"
  }],
  "name": "WrappedCollectionDeployed",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "uint8",
    "name": "nativeChainId_",
    "type": "uint8"
  }, {
    "indexed": false,
    "internalType": "bytes",
    "name": "_nativeCollection",
    "type": "bytes"
  }, {
    "indexed": false,
    "internalType": "address",
    "name": "wrappedCollection_",
    "type": "address"
  }],
  "name": "WrappedCollectionSet",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "address",
    "name": "wrappedCollection_",
    "type": "address"
  }],
  "name": "WrappedCollectionUnset",
  "type": "event"
}, {
  "inputs": [],
  "name": "administrativeNonce",
  "outputs": [{
    "internalType": "uint256",
    "name": "",
    "type": "uint256"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "components": [{
      "internalType": "address",
      "name": "facetAddress",
      "type": "address"
    }, {
      "internalType": "enum IDiamondCut.FacetCutAction",
      "name": "action",
      "type": "uint8"
    }, {
      "internalType": "bytes4[]",
      "name": "functionSelectors",
      "type": "bytes4[]"
    }],
    "internalType": "struct IDiamondCut.FacetCut[]",
    "name": "_diamondCut",
    "type": "tuple[]"
  }, {
    "internalType": "address",
    "name": "_init",
    "type": "address"
  }, {
    "internalType": "bytes",
    "name": "_calldata",
    "type": "bytes"
  }, {
    "internalType": "bytes[]",
    "name": "_signatures",
    "type": "bytes[]"
  }],
  "name": "diamondCut",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "uint8",
    "name": "targetChain_",
    "type": "uint8"
  }, {
    "components": [{
      "internalType": "address",
      "name": "collection",
      "type": "address"
    }, {
      "internalType": "uint256[]",
      "name": "tokenIds",
      "type": "uint256[]"
    }],
    "internalType": "struct IRouter.CollectionWithTokens[]",
    "name": "assets",
    "type": "tuple[]"
  }, {
    "internalType": "bytes",
    "name": "receiver_",
    "type": "bytes"
  }],
  "name": "egress",
  "outputs": [],
  "stateMutability": "payable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "bytes4",
    "name": "_functionSelector",
    "type": "bytes4"
  }],
  "name": "facetAddress",
  "outputs": [{
    "internalType": "address",
    "name": "facetAddress_",
    "type": "address"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [],
  "name": "facetAddresses",
  "outputs": [{
    "internalType": "address[]",
    "name": "facetAddresses_",
    "type": "address[]"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "_facet",
    "type": "address"
  }],
  "name": "facetFunctionSelectors",
  "outputs": [{
    "internalType": "bytes4[]",
    "name": "facetFunctionSelectors_",
    "type": "bytes4[]"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [],
  "name": "facets",
  "outputs": [{
    "components": [{
      "internalType": "address",
      "name": "facetAddress",
      "type": "address"
    }, {
      "internalType": "bytes4[]",
      "name": "functionSelectors",
      "type": "bytes4[]"
    }],
    "internalType": "struct IDiamondLoupe.Facet[]",
    "name": "facets_",
    "type": "tuple[]"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "bytes",
    "name": "data_",
    "type": "bytes"
  }],
  "name": "init",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "_member",
    "type": "address"
  }],
  "name": "isMember",
  "outputs": [{
    "internalType": "bool",
    "name": "",
    "type": "bool"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "uint256",
    "name": "_index",
    "type": "uint256"
  }],
  "name": "memberAt",
  "outputs": [{
    "internalType": "address",
    "name": "",
    "type": "address"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [],
  "name": "membersCount",
  "outputs": [{
    "internalType": "uint256",
    "name": "",
    "type": "uint256"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "uint8",
    "name": "_chainId",
    "type": "uint8"
  }, {
    "internalType": "bytes",
    "name": "_nativeCollection",
    "type": "bytes"
  }],
  "name": "nativeToWrappedCollection",
  "outputs": [{
    "internalType": "address",
    "name": "",
    "type": "address"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "uint8",
    "name": "_sourceChainId",
    "type": "uint8"
  }, {
    "internalType": "bytes",
    "name": "_transmissionSender",
    "type": "bytes"
  }, {
    "internalType": "bytes32",
    "name": "_dAppId",
    "type": "bytes32"
  }, {
    "internalType": "bytes",
    "name": "_payload",
    "type": "bytes"
  }],
  "name": "onTeleportMessage",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "collectionAddress_",
    "type": "address"
  }, {
    "internalType": "bytes[]",
    "name": "signatures_",
    "type": "bytes[]"
  }],
  "name": "pauseCollection",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [],
  "name": "serviceFee",
  "outputs": [{
    "internalType": "uint256",
    "name": "",
    "type": "uint256"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "components": [{
      "internalType": "uint8",
      "name": "chainId",
      "type": "uint8"
    }, {
      "internalType": "bytes",
      "name": "senderAddress",
      "type": "bytes"
    }],
    "internalType": "struct IUtility.TeleportSender[]",
    "name": "senders_",
    "type": "tuple[]"
  }, {
    "internalType": "bytes[]",
    "name": "signatures_",
    "type": "bytes[]"
  }],
  "name": "setTeleportSenders",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "uint8",
    "name": "nativeChainId_",
    "type": "uint8"
  }, {
    "internalType": "bytes",
    "name": "_nativeCollection",
    "type": "bytes"
  }, {
    "internalType": "address",
    "name": "wrappedCollection_",
    "type": "address"
  }, {
    "internalType": "bytes[]",
    "name": "signatures_",
    "type": "bytes[]"
  }],
  "name": "setWrappedCollection",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "collectionAddress_",
    "type": "address"
  }, {
    "internalType": "bytes[]",
    "name": "signatures_",
    "type": "bytes[]"
  }],
  "name": "unpauseCollection",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "wrappedCollection_",
    "type": "address"
  }, {
    "internalType": "bytes[]",
    "name": "signatures_",
    "type": "bytes[]"
  }],
  "name": "unsetWrappedCollection",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "_account",
    "type": "address"
  }, {
    "internalType": "bool",
    "name": "_status",
    "type": "bool"
  }, {
    "internalType": "bytes[]",
    "name": "_signatures",
    "type": "bytes[]"
  }],
  "name": "updateMember",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "_wrappedCollection",
    "type": "address"
  }],
  "name": "wrappedToNativeCollection",
  "outputs": [{
    "components": [{
      "internalType": "uint8",
      "name": "chainId",
      "type": "uint8"
    }, {
      "internalType": "bytes",
      "name": "contractAddress",
      "type": "bytes"
    }],
    "internalType": "struct LibRouter.NativeCollectionWithChainId",
    "name": "",
    "type": "tuple"
  }],
  "stateMutability": "view",
  "type": "function"
}];

var ERC20PermitAbi = [{
  "anonymous": false,
  "inputs": [{
    "indexed": true,
    "internalType": "address",
    "name": "owner",
    "type": "address"
  }, {
    "indexed": true,
    "internalType": "address",
    "name": "spender",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "uint256",
    "name": "value",
    "type": "uint256"
  }],
  "name": "Approval",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": true,
    "internalType": "address",
    "name": "from",
    "type": "address"
  }, {
    "indexed": true,
    "internalType": "address",
    "name": "to",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "uint256",
    "name": "value",
    "type": "uint256"
  }],
  "name": "Transfer",
  "type": "event"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "owner",
    "type": "address"
  }, {
    "internalType": "address",
    "name": "spender",
    "type": "address"
  }],
  "name": "allowance",
  "outputs": [{
    "internalType": "uint256",
    "name": "",
    "type": "uint256"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "spender",
    "type": "address"
  }, {
    "internalType": "uint256",
    "name": "amount",
    "type": "uint256"
  }],
  "name": "approve",
  "outputs": [{
    "internalType": "bool",
    "name": "",
    "type": "bool"
  }],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "account",
    "type": "address"
  }],
  "name": "balanceOf",
  "outputs": [{
    "internalType": "uint256",
    "name": "",
    "type": "uint256"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [],
  "name": "decimals",
  "outputs": [{
    "internalType": "uint8",
    "name": "",
    "type": "uint8"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "spender",
    "type": "address"
  }, {
    "internalType": "uint256",
    "name": "subtractedValue",
    "type": "uint256"
  }],
  "name": "decreaseAllowance",
  "outputs": [{
    "internalType": "bool",
    "name": "",
    "type": "bool"
  }],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "uint256",
    "name": "",
    "type": "uint256"
  }],
  "name": "domainSeparators",
  "outputs": [{
    "internalType": "bytes32",
    "name": "",
    "type": "bytes32"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "spender",
    "type": "address"
  }, {
    "internalType": "uint256",
    "name": "addedValue",
    "type": "uint256"
  }],
  "name": "increaseAllowance",
  "outputs": [{
    "internalType": "bool",
    "name": "",
    "type": "bool"
  }],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [],
  "name": "name",
  "outputs": [{
    "internalType": "string",
    "name": "",
    "type": "string"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "_owner",
    "type": "address"
  }],
  "name": "nonces",
  "outputs": [{
    "internalType": "uint256",
    "name": "",
    "type": "uint256"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "_owner",
    "type": "address"
  }, {
    "internalType": "address",
    "name": "_spender",
    "type": "address"
  }, {
    "internalType": "uint256",
    "name": "_amount",
    "type": "uint256"
  }, {
    "internalType": "uint256",
    "name": "_deadline",
    "type": "uint256"
  }, {
    "internalType": "uint8",
    "name": "_v",
    "type": "uint8"
  }, {
    "internalType": "bytes32",
    "name": "_r",
    "type": "bytes32"
  }, {
    "internalType": "bytes32",
    "name": "_s",
    "type": "bytes32"
  }],
  "name": "permit",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [],
  "name": "symbol",
  "outputs": [{
    "internalType": "string",
    "name": "",
    "type": "string"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [],
  "name": "totalSupply",
  "outputs": [{
    "internalType": "uint256",
    "name": "",
    "type": "uint256"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "to",
    "type": "address"
  }, {
    "internalType": "uint256",
    "name": "amount",
    "type": "uint256"
  }],
  "name": "transfer",
  "outputs": [{
    "internalType": "bool",
    "name": "",
    "type": "bool"
  }],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "from",
    "type": "address"
  }, {
    "internalType": "address",
    "name": "to",
    "type": "address"
  }, {
    "internalType": "uint256",
    "name": "amount",
    "type": "uint256"
  }],
  "name": "transferFrom",
  "outputs": [{
    "internalType": "bool",
    "name": "",
    "type": "bool"
  }],
  "stateMutability": "nonpayable",
  "type": "function"
}];

var ERC20RouterAbi = [{
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "address",
    "name": "albtToken",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "uint256",
    "name": "amount",
    "type": "uint256"
  }],
  "name": "AlbtFeeSet",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "uint8",
    "name": "targetChain",
    "type": "uint8"
  }, {
    "indexed": false,
    "internalType": "address",
    "name": "token",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "uint256",
    "name": "amount",
    "type": "uint256"
  }, {
    "indexed": false,
    "internalType": "bytes",
    "name": "receiver",
    "type": "bytes"
  }],
  "name": "BurnMint",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "uint8",
    "name": "targetChain",
    "type": "uint8"
  }, {
    "indexed": false,
    "internalType": "address",
    "name": "token",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "uint256",
    "name": "amount",
    "type": "uint256"
  }, {
    "indexed": false,
    "internalType": "bytes",
    "name": "receiver",
    "type": "bytes"
  }],
  "name": "BurnUnlock",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "bytes32",
    "name": "dappId_",
    "type": "bytes32"
  }],
  "name": "DappIdSet",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "address",
    "name": "deliveryAgent_",
    "type": "address"
  }],
  "name": "DeliveryAgentSet",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "address",
    "name": "user",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "address",
    "name": "agent",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "uint256",
    "name": "amount",
    "type": "uint256"
  }],
  "name": "DeliveryFeeCollected",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "components": [{
      "internalType": "address",
      "name": "facetAddress",
      "type": "address"
    }, {
      "internalType": "enum IDiamondCut.FacetCutAction",
      "name": "action",
      "type": "uint8"
    }, {
      "internalType": "bytes4[]",
      "name": "functionSelectors",
      "type": "bytes4[]"
    }],
    "indexed": false,
    "internalType": "struct IDiamondCut.FacetCut[]",
    "name": "_diamondCut",
    "type": "tuple[]"
  }, {
    "indexed": false,
    "internalType": "address",
    "name": "_init",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "bytes",
    "name": "_calldata",
    "type": "bytes"
  }],
  "name": "DiamondCut",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "address",
    "name": "feeTokenCollector_",
    "type": "address"
  }],
  "name": "FeeTokenCollectorSet",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "address",
    "name": "feeToken_",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "uint256",
    "name": "amount_",
    "type": "uint256"
  }],
  "name": "FeeTokenSet",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "address",
    "name": "feeToken",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "address",
    "name": "user",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "address",
    "name": "collector",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "uint256",
    "name": "amount",
    "type": "uint256"
  }],
  "name": "FeeTokensCollected",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "uint8",
    "name": "targetChain",
    "type": "uint8"
  }, {
    "indexed": false,
    "internalType": "address",
    "name": "token",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "uint256",
    "name": "amount",
    "type": "uint256"
  }, {
    "indexed": false,
    "internalType": "bytes",
    "name": "receiver",
    "type": "bytes"
  }],
  "name": "LockMint",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "address",
    "name": "member",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "bool",
    "name": "status",
    "type": "bool"
  }],
  "name": "MemberUpdated",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "address",
    "name": "token",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "uint256",
    "name": "amount",
    "type": "uint256"
  }, {
    "indexed": false,
    "internalType": "address",
    "name": "receiver",
    "type": "address"
  }],
  "name": "Mint",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "components": [{
      "internalType": "uint8",
      "name": "chainId",
      "type": "uint8"
    }, {
      "internalType": "bytes",
      "name": "senderAddress",
      "type": "bytes"
    }],
    "indexed": false,
    "internalType": "struct IUtility.TeleportSender[]",
    "name": "senders_",
    "type": "tuple[]"
  }],
  "name": "TeleportSenderSet",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "address",
    "name": "teleport",
    "type": "address"
  }],
  "name": "TeleportSet",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "address",
    "name": "account_",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "address",
    "name": "token_",
    "type": "address"
  }],
  "name": "TokenPaused",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "address",
    "name": "account_",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "address",
    "name": "token_",
    "type": "address"
  }],
  "name": "TokenUnpaused",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "address",
    "name": "token",
    "type": "address"
  }, {
    "indexed": false,
    "internalType": "uint256",
    "name": "amount",
    "type": "uint256"
  }, {
    "indexed": false,
    "internalType": "address",
    "name": "receiver",
    "type": "address"
  }],
  "name": "Unlock",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "uint8",
    "name": "sourceChain",
    "type": "uint8"
  }, {
    "indexed": false,
    "internalType": "bytes",
    "name": "nativeToken",
    "type": "bytes"
  }, {
    "indexed": false,
    "internalType": "address",
    "name": "wrappedToken",
    "type": "address"
  }],
  "name": "WrappedTokenDeployed",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "uint8",
    "name": "nativeChainId_",
    "type": "uint8"
  }, {
    "indexed": false,
    "internalType": "bytes",
    "name": "_nativeToken",
    "type": "bytes"
  }, {
    "indexed": false,
    "internalType": "address",
    "name": "wrappedToken_",
    "type": "address"
  }],
  "name": "WrappedTokenSet",
  "type": "event"
}, {
  "anonymous": false,
  "inputs": [{
    "indexed": false,
    "internalType": "address",
    "name": "wrappedToken_",
    "type": "address"
  }],
  "name": "WrappedTokenUnset",
  "type": "event"
}, {
  "inputs": [],
  "name": "administrativeNonce",
  "outputs": [{
    "internalType": "uint256",
    "name": "",
    "type": "uint256"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [],
  "name": "albtToken",
  "outputs": [{
    "internalType": "address",
    "name": "",
    "type": "address"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [],
  "name": "dappId",
  "outputs": [{
    "internalType": "bytes32",
    "name": "",
    "type": "bytes32"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [],
  "name": "deliveryAgent",
  "outputs": [{
    "internalType": "address",
    "name": "",
    "type": "address"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "sender_",
    "type": "address"
  }],
  "name": "deliveryFeeNonce",
  "outputs": [{
    "internalType": "uint256",
    "name": "",
    "type": "uint256"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "components": [{
      "internalType": "address",
      "name": "facetAddress",
      "type": "address"
    }, {
      "internalType": "enum IDiamondCut.FacetCutAction",
      "name": "action",
      "type": "uint8"
    }, {
      "internalType": "bytes4[]",
      "name": "functionSelectors",
      "type": "bytes4[]"
    }],
    "internalType": "struct IDiamondCut.FacetCut[]",
    "name": "_diamondCut",
    "type": "tuple[]"
  }, {
    "internalType": "address",
    "name": "_init",
    "type": "address"
  }, {
    "internalType": "bytes",
    "name": "_calldata",
    "type": "bytes"
  }, {
    "internalType": "bytes[]",
    "name": "_signatures",
    "type": "bytes[]"
  }],
  "name": "diamondCut",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "uint8",
    "name": "targetChain_",
    "type": "uint8"
  }, {
    "internalType": "address",
    "name": "feeToken_",
    "type": "address"
  }, {
    "internalType": "address",
    "name": "token_",
    "type": "address"
  }, {
    "internalType": "uint256",
    "name": "amount_",
    "type": "uint256"
  }, {
    "internalType": "bytes",
    "name": "receiver_",
    "type": "bytes"
  }, {
    "components": [{
      "internalType": "uint256",
      "name": "fee",
      "type": "uint256"
    }, {
      "internalType": "uint256",
      "name": "expiry",
      "type": "uint256"
    }, {
      "internalType": "bytes",
      "name": "signature",
      "type": "bytes"
    }],
    "internalType": "struct IRouter.DeliveryFeeData",
    "name": "deliveryFeeData_",
    "type": "tuple"
  }],
  "name": "egress",
  "outputs": [],
  "stateMutability": "payable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "uint8",
    "name": "targetChain_",
    "type": "uint8"
  }, {
    "internalType": "address",
    "name": "feeToken_",
    "type": "address"
  }, {
    "internalType": "address",
    "name": "token_",
    "type": "address"
  }, {
    "internalType": "uint256",
    "name": "amount_",
    "type": "uint256"
  }, {
    "internalType": "bytes",
    "name": "receiver_",
    "type": "bytes"
  }, {
    "components": [{
      "internalType": "uint256",
      "name": "fee",
      "type": "uint256"
    }, {
      "internalType": "uint256",
      "name": "expiry",
      "type": "uint256"
    }, {
      "internalType": "bytes",
      "name": "signature",
      "type": "bytes"
    }],
    "internalType": "struct IRouter.DeliveryFeeData",
    "name": "deliveryFeeData_",
    "type": "tuple"
  }, {
    "internalType": "uint256",
    "name": "_deadline",
    "type": "uint256"
  }, {
    "internalType": "uint8",
    "name": "_v",
    "type": "uint8"
  }, {
    "internalType": "bytes32",
    "name": "_r",
    "type": "bytes32"
  }, {
    "internalType": "bytes32",
    "name": "_s",
    "type": "bytes32"
  }],
  "name": "egressWithPermit",
  "outputs": [],
  "stateMutability": "payable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "bytes4",
    "name": "_functionSelector",
    "type": "bytes4"
  }],
  "name": "facetAddress",
  "outputs": [{
    "internalType": "address",
    "name": "facetAddress_",
    "type": "address"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [],
  "name": "facetAddresses",
  "outputs": [{
    "internalType": "address[]",
    "name": "facetAddresses_",
    "type": "address[]"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "_facet",
    "type": "address"
  }],
  "name": "facetFunctionSelectors",
  "outputs": [{
    "internalType": "bytes4[]",
    "name": "facetFunctionSelectors_",
    "type": "bytes4[]"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [],
  "name": "facets",
  "outputs": [{
    "components": [{
      "internalType": "address",
      "name": "facetAddress",
      "type": "address"
    }, {
      "internalType": "bytes4[]",
      "name": "functionSelectors",
      "type": "bytes4[]"
    }],
    "internalType": "struct IDiamondLoupe.Facet[]",
    "name": "facets_",
    "type": "tuple[]"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "feeToken_",
    "type": "address"
  }],
  "name": "feeAmountByToken",
  "outputs": [{
    "internalType": "uint256",
    "name": "",
    "type": "uint256"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [],
  "name": "feeTokenCollector",
  "outputs": [{
    "internalType": "address",
    "name": "",
    "type": "address"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [],
  "name": "feeTokens",
  "outputs": [{
    "internalType": "address[]",
    "name": "",
    "type": "address[]"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "_member",
    "type": "address"
  }],
  "name": "isMember",
  "outputs": [{
    "internalType": "bool",
    "name": "",
    "type": "bool"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "uint256",
    "name": "_index",
    "type": "uint256"
  }],
  "name": "memberAt",
  "outputs": [{
    "internalType": "address",
    "name": "",
    "type": "address"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [],
  "name": "membersCount",
  "outputs": [{
    "internalType": "uint256",
    "name": "",
    "type": "uint256"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "uint8",
    "name": "chainId_",
    "type": "uint8"
  }, {
    "internalType": "bytes",
    "name": "nativeToken_",
    "type": "bytes"
  }],
  "name": "nativeToWrappedToken",
  "outputs": [{
    "internalType": "address",
    "name": "",
    "type": "address"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "uint8",
    "name": "_sourceChainId",
    "type": "uint8"
  }, {
    "internalType": "bytes",
    "name": "_transmissionSender",
    "type": "bytes"
  }, {
    "internalType": "bytes32",
    "name": "_dAppId",
    "type": "bytes32"
  }, {
    "internalType": "bytes",
    "name": "_payload",
    "type": "bytes"
  }],
  "name": "onTeleportMessage",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "tokenAddress_",
    "type": "address"
  }, {
    "internalType": "bytes[]",
    "name": "signatures_",
    "type": "bytes[]"
  }],
  "name": "pauseToken",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [],
  "name": "serviceFee",
  "outputs": [{
    "internalType": "uint256",
    "name": "",
    "type": "uint256"
  }],
  "stateMutability": "view",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "bytes32",
    "name": "dappId_",
    "type": "bytes32"
  }, {
    "internalType": "bytes[]",
    "name": "signatures_",
    "type": "bytes[]"
  }],
  "name": "setDappId",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "deliveryAgent_",
    "type": "address"
  }, {
    "internalType": "bytes[]",
    "name": "signatures_",
    "type": "bytes[]"
  }],
  "name": "setDeliveryAgent",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "feeToken_",
    "type": "address"
  }, {
    "internalType": "uint256",
    "name": "amount_",
    "type": "uint256"
  }, {
    "internalType": "bytes[]",
    "name": "signatures_",
    "type": "bytes[]"
  }],
  "name": "setFeeToken",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "feeTokenCollector_",
    "type": "address"
  }, {
    "internalType": "bytes[]",
    "name": "signatures_",
    "type": "bytes[]"
  }],
  "name": "setFeeTokenCollector",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "components": [{
      "internalType": "uint8",
      "name": "chainId",
      "type": "uint8"
    }, {
      "internalType": "bytes",
      "name": "senderAddress",
      "type": "bytes"
    }],
    "internalType": "struct IUtility.TeleportSender[]",
    "name": "senders_",
    "type": "tuple[]"
  }, {
    "internalType": "bytes[]",
    "name": "signatures_",
    "type": "bytes[]"
  }],
  "name": "setTeleportSenders",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "uint8",
    "name": "nativeChainId_",
    "type": "uint8"
  }, {
    "internalType": "bytes",
    "name": "_nativeToken",
    "type": "bytes"
  }, {
    "internalType": "address",
    "name": "wrappedToken_",
    "type": "address"
  }, {
    "internalType": "bytes[]",
    "name": "signatures_",
    "type": "bytes[]"
  }],
  "name": "setWrappedToken",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "tokenAddress_",
    "type": "address"
  }, {
    "internalType": "bytes[]",
    "name": "signatures_",
    "type": "bytes[]"
  }],
  "name": "unpauseToken",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "wrappedToken_",
    "type": "address"
  }, {
    "internalType": "bytes[]",
    "name": "signatures_",
    "type": "bytes[]"
  }],
  "name": "unsetWrappedToken",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "_account",
    "type": "address"
  }, {
    "internalType": "bool",
    "name": "_status",
    "type": "bool"
  }, {
    "internalType": "bytes[]",
    "name": "_signatures",
    "type": "bytes[]"
  }],
  "name": "updateMember",
  "outputs": [],
  "stateMutability": "nonpayable",
  "type": "function"
}, {
  "inputs": [{
    "internalType": "address",
    "name": "wrappedToken_",
    "type": "address"
  }],
  "name": "wrappedToNativeToken",
  "outputs": [{
    "components": [{
      "internalType": "uint8",
      "name": "chainId",
      "type": "uint8"
    }, {
      "internalType": "bytes",
      "name": "contractAddress",
      "type": "bytes"
    }],
    "internalType": "struct LibRouter.NativeTokenWithChainId",
    "name": "",
    "type": "tuple"
  }],
  "stateMutability": "view",
  "type": "function"
}];

var abridge_messaging_protocol_contracts_solana = {
  "version": "0.1.10",
  "name": "abridge_messaging_protocol_contracts_solana",
  "instructions": [{
    "name": "updateMember",
    "accounts": [{
      "name": "teleportStorage",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "governanceStorage",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "payer",
      "isMut": true,
      "isSigner": true
    }],
    "args": [{
      "name": "params",
      "type": {
        "defined": "UpdateMemberParams"
      }
    }]
  }, {
    "name": "setServiceFee",
    "accounts": [{
      "name": "feeCalculatorStorage",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "teleportStorage",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "governanceStorage",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "payer",
      "isMut": true,
      "isSigner": true
    }],
    "args": [{
      "name": "params",
      "type": {
        "defined": "SetServiceFeeParams"
      }
    }]
  }, {
    "name": "claim",
    "accounts": [{
      "name": "feeCalculatorStorage",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "teleportStorage",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "governanceStorage",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "claimedRewards",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "feeCollector",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "receiver",
      "isMut": true,
      "isSigner": true
    }, {
      "name": "systemProgram",
      "isMut": false,
      "isSigner": false
    }],
    "args": [{
      "name": "params",
      "type": {
        "defined": "ClaimParams"
      }
    }]
  }, {
    "name": "initValidatorClaimAccount",
    "accounts": [{
      "name": "governanceStorage",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "claimedRewards",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "payer",
      "isMut": true,
      "isSigner": true
    }, {
      "name": "systemProgram",
      "isMut": false,
      "isSigner": false
    }],
    "args": [{
      "name": "params",
      "type": {
        "defined": "InitValidatorClaimAccountParams"
      }
    }]
  }, {
    "name": "initialize",
    "accounts": [{
      "name": "feeCalculatorStorage",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "teleportStorage",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "governanceStorage",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "feeCollector",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "initializer",
      "isMut": true,
      "isSigner": true
    }, {
      "name": "systemProgram",
      "isMut": false,
      "isSigner": false
    }],
    "args": [{
      "name": "params",
      "type": {
        "defined": "InitializeParams"
      }
    }]
  }, {
    "name": "transmit",
    "accounts": [{
      "name": "feeCalculatorStorage",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "feeCollector",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "payloadAccount",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "caller",
      "isMut": true,
      "isSigner": true
    }, {
      "name": "systemProgram",
      "isMut": false,
      "isSigner": false
    }],
    "args": [{
      "name": "targetChainId",
      "type": "u8"
    }, {
      "name": "dappId",
      "type": {
        "array": ["u8", 32]
      }
    }, {
      "name": "transmissionReceiver",
      "type": "bytes"
    }]
  }, {
    "name": "initPayloadAccount",
    "accounts": [{
      "name": "payloadAccount",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "initializer",
      "isMut": true,
      "isSigner": true
    }, {
      "name": "systemProgram",
      "isMut": false,
      "isSigner": false
    }],
    "args": [{
      "name": "params",
      "type": {
        "defined": "InitPayloadAccountParams"
      }
    }]
  }, {
    "name": "addPayloadPart",
    "accounts": [{
      "name": "payloadAccount",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "initializer",
      "isMut": true,
      "isSigner": true
    }, {
      "name": "systemProgram",
      "isMut": false,
      "isSigner": false
    }],
    "args": [{
      "name": "params",
      "type": {
        "defined": "AddPayloadPartParams"
      }
    }]
  }, {
    "name": "closePayload",
    "accounts": [{
      "name": "payloadAccount",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "user",
      "isMut": true,
      "isSigner": true
    }, {
      "name": "systemProgram",
      "isMut": false,
      "isSigner": false
    }],
    "args": [{
      "name": "transmissionId",
      "type": {
        "array": ["u8", 32]
      }
    }]
  }, {
    "name": "deliver",
    "accounts": [{
      "name": "governanceStorage",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "teleportStorage",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "deliveredTransmission",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "payloadAccount",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "user",
      "isMut": true,
      "isSigner": true
    }, {
      "name": "systemProgram",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "instructionSysvarAccount",
      "isMut": false,
      "isSigner": false
    }],
    "args": [{
      "name": "transmissionId",
      "type": {
        "array": ["u8", 32]
      }
    }, {
      "name": "params",
      "type": {
        "defined": "DeliverParams"
      }
    }]
  }],
  "accounts": [{
    "name": "ClaimedRewards",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "amountClaimed",
        "type": "u64"
      }, {
        "name": "bump",
        "type": "u8"
      }, {
        "name": "validatorEvmAddress",
        "type": {
          "array": ["u8", 20]
        }
      }]
    }
  }, {
    "name": "DeliveredTransmission",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "bump",
        "type": "u8"
      }, {
        "name": "alreadyDelivered",
        "type": "bool"
      }]
    }
  }, {
    "name": "TransmitPayloadAccount",
    "docs": ["This account needs to be initializated and filled by the dapp sending the payload"],
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "bump",
        "type": "u8"
      }, {
        "name": "payloadLength",
        "type": "u32"
      }, {
        "name": "payload",
        "type": {
          "array": ["u8", 3000]
        }
      }]
    }
  }, {
    "name": "PayloadAccount",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "bump",
        "type": "u8"
      }, {
        "name": "payload",
        "type": "bytes"
      }]
    }
  }, {
    "name": "FeeCollector",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "bump",
        "type": "u8"
      }]
    }
  }, {
    "name": "TeleportStorage",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "chainId",
        "type": "u8"
      }, {
        "name": "bump",
        "type": "u8"
      }]
    }
  }, {
    "name": "CalculatorStorage",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "serviceFee",
        "type": "u64"
      }, {
        "name": "feesAccrued",
        "type": "u64"
      }, {
        "name": "previousAccrued",
        "type": "u64"
      }, {
        "name": "accumulator",
        "type": "u64"
      }, {
        "name": "bump",
        "type": "u8"
      }]
    }
  }, {
    "name": "GovernanceStorage",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "administrativeNonce",
        "type": "u128"
      }, {
        "name": "membersSet",
        "type": {
          "vec": {
            "array": ["u8", 64]
          }
        }
      }, {
        "name": "bump",
        "type": "u8"
      }]
    }
  }],
  "types": [{
    "name": "ClaimParams",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "signature",
        "type": {
          "array": ["u8", 65]
        }
      }]
    }
  }, {
    "name": "InitValidatorClaimAccountParams",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "validatorEvmAddress",
        "type": "string"
      }]
    }
  }, {
    "name": "SetServiceFeeParams",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "newServiceFee",
        "type": "u64"
      }, {
        "name": "signatures",
        "type": {
          "vec": {
            "array": ["u8", 65]
          }
        }
      }]
    }
  }, {
    "name": "UpdateMemberParams",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "memberPublicKey",
        "type": "bytes"
      }, {
        "name": "status",
        "type": "bool"
      }, {
        "name": "signatures",
        "type": {
          "vec": {
            "array": ["u8", 65]
          }
        }
      }]
    }
  }, {
    "name": "InitializeParams",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "serviceFee",
        "type": "u64"
      }, {
        "name": "members",
        "type": {
          "vec": {
            "array": ["u8", 64]
          }
        }
      }, {
        "name": "chainId",
        "type": "u8"
      }]
    }
  }, {
    "name": "DeliverParams",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "sourceChainId",
        "type": "u8"
      }, {
        "name": "transmissionSender",
        "type": "bytes"
      }, {
        "name": "transmissionReceiver",
        "type": "bytes"
      }, {
        "name": "dAppId",
        "type": {
          "array": ["u8", 32]
        }
      }, {
        "name": "signatures",
        "type": {
          "vec": {
            "array": ["u8", 65]
          }
        }
      }]
    }
  }, {
    "name": "InitPayloadAccountParams",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "payloadLength",
        "type": "u32"
      }, {
        "name": "transmissionId",
        "type": {
          "array": ["u8", 32]
        }
      }]
    }
  }, {
    "name": "AddPayloadPartParams",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "transmissionId",
        "type": {
          "array": ["u8", 32]
        }
      }, {
        "name": "payloadPart",
        "type": "bytes"
      }, {
        "name": "partInitialIndex",
        "type": "u32"
      }]
    }
  }, {
    "name": "GovernanceErrors",
    "type": {
      "kind": "enum",
      "variants": [{
        "name": "SigVerificationFailed"
      }, {
        "name": "InvalidSignatureAmmount"
      }, {
        "name": "DuplicateSignature"
      }, {
        "name": "InvalidMemberPublicKey"
      }, {
        "name": "MemberAlreadyAdded"
      }, {
        "name": "MemberNonExistant"
      }, {
        "name": "MemberlessResult"
      }, {
        "name": "NothingToClaim"
      }, {
        "name": "InvalidClaimRewardsAccount"
      }]
    }
  }, {
    "name": "DeliverErrors",
    "type": {
      "kind": "enum",
      "variants": [{
        "name": "InvalidDappReceiver"
      }, {
        "name": "DuplicateSignature"
      }, {
        "name": "InvalidDappProgram"
      }, {
        "name": "InvalidDappMethod"
      }, {
        "name": "MissingDappCall"
      }]
    }
  }, {
    "name": "PayloadAccountGenerationErrors",
    "type": {
      "kind": "enum",
      "variants": [{
        "name": "MoreSpaceThanDeclared"
      }]
    }
  }],
  "events": [{
    "name": "Claim",
    "fields": [{
      "name": "member",
      "type": "string",
      "index": false
    }, {
      "name": "claimAmount",
      "type": "u64",
      "index": false
    }, {
      "name": "receiver",
      "type": "publicKey",
      "index": false
    }]
  }, {
    "name": "ServiceFeeSet",
    "fields": [{
      "name": "payer",
      "type": "publicKey",
      "index": false
    }, {
      "name": "newServiceFee",
      "type": "u64",
      "index": false
    }]
  }, {
    "name": "MemberUpdated",
    "fields": [{
      "name": "memberPublicKey",
      "type": "bytes",
      "index": false
    }, {
      "name": "status",
      "type": "bool",
      "index": false
    }]
  }, {
    "name": "Transmission",
    "fields": [{
      "name": "targetChainId",
      "type": "u8",
      "index": false
    }, {
      "name": "transmissionSender",
      "type": "bytes",
      "index": false
    }, {
      "name": "transmissionReceiver",
      "type": "bytes",
      "index": false
    }, {
      "name": "dappId",
      "type": {
        "array": ["u8", 32]
      },
      "index": false
    }, {
      "name": "payload",
      "type": "bytes",
      "index": false
    }]
  }, {
    "name": "Delivery",
    "fields": [{
      "name": "transmissionId",
      "type": {
        "array": ["u8", 32]
      },
      "index": false
    }]
  }, {
    "name": "TransmissionFees",
    "fields": [{
      "name": "serviceFee",
      "type": "u64",
      "index": false
    }]
  }],
  "errors": [{
    "code": 6000,
    "name": "FeeInsufficientAmount",
    "msg": "FeeCalculator: insufficient fee amount"
  }, {
    "code": 6001,
    "name": "InvalidDappCaller",
    "msg": "Transmit: transmit must be called from main dapp program pda"
  }],
  "metadata": {
    "address": "3Hxtb9zUfSbg6tvc426ynAkbVtNewEc3pkrC4vyqbC94"
  }
};

var abridge_erc20_solana = {
  "version": "0.1.11",
  "name": "abridge_erc20_solana",
  "instructions": [{
    "name": "initialize",
    "accounts": [{
      "name": "routerStorage",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "governanceStorage",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "routerVault",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "routerSigningPda",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "initializer",
      "isMut": true,
      "isSigner": true
    }, {
      "name": "systemProgram",
      "isMut": false,
      "isSigner": false
    }],
    "args": [{
      "name": "params",
      "type": {
        "defined": "InitializeParams"
      }
    }]
  }, {
    "name": "updateMember",
    "accounts": [{
      "name": "routerStorage",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "governanceStorage",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "payer",
      "isMut": true,
      "isSigner": true
    }],
    "args": [{
      "name": "params",
      "type": {
        "defined": "UpdateMemberParams"
      }
    }]
  }, {
    "name": "onTeleportMessageNativeUnlock",
    "accounts": [{
      "name": "routerStorage",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "routerVault",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "sourceChainInfo",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "payloadAccount",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "user",
      "isMut": true,
      "isSigner": true
    }, {
      "name": "receiver",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "instructionSysvarAccount",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "systemProgram",
      "isMut": false,
      "isSigner": false
    }],
    "args": [{
      "name": "params",
      "type": {
        "defined": "NativeUnlockParams"
      }
    }]
  }, {
    "name": "onTeleportMessageTokenUnlock",
    "accounts": [{
      "name": "routerStorage",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "routerTokenBag",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "receiverTokenBag",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "tokenMint",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "sourceChainInfo",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "payloadAccount",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "user",
      "isMut": true,
      "isSigner": true
    }, {
      "name": "receiver",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "instructionSysvarAccount",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "tokenProgram",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "systemProgram",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "rent",
      "isMut": false,
      "isSigner": false
    }],
    "args": [{
      "name": "params",
      "type": {
        "defined": "TokenUnlockParams"
      }
    }]
  }, {
    "name": "onTeleportMessageTokenMint",
    "accounts": [{
      "name": "routerStorage",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "routerVault",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "sourceChainInfo",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "tokenMint",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "metadata",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "chainCurrencyInfo",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "payloadAccount",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "user",
      "isMut": true,
      "isSigner": true
    }, {
      "name": "receiverTokenBag",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "instructionSysvarAccount",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "systemProgram",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "tokenProgram",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "tokenMetadataProgram",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "associatedTokenProgram",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "rent",
      "isMut": false,
      "isSigner": false
    }],
    "args": [{
      "name": "params",
      "type": {
        "defined": "OnTeleportMessageTokenMintParams"
      }
    }]
  }, {
    "name": "setTeleportSender",
    "accounts": [{
      "name": "governanceStorage",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "routerStorage",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "sourceChainInfo",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "initializer",
      "isMut": true,
      "isSigner": true
    }, {
      "name": "systemProgram",
      "isMut": false,
      "isSigner": false
    }],
    "args": [{
      "name": "params",
      "type": {
        "defined": "SetTeleportSenderParams"
      }
    }]
  }, {
    "name": "createWrappedMint",
    "accounts": [{
      "name": "routerStorage",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "routerVault",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "tokenMint",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "user",
      "isMut": true,
      "isSigner": true
    }, {
      "name": "systemProgram",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "tokenProgram",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "rent",
      "isMut": false,
      "isSigner": false
    }],
    "args": [{
      "name": "tokenDecimals",
      "type": "u8"
    }, {
      "name": "nativeTokenAddress",
      "type": "bytes"
    }, {
      "name": "chainId",
      "type": "u8"
    }]
  }, {
    "name": "egressNativeCoin",
    "accounts": [{
      "name": "routerStorage",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "targetChainInfo",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "routerVault",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "payloadPda",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "teleportFeeCalculatorStorage",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "routerSigningPda",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "teleportFeeCollector",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "teleportProgram",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "systemProgram",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "caller",
      "isMut": true,
      "isSigner": true
    }],
    "args": [{
      "name": "params",
      "type": {
        "defined": "EgressNativeCoinParams"
      }
    }]
  }, {
    "name": "egressNativeToken",
    "accounts": [{
      "name": "routerStorage",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "targetChainInfo",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "routerVault",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "payloadPda",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "teleportFeeCalculatorStorage",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "routerSigningPda",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "teleportFeeCollector",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "teleportProgram",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "systemProgram",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "caller",
      "isMut": true,
      "isSigner": true
    }, {
      "name": "tokenMint",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "userTokenBag",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "routerVaultTokenBag",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "tokenMetadata",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "tokenProgram",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "rent",
      "isMut": false,
      "isSigner": false
    }],
    "args": [{
      "name": "params",
      "type": {
        "defined": "EgressNativeTokenParams"
      }
    }]
  }, {
    "name": "egressNonNative",
    "accounts": [{
      "name": "routerStorage",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "targetChainInfo",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "routerVault",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "payloadPda",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "chainCurrencyInfo",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "teleportFeeCalculatorStorage",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "routerSigningPda",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "teleportFeeCollector",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "teleportProgram",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "systemProgram",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "caller",
      "isMut": true,
      "isSigner": true
    }, {
      "name": "tokenMint",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "userTokenBag",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "tokenProgram",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "rent",
      "isMut": false,
      "isSigner": false
    }],
    "args": [{
      "name": "params",
      "type": {
        "defined": "EgressNonNativeParams"
      }
    }]
  }, {
    "name": "initPayloadAccount",
    "accounts": [{
      "name": "payloadPda",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "caller",
      "isMut": true,
      "isSigner": true
    }, {
      "name": "systemProgram",
      "isMut": false,
      "isSigner": false
    }],
    "args": []
  }, {
    "name": "initRouterVaultTokenBag",
    "accounts": [{
      "name": "routerVaultTokenBag",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "tokenMint",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "initializer",
      "isMut": true,
      "isSigner": true
    }, {
      "name": "systemProgram",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "tokenProgram",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "rent",
      "isMut": false,
      "isSigner": false
    }],
    "args": []
  }],
  "accounts": [{
    "name": "ChainInfo",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "bridgeAddress",
        "type": "bytes"
      }, {
        "name": "bump",
        "type": "u8"
      }]
    }
  }, {
    "name": "CurrencyInfoWithChain",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "bump",
        "type": "u8"
      }, {
        "name": "nativeAddress",
        "type": "bytes"
      }, {
        "name": "nativeChainId",
        "type": "u8"
      }, {
        "name": "currencyInfo",
        "type": {
          "defined": "CurrencyInfo"
        }
      }]
    }
  }, {
    "name": "TransmitPayloadAccount",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "bump",
        "type": "u8"
      }, {
        "name": "payloadLength",
        "type": "u32"
      }, {
        "name": "payload",
        "type": {
          "array": ["u8", 3000]
        }
      }]
    }
  }, {
    "name": "GovernanceStorage",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "administrativeNonce",
        "type": "u128"
      }, {
        "name": "membersSet",
        "type": {
          "vec": {
            "array": ["u8", 64]
          }
        }
      }, {
        "name": "bump",
        "type": "u8"
      }]
    }
  }, {
    "name": "RouterStorage",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "nativeCurrency",
        "type": {
          "defined": "CurrencyInfo"
        }
      }, {
        "name": "chainId",
        "type": "u8"
      }, {
        "name": "albtToken",
        "type": "publicKey"
      }, {
        "name": "teleport",
        "type": "publicKey"
      }, {
        "name": "deliveryAgent",
        "type": "publicKey"
      }, {
        "name": "feeTokenCollector",
        "type": "publicKey"
      }, {
        "name": "dAppId",
        "type": {
          "array": ["u8", 32]
        }
      }, {
        "name": "deliveryFee",
        "type": "u64"
      }, {
        "name": "bump",
        "type": "u8"
      }, {
        "name": "routerSigningPdaBump",
        "type": "u8"
      }, {
        "name": "routerVaultPdaBump",
        "type": "u8"
      }]
    }
  }],
  "types": [{
    "name": "EgressNativeCoinParams",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "targetChainId",
        "type": "u8"
      }, {
        "name": "amount",
        "type": "u64"
      }, {
        "name": "receiver",
        "type": "bytes"
      }]
    }
  }, {
    "name": "EgressNativeTokenParams",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "targetChainId",
        "type": "u8"
      }, {
        "name": "amount",
        "type": "u64"
      }, {
        "name": "receiver",
        "type": "bytes"
      }]
    }
  }, {
    "name": "EgressNonNativeParams",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "targetChainId",
        "type": "u8"
      }, {
        "name": "amount",
        "type": "u64"
      }, {
        "name": "receiver",
        "type": "bytes"
      }]
    }
  }, {
    "name": "InitializeParams",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "serviceFee",
        "type": "u64"
      }, {
        "name": "members",
        "type": {
          "vec": {
            "array": ["u8", 64]
          }
        }
      }, {
        "name": "chainId",
        "type": "u8"
      }, {
        "name": "teleportAddress",
        "type": "publicKey"
      }, {
        "name": "dAppId",
        "type": {
          "array": ["u8", 32]
        }
      }]
    }
  }, {
    "name": "NativeUnlockParams",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "sourceChainId",
        "type": "u8"
      }, {
        "name": "routerVaultBump",
        "type": "u8"
      }]
    }
  }, {
    "name": "OnTeleportMessageTokenMintParams",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "sourceChainId",
        "type": "u8"
      }, {
        "name": "routerVaultBump",
        "type": "u8"
      }, {
        "name": "tokenDecimals",
        "type": "u8"
      }, {
        "name": "nativeTokenAddress",
        "type": "bytes"
      }, {
        "name": "tokenNativeChainId",
        "type": "u8"
      }]
    }
  }, {
    "name": "TokenUnlockParams",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "sourceChainId",
        "type": "u8"
      }, {
        "name": "routerTokenBagBump",
        "type": "u8"
      }]
    }
  }, {
    "name": "SetTeleportSenderParams",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "chainId",
        "type": "u8"
      }, {
        "name": "senderAddress",
        "type": "bytes"
      }, {
        "name": "signatures",
        "type": {
          "vec": {
            "array": ["u8", 65]
          }
        }
      }]
    }
  }, {
    "name": "UpdateMemberParams",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "memberPublicKey",
        "type": "bytes"
      }, {
        "name": "status",
        "type": "bool"
      }, {
        "name": "signatures",
        "type": {
          "vec": {
            "array": ["u8", 65]
          }
        }
      }]
    }
  }, {
    "name": "CurrencyInfo",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "name",
        "type": "string"
      }, {
        "name": "symbol",
        "type": "string"
      }, {
        "name": "decimals",
        "type": "u8"
      }]
    }
  }, {
    "name": "TeleportDeliverInstructionData",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "opCode",
        "type": {
          "array": ["u8", 8]
        }
      }, {
        "name": "transmissionId",
        "type": {
          "array": ["u8", 32]
        }
      }, {
        "name": "params",
        "type": {
          "defined": "TeleportDeliverParams"
        }
      }]
    }
  }, {
    "name": "TeleportDeliverParams",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "sourceChainId",
        "type": "u8"
      }, {
        "name": "transmissionSender",
        "type": "bytes"
      }, {
        "name": "transmissionReceiver",
        "type": "bytes"
      }, {
        "name": "dAppId",
        "type": {
          "array": ["u8", 32]
        }
      }, {
        "name": "signatures",
        "type": {
          "vec": {
            "array": ["u8", 65]
          }
        }
      }]
    }
  }, {
    "name": "EgressErrors",
    "type": {
      "kind": "enum",
      "variants": [{
        "name": "InsufficientValue"
      }, {
        "name": "UnknownDestination"
      }, {
        "name": "SignatureExpired"
      }, {
        "name": "InvalidDeliveryFeeSigner"
      }, {
        "name": "InvalidNativeChainId"
      }, {
        "name": "ErrorWhileGeneratingPayload"
      }, {
        "name": "WrongTokenMetadata"
      }, {
        "name": "InvalidTargetChain"
      }]
    }
  }, {
    "name": "GovernanceErrors",
    "type": {
      "kind": "enum",
      "variants": [{
        "name": "SigVerificationFailed"
      }, {
        "name": "InvalidSignatureAmmount"
      }, {
        "name": "DuplicateSignature"
      }, {
        "name": "InvalidMemberPublicKey"
      }, {
        "name": "MemberAlreadyAdded"
      }, {
        "name": "MemberNonExistant"
      }, {
        "name": "MemberlessResult"
      }]
    }
  }, {
    "name": "TargetAction",
    "type": {
      "kind": "enum",
      "variants": [{
        "name": "Unlock"
      }, {
        "name": "Mint"
      }]
    }
  }],
  "events": [{
    "name": "LockMint",
    "fields": [{
      "name": "targetChainId",
      "type": "u8",
      "index": false
    }, {
      "name": "token",
      "type": "publicKey",
      "index": false
    }, {
      "name": "amount",
      "type": "u64",
      "index": false
    }, {
      "name": "receiver",
      "type": "bytes",
      "index": false
    }]
  }, {
    "name": "BurnUnlock",
    "fields": [{
      "name": "targetChainId",
      "type": "u8",
      "index": false
    }, {
      "name": "token",
      "type": "publicKey",
      "index": false
    }, {
      "name": "amount",
      "type": "u64",
      "index": false
    }, {
      "name": "receiver",
      "type": "bytes",
      "index": false
    }]
  }, {
    "name": "BurnMint",
    "fields": [{
      "name": "targetChainId",
      "type": "u8",
      "index": false
    }, {
      "name": "token",
      "type": "publicKey",
      "index": false
    }, {
      "name": "amount",
      "type": "u64",
      "index": false
    }, {
      "name": "receiver",
      "type": "bytes",
      "index": false
    }]
  }, {
    "name": "MemberUpdated",
    "fields": [{
      "name": "memberPublicKey",
      "type": "bytes",
      "index": false
    }, {
      "name": "status",
      "type": "bool",
      "index": false
    }]
  }],
  "errors": [{
    "code": 6000,
    "name": "IncorrectTeleport",
    "msg": "Router: Incorrect teleport program provided"
  }, {
    "code": 6001,
    "name": "MissingTeleportCall",
    "msg": "Router: Missing teleport call"
  }, {
    "code": 6002,
    "name": "InvalidTeleportMethod",
    "msg": "Router: Invalid teleport method call"
  }, {
    "code": 6003,
    "name": "InvalidTeleportParams",
    "msg": "Router: Invalid teleport method call params"
  }, {
    "code": 6004,
    "name": "InvalidDappId",
    "msg": "Router: Unknown dAppId"
  }, {
    "code": 6005,
    "name": "InvalidSender",
    "msg": "Router: Unknown sender"
  }, {
    "code": 6006,
    "name": "InvalidFormat",
    "msg": "Router: Invalid payload format"
  }, {
    "code": 6007,
    "name": "UnknownFormat",
    "msg": "Router: Unknown payload format"
  }, {
    "code": 6008,
    "name": "NoSender",
    "msg": "Router: Should contain sender"
  }, {
    "code": 6009,
    "name": "InvalidTargetAction",
    "msg": "Router: Incorrect target action"
  }, {
    "code": 6010,
    "name": "NotEnoughFundsOnRouter",
    "msg": "Router: There are not enough funds on the router"
  }, {
    "code": 6011,
    "name": "IncorrectPayloadAccount",
    "msg": "Router: Incorrect payload account provided"
  }, {
    "code": 6012,
    "name": "WrongReceiverAccount",
    "msg": "Router: Incorrect receiver account provided"
  }, {
    "code": 6013,
    "name": "IncorrectCall",
    "msg": "Router: Incorrect call, use the correct onTeleportMessage call"
  }, {
    "code": 6014,
    "name": "IncorrectTokenAccount",
    "msg": "Router: Incorrect token account"
  }, {
    "code": 6015,
    "name": "IncorrectNativeAddress",
    "msg": "Router: Incorrect native address"
  }],
  "metadata": {
    "address": "8s1W9LKyV6YooAybhLuE3WXBQeWmspwbUoEM68AE2UE6"
  }
};

var abridge_erc721_solana = {
  "version": "0.1.10",
  "name": "abridge_erc721_solana",
  "instructions": [{
    "name": "initialize",
    "accounts": [{
      "name": "routerStorage",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "routerVault",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "governanceStorage",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "routerSigningPda",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "initializer",
      "isMut": true,
      "isSigner": true
    }, {
      "name": "systemProgram",
      "isMut": false,
      "isSigner": false
    }],
    "args": [{
      "name": "params",
      "type": {
        "defined": "InitializeParams"
      }
    }]
  }, {
    "name": "updateMember",
    "accounts": [{
      "name": "routerStorage",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "governanceStorage",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "payer",
      "isMut": true,
      "isSigner": true
    }],
    "args": [{
      "name": "params",
      "type": {
        "defined": "UpdateMemberParams"
      }
    }]
  }, {
    "name": "egressNativeToken",
    "accounts": [{
      "name": "routerStorage",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "targetChainInfo",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "routerVault",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "payloadPda",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "teleportFeeCalculatorStorage",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "routerSigningPda",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "teleportFeeCollector",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "teleportProgram",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "systemProgram",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "caller",
      "isMut": true,
      "isSigner": true
    }, {
      "name": "tokenMint",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "userTokenBag",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "routerVaultTokenBag",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "lockedMint",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "tokenMetadata",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "tokenProgram",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "rent",
      "isMut": false,
      "isSigner": false
    }],
    "args": [{
      "name": "params",
      "type": {
        "defined": "EgressNativeTokenParams"
      }
    }]
  }, {
    "name": "egressNonNative",
    "accounts": [{
      "name": "routerStorage",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "targetChainInfo",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "routerVault",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "payloadPda",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "chainCurrencyInfo",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "teleportFeeCalculatorStorage",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "routerSigningPda",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "teleportFeeCollector",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "teleportProgram",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "systemProgram",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "caller",
      "isMut": true,
      "isSigner": true
    }, {
      "name": "tokenMint",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "userTokenBag",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "tokenProgram",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "rent",
      "isMut": false,
      "isSigner": false
    }],
    "args": [{
      "name": "params",
      "type": {
        "defined": "EgressNonNativeParams"
      }
    }]
  }, {
    "name": "onTeleportMessageTokenUnlock",
    "accounts": [{
      "name": "routerVaultTokenBag",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "to",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "tokenProgram",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "routerStorage",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "sourceChainInfo",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "lockedMint",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "payloadAccount",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "user",
      "isMut": true,
      "isSigner": true
    }, {
      "name": "receiver",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "instructionSysvarAccount",
      "isMut": false,
      "isSigner": false
    }],
    "args": [{
      "name": "params",
      "type": {
        "defined": "OnTeleportMessageParams"
      }
    }]
  }, {
    "name": "onTeleportMessageTokenMint",
    "accounts": [{
      "name": "routerStorage",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "routerVault",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "sourceChainInfo",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "tokenMint",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "metadata",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "chainCurrencyInfo",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "payloadAccount",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "user",
      "isMut": true,
      "isSigner": true
    }, {
      "name": "receiverTokenBag",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "instructionSysvarAccount",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "systemProgram",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "tokenProgram",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "tokenMetadataProgram",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "associatedTokenProgram",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "rent",
      "isMut": false,
      "isSigner": false
    }],
    "args": [{
      "name": "params",
      "type": {
        "defined": "OnTeleportMessageTokenMintParams"
      }
    }]
  }, {
    "name": "setTeleportSender",
    "accounts": [{
      "name": "governanceStorage",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "routerStorage",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "sourceChainInfo",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "initializer",
      "isMut": true,
      "isSigner": true
    }, {
      "name": "systemProgram",
      "isMut": false,
      "isSigner": false
    }],
    "args": [{
      "name": "params",
      "type": {
        "defined": "SetTeleportSenderParams"
      }
    }]
  }, {
    "name": "createWrappedMint",
    "accounts": [{
      "name": "routerStorage",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "routerVault",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "tokenMint",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "user",
      "isMut": true,
      "isSigner": true
    }, {
      "name": "systemProgram",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "tokenProgram",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "rent",
      "isMut": false,
      "isSigner": false
    }],
    "args": [{
      "name": "tokenDecimals",
      "type": "u8"
    }, {
      "name": "nativeTokenAddress",
      "type": "bytes"
    }, {
      "name": "nativeTokenId",
      "type": "u64"
    }]
  }, {
    "name": "initRouterVaultTokenBag",
    "accounts": [{
      "name": "routerVaultTokenBag",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "tokenMint",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "initializer",
      "isMut": true,
      "isSigner": true
    }, {
      "name": "systemProgram",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "tokenProgram",
      "isMut": false,
      "isSigner": false
    }, {
      "name": "rent",
      "isMut": false,
      "isSigner": false
    }],
    "args": []
  }, {
    "name": "initPayloadAccount",
    "accounts": [{
      "name": "payloadPda",
      "isMut": true,
      "isSigner": false
    }, {
      "name": "caller",
      "isMut": true,
      "isSigner": true
    }, {
      "name": "systemProgram",
      "isMut": false,
      "isSigner": false
    }],
    "args": []
  }],
  "accounts": [{
    "name": "LockedMint",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "bump",
        "type": "u8"
      }, {
        "name": "mintAddress",
        "type": {
          "array": ["u8", 32]
        }
      }]
    }
  }, {
    "name": "ChainInfo",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "bridgeAddress",
        "type": "bytes"
      }, {
        "name": "bump",
        "type": "u8"
      }]
    }
  }, {
    "name": "CurrencyInfoWithChain",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "bump",
        "type": "u8"
      }, {
        "name": "nativeChainId",
        "type": "u8"
      }, {
        "name": "nativeAddress",
        "type": "bytes"
      }, {
        "name": "nativeTokenId",
        "type": "u64"
      }, {
        "name": "currencyInfo",
        "type": {
          "defined": "CurrencyInfo"
        }
      }]
    }
  }, {
    "name": "TransmitPayloadAccount",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "bump",
        "type": "u8"
      }, {
        "name": "payloadLength",
        "type": "u32"
      }, {
        "name": "payload",
        "type": {
          "array": ["u8", 3000]
        }
      }]
    }
  }, {
    "name": "GovernanceStorage",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "bump",
        "type": "u8"
      }, {
        "name": "administrativeNonce",
        "type": "u128"
      }, {
        "name": "membersSet",
        "type": {
          "vec": {
            "array": ["u8", 64]
          }
        }
      }]
    }
  }, {
    "name": "PayloadAccount",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "discriminator",
        "type": {
          "array": ["u8", 8]
        }
      }, {
        "name": "bump",
        "type": "u8"
      }, {
        "name": "payload",
        "type": "bytes"
      }, {
        "name": "extraData",
        "type": {
          "array": ["u8", 4]
        }
      }]
    }
  }, {
    "name": "RouterStorage",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "nativeCurrency",
        "type": {
          "defined": "CurrencyInfo"
        }
      }, {
        "name": "chainId",
        "type": "u8"
      }, {
        "name": "albtToken",
        "type": "publicKey"
      }, {
        "name": "teleport",
        "type": "publicKey"
      }, {
        "name": "deliveryAgent",
        "type": "publicKey"
      }, {
        "name": "feeTokenCollector",
        "type": "publicKey"
      }, {
        "name": "dAppId",
        "type": {
          "array": ["u8", 32]
        }
      }, {
        "name": "deliveryFee",
        "type": "u64"
      }, {
        "name": "bump",
        "type": "u8"
      }, {
        "name": "routerSigningPdaBump",
        "type": "u8"
      }, {
        "name": "routerVaultPdaBump",
        "type": "u8"
      }]
    }
  }],
  "types": [{
    "name": "EgressNativeTokenParams",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "targetChainId",
        "type": "u8"
      }, {
        "name": "amount",
        "type": "u64"
      }, {
        "name": "receiver",
        "type": "bytes"
      }]
    }
  }, {
    "name": "EgressNonNativeParams",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "targetChainId",
        "type": "u8"
      }, {
        "name": "amount",
        "type": "u64"
      }, {
        "name": "receiver",
        "type": "bytes"
      }]
    }
  }, {
    "name": "InitializeParams",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "serviceFee",
        "type": "u64"
      }, {
        "name": "members",
        "type": {
          "vec": {
            "array": ["u8", 64]
          }
        }
      }, {
        "name": "chainId",
        "type": "u8"
      }, {
        "name": "teleportAddress",
        "type": "publicKey"
      }, {
        "name": "dAppId",
        "type": {
          "array": ["u8", 32]
        }
      }]
    }
  }, {
    "name": "OnTeleportMessageParams",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "sourceChainId",
        "type": "u8"
      }]
    }
  }, {
    "name": "OnTeleportMessageTokenMintParams",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "sourceChainId",
        "type": "u8"
      }, {
        "name": "routerVaultBump",
        "type": "u8"
      }, {
        "name": "tokenDecimals",
        "type": "u8"
      }, {
        "name": "nativeTokenAddress",
        "type": "bytes"
      }, {
        "name": "nativeTokenId",
        "type": "u64"
      }]
    }
  }, {
    "name": "SetTeleportSenderParams",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "chainId",
        "type": "u8"
      }, {
        "name": "senderAddress",
        "type": "bytes"
      }, {
        "name": "signatures",
        "type": {
          "vec": {
            "array": ["u8", 65]
          }
        }
      }]
    }
  }, {
    "name": "UpdateMemberParams",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "memberPublicKey",
        "type": "bytes"
      }, {
        "name": "status",
        "type": "bool"
      }, {
        "name": "signatures",
        "type": {
          "vec": {
            "array": ["u8", 65]
          }
        }
      }]
    }
  }, {
    "name": "CurrencyInfo",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "uri",
        "type": "string"
      }, {
        "name": "name",
        "type": "string"
      }, {
        "name": "symbol",
        "type": "string"
      }, {
        "name": "decimals",
        "type": "u8"
      }]
    }
  }, {
    "name": "TeleportDeliverInstructionData",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "opCode",
        "type": {
          "array": ["u8", 8]
        }
      }, {
        "name": "transmissionId",
        "type": {
          "array": ["u8", 32]
        }
      }, {
        "name": "params",
        "type": {
          "defined": "TeleportDeliverParams"
        }
      }]
    }
  }, {
    "name": "TeleportDeliverParams",
    "type": {
      "kind": "struct",
      "fields": [{
        "name": "sourceChainId",
        "type": "u8"
      }, {
        "name": "transmissionSender",
        "type": "bytes"
      }, {
        "name": "transmissionReceiver",
        "type": "bytes"
      }, {
        "name": "dAppId",
        "type": {
          "array": ["u8", 32]
        }
      }, {
        "name": "signatures",
        "type": {
          "vec": {
            "array": ["u8", 65]
          }
        }
      }]
    }
  }, {
    "name": "TargetAction",
    "type": {
      "kind": "enum",
      "variants": [{
        "name": "Unlock"
      }, {
        "name": "Mint"
      }]
    }
  }, {
    "name": "EgressErrors",
    "type": {
      "kind": "enum",
      "variants": [{
        "name": "InsufficientValue"
      }, {
        "name": "UnknownDestination"
      }, {
        "name": "SignatureExpired"
      }, {
        "name": "InvalidDeliveryFeeSigner"
      }, {
        "name": "InvalidNativeChainId"
      }, {
        "name": "ErrorWhileGeneratingPayload"
      }, {
        "name": "WrongTokenMetadata"
      }, {
        "name": "InvalidTargetChain"
      }, {
        "name": "InvalidDecimals"
      }]
    }
  }, {
    "name": "GovernanceErrors",
    "type": {
      "kind": "enum",
      "variants": [{
        "name": "SigVerificationFailed"
      }, {
        "name": "InvalidSignatureAmmount"
      }, {
        "name": "DuplicateSignature"
      }, {
        "name": "InvalidMemberPublicKey"
      }, {
        "name": "MemberAlreadyAdded"
      }, {
        "name": "MemberNonExistant"
      }, {
        "name": "MemberlessResult"
      }]
    }
  }, {
    "name": "TargetAction",
    "type": {
      "kind": "enum",
      "variants": [{
        "name": "Unlock"
      }, {
        "name": "Mint"
      }]
    }
  }],
  "events": [{
    "name": "LockMint",
    "fields": [{
      "name": "targetChainId",
      "type": "u8",
      "index": false
    }, {
      "name": "token",
      "type": "publicKey",
      "index": false
    }, {
      "name": "tokenIds",
      "type": {
        "vec": "u64"
      },
      "index": false
    }, {
      "name": "receiver",
      "type": "bytes",
      "index": false
    }]
  }, {
    "name": "BurnUnlock",
    "fields": [{
      "name": "targetChainId",
      "type": "u8",
      "index": false
    }, {
      "name": "token",
      "type": "publicKey",
      "index": false
    }, {
      "name": "tokenIds",
      "type": {
        "vec": "u64"
      },
      "index": false
    }, {
      "name": "receiver",
      "type": "bytes",
      "index": false
    }]
  }, {
    "name": "BurnMint",
    "fields": [{
      "name": "targetChainId",
      "type": "u8",
      "index": false
    }, {
      "name": "token",
      "type": "publicKey",
      "index": false
    }, {
      "name": "tokenIds",
      "type": {
        "vec": "u64"
      },
      "index": false
    }, {
      "name": "receiver",
      "type": "bytes",
      "index": false
    }]
  }, {
    "name": "MemberUpdated",
    "fields": [{
      "name": "memberPublicKey",
      "type": "bytes",
      "index": false
    }, {
      "name": "status",
      "type": "bool",
      "index": false
    }]
  }],
  "errors": [{
    "code": 6000,
    "name": "IncorrectTeleport",
    "msg": "Router: Incorrect teleport program provided"
  }, {
    "code": 6001,
    "name": "MissingTeleportCall",
    "msg": "Router: Missing teleport call"
  }, {
    "code": 6002,
    "name": "InvalidTeleportMethod",
    "msg": "Router: Invalid teleport method call"
  }, {
    "code": 6003,
    "name": "InvalidTeleportParams",
    "msg": "Router: Invalid teleport method call params"
  }, {
    "code": 6004,
    "name": "InvalidDappId",
    "msg": "Router: Unknown dAppId"
  }, {
    "code": 6005,
    "name": "InvalidSender",
    "msg": "Router: Unknown sender"
  }, {
    "code": 6006,
    "name": "InvalidFormat",
    "msg": "Router: Invalid payload format"
  }, {
    "code": 6007,
    "name": "UnknownFormat",
    "msg": "Router: Unknown payload format"
  }, {
    "code": 6008,
    "name": "NoSender",
    "msg": "Router: Should contain sender"
  }, {
    "code": 6009,
    "name": "InvalidTargetAction",
    "msg": "Router: Incorrect target action"
  }, {
    "code": 6010,
    "name": "NotEnoughFundsOnRouter",
    "msg": "Router: There are not enough funds on the router"
  }, {
    "code": 6011,
    "name": "IncorrectPayloadAccount",
    "msg": "Router: Incorrect payload account provided"
  }, {
    "code": 6012,
    "name": "WrongReceiverAccount",
    "msg": "Router: Incorrect receiver account provided"
  }, {
    "code": 6013,
    "name": "IncorrectCall",
    "msg": "Router: Incorrect call, use the correct onTeleportMessage call"
  }, {
    "code": 6014,
    "name": "InvalidActionsSize",
    "msg": "Router: Actions size should be 1"
  }, {
    "code": 6015,
    "name": "InvalidTokensIdSize",
    "msg": "Router: TokenIds size should be 1"
  }, {
    "code": 6016,
    "name": "InvalidTokensIdUriSizes",
    "msg": "Router: TokenIds size should be equals to Uris size"
  }, {
    "code": 6017,
    "name": "InvalidTokenId",
    "msg": "Router: TokenId should be equal to Payload received token id"
  }, {
    "code": 6018,
    "name": "IncorrectTokenAccount",
    "msg": "Router: Incorrect token account"
  }, {
    "code": 6019,
    "name": "IncorrectLockedMintAccount",
    "msg": "Router: Incorrect Locked Mint account"
  }],
  "metadata": {
    "address": "DWuQ27y1ryJB6e3yvsr1QmvNccbcZ1kB3uBdBLRHpifA"
  }
};



var index = {
  __proto__: null,
  LegacyRouterAbi: LegacyRouterAbi,
  LegacyRouterProxyAbi: LegacyRouterProxyAbi,
  MulticallAbi: MulticallAbi,
  WrappedERC721Abi: WrappedERC721Abi,
  ITeleportAbi: ITeleportAbi,
  NFTRouterAbi: NFTRouterAbi,
  ERC20PermitAbi: ERC20PermitAbi,
  ERC20RouterAbi: ERC20RouterAbi,
  teleportIDL: abridge_messaging_protocol_contracts_solana,
  ERC20RouterIDL: abridge_erc20_solana,
  ERC721RouterIDL: abridge_erc721_solana
};

var TransferType = {
  LOCK: 1,
  BURN: 2,
  BURN_AND_TRANSFER: 3
};
var ChainId = {
  ETH: 1,
  BSC: 2,
  AVAX: 3,
  MATIC: 4,
  VOLTA: 5
};
var ChainsTypes;
(function (ChainsTypes) {
  ChainsTypes["EVM"] = "evm";
  ChainsTypes["SOLANA"] = "solana";
})(ChainsTypes || (ChainsTypes = {}));
var Seeds = {
  HASH_DELIVERED_SEED: "hash_delivered",
  TELEPORT_STORAGE_SEED: "teleport-storage-seed",
  TELEPORT_CALCULATOR_STORAGE_SEED: "fee-calculator-storage-seed",
  ROUTER_STORAGE_SEED: "router-storage-seed",
  CHAIN_INFO_SEED: "chain-info-seed",
  CHAIN_CURRENCY_INFO_SEED: "chain-currency-info-seed",
  GOVERNANCE_STORAGE_SEED: "governance-storage-seed",
  PAYLOAD_ACCOUNT_SEED: "payload-account-seed",
  FEE_CALCULATOR_STORAGE_SEED: "fee-calculator-storage-seed",
  TELEPORT_FEE_COLLECTOR_SEED: "fee-collector-seed",
  TELEPORT_GOVERNANCE_STORAGE_SEED: "governance-storage-seed",
  WRAPPED_MINT_SEED: "wrapped-token-mint-seed",
  ROUTER_VAULT_ATA_SEED: "router-vault-ata-seed",
  ROUTER_VAULT_SEED: "router-vault-seed",
  WRAPPED_MINT_INFO_SEED: "wrapped-token-mint-info-seed",
  LOCKED_MINT_SEED: "locked-mint-seed"
};
var CONFIRMED_COMMITMENT = "confirmed";
var MAX_PAYLOAD_PART_SIZE = 947;
var DEFAULT_TOKEN_ID = 0;

var index$1 = {
  __proto__: null,
  TransferType: TransferType,
  ChainId: ChainId,
  get ChainsTypes () { return ChainsTypes; },
  Seeds: Seeds,
  CONFIRMED_COMMITMENT: CONFIRMED_COMMITMENT,
  MAX_PAYLOAD_PART_SIZE: MAX_PAYLOAD_PART_SIZE,
  DEFAULT_TOKEN_ID: DEFAULT_TOKEN_ID
};

var ABridgeSDKError = /*#__PURE__*/function (_Error) {
  _inheritsLoose(ABridgeSDKError, _Error);
  function ABridgeSDKError(message, err) {
    var _this;
    _this = _Error.call(this, message) || this;
    if (err) {
      var errStak = err.stack ? err.stack : err;
      _this.stack += "\n Internal " + errStak;
    }
    return _this;
  }
  return ABridgeSDKError;
}( /*#__PURE__*/_wrapNativeSuper(Error));

var config = {
  solana_devnet: {
    nftValidators: {
      validator1: "https://validatornft1.alliancebridge-dev.net:443",
      validator2: "https://validatornft2.alliancebridge-dev.net:443",
      validator3: "https://validatornft3.alliancebridge-dev.net:443"
    },
    abridgeBackend: "https://backend.alliancebridge-dev.net/",
    isMainnet: false
  },
  19: {
    contracts: {
      legacyErc20: {
        router: "0xfA563b8B7447bd82548932B2996b86D2364eafcE",
        "router-proxy": "0x72B8509dAff28397a91c9b0faDb47EA2065272D4"
      },
      erc20Router: "0x6241CA7b9476E62EFb671dd6e8280DC35bb6dCA5",
      nftRouter: "0x8A9b214D147aC5b3d91E93405df703EEC4211341",
      teleport: "0xd3861fe92633568a380ab4788b65240b02d9c30E"
    },
    validators: {
      london: "https://validator1.alliancebridge-dev.net:5200",
      "north virginia": "https://validator2.alliancebridge-dev.net:5200",
      singapore: "https://validator3.alliancebridge-dev.net:5200"
    },
    nftValidators: {
      validator1: "https://validatornft1.alliancebridge-dev.net:443",
      validator2: "https://validatornft2.alliancebridge-dev.net:443",
      validator3: "https://validatornft3.alliancebridge-dev.net:443"
    },
    abridgeBackend: "https://backend.alliancebridge-dev.net/",
    threshold: "1000000000000000",
    isMainnet: false
  },
  1313161555: {
    contracts: {
      legacyErc20: {
        router: "0xe68b70e2Cc104E73596CE5ac28d3cD84703ab0b1",
        "router-proxy": "0xb100c8df168AC7dFbdb3aeDBa8cFA5356C5b3F54"
      },
      erc20Router: "0x6241CA7b9476E62EFb671dd6e8280DC35bb6dCA5",
      nftRouter: "0x8A9b214D147aC5b3d91E93405df703EEC4211341",
      teleport: "0x7f770C48C82aaEfc4808b7018c88Ef300A3fe9FB",
      multicall: "0xBD4B908Bca41De0200FBe5F98C062c72Aa6c8C6c"
    },
    validators: {
      london: "https://validator1.alliancebridge-dev.net:5200",
      "north virginia": "https://validator2.alliancebridge-dev.net:5200",
      singapore: "https://validator3.alliancebridge-dev.net:5200"
    },
    nftValidators: {
      validator1: "https://validatornft1.alliancebridge-dev.net:443",
      validator2: "https://validatornft2.alliancebridge-dev.net:443",
      validator3: "https://validatornft3.alliancebridge-dev.net:443"
    },
    abridgeBackend: "https://backend.alliancebridge-dev.net/",
    threshold: "1000000000000000",
    isMainnet: false
  },
  4: {
    contracts: {
      legacyErc20: {
        router: "0x6911F73a4DfDe160440689b1e4aC7fa266008457",
        "router-proxy": "0xC97c0D32Def7146cDb689B0095D34F8c60970e81"
      },
      erc20Router: "0x6241CA7b9476E62EFb671dd6e8280DC35bb6dCA5",
      nftRouter: "0x8A9b214D147aC5b3d91E93405df703EEC4211341",
      teleport: "0x7f770C48C82aaEfc4808b7018c88Ef300A3fe9FB",
      multicall: "0xBD4B908Bca41De0200FBe5F98C062c72Aa6c8C6c"
    },
    validators: {
      london: "https://validator1.alliancebridge-dev.net:5200",
      "north virginia": "https://validator2.alliancebridge-dev.net:5200",
      singapore: "https://validator3.alliancebridge-dev.net:5200"
    },
    nftValidators: {
      validator1: "https://validatornft1.alliancebridge-dev.net:443",
      validator2: "https://validatornft2.alliancebridge-dev.net:443",
      validator3: "https://validatornft3.alliancebridge-dev.net:443"
    },
    abridgeBackend: "https://backend.alliancebridge-dev.net/",
    threshold: "1000000000000000",
    isMainnet: false
  },
  97: {
    contracts: {
      legacyErc20: {
        router: "0xFdccb7de1d2065217457840C4D7e17D57bFC8612",
        "router-proxy": "0x1D7A51Ff6DA672EA0ed02cB344720e9AEDB7D3C1"
      },
      erc20Router: "0x6241CA7b9476E62EFb671dd6e8280DC35bb6dCA5",
      nftRouter: "0x8A9b214D147aC5b3d91E93405df703EEC4211341",
      teleport: "0x7f770C48C82aaEfc4808b7018c88Ef300A3fe9FB",
      multicall: "0xBD4B908Bca41De0200FBe5F98C062c72Aa6c8C6c"
    },
    validators: {
      london: "https://validator1.alliancebridge-dev.net:5200",
      "north virginia": "https://validator2.alliancebridge-dev.net:5200",
      singapore: "https://validator3.alliancebridge-dev.net:5200"
    },
    nftValidators: {
      validator1: "https://validatornft1.alliancebridge-dev.net:443",
      validator2: "https://validatornft2.alliancebridge-dev.net:443",
      validator3: "https://validatornft3.alliancebridge-dev.net:443"
    },
    abridgeBackend: "https://backend.alliancebridge-dev.net/",
    threshold: "1000000000000000",
    isMainnet: false
  },
  43113: {
    contracts: {
      legacyErc20: {
        router: "0xbbe95fbBC8890E17fBb9e2D33eD678045B1F83Ad",
        "router-proxy": "0x9F3cDc15AebB0906C2BB974a28cc3DC7D2fD50A4"
      },
      erc20Router: "0x6241CA7b9476E62EFb671dd6e8280DC35bb6dCA5",
      nftRouter: "0x8A9b214D147aC5b3d91E93405df703EEC4211341",
      teleport: "0x7f770C48C82aaEfc4808b7018c88Ef300A3fe9FB",
      multicall: "0xBD4B908Bca41De0200FBe5F98C062c72Aa6c8C6c"
    },
    validators: {
      london: "https://validator1.alliancebridge-dev.net:5200",
      "north virginia": "https://validator2.alliancebridge-dev.net:5200",
      singapore: "https://validator3.alliancebridge-dev.net:5200"
    },
    nftValidators: {
      validator1: "https://validatornft1.alliancebridge-dev.net:443",
      validator2: "https://validatornft2.alliancebridge-dev.net:443",
      validator3: "https://validatornft3.alliancebridge-dev.net:443"
    },
    abridgeBackend: "https://backend.alliancebridge-dev.net/",
    threshold: "1000000000000000",
    isMainnet: false
  },
  80001: {
    contracts: {
      legacyErc20: {
        router: "0x51199130815e433450d5ccD300d69774CCD922DB",
        "router-proxy": "0x3b9eF9a78C348c1B4d2E4BE15198846F7F6f088E"
      },
      erc20Router: "0x6241CA7b9476E62EFb671dd6e8280DC35bb6dCA5",
      nftRouter: "0x8A9b214D147aC5b3d91E93405df703EEC4211341",
      teleport: "0x7f770C48C82aaEfc4808b7018c88Ef300A3fe9FB",
      multicall: "0xBD4B908Bca41De0200FBe5F98C062c72Aa6c8C6c"
    },
    validators: {
      london: "https://validator1.alliancebridge-dev.net:5200",
      "north virginia": "https://validator2.alliancebridge-dev.net:5200",
      singapore: "https://validator3.alliancebridge-dev.net:5200"
    },
    nftValidators: {
      validator1: "https://validatornft1.alliancebridge-dev.net:443",
      validator2: "https://validatornft2.alliancebridge-dev.net:443",
      validator3: "https://validatornft3.alliancebridge-dev.net:443"
    },
    abridgeBackend: "https://backend.alliancebridge-dev.net/",
    threshold: "1000000000000000",
    isMainnet: false
  },
  73799: {
    contracts: {
      legacyErc20: {
        router: "0x0DC2D4892b14AF3C0f14755eCedB8aC0417B867B",
        "router-proxy": "0xa8CCD60a1A3bF75d863036350BD8941b7a14B831"
      },
      erc20Router: "0x6241CA7b9476E62EFb671dd6e8280DC35bb6dCA5",
      nftRouter: "0x8A9b214D147aC5b3d91E93405df703EEC4211341",
      teleport: "0x7f770C48C82aaEfc4808b7018c88Ef300A3fe9FB",
      multicall: "0xBD4B908Bca41De0200FBe5F98C062c72Aa6c8C6c"
    },
    validators: {
      london: "https://validator1.alliancebridge-dev.net:5200",
      "north virginia": "https://validator2.alliancebridge-dev.net:5200",
      singapore: "https://validator3.alliancebridge-dev.net:5200"
    },
    nftValidators: {
      validator1: "https://validatornft1.alliancebridge-dev.net:443",
      validator2: "https://validatornft2.alliancebridge-dev.net:443",
      validator3: "https://validatornft3.alliancebridge-dev.net:443"
    },
    abridgeBackend: "https://backend.alliancebridge-dev.net/",
    threshold: "1000000000000000",
    isMainnet: false
  },
  421611: {
    contracts: {
      legacyErc20: {
        router: "0x7973E21f5813229A31C38EEe937f4F581A8e8213",
        "router-proxy": "0xfc78DeBB2591382B5f853D51B0f9998c0509c0B3"
      },
      erc20Router: "0x6241CA7b9476E62EFb671dd6e8280DC35bb6dCA5",
      nftRouter: "0x8A9b214D147aC5b3d91E93405df703EEC4211341",
      teleport: "0x7f770C48C82aaEfc4808b7018c88Ef300A3fe9FB",
      multicall: "0xBD4B908Bca41De0200FBe5F98C062c72Aa6c8C6c"
    },
    validators: {
      london: "https://validator1.alliancebridge-dev.net:5200",
      "north virginia": "https://validator2.alliancebridge-dev.net:5200",
      singapore: "https://validator3.alliancebridge-dev.net:5200"
    },
    nftValidators: {
      validator1: "https://validatornft1.alliancebridge-dev.net:443",
      validator2: "https://validatornft2.alliancebridge-dev.net:443",
      validator3: "https://validatornft3.alliancebridge-dev.net:443"
    },
    abridgeBackend: "https://backend.alliancebridge-dev.net/",
    threshold: "1000000000000000",
    isMainnet: false
  },
  4002: {
    contracts: {
      legacyErc20: {
        router: "0xbcf7234A4703d02415e914B0bb8b78Fbf5Ed800C",
        "router-proxy": "0x350182D330E1fe6602E049db71dc743cBa0a5478"
      },
      erc20Router: "0x6241CA7b9476E62EFb671dd6e8280DC35bb6dCA5",
      nftRouter: "0x8A9b214D147aC5b3d91E93405df703EEC4211341",
      teleport: "0x7f770C48C82aaEfc4808b7018c88Ef300A3fe9FB",
      multicall: "0xBD4B908Bca41De0200FBe5F98C062c72Aa6c8C6c"
    },
    validators: {
      london: "https://validator1.alliancebridge-dev.net:5200",
      "north virginia": "https://validator2.alliancebridge-dev.net:5200",
      singapore: "https://validator3.alliancebridge-dev.net:5200"
    },
    nftValidators: {
      validator1: "https://validatornft1.alliancebridge-dev.net:443",
      validator2: "https://validatornft2.alliancebridge-dev.net:443",
      validator3: "https://validatornft3.alliancebridge-dev.net:443"
    },
    abridgeBackend: "https://backend.alliancebridge-dev.net/",
    threshold: "1000000000000000",
    isMainnet: false
  },
  69: {
    contracts: {
      legacyErc20: {
        router: "0xEA339f34D738968F21808651897549590DaA9fB6",
        "router-proxy": "0x67CF93AA43173B83AE4eAf22FC9f21d051e082a9"
      },
      erc20Router: "0x6241CA7b9476E62EFb671dd6e8280DC35bb6dCA5",
      nftRouter: "0x8A9b214D147aC5b3d91E93405df703EEC4211341",
      teleport: "0x7f770C48C82aaEfc4808b7018c88Ef300A3fe9FB",
      multicall: "0xBD4B908Bca41De0200FBe5F98C062c72Aa6c8C6c"
    },
    validators: {
      london: "https://validator1.alliancebridge-dev.net:5200",
      "north virginia": "https://validator2.alliancebridge-dev.net:5200",
      singapore: "https://validator3.alliancebridge-dev.net:5200"
    },
    nftValidators: {
      validator1: "https://validatornft1.alliancebridge-dev.net:443",
      validator2: "https://validatornft2.alliancebridge-dev.net:443",
      validator3: "https://validatornft3.alliancebridge-dev.net:443"
    },
    abridgeBackend: "https://backend.alliancebridge-dev.net/",
    threshold: "1000000000000000",
    isMainnet: false
  },
  1287: {
    contracts: {
      legacyErc20: {
        router: "0xe68b70e2Cc104E73596CE5ac28d3cD84703ab0b1",
        "router-proxy": "0x79FC575ddc5FbD003B3ed0D7337C1Bea4Ba62310"
      },
      erc20Router: "0x6241CA7b9476E62EFb671dd6e8280DC35bb6dCA5",
      nftRouter: "0x8A9b214D147aC5b3d91E93405df703EEC4211341",
      teleport: "0x7f770C48C82aaEfc4808b7018c88Ef300A3fe9FB",
      multicall: "0xBD4B908Bca41De0200FBe5F98C062c72Aa6c8C6c"
    },
    validators: {
      london: "https://validator1.alliancebridge-dev.net:5200",
      "north virginia": "https://validator2.alliancebridge-dev.net:5200",
      singapore: "https://validator3.alliancebridge-dev.net:5200"
    },
    nftValidators: {
      validator1: "https://validatornft1.alliancebridge-dev.net:443",
      validator2: "https://validatornft2.alliancebridge-dev.net:443",
      validator3: "https://validatornft3.alliancebridge-dev.net:443"
    },
    abridgeBackend: "https://backend.alliancebridge-dev.net/",
    threshold: "1000000000000000",
    isMainnet: false
  },
  // MAINNET
  1: {
    contracts: {
      legacyErc20: {
        router: "0x7CAB80B6FaCD52A0F3e044D8bfC43d0ad6D258F4",
        "router-proxy": "0xaE366B7C5e59822A9AAEbfDF7744F6445e5211D1"
      },
      erc20Router: "0x00",
      nftRouter: "0x081115F16d666C5479E45b8B3d80158abaAdDe1f",
      teleport: "0xF2D305dF14445a0609A44844edc657ABaDd13473",
      multicall: "0xD59c4C30fBa7DfD09263233D25DBF95e8Af3B7c5"
    },
    validators: {
      limechain: "https://0.alliance-bridge-validator.com:5300",
      allianceblock: "https://validator1.alliancebridge.io:5200",
      allianceblockHA: "https://validator2.alliancebridge.io"
    },
    nftValidators: {
      validator1: "https://validatornft1.alliancebridge.io",
      validator1_HA: "https://validatornft2.alliancebridge.io",
      validator2: "https://0.alliance-bridge-validator.com:5301"
    },
    abridgeBackend: "https://",
    threshold: "1000000000000000",
    isMainnet: true
  },
  56: {
    contracts: {
      legacyErc20: {
        router: "0xc47d16ae45E1Df2242107C35Bb0C9a399e4e5598",
        "router-proxy": "0x1C6F13d153EA1d53b077657F0A0e98881Ccc5112"
      },
      erc20Router: "0x00",
      nftRouter: "0x081115F16d666C5479E45b8B3d80158abaAdDe1f",
      teleport: "0xF2D305dF14445a0609A44844edc657ABaDd13473",
      multicall: "0xD59c4C30fBa7DfD09263233D25DBF95e8Af3B7c5"
    },
    validators: {
      limechain: "https://0.alliance-bridge-validator.com:5300",
      allianceblock: "https://validator1.alliancebridge.io:5200",
      allianceblockHA: "https://validator2.alliancebridge.io"
    },
    nftValidators: {
      validator1: "https://validatornft1.alliancebridge.io",
      validator1_HA: "https://validatornft2.alliancebridge.io",
      validator2: "https://0.alliance-bridge-validator.com:5301"
    },
    abridgeBackend: "https://",
    threshold: "1000000000000000",
    isMainnet: true
  },
  43114: {
    contracts: {
      legacyErc20: {
        router: "0xa5765ABE9f838F8a13d7c5dF933FDDF0409dC1eE",
        "router-proxy": "0xA4C174FdCff7FDaC3CD57bcCb8df1ACB28224f53"
      },
      erc20Router: "0x00",
      nftRouter: "0x081115F16d666C5479E45b8B3d80158abaAdDe1f",
      teleport: "0xF2D305dF14445a0609A44844edc657ABaDd13473",
      multicall: "0xD59c4C30fBa7DfD09263233D25DBF95e8Af3B7c5"
    },
    validators: {
      limechain: "https://0.alliance-bridge-validator.com:5300",
      allianceblock: "https://validator1.alliancebridge.io:5200",
      allianceblockHA: "https://validator2.alliancebridge.io"
    },
    nftValidators: {
      validator1: "https://validatornft1.alliancebridge.io",
      validator1_HA: "https://validatornft2.alliancebridge.io",
      validator2: "https://0.alliance-bridge-validator.com:5301"
    },
    abridgeBackend: "https://",
    threshold: "1000000000000000",
    isMainnet: true
  },
  137: {
    contracts: {
      legacyErc20: {
        router: "0xA16dfA9a67e6Aa054B2c0789B0c0Eb774371D004",
        "router-proxy": "0x08e30B616ec2f03ecAfBdf9654F24a4bd2F2c95A"
      },
      erc20Router: "0x00",
      nftRouter: "0x081115F16d666C5479E45b8B3d80158abaAdDe1f",
      teleport: "0xF2D305dF14445a0609A44844edc657ABaDd13473",
      multicall: "0xD59c4C30fBa7DfD09263233D25DBF95e8Af3B7c5"
    },
    validators: {
      limechain: "https://0.alliance-bridge-validator.com:5300",
      allianceblock: "https://validator1.alliancebridge.io:5200",
      allianceblockHA: "https://validator2.alliancebridge.io"
    },
    nftValidators: {
      validator1: "https://validatornft1.alliancebridge.io",
      validator1_HA: "https://validatornft2.alliancebridge.io",
      validator2: "https://0.alliance-bridge-validator.com:5301"
    },
    abridgeBackend: "https://",
    threshold: "1000000000000000",
    isMainnet: true
  },
  246: {
    contracts: {
      legacyErc20: {
        router: "0x8e442E46D7F009cAc7C1EE82D6453353aE7A463C",
        "router-proxy": "0x0DCF00f9223DCb4d4CE73BF08D1050ee8C5A143D"
      },
      erc20Router: "0x00",
      nftRouter: "0x081115F16d666C5479E45b8B3d80158abaAdDe1f",
      teleport: "0xF2D305dF14445a0609A44844edc657ABaDd13473",
      multicall: "0xD59c4C30fBa7DfD09263233D25DBF95e8Af3B7c5"
    },
    validators: {
      limechain: "https://0.alliance-bridge-validator.com:5300",
      allianceblock: "https://validator1.alliancebridge.io:5200",
      allianceblockHA: "https://validator2.alliancebridge.io"
    },
    nftValidators: {
      validator1: "https://validatornft1.alliancebridge.io",
      validator1_HA: "https://validatornft2.alliancebridge.io",
      validator2: "https://0.alliance-bridge-validator.com:5301"
    },
    abridgeBackend: "https://",
    threshold: "1000000000000000",
    isMainnet: true
  },
  42161: {
    contracts: {
      legacyErc20: {
        router: "0x4A0c2D99D2b8028F0D8facDe9aC0e631614F4293",
        "router-proxy": "0xF1f165A5cBC26727D77B1452C6c17B60c73B3586"
      },
      erc20Router: "0x00",
      nftRouter: "0x081115F16d666C5479E45b8B3d80158abaAdDe1f",
      teleport: "0xF2D305dF14445a0609A44844edc657ABaDd13473",
      multicall: "0xD59c4C30fBa7DfD09263233D25DBF95e8Af3B7c5"
    },
    validators: {
      limechain: "https://0.alliance-bridge-validator.com:5300",
      allianceblock: "https://validator1.alliancebridge.io:5200",
      allianceblockHA: "https://validator2.alliancebridge.io"
    },
    nftValidators: {
      validator1: "https://validatornft1.alliancebridge.io",
      validator1_HA: "https://validatornft2.alliancebridge.io",
      validator2: "https://0.alliance-bridge-validator.com:5301"
    },
    abridgeBackend: "https://",
    threshold: "1000000000000000",
    isMainnet: true
  },
  10: {
    contracts: {
      legacyErc20: {
        router: "0x3a1c5dd9735d39e961205ac57f95c1b5b1bb9626",
        "router-proxy": "0x4A0c2D99D2b8028F0D8facDe9aC0e631614F4293"
      },
      erc20Router: "0x00",
      nftRouter: "0x081115F16d666C5479E45b8B3d80158abaAdDe1f",
      teleport: "0xF2D305dF14445a0609A44844edc657ABaDd13473",
      multicall: "0xD59c4C30fBa7DfD09263233D25DBF95e8Af3B7c5"
    },
    validators: {
      limechain: "https://0.alliance-bridge-validator.com:5300",
      allianceblock: "https://validator1.alliancebridge.io:5200",
      allianceblockHA: "https://validator2.alliancebridge.io"
    },
    nftValidators: {
      validator1: "https://validatornft1.alliancebridge.io",
      validator1_HA: "https://validatornft2.alliancebridge.io",
      validator2: "https://0.alliance-bridge-validator.com:5301"
    },
    abridgeBackend: "https://",
    threshold: "1000000000000000",
    isMainnet: true
  },
  1284: {
    contracts: {
      legacyErc20: {
        router: "0x20cc413656Fd25939bD01Eb3a3a7163816744b4f",
        "router-proxy": "0xaE366B7C5e59822A9AAEbfDF7744F6445e5211D1"
      },
      erc20Router: "0x00",
      nftRouter: "0x081115F16d666C5479E45b8B3d80158abaAdDe1f",
      teleport: "0xF2D305dF14445a0609A44844edc657ABaDd13473",
      multicall: "0xD59c4C30fBa7DfD09263233D25DBF95e8Af3B7c5"
    },
    validators: {
      limechain: "https://0.alliance-bridge-validator.com:5300",
      allianceblock: "https://validator1.alliancebridge.io:5200",
      allianceblockHA: "https://validator2.alliancebridge.io"
    },
    nftValidators: {
      validator1: "https://validatornft1.alliancebridge.io",
      validator1_HA: "https://validatornft2.alliancebridge.io",
      validator2: "https://0.alliance-bridge-validator.com:5301"
    },
    abridgeBackend: "https://",
    threshold: "1000000000000000",
    isMainnet: true
  }
};
var openSeaApiPrefix = function openSeaApiPrefix(chainId) {
  // Currently Open Sea API only supports Ethereum and Goerli
  // But we return this value acordin if it's mainnet or not
  // Solana
  if (!chainId) return "testnets-api";
  // EVM
  return config[chainId].isMainnet ? "api" : "testnets-api";
};
var erc721DAppId = function erc721DAppId(chainId) {
  switch (chainId) {
    case 4:
    case 97:
    case 43113:
    case 80001:
    case 73799:
    case 421611:
    case 69:
    case 19:
    case 1313161555:
    case 4002:
    case 1287:
      return "0xc11c6ca05f75141386225b56d20e5d168000eb84f1244a4d1e001968bc5fe280";
    case 1:
    case 56:
    case 43114:
    case 137:
    case 246:
    case 42161:
    case 10:
    case 19:
    case 1284:
      return "0xc11c6ca05f75141386225b56d20e5d168000eb84f1244a4d1e001968bc5fe280";
    default:
      return "0xc11c6ca05f75141386225b56d20e5d168000eb84f1244a4d1e001968bc5fe280";
  }
};
var erc20DAppId = function erc20DAppId(chainId) {
  switch (chainId) {
    case 4:
    case 97:
    case 43113:
    case 80001:
    case 73799:
    case 421611:
    case 69:
    case 19:
    case 1313161555:
    case 4002:
    case 1287:
      return "0x72d39a1c0de7ff41e878b4d9fd3906d2fdc49e36188d0c595d57fb7dde21b1d8";
    case 1:
    case 56:
    case 43114:
    case 137:
    case 246:
    case 42161:
    case 10:
    case 19:
    case 1284:
      return "0x72d39a1c0de7ff41e878b4d9fd3906d2fdc49e36188d0c595d57fb7dde21b1d8";
    default:
      return "0x72d39a1c0de7ff41e878b4d9fd3906d2fdc49e36188d0c595d57fb7dde21b1d8";
  }
};
var getALBTTokenV1nativeInfo = function getALBTTokenV1nativeInfo(chainId) {
  switch (chainId) {
    case 4:
    case 97:
    case 43113:
    case 80001:
    case 73799:
    case 421611:
    case 69:
    case 19:
    case 1313161555:
    case 4002:
    case 1287:
      return {
        chainId: 1,
        tokenAddress: "0xc6869a93ef55e1d8ec8fdcda89c9d93616cf0a72"
      };
    case 1:
    case 56:
    case 43114:
    case 137:
    case 246:
    case 42161:
    case 10:
    case 19:
    case 1284:
      return {
        chainId: 1,
        tokenAddress: "0x00a8b738e453ffd858a7edf03bccfe20412f0eb0"
      };
    default:
      return {
        chainId: null,
        tokenAddress: ""
      };
  }
};

var index$2 = {
  __proto__: null,
  config: config,
  openSeaApiPrefix: openSeaApiPrefix,
  erc721DAppId: erc721DAppId,
  erc20DAppId: erc20DAppId,
  getALBTTokenV1nativeInfo: getALBTTokenV1nativeInfo
};

var uriToHttp = function uriToHttp(uri) {
  if (!uri || uri === "") return undefined;
  var protocol = uri.split(":")[0].toLowerCase();
  if (protocol == "ipfs" || protocol == "ipns") {
    var hash = uri.split(protocol + "://")[1];
    // Alternative `https://${protocol}.io/${protocol}/${hash}/`
    // CORS error `https://cloudflare-${protocol}.com/${protocol}/${hash}/` 
    // `https://gateway.pinata.cloud/${protocol}/${hash}/`
    return "https://gateway.pinata.cloud/" + protocol + "/" + hash + "/";
  }
  return uri;
};
var getProgram = function getProgram(_ref) {
  var idl = _ref.idl,
    provider = _ref.provider;
  var programID = new PublicKey(idl.metadata.address);
  return new Program(idl, programID, provider);
};
var sendAndConfirmTxs = /*#__PURE__*/function () {
  var _ref2 = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2(program, signedTxs) {
    return _regeneratorRuntime().wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return Promise.all(signedTxs.map( /*#__PURE__*/function () {
              var _ref3 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(tx) {
                var receipt;
                return _regeneratorRuntime().wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        _context.next = 2;
                        return program.provider.connection.sendRawTransaction(tx.serialize(), {
                          skipPreflight: false,
                          preflightCommitment: CONFIRMED_COMMITMENT
                        });
                      case 2:
                        receipt = _context.sent;
                        _context.next = 5;
                        return program.provider.connection.confirmTransaction(receipt, CONFIRMED_COMMITMENT);
                      case 5:
                        return _context.abrupt("return", receipt);
                      case 6:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee);
              }));
              return function (_x3) {
                return _ref3.apply(this, arguments);
              };
            }()));
          case 2:
            return _context2.abrupt("return", _context2.sent);
          case 3:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return function sendAndConfirmTxs(_x, _x2) {
    return _ref2.apply(this, arguments);
  };
}();
var createDeliverAndOnTeleportMessageTx = /*#__PURE__*/function () {
  var _ref5 = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee3(_ref4) {
    var teleportContract, erc20RouterContract, transmissionId, sourceChainId, transmissionSender, transmissionReceiver, dAppId, signatures, payloadAccountPDA, deliveredTransmissionPDA, governanceStoragePDA, teleportStoragePDA, routerStoragePDA, chainInfoPDA, result;
    return _regeneratorRuntime().wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            teleportContract = _ref4.teleportContract, erc20RouterContract = _ref4.erc20RouterContract, transmissionId = _ref4.transmissionId, sourceChainId = _ref4.sourceChainId, transmissionSender = _ref4.transmissionSender, transmissionReceiver = _ref4.transmissionReceiver, dAppId = _ref4.dAppId, signatures = _ref4.signatures, payloadAccountPDA = _ref4.payloadAccountPDA, deliveredTransmissionPDA = _ref4.deliveredTransmissionPDA, governanceStoragePDA = _ref4.governanceStoragePDA, teleportStoragePDA = _ref4.teleportStoragePDA, routerStoragePDA = _ref4.routerStoragePDA, chainInfoPDA = _ref4.chainInfoPDA;
            _context3.t0 = teleportContract.methods.deliver(Buffer$1.from(transmissionId), {
              sourceChainId: sourceChainId,
              transmissionSender: Buffer$1.from(transmissionSender),
              transmissionReceiver: Buffer$1.from(transmissionReceiver),
              dAppId: Buffer$1.from(dAppId),
              signatures: signatures
            }).accounts({
              governanceStorage: governanceStoragePDA,
              teleportStorage: teleportStoragePDA,
              deliveredTransmission: deliveredTransmissionPDA,
              payloadAccount: payloadAccountPDA,
              user: teleportContract.provider.wallet.publicKey,
              instructionSysvarAccount: web3.SYSVAR_INSTRUCTIONS_PUBKEY
            });
            _context3.next = 4;
            return erc20RouterContract.methods.onTeleportMessage({
              sourceChainId: sourceChainId,
              transmissionSender: Buffer$1.from(transmissionSender),
              dAppId: Buffer$1.from(dAppId)
            }).accounts({
              routerStorage: routerStoragePDA,
              sourceChainInfo: chainInfoPDA,
              caller: teleportContract.provider.wallet.publicKey
            }).instruction();
          case 4:
            _context3.t1 = _context3.sent;
            _context3.t2 = [_context3.t1];
            _context3.next = 8;
            return _context3.t0.postInstructions.call(_context3.t0, _context3.t2).transaction();
          case 8:
            result = _context3.sent;
            result.feePayer = teleportContract.provider.wallet.publicKey;
            _context3.next = 12;
            return teleportContract.provider.connection.getLatestBlockhash({
              commitment: CONFIRMED_COMMITMENT
            });
          case 12:
            result.recentBlockhash = _context3.sent.blockhash;
            return _context3.abrupt("return", result);
          case 14:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));
  return function createDeliverAndOnTeleportMessageTx(_x4) {
    return _ref5.apply(this, arguments);
  };
}();

var utils = {
  __proto__: null,
  uriToHttp: uriToHttp,
  getProgram: getProgram,
  sendAndConfirmTxs: sendAndConfirmTxs,
  createDeliverAndOnTeleportMessageTx: createDeliverAndOnTeleportMessageTx
};

// Abstract class for RouterFactorySDK implementations to extend from.
// This class is not meant to be used directly.
var RouterSDK = /*#__PURE__*/function () {
  function RouterSDK(signerOrProvider, optionalParams) {
    var _this$signerOrProvide;
    if (this.constructor == RouterSDK) {
      throw new Error("RouterSDK can't be instantiated directly.");
    }
    this.signerOrProvider = signerOrProvider;
    this.chainId = (_this$signerOrProvide = this.signerOrProvider.provider) == null ? void 0 : _this$signerOrProvide.network.chainId;
    this.nativeALBTinfo = getALBTTokenV1nativeInfo(this.chainId);
    this.blackListedTokens = optionalParams.blackListedTokens ? [this.nativeALBTinfo].concat(optionalParams.blackListedTokens) : [this.nativeALBTinfo];
    this.config = config[this.chainId || optionalParams.configName];
    this.setParams(optionalParams || {});
    this.backendAxios = axios$1.create({
      baseURL: this.abridgeBackendURL
    });
    this._configValidators(optionalParams);
  }
  var _proto = RouterSDK.prototype;
  _proto._configValidators = function _configValidators(optionalParams) {
    throw new Error("_configValidators should not be called from abstract RouterSDK.");
  }
  /**
   * @param optionalParams
   * @property nftValidators: string[]
   * @property abridgeBackend: string
   * @property frontEndVersion: number
   */;
  _proto.setParams = function setParams(optionalParams) {
    if (optionalParams["abridgeBackend"]) {
      this.abridgeBackendURL = optionalParams.abridgeBackend;
    } else {
      this.abridgeBackendURL = this.config.abridgeBackend;
    }
    if (optionalParams["nftValidators"]) {
      this.nftValidatorURL = this.getRandomProperty(optionalParams.nftValidators);
    } else {
      this.nftValidatorURL = this.getRandomProperty(this.config.nftValidators);
    }
    if (optionalParams["frontEndVersion"]) {
      this.frontEndVersion = Number(optionalParams.frontEndVersion);
    } else {
      this.frontEndVersion = 2;
    }
  };
  _proto.getUserAssets = /*#__PURE__*/function () {
    var _getUserAssets = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(userAddress, assetContractAddress, openseaApiKey, nftTransferPage) {
      var offsetValue, offset, result;
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              offsetValue = 20;
              offset = (nftTransferPage - 1) * offsetValue;
              _context.prev = 2;
              _context.next = 5;
              return axios$1.get("https://" + openSeaApiPrefix(this.chainId) + ".opensea.io/api/v1/assets?owner=" + userAddress + "&asset_contract_address=" + assetContractAddress + "&order_direction=desc&offset=" + offset, {
                headers: {
                  "X-API-KEY": openseaApiKey
                }
              });
            case 5:
              result = _context.sent.data.assets;
              return _context.abrupt("return", result);
            case 9:
              _context.prev = 9;
              _context.t0 = _context["catch"](2);
              throw new ABridgeSDKError("getUserAssets - Error", _context.t0);
            case 12:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this, [[2, 9]]);
    }));
    function getUserAssets(_x, _x2, _x3, _x4) {
      return _getUserAssets.apply(this, arguments);
    }
    return getUserAssets;
  }();
  _proto.getUserCollections = /*#__PURE__*/function () {
    var _getUserCollections = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2(userAddress, openseaApiKey) {
      var result;
      return _regeneratorRuntime().wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.prev = 0;
              _context2.next = 3;
              return axios$1.get("https://" + openSeaApiPrefix(this.chainId) + ".opensea.io/api/v1/collections?asset_owner=" + userAddress + "&offset=0&limit=300", {
                headers: {
                  "X-API-KEY": openseaApiKey
                }
              });
            case 3:
              result = _context2.sent.data;
              return _context2.abrupt("return", result);
            case 7:
              _context2.prev = 7;
              _context2.t0 = _context2["catch"](0);
              throw new ABridgeSDKError("getUserCollections - Error", _context2.t0);
            case 10:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, this, [[0, 7]]);
    }));
    function getUserCollections(_x5, _x6) {
      return _getUserCollections.apply(this, arguments);
    }
    return getUserCollections;
  }();
  _proto.estimateErc20AutoClaim = /*#__PURE__*/function () {
    var _estimateErc20AutoClaim = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee3(sourceChainId,
    // number
    targetChainId,
    // number
    tokenAddress,
    // address, like 0x...
    amount,
    // string, like 0.1
    senderAddress,
    // address, like 0x...
    receiverAddress // address, like 0x...
    ) {
      var response;
      return _regeneratorRuntime().wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              _context3.next = 2;
              return this.backendAxios("/erc20/estimateDeliveryFee?sourceChainId=" + sourceChainId + "&targetChainId=" + targetChainId + "&token=" + tokenAddress + "&amount=" + amount + "&sender=" + senderAddress + "&receiver=" + receiverAddress, {
                responseType: "json"
              });
            case 2:
              response = _context3.sent;
              return _context3.abrupt("return", response.data);
            case 4:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3, this);
    }));
    function estimateErc20AutoClaim(_x7, _x8, _x9, _x10, _x11, _x12) {
      return _estimateErc20AutoClaim.apply(this, arguments);
    }
    return estimateErc20AutoClaim;
  }();
  _proto.getClaimsLegacy = /*#__PURE__*/function () {
    var _getClaimsLegacy = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee4(userAddress, targetChainId, page) {
      var transfers;
      return _regeneratorRuntime().wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              if (page === void 0) {
                page = "undefined";
              }
              _context4.next = 3;
              return this.axios("/getTransfers?targetChainId=" + targetChainId + "&recipient=" + userAddress + "&page=" + page, {
                responseType: "json"
              });
            case 3:
              transfers = _context4.sent;
              return _context4.abrupt("return", {
                claims: transfers.data.transfers,
                totalCount: transfers.headers["x-total-count"]
              });
            case 5:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4, this);
    }));
    function getClaimsLegacy(_x13, _x14, _x15) {
      return _getClaimsLegacy.apply(this, arguments);
    }
    return getClaimsLegacy;
  }();
  _proto.getErc20Claims = /*#__PURE__*/function () {
    var _getErc20Claims = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee5(targetChainId, userAddress) {
      var response, transmissions;
      return _regeneratorRuntime().wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              _context5.next = 2;
              return this.backendAxios("/erc20/claims?targetChainId=" + targetChainId + "&receiver=" + userAddress, {
                responseType: "json"
              });
            case 2:
              response = _context5.sent;
              transmissions = response.data.map(function (item) {
                item.delivered = item.delivery ? true : false;
                return item;
              });
              return _context5.abrupt("return", this._decodeErc20Transmissions(transmissions));
            case 5:
            case "end":
              return _context5.stop();
          }
        }
      }, _callee5, this);
    }));
    function getErc20Claims(_x16, _x17) {
      return _getErc20Claims.apply(this, arguments);
    }
    return getErc20Claims;
  }();
  _proto.getNftClaims = /*#__PURE__*/function () {
    var _getNftClaims = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee6(targetChainId, userAddress) {
      var response, transmissions, decodedTransmissions, transmissionsForMulticall, nftData, index, decodedTransmission, operation, collectionAddress, tokenIds, collectionName, tokenURIs, i, tokenURI, tokenMetadata, multicallNfts, concatedArray;
      return _regeneratorRuntime().wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              _context6.next = 2;
              return this.backendAxios("/erc721/claims?targetChainId=" + targetChainId + "&receiver=" + userAddress, {
                responseType: "json"
              });
            case 2:
              response = _context6.sent;
              transmissions = response.data.map(function (item) {
                item.delivered = item.delivery ? true : false;
                return item;
              });
              decodedTransmissions = this._decodeNftTransmissions(transmissions);
              transmissionsForMulticall = [];
              nftData = [];
              index = 0;
            case 8:
              if (!(index < decodedTransmissions.length)) {
                _context6.next = 39;
                break;
              }
              decodedTransmission = decodedTransmissions[index];
              operation = decodedTransmission.decoded.actions[0].operation;
              collectionAddress = decodedTransmission.decoded.actions[0].collection;
              tokenIds = decodedTransmission.decoded.actions[0].data.tokenIds;
              if (!(operation != 0)) {
                _context6.next = 35;
                break;
              }
              collectionName = decodedTransmission.decoded.actions[0].data.name;
              tokenURIs = decodedTransmission.decoded.actions[0].data.tokenURIs;
              i = 0;
            case 17:
              if (!(i < tokenIds.length)) {
                _context6.next = 33;
                break;
              }
              tokenURI = tokenURIs[i];
              tokenMetadata = void 0;
              _context6.prev = 20;
              _context6.next = 23;
              return this.loadTokenMetadata(tokenURI);
            case 23:
              tokenMetadata = _context6.sent;
              _context6.next = 29;
              break;
            case 26:
              _context6.prev = 26;
              _context6.t0 = _context6["catch"](20);
              console.error("Token Metadata cannot be loaded");
            case 29:
              nftData.push(_extends({
                collectionAddress: collectionAddress,
                collectionName: collectionName,
                tokenURI: tokenURI,
                tokenId: tokenIds[i]
              }, tokenMetadata, decodedTransmission.transmissionDetails, {
                receiver: decodedTransmission.decoded.receiver
              }));
            case 30:
              i++;
              _context6.next = 17;
              break;
            case 33:
              _context6.next = 36;
              break;
            case 35:
              transmissionsForMulticall.push({
                collectionAddress: collectionAddress,
                tokenIds: tokenIds,
                transmissionDetails: decodedTransmission.transmissionDetails,
                receiver: decodedTransmission.decoded.receiver
              });
            case 36:
              index++;
              _context6.next = 8;
              break;
            case 39:
              _context6.next = 41;
              return this._loadNftsByCollectionAndIdMulticall(transmissionsForMulticall);
            case 41:
              multicallNfts = _context6.sent;
              concatedArray = nftData.concat(multicallNfts);
              return _context6.abrupt("return", concatedArray);
            case 44:
            case "end":
              return _context6.stop();
          }
        }
      }, _callee6, this, [[20, 26]]);
    }));
    function getNftClaims(_x18, _x19) {
      return _getNftClaims.apply(this, arguments);
    }
    return getNftClaims;
  }();
  _proto.getRandomProperty = function getRandomProperty(obj) {
    var keys = Object.keys(obj);
    var randomIndex = keys.length * Math.random() << 0;
    return obj[keys[randomIndex]];
  };
  _proto.getValidatorVersionLegacy = /*#__PURE__*/function () {
    var _getValidatorVersionLegacy = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee7() {
      var versionRequest;
      return _regeneratorRuntime().wrap(function _callee7$(_context7) {
        while (1) {
          switch (_context7.prev = _context7.next) {
            case 0:
              _context7.next = 2;
              return this.axios("/status", {
                responseType: "json"
              });
            case 2:
              versionRequest = _context7.sent;
              return _context7.abrupt("return", versionRequest.data.version);
            case 4:
            case "end":
              return _context7.stop();
          }
        }
      }, _callee7, this);
    }));
    function getValidatorVersionLegacy() {
      return _getValidatorVersionLegacy.apply(this, arguments);
    }
    return getValidatorVersionLegacy;
  }();
  _proto.getWrappedTokensLegacy = /*#__PURE__*/function () {
    var _getWrappedTokensLegacy = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee8(chainId) {
      var wrappedTokens;
      return _regeneratorRuntime().wrap(function _callee8$(_context8) {
        while (1) {
          switch (_context8.prev = _context8.next) {
            case 0:
              _context8.next = 2;
              return this.axios("/getWrappedTokens?chainId=" + chainId, {
                responseType: "json"
              });
            case 2:
              wrappedTokens = _context8.sent;
              return _context8.abrupt("return", wrappedTokens.data.wrappedTokens);
            case 4:
            case "end":
              return _context8.stop();
          }
        }
      }, _callee8, this);
    }));
    function getWrappedTokensLegacy(_x20) {
      return _getWrappedTokensLegacy.apply(this, arguments);
    }
    return getWrappedTokensLegacy;
  }();
  _proto.loadTokenMetadata = /*#__PURE__*/function () {
    var _loadTokenMetadata = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee9(metadataUrl) {
      var uri, axiosResponse;
      return _regeneratorRuntime().wrap(function _callee9$(_context9) {
        while (1) {
          switch (_context9.prev = _context9.next) {
            case 0:
              uri = uriToHttp(metadataUrl);
              _context9.prev = 1;
              _context9.next = 4;
              return axios$1.get(uri);
            case 4:
              axiosResponse = _context9.sent;
              return _context9.abrupt("return", axiosResponse.data);
            case 8:
              _context9.prev = 8;
              _context9.t0 = _context9["catch"](1);
              throw new ABridgeSDKError("loadTokenMetadata - Error", _context9.t0);
            case 11:
            case "end":
              return _context9.stop();
          }
        }
      }, _callee9, null, [[1, 8]]);
    }));
    function loadTokenMetadata(_x21) {
      return _loadTokenMetadata.apply(this, arguments);
    }
    return loadTokenMetadata;
  }();
  _proto.setNftValidator = function setNftValidator(url) {
    this.nftValidatorURL = url;
    this.nftAxios = axios$1.create({
      baseURL: this.nftValidatorURL
    });
  };
  _proto.setValidator = function setValidator(url) {
    this.validatorURL = url;
    this.axios = axios$1.create({
      baseURL: this.validatorURL
    });
  };
  _proto._decodeErc20Transmissions = function _decodeErc20Transmissions(transmissions) {
    var transferedTokens = [];
    for (var index = 0; index < transmissions.length; index++) {
      var transmissionDetails = transmissions[index];
      var payload = transmissionDetails.payload;
      var header = void 0,
        envelope = void 0;
      try {
        var _ethers$utils$default = ethers$1.utils.defaultAbiCoder.decode(["uint256", "bytes"], payload);
        header = _ethers$utils$default[0];
        envelope = _ethers$utils$default[1];
      } catch (error) {
        console.error("The wrong payload is skipped", payload);
        continue;
      }
      var blob = void 0,
        subblob = void 0;
      var decoded = {};
      var _ethers$utils$default2 = ethers$1.utils.defaultAbiCoder.decode(["bytes", "bytes", "bytes", "uint256"], envelope);
      decoded.sender = _ethers$utils$default2[0];
      decoded.receiver = _ethers$utils$default2[1];
      blob = _ethers$utils$default2[2];
      decoded.deliveryFee = _ethers$utils$default2[3];
      var action = {};
      var _ethers$utils$default3 = ethers$1.utils.defaultAbiCoder.decode(["uint8", "bytes", "bytes"], blob);
      action.operation = _ethers$utils$default3[0];
      action.token = _ethers$utils$default3[1];
      subblob = _ethers$utils$default3[2];
      if (action.operation == 0) {
        // burnUnlock
        var d = ethers$1.utils.defaultAbiCoder.decode(["uint256"], subblob);
        action.data = {
          amount: d[0]
        };
      } else {
        // lockMint or burnMint
        var _d = ethers$1.utils.defaultAbiCoder.decode(["uint256", "uint8", "string", "string", "uint8"], subblob);
        action.data = {
          amount: _d[0],
          nativeChainId: _d[1],
          name: _d[2],
          symbol: _d[3],
          decimals: _d[4]
        };
      }
      decoded.action = action;
      transferedTokens.push({
        decoded: decoded,
        transmissionDetails: transmissionDetails
      });
    }
    return transferedTokens;
  };
  _proto._decodeNftTransmissions = function _decodeNftTransmissions(transmissions) {
    var collections = [];
    for (var index = 0; index < transmissions.length; index++) {
      var transmissionDetails = transmissions[index];
      var payload = transmissionDetails.payload;
      var header = void 0,
        envelope = void 0;
      try {
        var _ethers$utils$default4 = ethers$1.utils.defaultAbiCoder.decode(["uint256", "bytes"], payload);
        header = _ethers$utils$default4[0];
        envelope = _ethers$utils$default4[1];
      } catch (error) {
        console.error("The wrong payload is skipped", payload);
        continue;
      }
      var blob = void 0,
        subblob = void 0;
      var decoded = {};
      var _ethers$utils$default5 = ethers$1.utils.defaultAbiCoder.decode(["bytes", "bytes", "bytes[]"], envelope);
      decoded.sender = _ethers$utils$default5[0];
      decoded.receiver = _ethers$utils$default5[1];
      blob = _ethers$utils$default5[2];
      decoded.actions = [];
      for (var i in blob) {
        var action = {};
        var _ethers$utils$default6 = ethers$1.utils.defaultAbiCoder.decode(["uint8", "bytes", "bytes"], blob[i]);
        action.operation = _ethers$utils$default6[0];
        action.collection = _ethers$utils$default6[1];
        subblob = _ethers$utils$default6[2];
        if (action.operation == 0) {
          // unlock
          var d = ethers$1.utils.defaultAbiCoder.decode(["uint256[]"], subblob);
          action.data = {
            tokenIds: d[0]
          };
        } else {
          // mint
          var _d2 = ethers$1.utils.defaultAbiCoder.decode(["uint256[]", "uint8", "string[]", "string", "string"], subblob);
          action.data = {
            tokenIds: _d2[0],
            nativeChainId: _d2[1],
            tokenURIs: _d2[2],
            name: _d2[3],
            symbol: _d2[4]
          };
        }
        decoded.actions[i] = action;
      }
      collections.push({
        decoded: decoded,
        transmissionDetails: transmissionDetails
      });
    }
    return collections;
  };
  _proto._getAllValidators = function _getAllValidators(validators) {
    var validatorArray = [];
    for (var key in validators) {
      if (Object.hasOwnProperty.call(validators, key)) {
        var element = validators[key];
        validatorArray.push(element);
      }
    }
    return validatorArray;
  };
  _proto._getDefaultConfiguredNftValidatorVersion = /*#__PURE__*/function () {
    var _getDefaultConfiguredNftValidatorVersion2 = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee10() {
      var validatorArray, index, version;
      return _regeneratorRuntime().wrap(function _callee10$(_context10) {
        while (1) {
          switch (_context10.prev = _context10.next) {
            case 0:
              validatorArray = this._getAllValidators(this.config.nftValidators);
              index = 0;
            case 2:
              if (!(index < validatorArray.length)) {
                _context10.next = 17;
                break;
              }
              _context10.prev = 3;
              _context10.next = 6;
              return axios$1.get(validatorArray[index] + "/status");
            case 6:
              version = _context10.sent.data.version;
              this.setNftValidator(validatorArray[index]);
              return _context10.abrupt("return", version);
            case 11:
              _context10.prev = 11;
              _context10.t0 = _context10["catch"](3);
              return _context10.abrupt("continue", 14);
            case 14:
              index++;
              _context10.next = 2;
              break;
            case 17:
            case "end":
              return _context10.stop();
          }
        }
      }, _callee10, this, [[3, 11]]);
    }));
    function _getDefaultConfiguredNftValidatorVersion() {
      return _getDefaultConfiguredNftValidatorVersion2.apply(this, arguments);
    }
    return _getDefaultConfiguredNftValidatorVersion;
  }();
  _proto._getDefaultConfiguredValidatorVersion = /*#__PURE__*/function () {
    var _getDefaultConfiguredValidatorVersion2 = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee11() {
      var validatorArray, index, version;
      return _regeneratorRuntime().wrap(function _callee11$(_context11) {
        while (1) {
          switch (_context11.prev = _context11.next) {
            case 0:
              validatorArray = this._getAllValidators(this.config.validators);
              index = 0;
            case 2:
              if (!(index < validatorArray.length)) {
                _context11.next = 17;
                break;
              }
              _context11.prev = 3;
              _context11.next = 6;
              return axios$1.get(validatorArray[index] + "/status");
            case 6:
              version = _context11.sent.data.version;
              this.setValidator(validatorArray[index]);
              return _context11.abrupt("return", version);
            case 11:
              _context11.prev = 11;
              _context11.t0 = _context11["catch"](3);
              return _context11.abrupt("continue", 14);
            case 14:
              index++;
              _context11.next = 2;
              break;
            case 17:
            case "end":
              return _context11.stop();
          }
        }
      }, _callee11, this, [[3, 11]]);
    }));
    function _getDefaultConfiguredValidatorVersion() {
      return _getDefaultConfiguredValidatorVersion2.apply(this, arguments);
    }
    return _getDefaultConfiguredValidatorVersion;
  }();
  _proto._setNftValidatorBasedOnVersion = /*#__PURE__*/function () {
    var _setNftValidatorBasedOnVersion2 = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee12(validatorArray, checkedVersion) {
      var checkedMajorVersion, checkedMinorVersion, index, version, majorVersion, minorVersion;
      return _regeneratorRuntime().wrap(function _callee12$(_context12) {
        while (1) {
          switch (_context12.prev = _context12.next) {
            case 0:
              checkedMajorVersion = parseInt(checkedVersion.split(".")[0]);
              checkedMinorVersion = parseInt(checkedVersion.split(".")[1]);
              index = 0;
            case 3:
              if (!(index < validatorArray.length)) {
                _context12.next = 25;
                break;
              }
              version = void 0;
              majorVersion = void 0;
              minorVersion = void 0;
              _context12.prev = 7;
              _context12.next = 10;
              return axios$1.get(validatorArray[index] + "/status");
            case 10:
              version = _context12.sent.data.version;
              majorVersion = parseInt(version.split(".")[0]);
              minorVersion = parseInt(version.split(".")[1]);
              _context12.next = 18;
              break;
            case 15:
              _context12.prev = 15;
              _context12.t0 = _context12["catch"](7);
              return _context12.abrupt("continue", 22);
            case 18:
              if (!(majorVersion === checkedMajorVersion && minorVersion >= checkedMinorVersion)) {
                _context12.next = 22;
                break;
              }
              this.nftValidatorVersion = version;
              this.setNftValidator(validatorArray[index]);
              return _context12.abrupt("break", 25);
            case 22:
              index++;
              _context12.next = 3;
              break;
            case 25:
            case "end":
              return _context12.stop();
          }
        }
      }, _callee12, this, [[7, 15]]);
    }));
    function _setNftValidatorBasedOnVersion(_x22, _x23) {
      return _setNftValidatorBasedOnVersion2.apply(this, arguments);
    }
    return _setNftValidatorBasedOnVersion;
  }();
  _proto._setValidatorBasedOnVersion = /*#__PURE__*/function () {
    var _setValidatorBasedOnVersion2 = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee13(validatorArray, checkedVersion) {
      var checkedMajorVersion, checkedMinorVersion, index, version, majorVersion, minorVersion;
      return _regeneratorRuntime().wrap(function _callee13$(_context13) {
        while (1) {
          switch (_context13.prev = _context13.next) {
            case 0:
              checkedMajorVersion = parseInt(checkedVersion.split(".")[0]);
              checkedMinorVersion = parseInt(checkedVersion.split(".")[1]);
              index = 0;
            case 3:
              if (!(index < validatorArray.length)) {
                _context13.next = 25;
                break;
              }
              version = void 0;
              majorVersion = void 0;
              minorVersion = void 0;
              _context13.prev = 7;
              _context13.next = 10;
              return axios$1.get(validatorArray[index] + "/status");
            case 10:
              version = _context13.sent.data.version;
              majorVersion = parseInt(version.split(".")[0]);
              minorVersion = parseInt(version.split(".")[1]);
              _context13.next = 18;
              break;
            case 15:
              _context13.prev = 15;
              _context13.t0 = _context13["catch"](7);
              return _context13.abrupt("continue", 22);
            case 18:
              if (!(majorVersion === checkedMajorVersion && minorVersion >= checkedMinorVersion)) {
                _context13.next = 22;
                break;
              }
              this.validatorVersion = version;
              this.setValidator(validatorArray[index]);
              return _context13.abrupt("break", 25);
            case 22:
              index++;
              _context13.next = 3;
              break;
            case 25:
            case "end":
              return _context13.stop();
          }
        }
      }, _callee13, this, [[7, 15]]);
    }));
    function _setValidatorBasedOnVersion(_x24, _x25) {
      return _setValidatorBasedOnVersion2.apply(this, arguments);
    }
    return _setValidatorBasedOnVersion;
  }();
  return RouterSDK;
}();

var _require = /*#__PURE__*/require("axios"),
  axios = _require["default"];
var _require2 = /*#__PURE__*/require("ethers"),
  ethers = _require2.ethers,
  BigNumber = _require2.BigNumber;
var EvmRouterSDK = /*#__PURE__*/function (_RouterSDK) {
  _inheritsLoose(EvmRouterSDK, _RouterSDK);
  function EvmRouterSDK(signerOrProvider, optionalParams) {
    var _this$config;
    var _this;
    _this = _RouterSDK.call(this, signerOrProvider, optionalParams) || this;
    _this.setParams(optionalParams || {});
    if ((_this$config = _this.config) != null && _this$config.contracts.multicall && _this.chainId == 1287 || _this.chainId == 1284 || _this.chainId == 421611 || _this.chainId == 42161 || _this.chainId == 1313161555) {
      _this.multicallContract = new ethers.Contract(_this.config.contracts.multicall, MulticallAbi, _this.signerOrProvider);
    }
    _this.erc20RouterContract = new ethers.Contract(_this.ERC20RouterAddress, _this.ERC20RouterAbi, _this.signerOrProvider);
    _this.legacyRouterContract = new ethers.Contract(_this.LegacyRouterAddress, _this.LegacyRouterAbi, _this.signerOrProvider);
    _this.legacyRouterProxyContract = new ethers.Contract(_this.LegacyRouterProxyAddress, _this.LegacyRouterProxyAbi, _this.signerOrProvider);
    return _this;
  }
  /**
   * @param optionalParams
   * @property validators: object
   * @property legacyRouterABI: LegacyRouterAbi
   * @property legacyRouterAddress: address
   * @property legacyRouterProxyABI: LegacyRouterProxyAbi
   * @property legacyRouterProxyAddress: address
   * @property wrappedErc721ABI: WrappedERC721
   * @property teleportABI: ITeleport
   * @property nftRouterABI: NFTIRouterDiamond
   * @property erc20RouterABI: ERC20IRouterDiamond
   * @property erc20RouterAddress: address
   * @property erc20PermitABI: ERC20Permit
   * @property threshold: number
   * @property validatorTargetVersion: string
   * @property nftValidatorTargetVersion: string
   */
  var _proto = EvmRouterSDK.prototype;
  _proto.setParams = function setParams(optionalParams) {
    // Call super.setParams to set common params for all routers
    _RouterSDK.prototype.setParams.call(this, optionalParams);
    if (optionalParams["validators"]) {
      this.validatorURL = this.getRandomProperty(optionalParams.validators);
    } else {
      this.validatorURL = this.getRandomProperty(this.config.validators);
    }
    if (optionalParams["legacyRouterABI"]) {
      this.LegacyRouterAbi = optionalParams.legacyRouterABI;
    } else {
      this.LegacyRouterAbi = LegacyRouterAbi;
    }
    if (optionalParams["legacyRouterAddress"]) {
      this.LegacyRouterAddress = optionalParams.legacyRouterAddress;
    } else {
      this.LegacyRouterAddress = this.config.contracts.legacyErc20["router"];
    }
    if (optionalParams["legacyRouterProxyABI"]) {
      this.LegacyRouterProxyAbi = optionalParams.legacyRouterProxyABI;
    } else {
      this.LegacyRouterProxyAbi = LegacyRouterProxyAbi;
    }
    if (optionalParams["legacyRouterProxyAddress"]) {
      this.LegacyRouterProxyAddress = optionalParams.legacyRouterProxyAddress;
    } else {
      this.LegacyRouterProxyAddress = this.config.contracts.legacyErc20["router-proxy"];
    }
    if (optionalParams["wrappedErc721ABI"]) {
      this.WrappedERC721Abi = optionalParams.wrappedErc721ABI;
    } else {
      this.WrappedERC721Abi = WrappedERC721Abi;
    }
    if (optionalParams["teleportABI"]) {
      this.ITeleportAbi = optionalParams.teleportABI;
    } else {
      this.ITeleportAbi = ITeleportAbi;
    }
    if (optionalParams["nftRouterABI"]) {
      this.NFTRouterAbi = optionalParams.nftRouterABI;
    } else {
      this.NFTRouterAbi = NFTRouterAbi;
    }
    if (optionalParams["erc20RouterABI"]) {
      this.ERC20RouterAbi = optionalParams.erc20RouterABI;
    } else {
      this.ERC20RouterAbi = ERC20RouterAbi;
    }
    if (optionalParams["erc20RouterAddress"]) {
      this.ERC20RouterAddress = optionalParams.erc20RouterAddress;
    } else {
      this.ERC20RouterAddress = this.config.contracts.erc20Router;
    }
    if (optionalParams["erc20PermitABI"]) {
      this.ERC20PermitAbi = optionalParams.erc20PermitABI;
    } else {
      this.ERC20PermitAbi = ERC20PermitAbi;
    }
    var threshold;
    if (optionalParams["threshold"]) {
      threshold = ethers.utils.formatUnits(optionalParams.threshold);
    } else {
      threshold = ethers.utils.formatUnits(this.config.threshold);
    }
    this.tokenAllowanceThreshold = ethers.utils.parseUnits(threshold);
  };
  _proto.allowance = /*#__PURE__*/function () {
    var _allowance = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(tokenAddress, userAddress) {
      var tokenContract, tokenDecimals, allowance;
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              tokenContract = new ethers.Contract(tokenAddress, this.ERC20PermitAbi, this.signerOrProvider);
              _context.next = 3;
              return tokenContract.decimals();
            case 3:
              tokenDecimals = _context.sent;
              _context.next = 6;
              return tokenContract.allowance(userAddress, this.erc20RouterContract.address);
            case 6:
              allowance = _context.sent;
              return _context.abrupt("return", {
                allowance: allowance,
                tokenDecimals: tokenDecimals
              });
            case 8:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));
    function allowance(_x, _x2) {
      return _allowance.apply(this, arguments);
    }
    return allowance;
  }();
  _proto.allowanceLegacy = /*#__PURE__*/function () {
    var _allowanceLegacy = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2(tokenAddress, userAddress) {
      var tokenContract, tokenDecimals, allowance;
      return _regeneratorRuntime().wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              tokenContract = new ethers.Contract(tokenAddress, this.ERC20PermitAbi, this.signerOrProvider);
              _context2.next = 3;
              return tokenContract.decimals();
            case 3:
              tokenDecimals = _context2.sent;
              _context2.next = 6;
              return tokenContract.allowance(userAddress, this.legacyRouterContract.address);
            case 6:
              allowance = _context2.sent;
              return _context2.abrupt("return", {
                allowance: allowance,
                tokenDecimals: tokenDecimals
              });
            case 8:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, this);
    }));
    function allowanceLegacy(_x3, _x4) {
      return _allowanceLegacy.apply(this, arguments);
    }
    return allowanceLegacy;
  }();
  _proto.approve = /*#__PURE__*/function () {
    var _approve = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee3(tokenAddress, amount) {
      var tokenContract;
      return _regeneratorRuntime().wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              tokenContract = new ethers.Contract(tokenAddress, this.ERC20PermitAbi, this.signerOrProvider);
              _context3.next = 3;
              return tokenContract.populateTransaction.approve(this.erc20RouterContract.address, amount);
            case 3:
              return _context3.abrupt("return", _context3.sent);
            case 4:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3, this);
    }));
    function approve(_x5, _x6) {
      return _approve.apply(this, arguments);
    }
    return approve;
  }();
  _proto.approveLegacy = /*#__PURE__*/function () {
    var _approveLegacy = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee4(tokenAddress, amount, bridgedTokenIsNativeTokenOrNonDefaultFee) {
      var tokenContract;
      return _regeneratorRuntime().wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              tokenContract = new ethers.Contract(tokenAddress, this.ERC20PermitAbi, this.signerOrProvider);
              _context4.next = 3;
              return tokenContract.populateTransaction.approve(bridgedTokenIsNativeTokenOrNonDefaultFee ? this.legacyRouterProxyContract.address : this.legacyRouterContract.address, amount);
            case 3:
              return _context4.abrupt("return", _context4.sent);
            case 4:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4, this);
    }));
    function approveLegacy(_x7, _x8, _x9) {
      return _approveLegacy.apply(this, arguments);
    }
    return approveLegacy;
  }();
  _proto.approveMaxInt = /*#__PURE__*/function () {
    var _approveMaxInt = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee5(tokenAddress) {
      return _regeneratorRuntime().wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              return _context5.abrupt("return", this.approve(tokenAddress, ethers.constants.MaxUint256));
            case 1:
            case "end":
              return _context5.stop();
          }
        }
      }, _callee5, this);
    }));
    function approveMaxInt(_x10) {
      return _approveMaxInt.apply(this, arguments);
    }
    return approveMaxInt;
  }();
  _proto.approveMaxIntLegacy = /*#__PURE__*/function () {
    var _approveMaxIntLegacy = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee6(tokenAddress, bridgedTokenIsNativeTokenOrNonDefaultFee) {
      return _regeneratorRuntime().wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              return _context6.abrupt("return", this.approveLegacy(tokenAddress, ethers.constants.MaxUint256, bridgedTokenIsNativeTokenOrNonDefaultFee));
            case 1:
            case "end":
              return _context6.stop();
          }
        }
      }, _callee6, this);
    }));
    function approveMaxIntLegacy(_x11, _x12) {
      return _approveMaxIntLegacy.apply(this, arguments);
    }
    return approveMaxIntLegacy;
  }();
  _proto.approveNfts = /*#__PURE__*/function () {
    var _approveNfts = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee7(collectionAddress) {
      var tokenContract;
      return _regeneratorRuntime().wrap(function _callee7$(_context7) {
        while (1) {
          switch (_context7.prev = _context7.next) {
            case 0:
              tokenContract = new ethers.Contract(collectionAddress, this.WrappedERC721Abi, this.signerOrProvider);
              return _context7.abrupt("return", tokenContract.populateTransaction.setApprovalForAll(this.config.contracts.nftRouter, true));
            case 2:
            case "end":
              return _context7.stop();
          }
        }
      }, _callee7, this);
    }));
    function approveNfts(_x13) {
      return _approveNfts.apply(this, arguments);
    }
    return approveNfts;
  }();
  _proto.balanceOf = /*#__PURE__*/function () {
    var _balanceOf = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee8(tokenAddress, userAddress) {
      var balance, tokenDecimals, tokenContract;
      return _regeneratorRuntime().wrap(function _callee8$(_context8) {
        while (1) {
          switch (_context8.prev = _context8.next) {
            case 0:
              tokenContract = new ethers.Contract(tokenAddress, this.ERC20PermitAbi, this.signerOrProvider);
              _context8.next = 3;
              return tokenContract.balanceOf(userAddress);
            case 3:
              balance = _context8.sent;
              _context8.next = 6;
              return tokenContract.decimals();
            case 6:
              tokenDecimals = _context8.sent;
              return _context8.abrupt("return", {
                balance: balance,
                tokenDecimals: tokenDecimals
              });
            case 8:
            case "end":
              return _context8.stop();
          }
        }
      }, _callee8, this);
    }));
    function balanceOf(_x14, _x15) {
      return _balanceOf.apply(this, arguments);
    }
    return balanceOf;
  }();
  _proto.balanceOfLegacy = /*#__PURE__*/function () {
    var _balanceOfLegacy = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee9(tokenAddress, userAddress) {
      var balance, tokenDecimals, tokenContract;
      return _regeneratorRuntime().wrap(function _callee9$(_context9) {
        while (1) {
          switch (_context9.prev = _context9.next) {
            case 0:
              if (!(tokenAddress === this.legacyRouterProxyContract.address)) {
                _context9.next = 9;
                break;
              }
              _context9.next = 3;
              return this.signerOrProvider.getBalance();
            case 3:
              balance = _context9.sent;
              _context9.next = 6;
              return this.legacyRouterProxyContract.decimals();
            case 6:
              tokenDecimals = _context9.sent;
              _context9.next = 16;
              break;
            case 9:
              tokenContract = new ethers.Contract(tokenAddress, this.ERC20PermitAbi, this.signerOrProvider);
              _context9.next = 12;
              return tokenContract.balanceOf(userAddress);
            case 12:
              balance = _context9.sent;
              _context9.next = 15;
              return tokenContract.decimals();
            case 15:
              tokenDecimals = _context9.sent;
            case 16:
              return _context9.abrupt("return", {
                balance: balance,
                tokenDecimals: tokenDecimals
              });
            case 17:
            case "end":
              return _context9.stop();
          }
        }
      }, _callee9, this);
    }));
    function balanceOfLegacy(_x16, _x17) {
      return _balanceOfLegacy.apply(this, arguments);
    }
    return balanceOfLegacy;
  }();
  _proto.balanceOfMulticall = /*#__PURE__*/function () {
    var _balanceOfMulticall = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee10(tokenAddresses, userAddress) {
      var tokenInterface, fragment_balance, multi, inputs, outputs, result, tokenAddress, index, balance, _tokenAddress, tokenData, i;
      return _regeneratorRuntime().wrap(function _callee10$(_context10) {
        while (1) {
          switch (_context10.prev = _context10.next) {
            case 0:
              tokenInterface = new ethers.utils.Interface(this.ERC20PermitAbi);
              fragment_balance = tokenInterface.getFunction("balanceOf");
              multi = new MultiCall(this.signerOrProvider);
              inputs = [];
              outputs = [];
              if (!(this.chainId == 1287 || this.chainId == 1284 || this.chainId == 421611 || this.chainId == 42161 || this.chainId == 1313161555)) {
                _context10.next = 20;
                break;
              }
              for (tokenAddress in tokenAddresses) {
                inputs.push({
                  target: tokenAddresses[tokenAddress],
                  callData: tokenInterface.encodeFunctionData(fragment_balance, [userAddress])
                });
              }
              _context10.prev = 7;
              _context10.next = 10;
              return this.multicallContract.callStatic.tryBlockAndAggregate(false, inputs);
            case 10:
              result = _context10.sent;
              _context10.next = 16;
              break;
            case 13:
              _context10.prev = 13;
              _context10.t0 = _context10["catch"](7);
              console.log(_context10.t0);
            case 16:
              for (index = 0; index < result.returnData.length; index++) {
                balance = tokenInterface.decodeFunctionResult(fragment_balance, result.returnData[index].returnData);
                outputs.push(balance);
              }
              return _context10.abrupt("return", outputs);
            case 20:
              for (_tokenAddress in tokenAddresses) {
                inputs.push({
                  target: tokenAddresses[_tokenAddress],
                  "function": "balanceOf",
                  args: [userAddress]
                });
              }
              _context10.next = 23;
              return multi.multiCall(this.ERC20PermitAbi, inputs);
            case 23:
              tokenData = _context10.sent;
              for (i = 0; i < inputs.length; i++) {
                outputs[i] = tokenData[1][i];
              }
              return _context10.abrupt("return", outputs);
            case 26:
            case "end":
              return _context10.stop();
          }
        }
      }, _callee10, this, [[7, 13]]);
    }));
    function balanceOfMulticall(_x18, _x19) {
      return _balanceOfMulticall.apply(this, arguments);
    }
    return balanceOfMulticall;
  }();
  _proto.balanceOfMulticallV2Legacy = /*#__PURE__*/function () {
    var _balanceOfMulticallV2Legacy = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee11(tokenAddresses, userAddress) {
      var tokenInterface, fragment_balance, multi, inputs, outputs, tokenAddress, balance, tokenData, i, _tokenAddress2, _balance, _tokenData, _i;
      return _regeneratorRuntime().wrap(function _callee11$(_context11) {
        while (1) {
          switch (_context11.prev = _context11.next) {
            case 0:
              tokenInterface = new ethers.utils.Interface(this.ERC20PermitAbi);
              fragment_balance = tokenInterface.getFunction("balanceOf");
              multi = new MultiCall(this.signerOrProvider);
              inputs = [];
              outputs = [];
              if (!(this.chainId == 1287 || this.chainId == 1284 || this.chainId == 421611 || this.chainId == 42161 || this.chainId == 1313161555)) {
                _context11.next = 26;
                break;
              }
              _context11.t0 = _regeneratorRuntime().keys(tokenAddresses);
            case 7:
              if ((_context11.t1 = _context11.t0()).done) {
                _context11.next = 19;
                break;
              }
              tokenAddress = _context11.t1.value;
              if (!(tokenAddresses[tokenAddress] === this.legacyRouterProxyContract.address)) {
                _context11.next = 16;
                break;
              }
              _context11.next = 12;
              return this.signerOrProvider.getBalance();
            case 12:
              balance = _context11.sent;
              outputs[tokenAddress] = balance;
              _context11.next = 17;
              break;
            case 16:
              inputs.push({
                target: tokenAddresses[tokenAddress],
                callData: tokenInterface.encodeFunctionData(fragment_balance, [userAddress])
              });
            case 17:
              _context11.next = 7;
              break;
            case 19:
              _context11.next = 21;
              return this.multicallContract.callStatic.tryBlockAndAggregate(false, inputs);
            case 21:
              tokenData = _context11.sent;
              for (i = 0; i < inputs.length; i++) {
                outputs[i] = tokenInterface.decodeFunctionResult(fragment_balance, tokenData.returnData[i].returnData)[0];
              }
              return _context11.abrupt("return", outputs);
            case 26:
              _context11.t2 = _regeneratorRuntime().keys(tokenAddresses);
            case 27:
              if ((_context11.t3 = _context11.t2()).done) {
                _context11.next = 39;
                break;
              }
              _tokenAddress2 = _context11.t3.value;
              if (!(tokenAddresses[_tokenAddress2] === this.legacyRouterProxyContract.address)) {
                _context11.next = 36;
                break;
              }
              _context11.next = 32;
              return this.signerOrProvider.getBalance();
            case 32:
              _balance = _context11.sent;
              outputs[_tokenAddress2] = _balance;
              _context11.next = 37;
              break;
            case 36:
              inputs.push({
                target: tokenAddresses[_tokenAddress2],
                "function": "balanceOf",
                args: [userAddress]
              });
            case 37:
              _context11.next = 27;
              break;
            case 39:
              _context11.next = 41;
              return multi.multiCall(this.ERC20PermitAbi, inputs);
            case 41:
              _tokenData = _context11.sent;
              for (_i = 0; _i < inputs.length; _i++) {
                outputs[_i] = _tokenData[1][_i];
              }
              return _context11.abrupt("return", outputs);
            case 44:
            case "end":
              return _context11.stop();
          }
        }
      }, _callee11, this);
    }));
    function balanceOfMulticallV2Legacy(_x20, _x21) {
      return _balanceOfMulticallV2Legacy.apply(this, arguments);
    }
    return balanceOfMulticallV2Legacy;
  }();
  _proto.checkTokenBlackListed = /*#__PURE__*/function () {
    var _checkTokenBlackListed = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee12(tokenAddress) {
      var _this2 = this;
      var nativeTokenAddress, isTokenBlackListed;
      return _regeneratorRuntime().wrap(function _callee12$(_context12) {
        while (1) {
          switch (_context12.prev = _context12.next) {
            case 0:
              _context12.prev = 0;
              _context12.next = 3;
              return this.getNativeTokenByWrappedAddress(tokenAddress);
            case 3:
              nativeTokenAddress = _context12.sent;
              isTokenBlackListed = this.blackListedTokens.some(function (tokenInfo) {
                if (_this2.chainId === tokenInfo.chainId) {
                  return tokenInfo.tokenAddress === tokenAddress;
                } else {
                  return tokenInfo.tokenAddress === nativeTokenAddress.contractAddress;
                }
              });
              return _context12.abrupt("return", isTokenBlackListed);
            case 8:
              _context12.prev = 8;
              _context12.t0 = _context12["catch"](0);
              return _context12.abrupt("return", false);
            case 11:
            case "end":
              return _context12.stop();
          }
        }
      }, _callee12, this, [[0, 8]]);
    }));
    function checkTokenBlackListed(_x22) {
      return _checkTokenBlackListed.apply(this, arguments);
    }
    return checkTokenBlackListed;
  }();
  _proto.claim = /*#__PURE__*/function () {
    var _claim = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee13(transmission) {
      var teleportContract;
      return _regeneratorRuntime().wrap(function _callee13$(_context13) {
        while (1) {
          switch (_context13.prev = _context13.next) {
            case 0:
              teleportContract = new ethers.Contract(this.config.contracts.teleport, this.ITeleportAbi, this.signerOrProvider);
              return _context13.abrupt("return", teleportContract.populateTransaction.deliver(transmission.transmissionId, transmission.sourceChainId, transmission.transmissionSender, transmission.transmissionReceiver, transmission.dAppId, transmission.payload, transmission.signatures));
            case 2:
            case "end":
              return _context13.stop();
          }
        }
      }, _callee13, this);
    }));
    function claim(_x23) {
      return _claim.apply(this, arguments);
    }
    return claim;
  }();
  _proto.claimLegacy = /*#__PURE__*/function () {
    var _claimLegacy = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee14(transfer) {
      return _regeneratorRuntime().wrap(function _callee14$(_context14) {
        while (1) {
          switch (_context14.prev = _context14.next) {
            case 0:
              _context14.t0 = transfer.transferType;
              _context14.next = _context14.t0 === TransferType.LOCK ? 3 : _context14.t0 === TransferType.BURN ? 6 : _context14.t0 === TransferType.BURN_AND_TRANSFER ? 9 : 12;
              break;
            case 3:
              _context14.next = 5;
              return this.legacyRouterContract.populateTransaction.mint(transfer.nativeChainId === 0 ? transfer.sourceChainId : transfer.nativeChainId, transfer.nativeToken, ethers.utils.toUtf8Bytes(transfer.sourceTx), transfer.amount, transfer.recipient, this.fixSignatures(transfer.signatures), {
                name: transfer.wrappedTokenName,
                symbol: transfer.wrappedTokenSymbol,
                decimals: transfer.wrappedTokenDecimals
              });
            case 5:
              return _context14.abrupt("return", _context14.sent);
            case 6:
              _context14.next = 8;
              return this.legacyRouterContract.populateTransaction.unlock(transfer.sourceChainId, ethers.utils.toUtf8Bytes(transfer.sourceTx), transfer.nativeToken, transfer.amount, transfer.recipient, this.fixSignatures(transfer.signatures));
            case 8:
              return _context14.abrupt("return", _context14.sent);
            case 9:
              _context14.next = 11;
              return this.legacyRouterContract.populateTransaction.mint(transfer.nativeChainId, transfer.nativeToken, ethers.utils.toUtf8Bytes(transfer.sourceTx), transfer.amount, transfer.recipient, this.fixSignatures(transfer.signatures), {
                name: transfer.wrappedTokenName,
                symbol: transfer.wrappedTokenSymbol,
                decimals: transfer.wrappedTokenDecimals
              });
            case 11:
              return _context14.abrupt("return", _context14.sent);
            case 12:
              return _context14.abrupt("return", null);
            case 13:
            case "end":
              return _context14.stop();
          }
        }
      }, _callee14, this);
    }));
    function claimLegacy(_x24) {
      return _claimLegacy.apply(this, arguments);
    }
    return claimLegacy;
  }();
  _proto.estimateApproveNfts = /*#__PURE__*/function () {
    var _estimateApproveNfts = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee15(collectionAddress) {
      var tokenContract;
      return _regeneratorRuntime().wrap(function _callee15$(_context15) {
        while (1) {
          switch (_context15.prev = _context15.next) {
            case 0:
              tokenContract = new ethers.Contract(collectionAddress, this.WrappedERC721Abi, this.signerOrProvider);
              return _context15.abrupt("return", tokenContract.estimateGas.setApprovalForAll(this.config.contracts.nftRouter, true));
            case 2:
            case "end":
              return _context15.stop();
          }
        }
      }, _callee15, this);
    }));
    function estimateApproveNfts(_x25) {
      return _estimateApproveNfts.apply(this, arguments);
    }
    return estimateApproveNfts;
  }();
  _proto.estimateClaim = /*#__PURE__*/function () {
    var _estimateClaim = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee16(transmission) {
      var teleportContract;
      return _regeneratorRuntime().wrap(function _callee16$(_context16) {
        while (1) {
          switch (_context16.prev = _context16.next) {
            case 0:
              teleportContract = new ethers.Contract(this.config.contracts.teleport, this.ITeleportAbi, this.signerOrProvider);
              return _context16.abrupt("return", teleportContract.estimateGas.deliver(transmission.transmissionId, transmission.sourceChainId, transmission.transmissionSender, transmission.transmissionReceiver, transmission.dAppId, transmission.payload, transmission.signatures));
            case 2:
            case "end":
              return _context16.stop();
          }
        }
      }, _callee16, this);
    }));
    function estimateClaim(_x26) {
      return _estimateClaim.apply(this, arguments);
    }
    return estimateClaim;
  }();
  _proto.estimateSendNftTokens = /*#__PURE__*/function () {
    var _estimateSendNftTokens = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee17(targetChainId, assets, userAddress, fee) {
      var nftRouter, assetInfo;
      return _regeneratorRuntime().wrap(function _callee17$(_context17) {
        while (1) {
          switch (_context17.prev = _context17.next) {
            case 0:
              nftRouter = new ethers.Contract(this.config.contracts.nftRouter, this.NFTRouterAbi, this.signerOrProvider);
              assetInfo = [{
                collection: assets[0].asset_contract.address,
                tokenIds: assets.map(function (x) {
                  return BigNumber.from(x.token_id);
                })
              }];
              return _context17.abrupt("return", nftRouter.estimateGas.egress(targetChainId, assetInfo, userAddress, {
                value: fee
              }));
            case 3:
            case "end":
              return _context17.stop();
          }
        }
      }, _callee17, this);
    }));
    function estimateSendNftTokens(_x27, _x28, _x29, _x30) {
      return _estimateSendNftTokens.apply(this, arguments);
    }
    return estimateSendNftTokens;
  }();
  _proto.fixSignatures = function fixSignatures(signatures) {
    var fixedSignatures = [];
    for (var i = 0; i < signatures.length; i++) {
      fixedSignatures[i] = signatures[i].startsWith("0x") ? signatures[i] : "0x" + signatures[i];
    }
    return fixedSignatures;
  };
  _proto.getALBTToken = /*#__PURE__*/function () {
    var _getALBTToken = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee18() {
      var albtAddress, albtDetails;
      return _regeneratorRuntime().wrap(function _callee18$(_context18) {
        while (1) {
          switch (_context18.prev = _context18.next) {
            case 0:
              _context18.next = 2;
              return this.erc20RouterContract.albtToken();
            case 2:
              albtAddress = _context18.sent;
              _context18.next = 5;
              return this.getTokenDetails(albtAddress);
            case 5:
              albtDetails = _context18.sent;
              return _context18.abrupt("return", _extends({
                address: albtAddress
              }, albtDetails));
            case 7:
            case "end":
              return _context18.stop();
          }
        }
      }, _callee18, this);
    }));
    function getALBTToken() {
      return _getALBTToken.apply(this, arguments);
    }
    return getALBTToken;
  }();
  _proto.getALBTTokenLegacy = /*#__PURE__*/function () {
    var _getALBTTokenLegacy = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee19() {
      var albtAddress, albtDetails;
      return _regeneratorRuntime().wrap(function _callee19$(_context19) {
        while (1) {
          switch (_context19.prev = _context19.next) {
            case 0:
              _context19.next = 2;
              return this.legacyRouterContract.albtToken();
            case 2:
              albtAddress = _context19.sent;
              _context19.next = 5;
              return this.getTokenDetails(albtAddress);
            case 5:
              albtDetails = _context19.sent;
              return _context19.abrupt("return", _extends({
                address: albtAddress
              }, albtDetails));
            case 7:
            case "end":
              return _context19.stop();
          }
        }
      }, _callee19, this);
    }));
    function getALBTTokenLegacy() {
      return _getALBTTokenLegacy.apply(this, arguments);
    }
    return getALBTTokenLegacy;
  }();
  _proto.getALBTTokenV1 = /*#__PURE__*/function () {
    var _getALBTTokenV = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee20() {
      var wrappedTokenAddress, albtDetails;
      return _regeneratorRuntime().wrap(function _callee20$(_context20) {
        while (1) {
          switch (_context20.prev = _context20.next) {
            case 0:
              if (!(this.chainId === this.nativeALBTinfo.chainId)) {
                _context20.next = 4;
                break;
              }
              return _context20.abrupt("return", this.nativeALBTinfo);
            case 4:
              _context20.next = 6;
              return this.getWrappedTokenDetails(this.nativeALBTinfo.tokenAddress, this.nativeALBTinfo.chainId);
            case 6:
              wrappedTokenAddress = _context20.sent;
              _context20.next = 9;
              return this.getTokenDetails(wrappedTokenAddress.address);
            case 9:
              albtDetails = _context20.sent;
              return _context20.abrupt("return", _extends({
                address: wrappedTokenAddress.address
              }, albtDetails));
            case 11:
            case "end":
              return _context20.stop();
          }
        }
      }, _callee20, this);
    }));
    function getALBTTokenV1() {
      return _getALBTTokenV.apply(this, arguments);
    }
    return getALBTTokenV1;
  }();
  _proto.getExternalFeeLegacy = /*#__PURE__*/function () {
    var _getExternalFeeLegacy = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee21() {
      return _regeneratorRuntime().wrap(function _callee21$(_context21) {
        while (1) {
          switch (_context21.prev = _context21.next) {
            case 0:
              _context21.next = 2;
              return this.legacyRouterContract.externalFee();
            case 2:
              return _context21.abrupt("return", _context21.sent);
            case 3:
            case "end":
              return _context21.stop();
          }
        }
      }, _callee21, this);
    }));
    function getExternalFeeLegacy() {
      return _getExternalFeeLegacy.apply(this, arguments);
    }
    return getExternalFeeLegacy;
  }();
  _proto.getFeeAmountByToken = /*#__PURE__*/function () {
    var _getFeeAmountByToken = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee22(tokenAddress) {
      return _regeneratorRuntime().wrap(function _callee22$(_context22) {
        while (1) {
          switch (_context22.prev = _context22.next) {
            case 0:
              _context22.next = 2;
              return this.erc20RouterContract.feeAmountByToken(tokenAddress);
            case 2:
              return _context22.abrupt("return", _context22.sent);
            case 3:
            case "end":
              return _context22.stop();
          }
        }
      }, _callee22, this);
    }));
    function getFeeAmountByToken(_x31) {
      return _getFeeAmountByToken.apply(this, arguments);
    }
    return getFeeAmountByToken;
  }();
  _proto.getFeeTokens = /*#__PURE__*/function () {
    var _getFeeTokens = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee23() {
      return _regeneratorRuntime().wrap(function _callee23$(_context23) {
        while (1) {
          switch (_context23.prev = _context23.next) {
            case 0:
              _context23.next = 2;
              return this.erc20RouterContract.feeTokens();
            case 2:
              return _context23.abrupt("return", _context23.sent);
            case 3:
            case "end":
              return _context23.stop();
          }
        }
      }, _callee23, this);
    }));
    function getFeeTokens() {
      return _getFeeTokens.apply(this, arguments);
    }
    return getFeeTokens;
  }();
  _proto.getNativeTokenByWrappedAddress = /*#__PURE__*/function () {
    var _getNativeTokenByWrappedAddress = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee24(wrappedTokenAddress) {
      return _regeneratorRuntime().wrap(function _callee24$(_context24) {
        while (1) {
          switch (_context24.prev = _context24.next) {
            case 0:
              _context24.next = 2;
              return this.erc20RouterContract.wrappedToNativeToken(wrappedTokenAddress);
            case 2:
              return _context24.abrupt("return", _context24.sent);
            case 3:
            case "end":
              return _context24.stop();
          }
        }
      }, _callee24, this);
    }));
    function getNativeTokenByWrappedAddress(_x32) {
      return _getNativeTokenByWrappedAddress.apply(this, arguments);
    }
    return getNativeTokenByWrappedAddress;
  }();
  _proto.getNativeTokenByWrappedAddressLegacy = /*#__PURE__*/function () {
    var _getNativeTokenByWrappedAddressLegacy = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee25(wrappedTokenAddress) {
      return _regeneratorRuntime().wrap(function _callee25$(_context25) {
        while (1) {
          switch (_context25.prev = _context25.next) {
            case 0:
              _context25.next = 2;
              return this.legacyRouterContract.wrappedToNativeToken(wrappedTokenAddress);
            case 2:
              return _context25.abrupt("return", _context25.sent);
            case 3:
            case "end":
              return _context25.stop();
          }
        }
      }, _callee25, this);
    }));
    function getNativeTokenByWrappedAddressLegacy(_x33) {
      return _getNativeTokenByWrappedAddressLegacy.apply(this, arguments);
    }
    return getNativeTokenByWrappedAddressLegacy;
  }();
  _proto.getNFTBridgeFee = /*#__PURE__*/function () {
    var _getNFTBridgeFee = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee26() {
      var nftRouter;
      return _regeneratorRuntime().wrap(function _callee26$(_context26) {
        while (1) {
          switch (_context26.prev = _context26.next) {
            case 0:
              nftRouter = new ethers.Contract(this.config.contracts.nftRouter, this.NFTRouterAbi, this.signerOrProvider);
              return _context26.abrupt("return", nftRouter.serviceFee());
            case 2:
            case "end":
              return _context26.stop();
          }
        }
      }, _callee26, this);
    }));
    function getNFTBridgeFee() {
      return _getNFTBridgeFee.apply(this, arguments);
    }
    return getNFTBridgeFee;
  }();
  _proto.getProxyFeeLegacy = /*#__PURE__*/function () {
    var _getProxyFeeLegacy = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee27(address) {
      return _regeneratorRuntime().wrap(function _callee27$(_context27) {
        while (1) {
          switch (_context27.prev = _context27.next) {
            case 0:
              _context27.next = 2;
              return this.legacyRouterProxyContract.feeAmountByToken(address);
            case 2:
              return _context27.abrupt("return", _context27.sent);
            case 3:
            case "end":
              return _context27.stop();
          }
        }
      }, _callee27, this);
    }));
    function getProxyFeeLegacy(_x34) {
      return _getProxyFeeLegacy.apply(this, arguments);
    }
    return getProxyFeeLegacy;
  }();
  _proto.getServiceFee = /*#__PURE__*/function () {
    var _getServiceFee = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee28() {
      return _regeneratorRuntime().wrap(function _callee28$(_context28) {
        while (1) {
          switch (_context28.prev = _context28.next) {
            case 0:
              _context28.next = 2;
              return this.erc20RouterContract.serviceFee();
            case 2:
              return _context28.abrupt("return", _context28.sent);
            case 3:
            case "end":
              return _context28.stop();
          }
        }
      }, _callee28, this);
    }));
    function getServiceFee() {
      return _getServiceFee.apply(this, arguments);
    }
    return getServiceFee;
  }();
  _proto.getServiceFeeLegacy = /*#__PURE__*/function () {
    var _getServiceFeeLegacy = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee29() {
      return _regeneratorRuntime().wrap(function _callee29$(_context29) {
        while (1) {
          switch (_context29.prev = _context29.next) {
            case 0:
              _context29.next = 2;
              return this.legacyRouterContract.serviceFee();
            case 2:
              return _context29.abrupt("return", _context29.sent);
            case 3:
            case "end":
              return _context29.stop();
          }
        }
      }, _callee29, this);
    }));
    function getServiceFeeLegacy() {
      return _getServiceFeeLegacy.apply(this, arguments);
    }
    return getServiceFeeLegacy;
  }();
  _proto.getTokenDecimals = /*#__PURE__*/function () {
    var _getTokenDecimals = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee30(tokenAddress) {
      var tokenContract;
      return _regeneratorRuntime().wrap(function _callee30$(_context30) {
        while (1) {
          switch (_context30.prev = _context30.next) {
            case 0:
              tokenContract = new ethers.Contract(tokenAddress, this.ERC20PermitAbi, this.signerOrProvider);
              _context30.next = 3;
              return tokenContract.decimals();
            case 3:
              return _context30.abrupt("return", _context30.sent);
            case 4:
            case "end":
              return _context30.stop();
          }
        }
      }, _callee30, this);
    }));
    function getTokenDecimals(_x35) {
      return _getTokenDecimals.apply(this, arguments);
    }
    return getTokenDecimals;
  }();
  _proto.getTokenDetails = /*#__PURE__*/function () {
    var _getTokenDetails = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee31(tokenAddress) {
      var tokenContract;
      return _regeneratorRuntime().wrap(function _callee31$(_context31) {
        while (1) {
          switch (_context31.prev = _context31.next) {
            case 0:
              tokenContract = new ethers.Contract(tokenAddress, this.ERC20PermitAbi, this.signerOrProvider);
              _context31.next = 3;
              return tokenContract.name();
            case 3:
              _context31.t0 = _context31.sent;
              _context31.next = 6;
              return tokenContract.symbol();
            case 6:
              _context31.t1 = _context31.sent;
              _context31.next = 9;
              return tokenContract.decimals();
            case 9:
              _context31.t2 = _context31.sent;
              return _context31.abrupt("return", {
                name: _context31.t0,
                symbol: _context31.t1,
                decimals: _context31.t2
              });
            case 11:
            case "end":
              return _context31.stop();
          }
        }
      }, _callee31, this);
    }));
    function getTokenDetails(_x36) {
      return _getTokenDetails.apply(this, arguments);
    }
    return getTokenDetails;
  }();
  _proto.getTokenDetailsMulticall = /*#__PURE__*/function () {
    var _getTokenDetailsMulticall = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee32(tokenAddresses, userAddress) {
      var _userAddress;
      var tokenInterface, fragment_balance, fragment_name, fragment_symbol, fragment_decimals, multi, inputs, inputs_second_chunk, outputs, tokenAddressesArray, tokenAddress, result, index, balance, name, symbol, decimals, _tokenAddress3, balances, tokenData, names, i;
      return _regeneratorRuntime().wrap(function _callee32$(_context32) {
        while (1) {
          switch (_context32.prev = _context32.next) {
            case 0:
              userAddress = (_userAddress = userAddress) != null ? _userAddress : this.signerOrProvider;
              tokenInterface = new ethers.utils.Interface(this.ERC20PermitAbi);
              fragment_balance = tokenInterface.getFunction("balanceOf");
              fragment_name = tokenInterface.getFunction("name");
              fragment_symbol = tokenInterface.getFunction("symbol");
              fragment_decimals = tokenInterface.getFunction("decimals");
              multi = new MultiCall(this.signerOrProvider);
              inputs = [];
              inputs_second_chunk = [];
              outputs = [];
              tokenAddressesArray = [];
              _context32.prev = 11;
              if (!(this.chainId == 1287 || this.chainId == 1284 || this.chainId == 421611 || this.chainId == 42161 || this.chainId == 1313161555)) {
                _context32.next = 21;
                break;
              }
              for (tokenAddress in tokenAddresses) {
                inputs.push({
                  target: tokenAddresses[tokenAddress],
                  callData: tokenInterface.encodeFunctionData(fragment_balance, [userAddress])
                });
                inputs.push({
                  target: tokenAddresses[tokenAddress],
                  callData: tokenInterface.encodeFunctionData(fragment_name, [])
                });
                inputs.push({
                  target: tokenAddresses[tokenAddress],
                  callData: tokenInterface.encodeFunctionData(fragment_symbol, [])
                });
                inputs.push({
                  target: tokenAddresses[tokenAddress],
                  callData: tokenInterface.encodeFunctionData(fragment_decimals, [])
                });
                outputs.push({
                  address: tokenAddresses[tokenAddress]
                });
              }
              _context32.next = 16;
              return this.multicallContract.callStatic.tryBlockAndAggregate(false, inputs);
            case 16:
              result = _context32.sent;
              for (index = 0; index < result.returnData.length; index = index + 4) {
                balance = tokenInterface.decodeFunctionResult(fragment_balance, result.returnData[index].returnData);
                name = tokenInterface.decodeFunctionResult(fragment_name, result.returnData[index + 1].returnData);
                symbol = tokenInterface.decodeFunctionResult(fragment_symbol, result.returnData[index + 2].returnData);
                decimals = tokenInterface.decodeFunctionResult(fragment_decimals, result.returnData[index + 3].returnData);
                outputs[index / 4].balance = balance[0];
                outputs[index / 4].name = name[0];
                outputs[index / 4].symbol = symbol[0];
                outputs[index / 4].decimals = decimals[0];
              }
              return _context32.abrupt("return", outputs);
            case 21:
              for (_tokenAddress3 in tokenAddresses) {
                inputs.push({
                  target: tokenAddresses[_tokenAddress3],
                  "function": "symbol",
                  args: []
                });
                inputs.push({
                  target: tokenAddresses[_tokenAddress3],
                  "function": "decimals",
                  args: []
                });
                inputs_second_chunk.push({
                  target: tokenAddresses[_tokenAddress3],
                  "function": "name",
                  args: []
                });
                outputs.push({
                  address: tokenAddresses[_tokenAddress3]
                });
                tokenAddressesArray.push(tokenAddresses[_tokenAddress3]);
              }
              _context32.next = 24;
              return multi.getBalances(tokenAddressesArray, userAddress);
            case 24:
              balances = _context32.sent;
              _context32.next = 27;
              return multi.multiCall(this.ERC20PermitAbi, inputs);
            case 27:
              tokenData = _context32.sent;
              _context32.next = 30;
              return multi.multiCall(this.ERC20PermitAbi, inputs_second_chunk);
            case 30:
              names = _context32.sent;
              for (i = 0; i < outputs.length; i++) {
                outputs[i].balance = balances[1][outputs[i].address];
                outputs[i].name = names[1][i];
                outputs[i].symbol = tokenData[1][i * 2];
                outputs[i].decimals = tokenData[1][i * 2 + 1];
              }
              return _context32.abrupt("return", outputs);
            case 33:
              _context32.next = 38;
              break;
            case 35:
              _context32.prev = 35;
              _context32.t0 = _context32["catch"](11);
              console.log(_context32.t0);
            case 38:
            case "end":
              return _context32.stop();
          }
        }
      }, _callee32, this, [[11, 35]]);
    }));
    function getTokenDetailsMulticall(_x37, _x38) {
      return _getTokenDetailsMulticall.apply(this, arguments);
    }
    return getTokenDetailsMulticall;
  }();
  _proto.getTokenName = /*#__PURE__*/function () {
    var _getTokenName = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee33(tokenAddress) {
      var tokenContract;
      return _regeneratorRuntime().wrap(function _callee33$(_context33) {
        while (1) {
          switch (_context33.prev = _context33.next) {
            case 0:
              tokenContract = new ethers.Contract(tokenAddress, this.ERC20PermitAbi, this.signerOrProvider);
              _context33.next = 3;
              return tokenContract.name();
            case 3:
              return _context33.abrupt("return", _context33.sent);
            case 4:
            case "end":
              return _context33.stop();
          }
        }
      }, _callee33, this);
    }));
    function getTokenName(_x39) {
      return _getTokenName.apply(this, arguments);
    }
    return getTokenName;
  }();
  _proto.getTokenSymbol = /*#__PURE__*/function () {
    var _getTokenSymbol = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee34(tokenAddress) {
      var tokenContract;
      return _regeneratorRuntime().wrap(function _callee34$(_context34) {
        while (1) {
          switch (_context34.prev = _context34.next) {
            case 0:
              tokenContract = new ethers.Contract(tokenAddress, this.ERC20PermitAbi, this.signerOrProvider);
              _context34.next = 3;
              return tokenContract.symbol();
            case 3:
              return _context34.abrupt("return", _context34.sent);
            case 4:
            case "end":
              return _context34.stop();
          }
        }
      }, _callee34, this);
    }));
    function getTokenSymbol(_x40) {
      return _getTokenSymbol.apply(this, arguments);
    }
    return getTokenSymbol;
  }();
  _proto.getWrappedForNativeToken = /*#__PURE__*/function () {
    var _getWrappedForNativeToken = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee35(nativeChainId, nativeToken) {
      return _regeneratorRuntime().wrap(function _callee35$(_context35) {
        while (1) {
          switch (_context35.prev = _context35.next) {
            case 0:
              _context35.next = 2;
              return this.erc20RouterContract.nativeToWrappedToken(nativeChainId, nativeToken);
            case 2:
              return _context35.abrupt("return", _context35.sent);
            case 3:
            case "end":
              return _context35.stop();
          }
        }
      }, _callee35, this);
    }));
    function getWrappedForNativeToken(_x41, _x42) {
      return _getWrappedForNativeToken.apply(this, arguments);
    }
    return getWrappedForNativeToken;
  }();
  _proto.getWrappedTokenDetails = /*#__PURE__*/function () {
    var _getWrappedTokenDetails = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee36(nativeTokenAddress, nativeChainId) {
      var wrappedTokenAddress, wrappedTokenDetails;
      return _regeneratorRuntime().wrap(function _callee36$(_context36) {
        while (1) {
          switch (_context36.prev = _context36.next) {
            case 0:
              _context36.next = 2;
              return this.erc20RouterContract.nativeToWrappedToken(nativeChainId, nativeTokenAddress);
            case 2:
              wrappedTokenAddress = _context36.sent;
              _context36.next = 5;
              return this.getTokenDetails(wrappedTokenAddress);
            case 5:
              wrappedTokenDetails = _context36.sent;
              return _context36.abrupt("return", _extends({
                address: wrappedTokenAddress
              }, wrappedTokenDetails));
            case 7:
            case "end":
              return _context36.stop();
          }
        }
      }, _callee36, this);
    }));
    function getWrappedTokenDetails(_x43, _x44) {
      return _getWrappedTokenDetails.apply(this, arguments);
    }
    return getWrappedTokenDetails;
  }();
  _proto.getWrappedTokenDetailsLegacy = /*#__PURE__*/function () {
    var _getWrappedTokenDetailsLegacy = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee37(nativeTokenAddress, nativeChainId) {
      var wrappedTokenAddress, wrappedTokenDetails;
      return _regeneratorRuntime().wrap(function _callee37$(_context37) {
        while (1) {
          switch (_context37.prev = _context37.next) {
            case 0:
              _context37.next = 2;
              return this.legacyRouterContract.nativeToWrappedToken(nativeChainId, nativeTokenAddress);
            case 2:
              wrappedTokenAddress = _context37.sent;
              _context37.next = 5;
              return this.getTokenDetails(wrappedTokenAddress);
            case 5:
              wrappedTokenDetails = _context37.sent;
              return _context37.abrupt("return", _extends({
                address: wrappedTokenAddress
              }, wrappedTokenDetails));
            case 7:
            case "end":
              return _context37.stop();
          }
        }
      }, _callee37, this);
    }));
    function getWrappedTokenDetailsLegacy(_x45, _x46) {
      return _getWrappedTokenDetailsLegacy.apply(this, arguments);
    }
    return getWrappedTokenDetailsLegacy;
  }();
  _proto.isAddress = function isAddress(address, limitOnCurve) {
    return ethers.utils.isAddress(address);
  };
  _proto.isClaimedLegacy = /*#__PURE__*/function () {
    var _isClaimedLegacy = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee38(transfer) {
      var encodedData, hashMsg, hashData;
      return _regeneratorRuntime().wrap(function _callee38$(_context38) {
        while (1) {
          switch (_context38.prev = _context38.next) {
            case 0:
              _context38.t0 = transfer.transferType;
              _context38.next = _context38.t0 === TransferType.BURN ? 3 : _context38.t0 === TransferType.LOCK ? 5 : _context38.t0 === TransferType.BURN_AND_TRANSFER ? 8 : 10;
              break;
            case 3:
              encodedData = ethers.utils.defaultAbiCoder.encode(["uint8", "uint8", "bytes", "address", "uint256", "bytes"], [transfer.sourceChainId, transfer.targetChainId, ethers.utils.toUtf8Bytes(transfer.sourceTx), transfer.recipient, transfer.amount, transfer.nativeToken]);
              return _context38.abrupt("break", 10);
            case 5:
              // Backwards compatibility fix
              if (transfer.nativeChainId === 0) {
                transfer.nativeChainId = transfer.sourceChainId;
              }
              encodedData = ethers.utils.defaultAbiCoder.encode(["uint8", "uint8", "bytes", "address", "uint256", "bytes", "string", "string", "uint8"], [transfer.nativeChainId, transfer.targetChainId, ethers.utils.toUtf8Bytes(transfer.sourceTx), transfer.recipient, transfer.amount, transfer.nativeToken, transfer.wrappedTokenName, transfer.wrappedTokenSymbol, transfer.wrappedTokenDecimals]);
              return _context38.abrupt("break", 10);
            case 8:
              encodedData = ethers.utils.defaultAbiCoder.encode(["uint8", "uint8", "bytes", "address", "uint256", "bytes", "string", "string", "uint8"], [transfer.nativeChainId, transfer.targetChainId, ethers.utils.toUtf8Bytes(transfer.sourceTx), transfer.recipient, transfer.amount, transfer.nativeToken, transfer.wrappedTokenName, transfer.wrappedTokenSymbol, transfer.wrappedTokenDecimals]);
              return _context38.abrupt("break", 10);
            case 10:
              hashMsg = ethers.utils.keccak256(encodedData);
              hashData = ethers.utils.arrayify(hashMsg);
              _context38.next = 14;
              return this.legacyRouterContract.hashesUsed(transfer.transferType == TransferType.BURN ? transfer.sourceChainId : transfer.nativeChainId, ethers.utils.hashMessage(hashData));
            case 14:
              return _context38.abrupt("return", _context38.sent);
            case 15:
            case "end":
              return _context38.stop();
          }
        }
      }, _callee38, this);
    }));
    function isClaimedLegacy(_x47) {
      return _isClaimedLegacy.apply(this, arguments);
    }
    return isClaimedLegacy;
  }();
  _proto.isClaimedMulticallLegacy = /*#__PURE__*/function () {
    var _isClaimedMulticallLegacy = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee39(transfers) {
      var size, arrayOfTransferArrays, i, multi, routerInterface, fragment, results, index, transferChunkArray, inputs, _index, transfer, transferChainId, encodedData, hashMsg, hashData, hashed, callArray, statuses, _index2, callData, result, _index3, status, _index4, _statuses;
      return _regeneratorRuntime().wrap(function _callee39$(_context39) {
        while (1) {
          switch (_context39.prev = _context39.next) {
            case 0:
              size = 20;
              arrayOfTransferArrays = [];
              for (i = 0; i < transfers.length; i += size) {
                arrayOfTransferArrays.push(transfers.slice(i, i + size));
              }
              multi = new MultiCall(this.signerOrProvider);
              routerInterface = new ethers.utils.Interface(this.LegacyRouterAbi);
              fragment = routerInterface.getFunction("hashesUsed");
              results = [];
              index = 0;
            case 8:
              if (!(index < arrayOfTransferArrays.length)) {
                _context39.next = 52;
                break;
              }
              transferChunkArray = arrayOfTransferArrays[index];
              inputs = [];
              _index = 0;
            case 12:
              if (!(_index < transferChunkArray.length)) {
                _context39.next = 33;
                break;
              }
              transfer = transferChunkArray[_index];
              transferChainId = transfer.transferType == TransferType.BURN ? transfer.sourceChainId : transfer.nativeChainId;
              encodedData = void 0;
              _context39.t0 = transfer.transferType;
              _context39.next = _context39.t0 === TransferType.BURN ? 19 : _context39.t0 === TransferType.LOCK ? 21 : _context39.t0 === TransferType.BURN_AND_TRANSFER ? 24 : 26;
              break;
            case 19:
              encodedData = ethers.utils.defaultAbiCoder.encode(["uint8", "uint8", "bytes", "address", "uint256", "bytes"], [transfer.sourceChainId, transfer.targetChainId, ethers.utils.toUtf8Bytes(transfer.sourceTx), transfer.recipient, transfer.amount, transfer.nativeToken]);
              return _context39.abrupt("break", 26);
            case 21:
              // Backwards compatibility fix
              if (transfer.nativeChainId === 0) {
                transfer.nativeChainId = transfer.sourceChainId;
              }
              encodedData = ethers.utils.defaultAbiCoder.encode(["uint8", "uint8", "bytes", "address", "uint256", "bytes", "string", "string", "uint8"], [transfer.nativeChainId, transfer.targetChainId, ethers.utils.toUtf8Bytes(transfer.sourceTx), transfer.recipient, transfer.amount, transfer.nativeToken, transfer.wrappedTokenName, transfer.wrappedTokenSymbol, transfer.wrappedTokenDecimals]);
              return _context39.abrupt("break", 26);
            case 24:
              encodedData = ethers.utils.defaultAbiCoder.encode(["uint8", "uint8", "bytes", "address", "uint256", "bytes", "string", "string", "uint8"], [transfer.nativeChainId, transfer.targetChainId, ethers.utils.toUtf8Bytes(transfer.sourceTx), transfer.recipient, transfer.amount, transfer.nativeToken, transfer.wrappedTokenName, transfer.wrappedTokenSymbol, transfer.wrappedTokenDecimals]);
              return _context39.abrupt("break", 26);
            case 26:
              hashMsg = ethers.utils.keccak256(encodedData);
              hashData = ethers.utils.arrayify(hashMsg);
              hashed = ethers.utils.hashMessage(hashData);
              inputs.push([transferChainId, hashed]);
            case 30:
              _index++;
              _context39.next = 12;
              break;
            case 33:
              callArray = []; // TODO: Add mainnet Moonbeam chainId
              if (!(this.chainId == 1287 || this.chainId == 1284 || this.chainId == 421611 || this.chainId == 42161 || this.chainId == 1313161555)) {
                _context39.next = 44;
                break;
              }
              statuses = [];
              for (_index2 = 0; _index2 < transferChunkArray.length; _index2++) {
                callData = routerInterface.encodeFunctionData(fragment, inputs[_index2]);
                callArray.push({
                  target: this.LegacyRouterAddress,
                  callData: callData
                });
              }
              _context39.next = 39;
              return this.multicallContract.callStatic.tryBlockAndAggregate(false, callArray);
            case 39:
              result = _context39.sent;
              for (_index3 = 0; _index3 < result.returnData.length; _index3++) {
                status = routerInterface.decodeFunctionResult(fragment, result.returnData[_index3].returnData);
                statuses.push(status[0]);
              }
              results.push.apply(results, statuses);
              _context39.next = 49;
              break;
            case 44:
              for (_index4 = 0; _index4 < transferChunkArray.length; _index4++) {
                callArray.push({
                  target: this.LegacyRouterAddress,
                  "function": "hashesUsed",
                  args: inputs[_index4]
                });
              }
              _context39.next = 47;
              return multi.multiCall(this.LegacyRouterAbi, callArray);
            case 47:
              _statuses = _context39.sent;
              results.push.apply(results, _statuses[1]);
            case 49:
              index++;
              _context39.next = 8;
              break;
            case 52:
              return _context39.abrupt("return", results);
            case 53:
            case "end":
              return _context39.stop();
          }
        }
      }, _callee39, this);
    }));
    function isClaimedMulticallLegacy(_x48) {
      return _isClaimedMulticallLegacy.apply(this, arguments);
    }
    return isClaimedMulticallLegacy;
  }();
  _proto.isNftsApproved = /*#__PURE__*/function () {
    var _isNftsApproved = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee40(userAddress, collectionAddress) {
      var tokenContract;
      return _regeneratorRuntime().wrap(function _callee40$(_context40) {
        while (1) {
          switch (_context40.prev = _context40.next) {
            case 0:
              tokenContract = new ethers.Contract(collectionAddress, this.WrappedERC721Abi, this.signerOrProvider);
              return _context40.abrupt("return", tokenContract.isApprovedForAll(userAddress, this.config.contracts.nftRouter));
            case 2:
            case "end":
              return _context40.stop();
          }
        }
      }, _callee40, this);
    }));
    function isNftsApproved(_x49, _x50) {
      return _isNftsApproved.apply(this, arguments);
    }
    return isNftsApproved;
  }();
  _proto.isTokenApproved = /*#__PURE__*/function () {
    var _isTokenApproved = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee41(tokenAddress, userAddress, threshold /** optional */) {
      var allowanceThreshold, tokenContract, currentAllowance;
      return _regeneratorRuntime().wrap(function _callee41$(_context41) {
        while (1) {
          switch (_context41.prev = _context41.next) {
            case 0:
              allowanceThreshold = threshold || this.tokenAllowanceThreshold;
              tokenContract = new ethers.Contract(tokenAddress, this.ERC20PermitAbi, this.signerOrProvider);
              _context41.next = 4;
              return tokenContract.allowance(userAddress, this.erc20RouterContract.address);
            case 4:
              currentAllowance = _context41.sent;
              return _context41.abrupt("return", currentAllowance.gte(allowanceThreshold));
            case 6:
            case "end":
              return _context41.stop();
          }
        }
      }, _callee41, this);
    }));
    function isTokenApproved(_x51, _x52, _x53) {
      return _isTokenApproved.apply(this, arguments);
    }
    return isTokenApproved;
  }();
  _proto.isTokenApprovedLegacy = /*#__PURE__*/function () {
    var _isTokenApprovedLegacy = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee42(tokenAddress, userAddress, bridgedTokenIsNativeTokenOrNonDefaultFee, threshold /** optional */) {
      var allowanceThreshold, tokenContract, currentAllowance;
      return _regeneratorRuntime().wrap(function _callee42$(_context42) {
        while (1) {
          switch (_context42.prev = _context42.next) {
            case 0:
              allowanceThreshold = threshold || this.tokenAllowanceThreshold;
              tokenContract = new ethers.Contract(tokenAddress, this.ERC20PermitAbi, this.signerOrProvider);
              _context42.next = 4;
              return tokenContract.allowance(userAddress, bridgedTokenIsNativeTokenOrNonDefaultFee ? this.legacyRouterProxyContract.address : this.legacyRouterContract.address);
            case 4:
              currentAllowance = _context42.sent;
              return _context42.abrupt("return", currentAllowance.gte(allowanceThreshold));
            case 6:
            case "end":
              return _context42.stop();
          }
        }
      }, _callee42, this);
    }));
    function isTokenApprovedLegacy(_x54, _x55, _x56, _x57) {
      return _isTokenApprovedLegacy.apply(this, arguments);
    }
    return isTokenApprovedLegacy;
  }();
  _proto.loadTokenByAddressAndId = /*#__PURE__*/function () {
    var _loadTokenByAddressAndId = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee43(collectionAddress, id, userAddress, skipOwnerCheck) {
      var tokenMetadata, tokenContract, owner, collectionName, tokenURI;
      return _regeneratorRuntime().wrap(function _callee43$(_context43) {
        while (1) {
          switch (_context43.prev = _context43.next) {
            case 0:
              if (skipOwnerCheck === void 0) {
                skipOwnerCheck = false;
              }
              _context43.prev = 1;
              tokenContract = new ethers.Contract(collectionAddress, this.WrappedERC721Abi, this.signerOrProvider);
              if (skipOwnerCheck) {
                _context43.next = 15;
                break;
              }
              _context43.prev = 4;
              _context43.next = 7;
              return tokenContract.ownerOf(id);
            case 7:
              owner = _context43.sent;
              _context43.next = 13;
              break;
            case 10:
              _context43.prev = 10;
              _context43.t0 = _context43["catch"](4);
              return _context43.abrupt("return");
            case 13:
              if (!(owner.toLowerCase() !== userAddress.toLowerCase())) {
                _context43.next = 15;
                break;
              }
              return _context43.abrupt("return");
            case 15:
              _context43.next = 17;
              return tokenContract.name();
            case 17:
              collectionName = _context43.sent;
              _context43.next = 20;
              return tokenContract.tokenURI(id);
            case 20:
              tokenURI = _context43.sent;
              _context43.prev = 21;
              _context43.next = 24;
              return this.loadTokenMetadata(tokenURI);
            case 24:
              tokenMetadata = _context43.sent;
              _context43.next = 30;
              break;
            case 27:
              _context43.prev = 27;
              _context43.t1 = _context43["catch"](21);
              console.error("Token Metadata cannot be loaded");
            case 30:
              return _context43.abrupt("return", _extends({
                collectionName: collectionName
              }, tokenMetadata, {
                id: id,
                tokenURI: tokenURI,
                collectionAddress: collectionAddress
              }));
            case 33:
              _context43.prev = 33;
              _context43.t2 = _context43["catch"](1);
              throw new Error(_context43.t2.message);
            case 36:
            case "end":
              return _context43.stop();
          }
        }
      }, _callee43, this, [[1, 33], [4, 10], [21, 27]]);
    }));
    function loadTokenByAddressAndId(_x58, _x59, _x60, _x61) {
      return _loadTokenByAddressAndId.apply(this, arguments);
    }
    return loadTokenByAddressAndId;
  }();
  _proto.loadTokensByCollectionAddress = /*#__PURE__*/function () {
    var _loadTokensByCollectionAddress = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee44(collectionAddress) {
      var tokenContract, userAddress, balance, collectionName, tokens, index, tokenMetadata, tokenID, tokenURI, slicedDataLength, slicedDataLastSymbol, isEmbeddedData;
      return _regeneratorRuntime().wrap(function _callee44$(_context44) {
        while (1) {
          switch (_context44.prev = _context44.next) {
            case 0:
              _context44.prev = 0;
              tokenContract = new ethers.Contract(collectionAddress, this.WrappedERC721Abi, this.signerOrProvider);
              _context44.next = 4;
              return this.signerOrProvider.getAddress();
            case 4:
              userAddress = _context44.sent;
              _context44.prev = 5;
              _context44.next = 8;
              return tokenContract.balanceOf(userAddress);
            case 8:
              balance = _context44.sent;
              _context44.next = 11;
              return tokenContract.name();
            case 11:
              collectionName = _context44.sent;
              _context44.next = 17;
              break;
            case 14:
              _context44.prev = 14;
              _context44.t0 = _context44["catch"](5);
              throw new Error("Cannot find collection at address.");
            case 17:
              tokens = {
                collectionName: "",
                collectionAddress: collectionAddress,
                items: []
              };
              tokens.collectionName = collectionName;
              if (!balance.gt(0)) {
                _context44.next = 59;
                break;
              }
              index = 0;
            case 21:
              if (!(index < balance.toString())) {
                _context44.next = 59;
                break;
              }
              tokenMetadata = void 0;
              tokenID = void 0;
              tokenURI = void 0;
              _context44.prev = 25;
              _context44.next = 28;
              return tokenContract.tokenOfOwnerByIndex(userAddress, index);
            case 28:
              tokenID = _context44.sent;
              _context44.next = 31;
              return tokenContract.tokenURI(tokenID);
            case 31:
              _context44.next = 33;
              return _context44.sent;
            case 33:
              tokenURI = _context44.sent;
              _context44.next = 39;
              break;
            case 36:
              _context44.prev = 36;
              _context44.t1 = _context44["catch"](25);
              throw new Error("Cannot find tokens by collection address only. Please, enter token ID.");
            case 39:
              _context44.prev = 39;
              slicedDataLength = tokenURI.slice(tokenURI.indexOf(",") + 1, tokenURI.length).length;
              slicedDataLastSymbol = tokenURI.slice(tokenURI.indexOf(",") + 1, tokenURI.length)[slicedDataLength - 1];
              isEmbeddedData = tokenURI.slice(tokenURI.indexOf(",") + 1, tokenURI.length)[0] === "{" && slicedDataLastSymbol === "}";
              if (!isEmbeddedData) {
                _context44.next = 47;
                break;
              }
              tokenMetadata = JSON.parse(tokenURI.slice(tokenURI.indexOf(",") + 1, tokenURI.length));
              _context44.next = 50;
              break;
            case 47:
              _context44.next = 49;
              return this.loadTokenMetadata(tokenURI);
            case 49:
              tokenMetadata = _context44.sent;
            case 50:
              _context44.next = 55;
              break;
            case 52:
              _context44.prev = 52;
              _context44.t2 = _context44["catch"](39);
              console.error("Token Metadata cannot be loaded");
            case 55:
              tokens.items.push(_extends({
                collectionName: collectionName
              }, tokenMetadata, {
                id: tokenID.toString(),
                tokenURI: tokenURI
              }));
            case 56:
              index++;
              _context44.next = 21;
              break;
            case 59:
              return _context44.abrupt("return", tokens);
            case 62:
              _context44.prev = 62;
              _context44.t3 = _context44["catch"](0);
              throw new Error(_context44.t3.message);
            case 65:
            case "end":
              return _context44.stop();
          }
        }
      }, _callee44, this, [[0, 62], [5, 14], [25, 36], [39, 52]]);
    }));
    function loadTokensByCollectionAddress(_x62) {
      return _loadTokensByCollectionAddress.apply(this, arguments);
    }
    return loadTokensByCollectionAddress;
  }();
  _proto.sendErc20 = /*#__PURE__*/function () {
    var _sendErc = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee45( /* control */
    estimateOnly,
    // boolean - true if we need to call estimate gas only
    /* egress mandatory-ish */
    targetChainId,
    // number
    tokenAddress,
    // address - could be AddressZero when bridging native chain currency
    amount,
    // ethers.BigNumber
    receiverAddress,
    // address
    feeTokenAddress,
    // address - could be AddressZero
    /* optional - auto-delivery */
    deliveryFeeEstimate,
    // ethers.BigNumber
    deliveryFeeExpiry,
    // number
    deliveryFeeSignature,
    // hex string
    /* optional - permit */
    v, r, s, deadline // all should be 'undefined' if not using egressWithPermit
    ) {
      var isBlackListed, msgValue, serviceFee, deliveryFeeData, usePermit;
      return _regeneratorRuntime().wrap(function _callee45$(_context45) {
        while (1) {
          switch (_context45.prev = _context45.next) {
            case 0:
              _context45.next = 2;
              return this.checkTokenBlackListed(tokenAddress);
            case 2:
              isBlackListed = _context45.sent;
              if (isBlackListed) this._unsupportedTokenError();
              msgValue = !tokenAddress || tokenAddress === ethers.constants.AddressZero ? amount : ethers.BigNumber.from(0);
              if (!(!feeTokenAddress || feeTokenAddress === ethers.constants.AddressZero)) {
                _context45.next = 10;
                break;
              }
              _context45.next = 8;
              return this.getServiceFee();
            case 8:
              serviceFee = _context45.sent;
              msgValue = msgValue.add(serviceFee);
            case 10:
              if (deliveryFeeEstimate && !deliveryFeeEstimate.isZero()) {
                deliveryFeeData = [deliveryFeeEstimate, deliveryFeeExpiry, deliveryFeeSignature];
                msgValue = msgValue.add(deliveryFeeEstimate);
              } else {
                deliveryFeeData = [0, 0, []];
              }
              usePermit = v || r || s || deadline;
              if (!estimateOnly) {
                _context45.next = 20;
                break;
              }
              if (!usePermit) {
                _context45.next = 17;
                break;
              }
              return _context45.abrupt("return", this.erc20RouterContract.estimateGas.egressWithPermit(targetChainId, feeTokenAddress, tokenAddress, amount, receiverAddress, deliveryFeeData, deadline, v, r, s, {
                value: msgValue
              }));
            case 17:
              return _context45.abrupt("return", this.erc20RouterContract.estimateGas.egress(targetChainId, feeTokenAddress, tokenAddress, amount, receiverAddress, deliveryFeeData, {
                value: msgValue
              }));
            case 18:
              _context45.next = 25;
              break;
            case 20:
              if (!usePermit) {
                _context45.next = 24;
                break;
              }
              return _context45.abrupt("return", this.erc20RouterContract.populateTransaction.egressWithPermit(targetChainId, feeTokenAddress, tokenAddress, amount, receiverAddress, deliveryFeeData, deadline, v, r, s, {
                value: msgValue
              }));
            case 24:
              return _context45.abrupt("return", this.erc20RouterContract.populateTransaction.egress(targetChainId, feeTokenAddress, tokenAddress, amount, receiverAddress, deliveryFeeData, {
                value: msgValue
              }));
            case 25:
            case "end":
              return _context45.stop();
          }
        }
      }, _callee45, this);
    }));
    function sendErc20(_x63, _x64, _x65, _x66, _x67, _x68, _x69, _x70, _x71, _x72, _x73, _x74, _x75) {
      return _sendErc.apply(this, arguments);
    }
    return sendErc20;
  }();
  _proto.sendLegacy = /*#__PURE__*/function () {
    var _sendLegacy = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee46(targetChainId, tokenAddress, amount, receiver, feeTokenAddress, bridgedTokenIsNativeToken) {
      var isBlackListed, nativeToken, fee;
      return _regeneratorRuntime().wrap(function _callee46$(_context46) {
        while (1) {
          switch (_context46.prev = _context46.next) {
            case 0:
              _context46.next = 2;
              return this.checkTokenBlackListed(tokenAddress);
            case 2:
              isBlackListed = _context46.sent;
              if (isBlackListed) this._unsupportedTokenError();
              _context46.next = 6;
              return this.legacyRouterContract.wrappedToNativeToken(tokenAddress);
            case 6:
              nativeToken = _context46.sent;
              if (!feeTokenAddress) {
                _context46.next = 32;
                break;
              }
              if (!(feeTokenAddress === this.legacyRouterProxyContract.address)) {
                _context46.next = 14;
                break;
              }
              _context46.next = 11;
              return this.getProxyFeeLegacy(feeTokenAddress);
            case 11:
              _context46.t0 = _context46.sent;
              _context46.next = 15;
              break;
            case 14:
              _context46.t0 = 0;
            case 15:
              fee = _context46.t0;
              // Check if bridged token is native token
              if (bridgedTokenIsNativeToken) {
                fee = amount.add(fee);
              }
              if (!(nativeToken.chainId == 0)) {
                _context46.next = 23;
                break;
              }
              _context46.next = 20;
              return this.legacyRouterProxyContract.populateTransaction.lock(feeTokenAddress, targetChainId, tokenAddress, amount, receiver, {
                value: fee
              });
            case 20:
              return _context46.abrupt("return", _context46.sent);
            case 23:
              if (!(nativeToken.chainId !== targetChainId)) {
                _context46.next = 27;
                break;
              }
              _context46.next = 26;
              return this.legacyRouterProxyContract.populateTransaction.burnAndTransfer(feeTokenAddress, targetChainId, tokenAddress, amount, receiver, {
                value: fee
              });
            case 26:
              return _context46.abrupt("return", _context46.sent);
            case 27:
              _context46.next = 29;
              return this.legacyRouterProxyContract.populateTransaction.burn(feeTokenAddress, tokenAddress, amount, receiver, {
                value: fee
              });
            case 29:
              return _context46.abrupt("return", _context46.sent);
            case 32:
              if (!(nativeToken.chainId == 0)) {
                _context46.next = 38;
                break;
              }
              _context46.next = 35;
              return this.legacyRouterContract.populateTransaction.lock(targetChainId, tokenAddress, amount, receiver);
            case 35:
              return _context46.abrupt("return", _context46.sent);
            case 38:
              if (!(nativeToken.chainId !== targetChainId)) {
                _context46.next = 42;
                break;
              }
              _context46.next = 41;
              return this.legacyRouterContract.populateTransaction.burnAndTransfer(targetChainId, tokenAddress, amount, receiver);
            case 41:
              return _context46.abrupt("return", _context46.sent);
            case 42:
              _context46.next = 44;
              return this.legacyRouterContract.populateTransaction.burn(tokenAddress, amount, receiver);
            case 44:
              return _context46.abrupt("return", _context46.sent);
            case 45:
            case "end":
              return _context46.stop();
          }
        }
      }, _callee46, this);
    }));
    function sendLegacy(_x76, _x77, _x78, _x79, _x80, _x81) {
      return _sendLegacy.apply(this, arguments);
    }
    return sendLegacy;
  }();
  _proto.sendNftTokens = /*#__PURE__*/function () {
    var _sendNftTokens = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee47(targetChainId, assets, userAddress, fee) {
      var nftRouter, assetInfo;
      return _regeneratorRuntime().wrap(function _callee47$(_context47) {
        while (1) {
          switch (_context47.prev = _context47.next) {
            case 0:
              nftRouter = new ethers.Contract(this.config.contracts.nftRouter, this.NFTRouterAbi, this.signerOrProvider);
              assetInfo = [{
                collection: assets[0].asset_contract.address,
                tokenIds: assets.map(function (x) {
                  return BigNumber.from(x.token_id);
                })
              }];
              return _context47.abrupt("return", nftRouter.populateTransaction.egress(targetChainId, assetInfo, userAddress, {
                value: fee
              }));
            case 3:
            case "end":
              return _context47.stop();
          }
        }
      }, _callee47, this);
    }));
    function sendNftTokens(_x82, _x83, _x84, _x85) {
      return _sendNftTokens.apply(this, arguments);
    }
    return sendNftTokens;
  }();
  _proto.sendWithPermitLegacy = /*#__PURE__*/function () {
    var _sendWithPermitLegacy = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee48(targetChainId, tokenAddress, amount, receiver, v, r, s, deadline, feeTokenAddress, bridgedTokenIsNativeToken) {
      var isBlackListed, nativeToken, fee;
      return _regeneratorRuntime().wrap(function _callee48$(_context48) {
        while (1) {
          switch (_context48.prev = _context48.next) {
            case 0:
              _context48.next = 2;
              return this.checkTokenBlackListed(tokenAddress);
            case 2:
              isBlackListed = _context48.sent;
              if (isBlackListed) this._unsupportedTokenError();
              _context48.next = 6;
              return this.legacyRouterContract.wrappedToNativeToken(tokenAddress);
            case 6:
              nativeToken = _context48.sent;
              if (!feeTokenAddress) {
                _context48.next = 32;
                break;
              }
              if (!(feeTokenAddress === this.legacyRouterProxyContract.address)) {
                _context48.next = 14;
                break;
              }
              _context48.next = 11;
              return this.getProxyFeeLegacy(feeTokenAddress);
            case 11:
              _context48.t0 = _context48.sent;
              _context48.next = 15;
              break;
            case 14:
              _context48.t0 = 0;
            case 15:
              fee = _context48.t0;
              // Check if bridged token is native token
              if (bridgedTokenIsNativeToken) {
                fee = amount.add(fee);
              }
              if (!(nativeToken.chainId == 0)) {
                _context48.next = 23;
                break;
              }
              _context48.next = 20;
              return this.legacyRouterProxyContract.populateTransaction.lockWithPermit(feeTokenAddress, targetChainId, tokenAddress, amount, receiver, deadline, v, r, s, {
                value: fee
              });
            case 20:
              return _context48.abrupt("return", _context48.sent);
            case 23:
              if (!(nativeToken.chainId !== targetChainId)) {
                _context48.next = 27;
                break;
              }
              _context48.next = 26;
              return this.legacyRouterProxyContract.populateTransaction.burnAndTransferWithPermit(feeTokenAddress, targetChainId, tokenAddress, amount, receiver, deadline, v, r, s, {
                value: fee
              });
            case 26:
              return _context48.abrupt("return", _context48.sent);
            case 27:
              _context48.next = 29;
              return this.legacyRouterProxyContract.populateTransaction.burnWithPermit(feeTokenAddress, tokenAddress, amount, receiver, deadline, v, r, s, {
                value: fee
              });
            case 29:
              return _context48.abrupt("return", _context48.sent);
            case 32:
              if (!(nativeToken.chainId == 0)) {
                _context48.next = 38;
                break;
              }
              _context48.next = 35;
              return this.legacyRouterContract.populateTransaction.lockWithPermit(targetChainId, tokenAddress, amount, receiver, deadline, v, r, s);
            case 35:
              return _context48.abrupt("return", _context48.sent);
            case 38:
              if (!(nativeToken.chainId !== targetChainId)) {
                _context48.next = 42;
                break;
              }
              _context48.next = 41;
              return this.legacyRouterContract.populateTransaction.burnAndTransferWithPermit(targetChainId, tokenAddress, amount, receiver, deadline, v, r, s);
            case 41:
              return _context48.abrupt("return", _context48.sent);
            case 42:
              _context48.next = 44;
              return this.legacyRouterContract.populateTransaction.burnWithPermit(tokenAddress, amount, receiver, deadline, v, r, s);
            case 44:
              return _context48.abrupt("return", _context48.sent);
            case 45:
            case "end":
              return _context48.stop();
          }
        }
      }, _callee48, this);
    }));
    function sendWithPermitLegacy(_x86, _x87, _x88, _x89, _x90, _x91, _x92, _x93, _x94, _x95) {
      return _sendWithPermitLegacy.apply(this, arguments);
    }
    return sendWithPermitLegacy;
  }() // Private functions
  ;
  _proto._configValidators =
  /*#__PURE__*/
  function () {
    var _configValidators2 = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee49(optionalParams) {
      var validatorArray, initialValidatorVersion, initialNFTValidatorVersion, initialValidatorMajorVersion, initialValidatorMinorVersion, initialNftValidatorMajorVersion, initialNftValidatorMinorVersion, optionalParamsValidatorMajorVersion, optionalParamsValidatorMinorVersion, optionalParamsNftValidatorMajorVersion, optionalParamsNftValidatorMinorVersion;
      return _regeneratorRuntime().wrap(function _callee49$(_context49) {
        while (1) {
          switch (_context49.prev = _context49.next) {
            case 0:
              validatorArray = [];
              _context49.prev = 1;
              _context49.next = 4;
              return axios.get(this.validatorURL + "/status");
            case 4:
              initialValidatorVersion = _context49.sent.data.version;
              if (!(this.frontEndVersion !== 1)) {
                _context49.next = 9;
                break;
              }
              _context49.next = 8;
              return axios.get(this.nftValidatorURL + "/status");
            case 8:
              initialNFTValidatorVersion = _context49.sent.data.version;
            case 9:
              _context49.next = 22;
              break;
            case 11:
              _context49.prev = 11;
              _context49.t0 = _context49["catch"](1);
              _context49.next = 15;
              return this._getDefaultConfiguredValidatorVersion();
            case 15:
              initialValidatorVersion = _context49.sent;
              if (!(this.frontEndVersion !== 1)) {
                _context49.next = 20;
                break;
              }
              _context49.next = 19;
              return this._getDefaultConfiguredNftValidatorVersion();
            case 19:
              initialNFTValidatorVersion = _context49.sent;
            case 20:
              if (!(!initialValidatorVersion || !initialNFTValidatorVersion)) {
                _context49.next = 22;
                break;
              }
              throw new Error("Validators are not accessible");
            case 22:
              initialValidatorMajorVersion = parseInt(initialValidatorVersion.split(".")[0]);
              initialValidatorMinorVersion = parseInt(initialValidatorVersion.split(".")[1]);
              if (this.frontEndVersion !== 1) {
                initialNftValidatorMajorVersion = parseInt(initialNFTValidatorVersion.split(".")[0]);
                initialNftValidatorMinorVersion = parseInt(initialNFTValidatorVersion.split(".")[1]);
              }
              optionalParamsValidatorMajorVersion = parseInt(optionalParams["validatorTargetVersion"].split(".")[0]);
              optionalParamsValidatorMinorVersion = parseInt(optionalParams["validatorTargetVersion"].split(".")[1]);
              if (this.frontEndVersion !== 1) {
                optionalParamsNftValidatorMajorVersion = parseInt(optionalParams["nftValidatorTargetVersion"].split(".")[0]);
                optionalParamsNftValidatorMinorVersion = parseInt(optionalParams["nftValidatorTargetVersion"].split(".")[1]);
              }
              this.axios = new axios.create({
                baseURL: this.validatorURL
              });
              this.nftAxios = new axios.create({
                baseURL: this.nftValidatorURL
              });
              this.validatorVersion = initialValidatorVersion;
              this.nftValidatorVersion = initialNFTValidatorVersion;
              // Check for passed validatorTargetVersion
              if (!(optionalParams && optionalParams["validatorTargetVersion"] && (initialValidatorMajorVersion !== optionalParamsValidatorMajorVersion || !(initialValidatorMinorVersion >= optionalParamsValidatorMinorVersion)))) {
                _context49.next = 36;
                break;
              }
              if (optionalParams && optionalParams.validators) {
                validatorArray = this._getAllValidators(optionalParams.validators);
              } else {
                validatorArray = this._getAllValidators(this.config.validators);
              }
              _context49.next = 36;
              return this._setValidatorBasedOnVersion(validatorArray, optionalParams["validatorTargetVersion"]);
            case 36:
              if (!(this.frontEndVersion !== 1 && optionalParams && optionalParams["nftValidatorTargetVersion"] && (initialNftValidatorMajorVersion !== optionalParamsNftValidatorMajorVersion || !(initialNftValidatorMinorVersion >= optionalParamsNftValidatorMinorVersion)))) {
                _context49.next = 40;
                break;
              }
              if (optionalParams && optionalParams.nftValidators) {
                validatorArray = this._getAllValidators(optionalParams.nftValidators);
              } else {
                validatorArray = this._getAllValidators(this.config.nftValidators);
              }
              _context49.next = 40;
              return this._setValidatorBasedOnVersion(validatorArray, optionalParams["nftValidatorTargetVersion"]);
            case 40:
            case "end":
              return _context49.stop();
          }
        }
      }, _callee49, this, [[1, 11]]);
    }));
    function _configValidators(_x96) {
      return _configValidators2.apply(this, arguments);
    }
    return _configValidators;
  }();
  _proto._getAllUserTokens = /*#__PURE__*/function () {
    var _getAllUserTokens2 = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee50() {
      return _regeneratorRuntime().wrap(function _callee50$(_context50) {
        while (1) {
          switch (_context50.prev = _context50.next) {
            case 0:
              throw "_getAllUserTokens - Not implemented for EVM";
            case 1:
            case "end":
              return _context50.stop();
          }
        }
      }, _callee50);
    }));
    function _getAllUserTokens() {
      return _getAllUserTokens2.apply(this, arguments);
    }
    return _getAllUserTokens;
  }();
  _proto._getMetadata = /*#__PURE__*/function () {
    var _getMetadata2 = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee51() {
      return _regeneratorRuntime().wrap(function _callee51$(_context51) {
        while (1) {
          switch (_context51.prev = _context51.next) {
            case 0:
              throw "_getMetadata - Not implemented for EVM";
            case 1:
            case "end":
              return _context51.stop();
          }
        }
      }, _callee51);
    }));
    function _getMetadata() {
      return _getMetadata2.apply(this, arguments);
    }
    return _getMetadata;
  }();
  _proto._loadNftsByCollectionAndIdMulticall = /*#__PURE__*/function () {
    var _loadNftsByCollectionAndIdMulticall2 = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee52(collections) {
      var tokenInterface, fragment_name, fragment_tokenURI, multi, inputs, nftData, tokenData, _iterator, _step, collection, _iterator2, _step2, id, _iterator3, _step3, _collection, _iterator4, _step4, _id, chunkSize, i, chunk, indexName, _i2, collectionName, j, tokenURI, tokenMetadata, data;
      return _regeneratorRuntime().wrap(function _callee52$(_context52) {
        while (1) {
          switch (_context52.prev = _context52.next) {
            case 0:
              tokenInterface = new ethers.utils.Interface(this.WrappedERC721Abi);
              fragment_name = tokenInterface.getFunction("name");
              fragment_tokenURI = tokenInterface.getFunction("tokenURI");
              multi = new MultiCall(this.signerOrProvider);
              inputs = [];
              nftData = [];
              tokenData = [];
              if (!(this.chainId == 1287 || this.chainId == 1284 || this.chainId == 421611 || this.chainId == 42161 || this.chainId == 1313161555)) {
                _context52.next = 14;
                break;
              }
              for (_iterator = _createForOfIteratorHelperLoose(collections); !(_step = _iterator()).done;) {
                collection = _step.value;
                inputs.push({
                  target: collection.collectionAddress,
                  callData: tokenInterface.encodeFunctionData(fragment_name, [])
                });
                for (_iterator2 = _createForOfIteratorHelperLoose(collection.tokenIds); !(_step2 = _iterator2()).done;) {
                  id = _step2.value;
                  inputs.push({
                    target: collection.collectionAddress,
                    callData: tokenInterface.encodeFunctionData(fragment_tokenURI, [id])
                  });
                }
              }
              _context52.next = 11;
              return this.multicallContract.callStatic.tryBlockAndAggregate(false, inputs);
            case 11:
              tokenData = _context52.sent.returnData;
              _context52.next = 28;
              break;
            case 14:
              for (_iterator3 = _createForOfIteratorHelperLoose(collections); !(_step3 = _iterator3()).done;) {
                _collection = _step3.value;
                inputs.push({
                  target: _collection.collectionAddress,
                  "function": "name",
                  args: []
                });
                for (_iterator4 = _createForOfIteratorHelperLoose(_collection.tokenIds); !(_step4 = _iterator4()).done;) {
                  _id = _step4.value;
                  inputs.push({
                    target: _collection.collectionAddress,
                    "function": "tokenURI",
                    args: [_id]
                  });
                }
              }
              chunkSize = 20;
              i = 0;
            case 17:
              if (!(i < inputs.length)) {
                _context52.next = 27;
                break;
              }
              chunk = inputs.slice(i, i + chunkSize);
              _context52.t0 = tokenData;
              _context52.next = 22;
              return multi.multiCall(this.WrappedERC721Abi, chunk);
            case 22:
              _context52.t1 = _context52.sent[1];
              _context52.t0.push.call(_context52.t0, _context52.t1);
            case 24:
              i += chunkSize;
              _context52.next = 17;
              break;
            case 27:
              tokenData = [].concat.apply([], tokenData);
            case 28:
              indexName = 0;
              _i2 = 0;
            case 30:
              if (!(_i2 < collections.length)) {
                _context52.next = 54;
                break;
              }
              collectionName = tokenData[indexName];
              j = indexName + 1;
            case 33:
              if (!(j < collections[_i2].tokenIds.length + indexName + 1)) {
                _context52.next = 50;
                break;
              }
              tokenURI = tokenData[j];
              tokenMetadata = void 0;
              _context52.prev = 36;
              _context52.next = 39;
              return this.loadTokenMetadata(tokenURI);
            case 39:
              tokenMetadata = _context52.sent;
              _context52.next = 45;
              break;
            case 42:
              _context52.prev = 42;
              _context52.t2 = _context52["catch"](36);
              console.error("Token Metadata cannot be loaded");
            case 45:
              data = _extends({
                collectionName: collectionName,
                tokenURI: tokenURI
              }, tokenMetadata, collections[_i2].transmissionDetails, {
                receiver: collections[_i2].receiver
              });
              nftData.push(data);
            case 47:
              j++;
              _context52.next = 33;
              break;
            case 50:
              indexName += collections[_i2].tokenIds.length + 1;
            case 51:
              _i2++;
              _context52.next = 30;
              break;
            case 54:
              return _context52.abrupt("return", nftData);
            case 55:
            case "end":
              return _context52.stop();
          }
        }
      }, _callee52, this, [[36, 42]]);
    }));
    function _loadNftsByCollectionAndIdMulticall(_x97) {
      return _loadNftsByCollectionAndIdMulticall2.apply(this, arguments);
    }
    return _loadNftsByCollectionAndIdMulticall;
  }();
  _proto._unsupportedTokenError = function _unsupportedTokenError() {
    var error = new Error();
    error.name = "UnsupportedToken";
    error.message = "Token not supported";
    // @ts-ignore
    error.code = 212023;
    throw error;
  };
  return EvmRouterSDK;
}(RouterSDK);

var FEE_CALCULATOR_STORAGE_SEED = Seeds.FEE_CALCULATOR_STORAGE_SEED,
  TELEPORT_FEE_COLLECTOR_SEED = Seeds.TELEPORT_FEE_COLLECTOR_SEED,
  TELEPORT_GOVERNANCE_STORAGE_SEED = Seeds.TELEPORT_GOVERNANCE_STORAGE_SEED,
  TELEPORT_STORAGE_SEED = Seeds.TELEPORT_STORAGE_SEED,
  PAYLOAD_ACCOUNT_SEED = Seeds.PAYLOAD_ACCOUNT_SEED,
  HASH_DELIVERED_SEED = Seeds.HASH_DELIVERED_SEED;
var teleportHelperConstructor = function teleportHelperConstructor(teleport) {
  var findFeeCalculatorStoragePDA = /*#__PURE__*/function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return PublicKey.findProgramAddress([utils$1.bytes.utf8.encode(FEE_CALCULATOR_STORAGE_SEED)], teleport.programId);
            case 2:
              return _context.abrupt("return", _context.sent);
            case 3:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));
    return function findFeeCalculatorStoragePDA() {
      return _ref.apply(this, arguments);
    };
  }();
  var findFeeCollectorPDA = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2() {
      return _regeneratorRuntime().wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return PublicKey.findProgramAddress([utils$1.bytes.utf8.encode(TELEPORT_FEE_COLLECTOR_SEED)], teleport.programId);
            case 2:
              return _context2.abrupt("return", _context2.sent);
            case 3:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));
    return function findFeeCollectorPDA() {
      return _ref2.apply(this, arguments);
    };
  }();
  var findTeleportStoragePDA = /*#__PURE__*/function () {
    var _ref3 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee3() {
      return _regeneratorRuntime().wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              _context3.next = 2;
              return PublicKey.findProgramAddress([utils$1.bytes.utf8.encode(TELEPORT_STORAGE_SEED)], teleport.programId);
            case 2:
              return _context3.abrupt("return", _context3.sent);
            case 3:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    }));
    return function findTeleportStoragePDA() {
      return _ref3.apply(this, arguments);
    };
  }();
  var findGovernanceStoragePDA = /*#__PURE__*/function () {
    var _ref4 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee4() {
      return _regeneratorRuntime().wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              _context4.next = 2;
              return PublicKey.findProgramAddress([utils$1.bytes.utf8.encode(TELEPORT_GOVERNANCE_STORAGE_SEED)], teleport.programId);
            case 2:
              return _context4.abrupt("return", _context4.sent);
            case 3:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4);
    }));
    return function findGovernanceStoragePDA() {
      return _ref4.apply(this, arguments);
    };
  }();
  var findDeliverPayloadPDA = /*#__PURE__*/function () {
    var _ref5 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee5(transmissionId) {
      return _regeneratorRuntime().wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              _context5.next = 2;
              return PublicKey.findProgramAddress([utils$1.bytes.utf8.encode(PAYLOAD_ACCOUNT_SEED), ethers$1.utils.arrayify(transmissionId)], teleport.programId);
            case 2:
              return _context5.abrupt("return", _context5.sent);
            case 3:
            case "end":
              return _context5.stop();
          }
        }
      }, _callee5);
    }));
    return function findDeliverPayloadPDA(_x) {
      return _ref5.apply(this, arguments);
    };
  }();
  var findDeliverAccountPDA = /*#__PURE__*/function () {
    var _ref6 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee6(transmissionId) {
      return _regeneratorRuntime().wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              _context6.next = 2;
              return PublicKey.findProgramAddress([utils$1.bytes.utf8.encode(HASH_DELIVERED_SEED), ethers$1.utils.arrayify(transmissionId)], teleport.programId);
            case 2:
              return _context6.abrupt("return", _context6.sent);
            case 3:
            case "end":
              return _context6.stop();
          }
        }
      }, _callee6);
    }));
    return function findDeliverAccountPDA(_x2) {
      return _ref6.apply(this, arguments);
    };
  }();
  var createInitPayloadAccountTx = /*#__PURE__*/function () {
    var _ref8 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee7(_ref7) {
      var transmissionId, payloadLength, payloadAccountPDA, result;
      return _regeneratorRuntime().wrap(function _callee7$(_context7) {
        while (1) {
          switch (_context7.prev = _context7.next) {
            case 0:
              transmissionId = _ref7.transmissionId, payloadLength = _ref7.payloadLength, payloadAccountPDA = _ref7.payloadAccountPDA;
              _context7.t0 = new Transaction();
              _context7.next = 4;
              return teleport.methods.initPayloadAccount({
                transmissionId: Buffer.from(ethers$1.utils.arrayify(transmissionId)),
                payloadLength: payloadLength
              }).accounts({
                initializer: teleport.provider.wallet.publicKey,
                payloadAccount: payloadAccountPDA,
                systemProgram: web3.SystemProgram.programId
              }).instruction();
            case 4:
              _context7.t1 = _context7.sent;
              result = _context7.t0.add.call(_context7.t0, _context7.t1);
              return _context7.abrupt("return", result);
            case 7:
            case "end":
              return _context7.stop();
          }
        }
      }, _callee7);
    }));
    return function createInitPayloadAccountTx(_x3) {
      return _ref8.apply(this, arguments);
    };
  }();
  var createAddPayloadPartsTxs = /*#__PURE__*/function () {
    var _ref10 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee8(_ref9) {
      var transmissionId, payload, payloadAccountPDA, transactions, index, initial, _final, tx;
      return _regeneratorRuntime().wrap(function _callee8$(_context8) {
        while (1) {
          switch (_context8.prev = _context8.next) {
            case 0:
              transmissionId = _ref9.transmissionId, payload = _ref9.payload, payloadAccountPDA = _ref9.payloadAccountPDA;
              transactions = [];
              index = 0;
            case 3:
              if (!(index < payload.length / MAX_PAYLOAD_PART_SIZE)) {
                _context8.next = 15;
                break;
              }
              initial = index * MAX_PAYLOAD_PART_SIZE;
              _final = index == payload.length / MAX_PAYLOAD_PART_SIZE ? payload.length : (index + 1) * MAX_PAYLOAD_PART_SIZE;
              _context8.t0 = new Transaction();
              _context8.next = 9;
              return teleport.methods.addPayloadPart({
                transmissionId: Buffer.from(ethers$1.utils.arrayify(transmissionId)),
                payloadPart: Buffer.from(payload.slice(initial, _final)),
                partInitialIndex: index * MAX_PAYLOAD_PART_SIZE
              }).accounts({
                initializer: teleport.provider.wallet.publicKey,
                payloadAccount: payloadAccountPDA,
                systemProgram: web3.SystemProgram.programId
              }).instruction();
            case 9:
              _context8.t1 = _context8.sent;
              tx = _context8.t0.add.call(_context8.t0, _context8.t1);
              transactions.push(tx);
            case 12:
              index++;
              _context8.next = 3;
              break;
            case 15:
              return _context8.abrupt("return", transactions);
            case 16:
            case "end":
              return _context8.stop();
          }
        }
      }, _callee8);
    }));
    return function createAddPayloadPartsTxs(_x4) {
      return _ref10.apply(this, arguments);
    };
  }();
  var getInitClaimPayloadAccountTxs = /*#__PURE__*/function () {
    var _ref11 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee9(payload, transmissionId, payloadAccountPDA) {
      var payloadBytes, result, partsTxs;
      return _regeneratorRuntime().wrap(function _callee9$(_context9) {
        while (1) {
          switch (_context9.prev = _context9.next) {
            case 0:
              payloadBytes = ethers$1.utils.arrayify(payload);
              result = [];
              _context9.t0 = result;
              _context9.next = 5;
              return createInitPayloadAccountTx({
                transmissionId: transmissionId,
                payloadLength: payloadBytes.length,
                payloadAccountPDA: payloadAccountPDA
              });
            case 5:
              _context9.t1 = _context9.sent;
              _context9.t0.push.call(_context9.t0, _context9.t1);
              _context9.next = 9;
              return createAddPayloadPartsTxs({
                transmissionId: transmissionId,
                payload: payloadBytes,
                payloadAccountPDA: payloadAccountPDA
              });
            case 9:
              partsTxs = _context9.sent;
              result.push.apply(result, partsTxs);
              return _context9.abrupt("return", result);
            case 12:
            case "end":
              return _context9.stop();
          }
        }
      }, _callee9);
    }));
    return function getInitClaimPayloadAccountTxs(_x5, _x6, _x7) {
      return _ref11.apply(this, arguments);
    };
  }();
  var getDeliverTx = /*#__PURE__*/function () {
    var _ref12 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee10(transmission, payloadAccountPDA, user, dappInstruction) {
      var _yield$findDeliverAcc, deliveredTransmissionPDA, _yield$findGovernance, governanceStoragePDA, _yield$findTeleportSt, teleportStoragePDA, result;
      return _regeneratorRuntime().wrap(function _callee10$(_context10) {
        while (1) {
          switch (_context10.prev = _context10.next) {
            case 0:
              _context10.next = 2;
              return findDeliverAccountPDA(transmission.transmissionId);
            case 2:
              _yield$findDeliverAcc = _context10.sent;
              deliveredTransmissionPDA = _yield$findDeliverAcc[0];
              _context10.next = 6;
              return findGovernanceStoragePDA();
            case 6:
              _yield$findGovernance = _context10.sent;
              governanceStoragePDA = _yield$findGovernance[0];
              _context10.next = 10;
              return findTeleportStoragePDA();
            case 10:
              _yield$findTeleportSt = _context10.sent;
              teleportStoragePDA = _yield$findTeleportSt[0];
              console.log(new PublicKey(ethers$1.utils.arrayify(transmission.transmissionReceiver)).toString());
              _context10.next = 15;
              return teleport.methods.deliver(Buffer.from(ethers$1.utils.arrayify(transmission.transmissionId)), {
                sourceChainId: transmission.sourceChainId,
                transmissionSender: Buffer.from(ethers$1.utils.arrayify(transmission.transmissionSender)),
                transmissionReceiver: Buffer.from(ethers$1.utils.arrayify(transmission.transmissionReceiver)),
                dAppId: Buffer.from(ethers$1.utils.arrayify(transmission.dAppId)),
                signatures: transmission.signatures.map(function (sng) {
                  return ethers$1.utils.arrayify(sng);
                })
              }).accounts({
                governanceStorage: governanceStoragePDA,
                teleportStorage: teleportStoragePDA,
                deliveredTransmission: deliveredTransmissionPDA,
                payloadAccount: payloadAccountPDA,
                user: user.publicKey,
                instructionSysvarAccount: web3.SYSVAR_INSTRUCTIONS_PUBKEY
              }).postInstructions([dappInstruction]).transaction();
            case 15:
              result = _context10.sent;
              result.feePayer = user.publicKey;
              _context10.next = 19;
              return teleport.provider.connection.getLatestBlockhash({
                commitment: CONFIRMED_COMMITMENT
              });
            case 19:
              result.recentBlockhash = _context10.sent.blockhash;
              return _context10.abrupt("return", result);
            case 21:
            case "end":
              return _context10.stop();
          }
        }
      }, _callee10);
    }));
    return function getDeliverTx(_x8, _x9, _x10, _x11) {
      return _ref12.apply(this, arguments);
    };
  }();
  var getClosePayloadAccountInstruction = /*#__PURE__*/function () {
    var _ref13 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee11(transmissionId, payloadAccountPDA, user) {
      var accounts;
      return _regeneratorRuntime().wrap(function _callee11$(_context11) {
        while (1) {
          switch (_context11.prev = _context11.next) {
            case 0:
              accounts = {
                payloadAccount: payloadAccountPDA,
                user: user.publicKey
              };
              _context11.next = 3;
              return teleport.methods.closePayload(ethers$1.utils.arrayify(transmissionId)).accounts(accounts).instruction();
            case 3:
              return _context11.abrupt("return", _context11.sent);
            case 4:
            case "end":
              return _context11.stop();
          }
        }
      }, _callee11);
    }));
    return function getClosePayloadAccountInstruction(_x12, _x13, _x14) {
      return _ref13.apply(this, arguments);
    };
  }();
  return {
    findFeeCalculatorStoragePDA: findFeeCalculatorStoragePDA,
    findFeeCollectorPDA: findFeeCollectorPDA,
    findGovernanceStoragePDA: findGovernanceStoragePDA,
    findTeleportStoragePDA: findTeleportStoragePDA,
    findDeliverPayloadPDA: findDeliverPayloadPDA,
    findDeliverAccountPDA: findDeliverAccountPDA,
    getInitClaimPayloadAccountTxs: getInitClaimPayloadAccountTxs,
    getDeliverTx: getDeliverTx,
    getClosePayloadAccountInstruction: getClosePayloadAccountInstruction
  };
};

var ROUTER_VAULT_SEED = Seeds.ROUTER_VAULT_SEED,
  PAYLOAD_ACCOUNT_SEED$1 = Seeds.PAYLOAD_ACCOUNT_SEED,
  ROUTER_STORAGE_SEED = Seeds.ROUTER_STORAGE_SEED,
  CHAIN_INFO_SEED = Seeds.CHAIN_INFO_SEED,
  WRAPPED_MINT_SEED = Seeds.WRAPPED_MINT_SEED,
  CHAIN_CURRENCY_INFO_SEED = Seeds.CHAIN_CURRENCY_INFO_SEED,
  ROUTER_VAULT_ATA_SEED = Seeds.ROUTER_VAULT_ATA_SEED;
//TODO: Change this helper object to a helper class, to improve mantainance and usage
var ERC20RouterHelperConstructor = function ERC20RouterHelperConstructor(routerProgram) {
  var connection = routerProgram.provider.connection;
  var findRouterVaultPDA = /*#__PURE__*/function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return PublicKey.findProgramAddress([utils$1.bytes.utf8.encode(ROUTER_VAULT_SEED)], routerProgram.programId);
            case 2:
              return _context.abrupt("return", _context.sent);
            case 3:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));
    return function findRouterVaultPDA() {
      return _ref.apply(this, arguments);
    };
  }();
  var findEgressPayloadPDA = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2(userPublicKey) {
      return _regeneratorRuntime().wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return PublicKey.findProgramAddress([utils$1.bytes.utf8.encode(PAYLOAD_ACCOUNT_SEED$1), userPublicKey.toBytes()], routerProgram.programId);
            case 2:
              return _context2.abrupt("return", _context2.sent);
            case 3:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));
    return function findEgressPayloadPDA(_x) {
      return _ref2.apply(this, arguments);
    };
  }();
  var findRouterStoragePDA = /*#__PURE__*/function () {
    var _ref3 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee3() {
      return _regeneratorRuntime().wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              _context3.next = 2;
              return PublicKey.findProgramAddress([utils$1.bytes.utf8.encode(ROUTER_STORAGE_SEED)], routerProgram.programId);
            case 2:
              return _context3.abrupt("return", _context3.sent);
            case 3:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    }));
    return function findRouterStoragePDA() {
      return _ref3.apply(this, arguments);
    };
  }();
  var findChainInfoPDA = /*#__PURE__*/function () {
    var _ref4 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee4(chainId) {
      return _regeneratorRuntime().wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              _context4.next = 2;
              return PublicKey.findProgramAddress([utils$1.bytes.utf8.encode(CHAIN_INFO_SEED), ethers$1.utils.arrayify(chainId)], routerProgram.programId);
            case 2:
              return _context4.abrupt("return", _context4.sent);
            case 3:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4);
    }));
    return function findChainInfoPDA(_x2) {
      return _ref4.apply(this, arguments);
    };
  }();
  var getInitEgressPayloadAccountTx = /*#__PURE__*/function () {
    var _ref5 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee5(payloadPDA, userPublicKey) {
      var result;
      return _regeneratorRuntime().wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              _context5.next = 2;
              return routerProgram.methods.initPayloadAccount().accounts({
                payloadPda: payloadPDA,
                caller: userPublicKey,
                systemProgram: web3.SystemProgram.programId
              }).transaction();
            case 2:
              result = _context5.sent;
              result.feePayer = userPublicKey;
              _context5.next = 6;
              return connection.getLatestBlockhash({
                commitment: CONFIRMED_COMMITMENT
              });
            case 6:
              result.recentBlockhash = _context5.sent.blockhash;
              return _context5.abrupt("return", result);
            case 8:
            case "end":
              return _context5.stop();
          }
        }
      }, _callee5);
    }));
    return function getInitEgressPayloadAccountTx(_x3, _x4) {
      return _ref5.apply(this, arguments);
    };
  }();
  var findChainCurrencyInfoPDA = /*#__PURE__*/function () {
    var _ref6 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee6(tokenMint) {
      return _regeneratorRuntime().wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              _context6.next = 2;
              return PublicKey.findProgramAddress([utils$1.bytes.utf8.encode(CHAIN_CURRENCY_INFO_SEED), tokenMint.toBytes()], routerProgram.programId);
            case 2:
              return _context6.abrupt("return", _context6.sent);
            case 3:
            case "end":
              return _context6.stop();
          }
        }
      }, _callee6);
    }));
    return function findChainCurrencyInfoPDA(_x5) {
      return _ref6.apply(this, arguments);
    };
  }();
  var findWrappedTokenPDA = /*#__PURE__*/function () {
    var _ref7 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee7(nativeChainTokenAddressBytes, nativeChainId) {
      return _regeneratorRuntime().wrap(function _callee7$(_context7) {
        while (1) {
          switch (_context7.prev = _context7.next) {
            case 0:
              _context7.next = 2;
              return PublicKey.findProgramAddress([utils$1.bytes.utf8.encode(WRAPPED_MINT_SEED), nativeChainTokenAddressBytes, arrayify(nativeChainId)], routerProgram.programId);
            case 2:
              return _context7.abrupt("return", _context7.sent);
            case 3:
            case "end":
              return _context7.stop();
          }
        }
      }, _callee7);
    }));
    return function findWrappedTokenPDA(_x6, _x7) {
      return _ref7.apply(this, arguments);
    };
  }();
  var findRouterSigningPDA = /*#__PURE__*/function () {
    var _ref8 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee8() {
      return _regeneratorRuntime().wrap(function _callee8$(_context8) {
        while (1) {
          switch (_context8.prev = _context8.next) {
            case 0:
              _context8.next = 2;
              return PublicKey.findProgramAddress([], routerProgram.programId);
            case 2:
              return _context8.abrupt("return", _context8.sent);
            case 3:
            case "end":
              return _context8.stop();
          }
        }
      }, _callee8);
    }));
    return function findRouterSigningPDA() {
      return _ref8.apply(this, arguments);
    };
  }();
  var findRouterVaultATAPDA = /*#__PURE__*/function () {
    var _ref9 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee9(tokenMintPK) {
      return _regeneratorRuntime().wrap(function _callee9$(_context9) {
        while (1) {
          switch (_context9.prev = _context9.next) {
            case 0:
              _context9.next = 2;
              return PublicKey.findProgramAddress([utils$1.bytes.utf8.encode(ROUTER_VAULT_ATA_SEED), tokenMintPK.toBytes()], routerProgram.programId);
            case 2:
              return _context9.abrupt("return", _context9.sent);
            case 3:
            case "end":
              return _context9.stop();
          }
        }
      }, _callee9);
    }));
    return function findRouterVaultATAPDA(_x8) {
      return _ref9.apply(this, arguments);
    };
  }();
  /**
   * Returns the txs needed for performing the egress
   * @param tokenAddressPK ed25519 public key of the: default Publickey if solana, wrapped mint if non native and token mint if native
   */
  var getEgressTxs = /*#__PURE__*/function () {
    var _ref10 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee10(tokenAddressPK, targetChainId, amount, receiverAddress, user, teleportProgramId, teleportFeeCalculatorStoragePDA, teleportFeeCollectorPDA) {
      var preTxs, egressTx, _yield$findRouterVaul, routerVaultPDA, _yield$findRouterSign, routerSigningPDA, _yield$findRouterStor, routerStoragePDA, _yield$findChainInfoP, targetChainInfoPDA, _yield$findEgressPayl, payloadPDA, receiverAddressBytes, _yield$connection$get, _yield$connection$get2, _yield$connection$get3, _yield$findChainCurre, chainCurrencyInfoPDA, chainCurrencyInfoIsInit, userTokenBag, _yield$connection$get4, _yield$connection$get5, _yield$connection$get6, tokenMintPK, _yield$findRouterVaul2, routerVaultTokenBag, _userTokenBag, metadataPDA, latestBlockhash;
      return _regeneratorRuntime().wrap(function _callee10$(_context10) {
        while (1) {
          switch (_context10.prev = _context10.next) {
            case 0:
              //  Egress type:
              //    If token address is zero => native coin.
              //    Else If token address is wrapped PDA => non native token.
              //    Else => native token.
              preTxs = [];
              _context10.next = 3;
              return findRouterVaultPDA();
            case 3:
              _yield$findRouterVaul = _context10.sent;
              routerVaultPDA = _yield$findRouterVaul[0];
              _context10.next = 7;
              return findRouterSigningPDA();
            case 7:
              _yield$findRouterSign = _context10.sent;
              routerSigningPDA = _yield$findRouterSign[0];
              _context10.next = 11;
              return findRouterStoragePDA();
            case 11:
              _yield$findRouterStor = _context10.sent;
              routerStoragePDA = _yield$findRouterStor[0];
              _context10.next = 15;
              return findChainInfoPDA(targetChainId);
            case 15:
              _yield$findChainInfoP = _context10.sent;
              targetChainInfoPDA = _yield$findChainInfoP[0];
              _context10.next = 19;
              return findEgressPayloadPDA(user.publicKey);
            case 19:
              _yield$findEgressPayl = _context10.sent;
              payloadPDA = _yield$findEgressPayl[0];
              receiverAddressBytes = ethers$1.utils.arrayify(receiverAddress);
              amount = new BN(amount.toString());
              if (!(tokenAddressPK.toString() === PublicKey["default"].toString())) {
                _context10.next = 29;
                break;
              }
              _context10.next = 26;
              return routerProgram.methods.egressNativeCoin({
                targetChainId: targetChainId,
                amount: amount,
                receiver: Buffer.from(receiverAddressBytes)
              }).accounts({
                routerStorage: routerStoragePDA,
                targetChainInfo: targetChainInfoPDA,
                routerVault: routerVaultPDA,
                payloadPda: payloadPDA,
                teleportFeeCalculatorStorage: teleportFeeCalculatorStoragePDA,
                routerSigningPda: routerSigningPDA,
                teleportFeeCollector: teleportFeeCollectorPDA,
                teleportProgram: teleportProgramId,
                caller: user.publicKey,
                systemProgram: web3.SystemProgram.programId
              }).transaction();
            case 26:
              egressTx = _context10.sent;
              _context10.next = 93;
              break;
            case 29:
              _context10.next = 31;
              return findChainCurrencyInfoPDA(tokenAddressPK);
            case 31:
              _yield$findChainCurre = _context10.sent;
              chainCurrencyInfoPDA = _yield$findChainCurre[0];
              _context10.next = 35;
              return connection.getAccountInfo(chainCurrencyInfoPDA);
            case 35:
              _context10.t0 = _yield$connection$get2 = _context10.sent;
              if (!(_context10.t0 == null)) {
                _context10.next = 40;
                break;
              }
              _context10.t1 = void 0;
              _context10.next = 41;
              break;
            case 40:
              _context10.t1 = (_yield$connection$get3 = _yield$connection$get2.data) == null ? void 0 : _yield$connection$get3.readUintLE(0, 8);
            case 41:
              _context10.t2 = _yield$connection$get = _context10.t1;
              if (!(_context10.t2 != null)) {
                _context10.next = 46;
                break;
              }
              _context10.t3 = _yield$connection$get;
              _context10.next = 47;
              break;
            case 46:
              _context10.t3 = 0;
            case 47:
              _context10.t4 = _context10.t3;
              chainCurrencyInfoIsInit = _context10.t4 !== 0;
              if (!chainCurrencyInfoIsInit) {
                _context10.next = 58;
                break;
              }
              _context10.next = 52;
              return getAssociatedTokenAddress(tokenAddressPK, user.publicKey);
            case 52:
              userTokenBag = _context10.sent;
              _context10.next = 55;
              return routerProgram.methods.egressNonNative({
                targetChainId: targetChainId,
                amount: amount,
                receiver: Buffer.from(receiverAddressBytes)
              }).accounts({
                routerStorage: routerStoragePDA,
                targetChainInfo: targetChainInfoPDA,
                routerVault: routerVaultPDA,
                payloadPda: payloadPDA,
                teleportFeeCalculatorStorage: teleportFeeCalculatorStoragePDA,
                routerSigningPda: routerSigningPDA,
                teleportFeeCollector: teleportFeeCollectorPDA,
                teleportProgram: teleportProgramId,
                caller: user.publicKey,
                systemProgram: web3.SystemProgram.programId,
                tokenProgram: TOKEN_PROGRAM_ID,
                tokenMint: tokenAddressPK,
                userTokenBag: userTokenBag,
                chainCurrencyInfo: chainCurrencyInfoPDA,
                rent: SYSVAR_RENT_PUBKEY
              }).transaction();
            case 55:
              egressTx = _context10.sent;
              _context10.next = 93;
              break;
            case 58:
              // Native token
              tokenMintPK = tokenAddressPK;
              _context10.next = 61;
              return findRouterVaultATAPDA(tokenMintPK);
            case 61:
              _yield$findRouterVaul2 = _context10.sent;
              routerVaultTokenBag = _yield$findRouterVaul2[0];
              _context10.next = 65;
              return connection.getAccountInfo(routerVaultTokenBag);
            case 65:
              _context10.t5 = _yield$connection$get5 = _context10.sent;
              if (!(_context10.t5 == null)) {
                _context10.next = 70;
                break;
              }
              _context10.t6 = void 0;
              _context10.next = 71;
              break;
            case 70:
              _context10.t6 = (_yield$connection$get6 = _yield$connection$get5.data) == null ? void 0 : _yield$connection$get6.readUintLE(0, 8);
            case 71:
              _context10.t7 = _yield$connection$get4 = _context10.t6;
              if (!(_context10.t7 != null)) {
                _context10.next = 76;
                break;
              }
              _context10.t8 = _yield$connection$get4;
              _context10.next = 77;
              break;
            case 76:
              _context10.t8 = 0;
            case 77:
              _context10.t9 = _context10.t8;
              if (!(_context10.t9 === 0)) {
                _context10.next = 84;
                break;
              }
              _context10.t10 = preTxs;
              _context10.next = 82;
              return routerProgram.methods.initRouterVaultTokenBag().accounts({
                routerVaultTokenBag: routerVaultTokenBag,
                initializer: user.publicKey,
                tokenProgram: TOKEN_PROGRAM_ID,
                rent: SYSVAR_RENT_PUBKEY,
                tokenMint: tokenMintPK
              }).transaction();
            case 82:
              _context10.t11 = _context10.sent;
              _context10.t10.push.call(_context10.t10, _context10.t11);
            case 84:
              _context10.next = 86;
              return getAssociatedTokenAddress(tokenMintPK, user.publicKey);
            case 86:
              _userTokenBag = _context10.sent;
              _context10.next = 89;
              return programs.metadata.Metadata.getPDA(tokenMintPK);
            case 89:
              metadataPDA = _context10.sent;
              _context10.next = 92;
              return routerProgram.methods.egressNativeToken({
                targetChainId: targetChainId,
                amount: amount,
                receiver: Buffer.from(receiverAddressBytes)
              }).accounts({
                routerStorage: routerStoragePDA,
                targetChainInfo: targetChainInfoPDA,
                routerVault: routerVaultPDA,
                payloadPda: payloadPDA,
                teleportFeeCalculatorStorage: teleportFeeCalculatorStoragePDA,
                routerSigningPda: routerSigningPDA,
                teleportFeeCollector: teleportFeeCollectorPDA,
                teleportProgram: teleportProgramId,
                caller: user.publicKey,
                systemProgram: web3.SystemProgram.programId,
                tokenProgram: TOKEN_PROGRAM_ID,
                rent: SYSVAR_RENT_PUBKEY,
                tokenMint: tokenMintPK,
                userTokenBag: _userTokenBag,
                routerVaultTokenBag: routerVaultTokenBag,
                tokenMetadata: metadataPDA
              }).transaction();
            case 92:
              egressTx = _context10.sent;
            case 93:
              _context10.next = 95;
              return connection.getLatestBlockhash({
                commitment: CONFIRMED_COMMITMENT
              });
            case 95:
              latestBlockhash = _context10.sent.blockhash;
              preTxs.concat(egressTx).forEach(function (element) {
                element.feePayer = user.publicKey;
                element.recentBlockhash = latestBlockhash;
              });
              return _context10.abrupt("return", {
                preTxs: preTxs,
                egressTx: egressTx
              });
            case 98:
            case "end":
              return _context10.stop();
          }
        }
      }, _callee10);
    }));
    return function getEgressTxs(_x9, _x10, _x11, _x12, _x13, _x14, _x15, _x16) {
      return _ref10.apply(this, arguments);
    };
  }();
  var parsePayload = function parsePayload(payload) {
    return new Payload(payload);
  };
  var getOnTeleportMessageInstruction = /*#__PURE__*/function () {
    var _ref11 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee11(transmission, payloadAccountPDA, user) {
      var parsedPayload, actionId, _yield$findRouterStor2, routerStoragePDA, _yield$findChainInfoP2, chainInfoPDA, nativeAddressBytes, nativeAddressPK, _yield$findRouterVaul3, routerVaultPDA, routerVaultBump, _yield$findRouterVaul4, programTokenBagPda, programTokenBagPdaBump, userTokenBag, _yield$connection$get7, _yield$connection$get8, _yield$connection$get9, _parsedPayload$envelo, nativeChainId, tokenDecimals, _yield$findWrappedTok, wrappedTokenMint, _yield$findChainCurre2, chainCurrencyInfoPDA, _yield$findRouterVaul5, _routerVaultPDA, _routerVaultBump, preTxs, wrappedNeedsInit, _accounts, initTx, blockhashObj, signed, signature, _userTokenBag2, _yield$anchor$web3$Pu, tokenMetadata, accounts;
      return _regeneratorRuntime().wrap(function _callee11$(_context11) {
        while (1) {
          switch (_context11.prev = _context11.next) {
            case 0:
              parsedPayload = parsePayload(transmission.payload);
              actionId = parsedPayload.envelope.action.actionId; //0 = Unlock | 1 = Mint
              _context11.next = 4;
              return findRouterStoragePDA();
            case 4:
              _yield$findRouterStor2 = _context11.sent;
              routerStoragePDA = _yield$findRouterStor2[0];
              _context11.next = 8;
              return findChainInfoPDA(transmission.sourceChainId);
            case 8:
              _yield$findChainInfoP2 = _context11.sent;
              chainInfoPDA = _yield$findChainInfoP2[0];
              nativeAddressBytes = ethers$1.utils.arrayify(parsedPayload.envelope.action.nativeAddress);
              if (!(actionId === 0)) {
                _context11.next = 41;
                break;
              }
              // Native case
              nativeAddressPK = new PublicKey(nativeAddressBytes);
              if (!(nativeAddressPK.toString() === PublicKey["default"].toString())) {
                _context11.next = 26;
                break;
              }
              _context11.next = 16;
              return findRouterVaultPDA();
            case 16:
              _yield$findRouterVaul3 = _context11.sent;
              routerVaultPDA = _yield$findRouterVaul3[0];
              routerVaultBump = _yield$findRouterVaul3[1];
              _context11.t0 = [];
              _context11.next = 22;
              return routerProgram.methods.onTeleportMessageNativeUnlock({
                sourceChainId: transmission.sourceChainId,
                routerVaultBump: routerVaultBump
              }).accounts({
                routerStorage: routerStoragePDA,
                sourceChainInfo: chainInfoPDA,
                instructionSysvarAccount: web3.SYSVAR_INSTRUCTIONS_PUBKEY,
                payloadAccount: payloadAccountPDA,
                routerVault: routerVaultPDA,
                receiver: user.publicKey
              }).instruction();
            case 22:
              _context11.t1 = _context11.sent;
              return _context11.abrupt("return", {
                pretxs: _context11.t0,
                onTeleportMessageInstruction: _context11.t1
              });
            case 26:
              _context11.next = 28;
              return findRouterVaultATAPDA(nativeAddressPK);
            case 28:
              _yield$findRouterVaul4 = _context11.sent;
              programTokenBagPda = _yield$findRouterVaul4[0];
              programTokenBagPdaBump = _yield$findRouterVaul4[1];
              _context11.next = 33;
              return getAssociatedTokenAddress(nativeAddressPK, user.publicKey);
            case 33:
              userTokenBag = _context11.sent;
              _context11.t2 = [];
              _context11.next = 37;
              return routerProgram.methods.onTeleportMessageTokenUnlock({
                sourceChainId: transmission.sourceChainId,
                routerTokenBagBump: programTokenBagPdaBump
              }).accounts({
                routerStorage: routerStoragePDA,
                sourceChainInfo: chainInfoPDA,
                instructionSysvarAccount: web3.SYSVAR_INSTRUCTIONS_PUBKEY,
                payloadAccount: payloadAccountPDA,
                tokenMint: nativeAddressPK,
                tokenProgram: TOKEN_PROGRAM_ID,
                rent: SYSVAR_RENT_PUBKEY,
                user: user.publicKey,
                receiverTokenBag: userTokenBag,
                routerTokenBag: programTokenBagPda,
                receiver: user.publicKey
              }).instruction();
            case 37:
              _context11.t3 = _context11.sent;
              return _context11.abrupt("return", {
                pretxs: _context11.t2,
                onTeleportMessageInstruction: _context11.t3
              });
            case 39:
              _context11.next = 109;
              break;
            case 41:
              // Non native case
              _parsedPayload$envelo = parsedPayload.envelope.action.getMintData(), nativeChainId = _parsedPayload$envelo.nativeChainId, tokenDecimals = _parsedPayload$envelo.tokenDecimals;
              _context11.next = 44;
              return findWrappedTokenPDA(nativeAddressBytes, nativeChainId);
            case 44:
              _yield$findWrappedTok = _context11.sent;
              wrappedTokenMint = _yield$findWrappedTok[0];
              _context11.next = 48;
              return findChainCurrencyInfoPDA(wrappedTokenMint);
            case 48:
              _yield$findChainCurre2 = _context11.sent;
              chainCurrencyInfoPDA = _yield$findChainCurre2[0];
              _context11.next = 52;
              return findRouterVaultPDA();
            case 52:
              _yield$findRouterVaul5 = _context11.sent;
              _routerVaultPDA = _yield$findRouterVaul5[0];
              _routerVaultBump = _yield$findRouterVaul5[1];
              preTxs = [];
              _context11.next = 58;
              return connection.getAccountInfo(wrappedTokenMint);
            case 58:
              _context11.t4 = _yield$connection$get8 = _context11.sent;
              if (!(_context11.t4 == null)) {
                _context11.next = 63;
                break;
              }
              _context11.t5 = void 0;
              _context11.next = 64;
              break;
            case 63:
              _context11.t5 = (_yield$connection$get9 = _yield$connection$get8.data) == null ? void 0 : _yield$connection$get9.readUintLE(0, 8);
            case 64:
              _context11.t6 = _yield$connection$get7 = _context11.t5;
              if (!(_context11.t6 != null)) {
                _context11.next = 69;
                break;
              }
              _context11.t7 = _yield$connection$get7;
              _context11.next = 70;
              break;
            case 69:
              _context11.t7 = 0;
            case 70:
              _context11.t8 = _context11.t7;
              wrappedNeedsInit = _context11.t8 === 0;
              if (!wrappedNeedsInit) {
                _context11.next = 95;
                break;
              }
              // await createMint(
              //   connection,
              //   user,
              //   routerVaultPDA, // mint authority
              //   null, // freeze authority (you can use `null` to disable it. when you disable it, you can't turn it on again)
              //   tokenDecimals, // decimals
              //   Keypair.generate() // address of the mint
              // );
              _accounts = {
                routerStorage: routerStoragePDA,
                routerVault: _routerVaultPDA,
                tokenMint: wrappedTokenMint,
                tokenProgram: TOKEN_PROGRAM_ID,
                rent: SYSVAR_RENT_PUBKEY,
                user: user.publicKey
              };
              console.table(Object.entries(_accounts).map(function (prop) {
                prop[1] = prop[1].toString();
                return prop;
              }));
              _context11.next = 77;
              return routerProgram.methods.createWrappedMint(tokenDecimals, Buffer.from(nativeAddressBytes), nativeChainId).accounts(_accounts).transaction();
            case 77:
              initTx = _context11.sent;
              _context11.next = 80;
              return user.publicKey;
            case 80:
              initTx.feePayer = _context11.sent;
              _context11.next = 83;
              return connection.getRecentBlockhash();
            case 83:
              blockhashObj = _context11.sent;
              _context11.next = 86;
              return blockhashObj.blockhash;
            case 86:
              initTx.recentBlockhash = _context11.sent;
              _context11.next = 89;
              return user.signTransaction(initTx);
            case 89:
              signed = _context11.sent;
              _context11.next = 92;
              return connection.sendRawTransaction(signed.serialize());
            case 92:
              signature = _context11.sent;
              _context11.next = 95;
              return connection.confirmTransaction(signature);
            case 95:
              _context11.next = 97;
              return getAssociatedTokenAddress(wrappedTokenMint, user.publicKey);
            case 97:
              _userTokenBag2 = _context11.sent;
              _context11.next = 100;
              return web3.PublicKey.findProgramAddress([Buffer.from("metadata"), MetadataProgram.PUBKEY.toBuffer(), wrappedTokenMint.toBuffer()], MetadataProgram.PUBKEY);
            case 100:
              _yield$anchor$web3$Pu = _context11.sent;
              tokenMetadata = _yield$anchor$web3$Pu[0];
              accounts = {
                routerStorage: routerStoragePDA,
                sourceChainInfo: chainInfoPDA,
                instructionSysvarAccount: web3.SYSVAR_INSTRUCTIONS_PUBKEY,
                payloadAccount: payloadAccountPDA,
                routerVault: _routerVaultPDA,
                chainCurrencyInfo: chainCurrencyInfoPDA,
                tokenMint: wrappedTokenMint,
                tokenProgram: TOKEN_PROGRAM_ID,
                rent: SYSVAR_RENT_PUBKEY,
                user: user.publicKey,
                receiverTokenBag: _userTokenBag2,
                associatedTokenProgram: ASSOCIATED_TOKEN_PROGRAM_ID,
                tokenMetadataProgram: MetadataProgram.PUBKEY,
                metadata: tokenMetadata
              };
              console.table(Object.entries(accounts).map(function (prop) {
                prop[1] = prop[1].toString();
                return prop;
              }));
              _context11.t9 = preTxs;
              _context11.next = 107;
              return routerProgram.methods.onTeleportMessageTokenMint({
                sourceChainId: transmission.sourceChainId,
                routerVaultBump: _routerVaultBump,
                tokenDecimals: tokenDecimals,
                nativeTokenAddress: Buffer.from(nativeAddressBytes),
                tokenNativeChainId: nativeChainId
              }).accounts(accounts).instruction();
            case 107:
              _context11.t10 = _context11.sent;
              return _context11.abrupt("return", {
                pretxs: _context11.t9,
                onTeleportMessageInstruction: _context11.t10
              });
            case 109:
            case "end":
              return _context11.stop();
          }
        }
      }, _callee11);
    }));
    return function getOnTeleportMessageInstruction(_x17, _x18, _x19) {
      return _ref11.apply(this, arguments);
    };
  }();
  var getDAppId = /*#__PURE__*/function () {
    var _ref12 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee12() {
      var _yield$findRouterStor3, routerStoragePDA, routerStorage;
      return _regeneratorRuntime().wrap(function _callee12$(_context12) {
        while (1) {
          switch (_context12.prev = _context12.next) {
            case 0:
              _context12.next = 2;
              return findRouterStoragePDA();
            case 2:
              _yield$findRouterStor3 = _context12.sent;
              routerStoragePDA = _yield$findRouterStor3[0];
              _context12.next = 6;
              return routerProgram.account.routerStorage.fetch(routerStoragePDA);
            case 6:
              routerStorage = _context12.sent;
              return _context12.abrupt("return", routerStorage.dAppId);
            case 8:
            case "end":
              return _context12.stop();
          }
        }
      }, _callee12);
    }));
    return function getDAppId() {
      return _ref12.apply(this, arguments);
    };
  }();
  var isERC20Claim = /*#__PURE__*/function () {
    var _ref13 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee13(claim) {
      var expectedDAppId;
      return _regeneratorRuntime().wrap(function _callee13$(_context13) {
        while (1) {
          switch (_context13.prev = _context13.next) {
            case 0:
              if (!(claim.dAppId === "")) {
                _context13.next = 2;
                break;
              }
              return _context13.abrupt("return", false);
            case 2:
              if (!(ethers$1.utils.isHexString(claim.dAppId) === false)) {
                _context13.next = 4;
                break;
              }
              throw new ABridgeSDKError("dAppId needs to be an hex string");
            case 4:
              _context13.t0 = ethers$1.utils;
              _context13.next = 7;
              return getDAppId();
            case 7:
              _context13.t1 = _context13.sent;
              expectedDAppId = _context13.t0.hexlify.call(_context13.t0, _context13.t1);
              return _context13.abrupt("return", claim.dAppId === expectedDAppId);
            case 10:
            case "end":
              return _context13.stop();
          }
        }
      }, _callee13);
    }));
    return function isERC20Claim(_x20) {
      return _ref13.apply(this, arguments);
    };
  }();
  return {
    findRouterVaultPDA: findRouterVaultPDA,
    findEgressPayloadPDA: findEgressPayloadPDA,
    findRouterStoragePDA: findRouterStoragePDA,
    findChainInfoPDA: findChainInfoPDA,
    findRouterSigningPDA: findRouterSigningPDA,
    findWrappedTokenPDA: findWrappedTokenPDA,
    getInitEgressPayloadAccountTx: getInitEgressPayloadAccountTx,
    getEgressTxs: getEgressTxs,
    getOnTeleportMessageInstruction: getOnTeleportMessageInstruction,
    parsePayload: parsePayload,
    isERC20Claim: isERC20Claim,
    getDAppId: getDAppId
  };
};
var Payload = function Payload(payloadBytes) {
  var _ethers$utils$default = ethers$1.utils.defaultAbiCoder.decode(["uint256", "bytes"], payloadBytes),
    header = _ethers$utils$default[0],
    envelopeBytes = _ethers$utils$default[1];
  this.header = header;
  this.envelope = new Envelope(envelopeBytes);
};
var Envelope = function Envelope(envelopeBytes) {
  var _ethers$utils$default2 = ethers$1.utils.defaultAbiCoder.decode(["bytes", "bytes", "bytes", "uint256"], envelopeBytes),
    senderBytes = _ethers$utils$default2[0],
    receiverBytes = _ethers$utils$default2[1],
    actionBytes = _ethers$utils$default2[2],
    deliveryFee = _ethers$utils$default2[3];
  this.deliveryFee = deliveryFee;
  this.sender = senderBytes;
  this.receiver = receiverBytes;
  this.action = new Action(actionBytes);
};
var Action = /*#__PURE__*/function () {
  function Action(actionBytes) {
    var _ethers$utils$default3 = ethers$1.utils.defaultAbiCoder.decode(["uint8", "bytes", "bytes"], actionBytes),
      actionId = _ethers$utils$default3[0],
      nativeAddressBytes = _ethers$utils$default3[1],
      actionDataBytes = _ethers$utils$default3[2];
    this.actionId = actionId;
    this.nativeAddress = nativeAddressBytes;
    this.dataBytes = actionDataBytes;
  }
  var _proto = Action.prototype;
  _proto.getMintData = function getMintData() {
    var _ethers$utils$default4 = ethers$1.utils.defaultAbiCoder.decode(["uint256", "uint8", "string", "string", "uint8"], this.dataBytes),
      amount = _ethers$utils$default4[0],
      nativeChainId = _ethers$utils$default4[1],
      tokenName = _ethers$utils$default4[2],
      tokenSymbol = _ethers$utils$default4[3],
      tokenDecimals = _ethers$utils$default4[4];
    return {
      amount: amount,
      nativeChainId: nativeChainId,
      tokenName: tokenName,
      tokenSymbol: tokenSymbol,
      tokenDecimals: tokenDecimals
    };
  };
  return Action;
}();

var ROUTER_VAULT_SEED$1 = Seeds.ROUTER_VAULT_SEED,
  PAYLOAD_ACCOUNT_SEED$2 = Seeds.PAYLOAD_ACCOUNT_SEED,
  ROUTER_STORAGE_SEED$1 = Seeds.ROUTER_STORAGE_SEED,
  CHAIN_INFO_SEED$1 = Seeds.CHAIN_INFO_SEED,
  WRAPPED_MINT_SEED$1 = Seeds.WRAPPED_MINT_SEED,
  CHAIN_CURRENCY_INFO_SEED$1 = Seeds.CHAIN_CURRENCY_INFO_SEED,
  ROUTER_VAULT_ATA_SEED$1 = Seeds.ROUTER_VAULT_ATA_SEED,
  LOCKED_MINT_SEED = Seeds.LOCKED_MINT_SEED;
//TODO: Change this helper object to a helper class, to improve mantainance and usage
var ERC721RouterHelperConstructor = function ERC721RouterHelperConstructor(routerProgram) {
  var connection = routerProgram.provider.connection;
  var findRouterVaultPDA = /*#__PURE__*/function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return PublicKey.findProgramAddress([utils$1.bytes.utf8.encode(ROUTER_VAULT_SEED$1)], routerProgram.programId);
            case 2:
              return _context.abrupt("return", _context.sent);
            case 3:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));
    return function findRouterVaultPDA() {
      return _ref.apply(this, arguments);
    };
  }();
  var findEgressPayloadPDA = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2(userPublicKey) {
      return _regeneratorRuntime().wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return PublicKey.findProgramAddress([utils$1.bytes.utf8.encode(PAYLOAD_ACCOUNT_SEED$2), userPublicKey.toBytes()], routerProgram.programId);
            case 2:
              return _context2.abrupt("return", _context2.sent);
            case 3:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));
    return function findEgressPayloadPDA(_x) {
      return _ref2.apply(this, arguments);
    };
  }();
  var findRouterStoragePDA = /*#__PURE__*/function () {
    var _ref3 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee3() {
      return _regeneratorRuntime().wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              _context3.next = 2;
              return PublicKey.findProgramAddress([utils$1.bytes.utf8.encode(ROUTER_STORAGE_SEED$1)], routerProgram.programId);
            case 2:
              return _context3.abrupt("return", _context3.sent);
            case 3:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    }));
    return function findRouterStoragePDA() {
      return _ref3.apply(this, arguments);
    };
  }();
  var findChainInfoPDA = /*#__PURE__*/function () {
    var _ref4 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee4(chainId) {
      return _regeneratorRuntime().wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              _context4.next = 2;
              return PublicKey.findProgramAddress([utils$1.bytes.utf8.encode(CHAIN_INFO_SEED$1), ethers$1.utils.arrayify(chainId)], routerProgram.programId);
            case 2:
              return _context4.abrupt("return", _context4.sent);
            case 3:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4);
    }));
    return function findChainInfoPDA(_x2) {
      return _ref4.apply(this, arguments);
    };
  }();
  var getInitEgressPayloadAccountTx = /*#__PURE__*/function () {
    var _ref5 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee5(payloadPDA, userPublicKey) {
      var result;
      return _regeneratorRuntime().wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              _context5.next = 2;
              return routerProgram.methods.initPayloadAccount().accounts({
                payloadPda: payloadPDA,
                caller: userPublicKey,
                systemProgram: web3.SystemProgram.programId
              }).transaction();
            case 2:
              result = _context5.sent;
              result.feePayer = userPublicKey;
              _context5.next = 6;
              return connection.getLatestBlockhash({
                commitment: CONFIRMED_COMMITMENT
              });
            case 6:
              result.recentBlockhash = _context5.sent.blockhash;
              return _context5.abrupt("return", result);
            case 8:
            case "end":
              return _context5.stop();
          }
        }
      }, _callee5);
    }));
    return function getInitEgressPayloadAccountTx(_x3, _x4) {
      return _ref5.apply(this, arguments);
    };
  }();
  var findChainCurrencyInfoPDA = /*#__PURE__*/function () {
    var _ref6 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee6(tokenMint) {
      return _regeneratorRuntime().wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              _context6.next = 2;
              return PublicKey.findProgramAddress([utils$1.bytes.utf8.encode(CHAIN_CURRENCY_INFO_SEED$1), tokenMint.toBytes()], routerProgram.programId);
            case 2:
              return _context6.abrupt("return", _context6.sent);
            case 3:
            case "end":
              return _context6.stop();
          }
        }
      }, _callee6);
    }));
    return function findChainCurrencyInfoPDA(_x5) {
      return _ref6.apply(this, arguments);
    };
  }();
  var findLockedMintPDA = /*#__PURE__*/function () {
    var _ref7 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee7(tokenMint, tokenId) {
      var _yield$PublicKey$find, lockedMintPDA;
      return _regeneratorRuntime().wrap(function _callee7$(_context7) {
        while (1) {
          switch (_context7.prev = _context7.next) {
            case 0:
              _context7.next = 2;
              return PublicKey.findProgramAddress([Buffer.from(LOCKED_MINT_SEED), tokenMint.toBytes(), tokenId.toArrayLike(Buffer, "le", 8)], routerProgram.programId);
            case 2:
              _yield$PublicKey$find = _context7.sent;
              lockedMintPDA = _yield$PublicKey$find[0];
              return _context7.abrupt("return", {
                lockedMintPDA: lockedMintPDA
              });
            case 5:
            case "end":
              return _context7.stop();
          }
        }
      }, _callee7);
    }));
    return function findLockedMintPDA(_x6, _x7) {
      return _ref7.apply(this, arguments);
    };
  }();
  var findWrappedTokenPDA = /*#__PURE__*/function () {
    var _ref8 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee8(nativeChainTokenAddressBytes, nativeTokenId) {
      return _regeneratorRuntime().wrap(function _callee8$(_context8) {
        while (1) {
          switch (_context8.prev = _context8.next) {
            case 0:
              _context8.next = 2;
              return PublicKey.findProgramAddress([utils$1.bytes.utf8.encode(WRAPPED_MINT_SEED$1), nativeChainTokenAddressBytes, nativeTokenId.toArrayLike(Buffer, "be", 8)], routerProgram.programId);
            case 2:
              return _context8.abrupt("return", _context8.sent);
            case 3:
            case "end":
              return _context8.stop();
          }
        }
      }, _callee8);
    }));
    return function findWrappedTokenPDA(_x8, _x9) {
      return _ref8.apply(this, arguments);
    };
  }();
  var findRouterSigningPDA = /*#__PURE__*/function () {
    var _ref9 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee9() {
      return _regeneratorRuntime().wrap(function _callee9$(_context9) {
        while (1) {
          switch (_context9.prev = _context9.next) {
            case 0:
              _context9.next = 2;
              return PublicKey.findProgramAddress([], routerProgram.programId);
            case 2:
              return _context9.abrupt("return", _context9.sent);
            case 3:
            case "end":
              return _context9.stop();
          }
        }
      }, _callee9);
    }));
    return function findRouterSigningPDA() {
      return _ref9.apply(this, arguments);
    };
  }();
  var findRouterVaultATAPDA = /*#__PURE__*/function () {
    var _ref10 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee10(tokenMintPK) {
      return _regeneratorRuntime().wrap(function _callee10$(_context10) {
        while (1) {
          switch (_context10.prev = _context10.next) {
            case 0:
              _context10.next = 2;
              return PublicKey.findProgramAddress([utils$1.bytes.utf8.encode(ROUTER_VAULT_ATA_SEED$1), tokenMintPK.toBytes()], routerProgram.programId);
            case 2:
              return _context10.abrupt("return", _context10.sent);
            case 3:
            case "end":
              return _context10.stop();
          }
        }
      }, _callee10);
    }));
    return function findRouterVaultATAPDA(_x10) {
      return _ref10.apply(this, arguments);
    };
  }();
  /**
   * Returns the txs needed for performing the egress
   * @param tokenAddressPK ed25519 public key of the: default Publickey if solana, wrapped mint if non native and token mint if native
   */
  var getEgressTxs = /*#__PURE__*/function () {
    var _ref11 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee11(tokenAddressPK, targetChainId, amount, receiverAddress, user, teleportProgramId, teleportFeeCalculatorStoragePDA, teleportFeeCollectorPDA) {
      var _yield$connection$get, _yield$connection$get2, _yield$connection$get3;
      var preTxs, egressTx, _yield$findRouterVaul, routerVaultPDA, _yield$findRouterSign, routerSigningPDA, _yield$findRouterStor, routerStoragePDA, _yield$findChainInfoP, targetChainInfoPDA, _yield$findEgressPayl, payloadPDA, receiverAddressBytes, _yield$findChainCurre, chainCurrencyInfoPDA, chainCurrencyInfoIsInit, userTokenBag, _yield$connection$get4, _yield$connection$get5, _yield$connection$get6, tokenMintPK, _yield$findRouterVaul2, routerVaultTokenBag, _yield$findLockedMint, lockedMintPDA, _userTokenBag, metadataPDA, latestBlockhash;
      return _regeneratorRuntime().wrap(function _callee11$(_context11) {
        while (1) {
          switch (_context11.prev = _context11.next) {
            case 0:
              //  Egress type:
              //    If token address is wrapped PDA => non native token.
              //    Else => native token.
              preTxs = [];
              _context11.next = 3;
              return findRouterVaultPDA();
            case 3:
              _yield$findRouterVaul = _context11.sent;
              routerVaultPDA = _yield$findRouterVaul[0];
              _context11.next = 7;
              return findRouterSigningPDA();
            case 7:
              _yield$findRouterSign = _context11.sent;
              routerSigningPDA = _yield$findRouterSign[0];
              _context11.next = 11;
              return findRouterStoragePDA();
            case 11:
              _yield$findRouterStor = _context11.sent;
              routerStoragePDA = _yield$findRouterStor[0];
              _context11.next = 15;
              return findChainInfoPDA(targetChainId);
            case 15:
              _yield$findChainInfoP = _context11.sent;
              targetChainInfoPDA = _yield$findChainInfoP[0];
              _context11.next = 19;
              return findEgressPayloadPDA(user.publicKey);
            case 19:
              _yield$findEgressPayl = _context11.sent;
              payloadPDA = _yield$findEgressPayl[0];
              receiverAddressBytes = ethers$1.utils.arrayify(receiverAddress);
              amount = new BN(amount.toString());
              _context11.next = 25;
              return findChainCurrencyInfoPDA(tokenAddressPK);
            case 25:
              _yield$findChainCurre = _context11.sent;
              chainCurrencyInfoPDA = _yield$findChainCurre[0];
              _context11.next = 29;
              return connection.getAccountInfo(chainCurrencyInfoPDA);
            case 29:
              _context11.t0 = _yield$connection$get2 = _context11.sent;
              if (!(_context11.t0 == null)) {
                _context11.next = 34;
                break;
              }
              _context11.t1 = void 0;
              _context11.next = 35;
              break;
            case 34:
              _context11.t1 = (_yield$connection$get3 = _yield$connection$get2.data) == null ? void 0 : _yield$connection$get3.readUintLE(0, 8);
            case 35:
              _context11.t2 = _yield$connection$get = _context11.t1;
              if (!(_context11.t2 != null)) {
                _context11.next = 40;
                break;
              }
              _context11.t3 = _yield$connection$get;
              _context11.next = 41;
              break;
            case 40:
              _context11.t3 = 0;
            case 41:
              _context11.t4 = _context11.t3;
              chainCurrencyInfoIsInit = _context11.t4 !== 0;
              if (!chainCurrencyInfoIsInit) {
                _context11.next = 52;
                break;
              }
              _context11.next = 46;
              return getAssociatedTokenAddress(tokenAddressPK, user.publicKey);
            case 46:
              userTokenBag = _context11.sent;
              _context11.next = 49;
              return routerProgram.methods.egressNonNative({
                targetChainId: targetChainId,
                amount: amount,
                receiver: Buffer.from(receiverAddressBytes)
              }).accounts({
                routerStorage: routerStoragePDA,
                targetChainInfo: targetChainInfoPDA,
                routerVault: routerVaultPDA,
                payloadPda: payloadPDA,
                teleportFeeCalculatorStorage: teleportFeeCalculatorStoragePDA,
                routerSigningPda: routerSigningPDA,
                teleportFeeCollector: teleportFeeCollectorPDA,
                teleportProgram: teleportProgramId,
                caller: user.publicKey,
                systemProgram: web3.SystemProgram.programId,
                tokenProgram: TOKEN_PROGRAM_ID,
                tokenMint: tokenAddressPK,
                userTokenBag: userTokenBag,
                chainCurrencyInfo: chainCurrencyInfoPDA,
                rent: SYSVAR_RENT_PUBKEY
              }).transaction();
            case 49:
              egressTx = _context11.sent;
              _context11.next = 91;
              break;
            case 52:
              // Native token
              tokenMintPK = tokenAddressPK;
              _context11.next = 55;
              return findRouterVaultATAPDA(tokenMintPK);
            case 55:
              _yield$findRouterVaul2 = _context11.sent;
              routerVaultTokenBag = _yield$findRouterVaul2[0];
              _context11.next = 59;
              return connection.getAccountInfo(routerVaultTokenBag);
            case 59:
              _context11.t5 = _yield$connection$get5 = _context11.sent;
              if (!(_context11.t5 == null)) {
                _context11.next = 64;
                break;
              }
              _context11.t6 = void 0;
              _context11.next = 65;
              break;
            case 64:
              _context11.t6 = (_yield$connection$get6 = _yield$connection$get5.data) == null ? void 0 : _yield$connection$get6.readUintLE(0, 8);
            case 65:
              _context11.t7 = _yield$connection$get4 = _context11.t6;
              if (!(_context11.t7 != null)) {
                _context11.next = 70;
                break;
              }
              _context11.t8 = _yield$connection$get4;
              _context11.next = 71;
              break;
            case 70:
              _context11.t8 = 0;
            case 71:
              _context11.t9 = _context11.t8;
              if (!(_context11.t9 === 0)) {
                _context11.next = 78;
                break;
              }
              _context11.t10 = preTxs;
              _context11.next = 76;
              return routerProgram.methods.initRouterVaultTokenBag().accounts({
                routerVaultTokenBag: routerVaultTokenBag,
                initializer: user.publicKey,
                tokenProgram: TOKEN_PROGRAM_ID,
                rent: SYSVAR_RENT_PUBKEY,
                tokenMint: tokenMintPK
              }).transaction();
            case 76:
              _context11.t11 = _context11.sent;
              _context11.t10.push.call(_context11.t10, _context11.t11);
            case 78:
              _context11.next = 80;
              return findLockedMintPDA(tokenMintPK, new BN(DEFAULT_TOKEN_ID));
            case 80:
              _yield$findLockedMint = _context11.sent;
              lockedMintPDA = _yield$findLockedMint.lockedMintPDA;
              _context11.next = 84;
              return getAssociatedTokenAddress(tokenMintPK, user.publicKey);
            case 84:
              _userTokenBag = _context11.sent;
              _context11.next = 87;
              return programs.metadata.Metadata.getPDA(tokenMintPK);
            case 87:
              metadataPDA = _context11.sent;
              _context11.next = 90;
              return routerProgram.methods.egressNativeToken({
                targetChainId: targetChainId,
                amount: amount,
                receiver: Buffer.from(receiverAddressBytes)
              }).accounts({
                routerStorage: routerStoragePDA,
                targetChainInfo: targetChainInfoPDA,
                routerVault: routerVaultPDA,
                payloadPda: payloadPDA,
                teleportFeeCalculatorStorage: teleportFeeCalculatorStoragePDA,
                routerSigningPda: routerSigningPDA,
                teleportFeeCollector: teleportFeeCollectorPDA,
                teleportProgram: teleportProgramId,
                caller: user.publicKey,
                systemProgram: web3.SystemProgram.programId,
                tokenProgram: TOKEN_PROGRAM_ID,
                rent: SYSVAR_RENT_PUBKEY,
                tokenMint: tokenMintPK,
                userTokenBag: _userTokenBag,
                routerVaultTokenBag: routerVaultTokenBag,
                tokenMetadata: metadataPDA,
                lockedMint: lockedMintPDA
              }).transaction();
            case 90:
              egressTx = _context11.sent;
            case 91:
              _context11.next = 93;
              return connection.getLatestBlockhash({
                commitment: CONFIRMED_COMMITMENT
              });
            case 93:
              latestBlockhash = _context11.sent.blockhash;
              preTxs.concat(egressTx).forEach(function (element) {
                element.feePayer = user.publicKey;
                element.recentBlockhash = latestBlockhash;
              });
              return _context11.abrupt("return", {
                preTxs: preTxs,
                egressTx: egressTx
              });
            case 96:
            case "end":
              return _context11.stop();
          }
        }
      }, _callee11);
    }));
    return function getEgressTxs(_x11, _x12, _x13, _x14, _x15, _x16, _x17, _x18) {
      return _ref11.apply(this, arguments);
    };
  }();
  var parsePayload = function parsePayload(payload) {
    return new Payload$1(payload);
  };
  var getOnTeleportMessageInstruction = /*#__PURE__*/function () {
    var _ref12 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee12(transmission, payloadAccountPDA, user) {
      var parsedPayload, actionId, _yield$findRouterStor2, routerStoragePDA, _yield$findChainInfoP2, chainInfoPDA, nativeAddressBytes, nativeAddressPK, _yield$findRouterVaul3, fromPda, _yield$findLockedMint2, lockedMintPDA, preTxs, userTokenBag, _yield$connection$get7, _yield$connection$get8, _yield$connection$get9, nativeTokenId, _yield$findWrappedTok, wrappedTokenMint, _yield$findChainCurre2, chainCurrencyInfoPDA, _yield$findRouterVaul4, routerVaultPDA, routerVaultBump, _preTxs, wrappedNeedsInit, _accounts, initTx, blockhashObj, _userTokenBag2, _yield$anchor$web3$Pu, tokenMetadata, accounts;
      return _regeneratorRuntime().wrap(function _callee12$(_context12) {
        while (1) {
          switch (_context12.prev = _context12.next) {
            case 0:
              parsedPayload = parsePayload(transmission.payload);
              actionId = parsedPayload.envelope.actions[0].actionId; //0 = Unlock | 1 = Mint
              _context12.next = 4;
              return findRouterStoragePDA();
            case 4:
              _yield$findRouterStor2 = _context12.sent;
              routerStoragePDA = _yield$findRouterStor2[0];
              _context12.next = 8;
              return findChainInfoPDA(transmission.sourceChainId);
            case 8:
              _yield$findChainInfoP2 = _context12.sent;
              chainInfoPDA = _yield$findChainInfoP2[0];
              nativeAddressBytes = ethers$1.utils.arrayify(parsedPayload.envelope.actions[0].nativeAddress);
              if (!(actionId === 0)) {
                _context12.next = 32;
                break;
              }
              // Native case
              nativeAddressPK = new PublicKey(nativeAddressBytes); //Native token case
              // const [
              //   programTokenBagPda,
              //   programTokenBagPdaBump,
              // ] = await findRouterVaultATAPDA(nativeAddressPK);
              _context12.next = 15;
              return findRouterVaultATAPDA(nativeAddressPK);
            case 15:
              _yield$findRouterVaul3 = _context12.sent;
              fromPda = _yield$findRouterVaul3[0];
              _context12.next = 19;
              return findLockedMintPDA(nativeAddressPK, new BN(DEFAULT_TOKEN_ID));
            case 19:
              _yield$findLockedMint2 = _context12.sent;
              lockedMintPDA = _yield$findLockedMint2.lockedMintPDA;
              preTxs = [];
              _context12.next = 24;
              return getAssociatedTokenAddress(nativeAddressPK, user.publicKey);
            case 24:
              userTokenBag = _context12.sent;
              _context12.t0 = preTxs;
              _context12.next = 28;
              return routerProgram.methods.onTeleportMessageTokenUnlock({
                sourceChainId: transmission.sourceChainId
              }).accounts({
                routerVaultTokenBag: fromPda,
                routerStorage: routerStoragePDA,
                sourceChainInfo: chainInfoPDA,
                instructionSysvarAccount: web3.SYSVAR_INSTRUCTIONS_PUBKEY,
                payloadAccount: payloadAccountPDA,
                tokenProgram: TOKEN_PROGRAM_ID,
                user: user.publicKey,
                to: userTokenBag,
                receiver: user.publicKey,
                lockedMint: lockedMintPDA
              }).instruction();
            case 28:
              _context12.t1 = _context12.sent;
              return _context12.abrupt("return", {
                pretxs: _context12.t0,
                onTeleportMessageInstruction: _context12.t1
              });
            case 32:
              // Non native case
              nativeTokenId = parsedPayload.envelope.actions[0].getMintData().tokenIds[0]; // TODO: handle multiple tokenids
              _context12.next = 35;
              return findWrappedTokenPDA(nativeAddressBytes, nativeTokenId);
            case 35:
              _yield$findWrappedTok = _context12.sent;
              wrappedTokenMint = _yield$findWrappedTok[0];
              _context12.next = 39;
              return findChainCurrencyInfoPDA(wrappedTokenMint);
            case 39:
              _yield$findChainCurre2 = _context12.sent;
              chainCurrencyInfoPDA = _yield$findChainCurre2[0];
              _context12.next = 43;
              return findRouterVaultPDA();
            case 43:
              _yield$findRouterVaul4 = _context12.sent;
              routerVaultPDA = _yield$findRouterVaul4[0];
              routerVaultBump = _yield$findRouterVaul4[1];
              _preTxs = [];
              _context12.next = 49;
              return connection.getAccountInfo(wrappedTokenMint);
            case 49:
              _context12.t2 = _yield$connection$get8 = _context12.sent;
              if (!(_context12.t2 == null)) {
                _context12.next = 54;
                break;
              }
              _context12.t3 = void 0;
              _context12.next = 55;
              break;
            case 54:
              _context12.t3 = (_yield$connection$get9 = _yield$connection$get8.data) == null ? void 0 : _yield$connection$get9.readUintLE(0, 8);
            case 55:
              _context12.t4 = _yield$connection$get7 = _context12.t3;
              if (!(_context12.t4 != null)) {
                _context12.next = 60;
                break;
              }
              _context12.t5 = _yield$connection$get7;
              _context12.next = 61;
              break;
            case 60:
              _context12.t5 = 0;
            case 61:
              _context12.t6 = _context12.t5;
              wrappedNeedsInit = _context12.t6 === 0;
              if (!wrappedNeedsInit) {
                _context12.next = 79;
                break;
              }
              _accounts = {
                routerStorage: routerStoragePDA,
                routerVault: routerVaultPDA,
                tokenMint: wrappedTokenMint,
                tokenProgram: TOKEN_PROGRAM_ID,
                rent: SYSVAR_RENT_PUBKEY,
                user: user.publicKey
              };
              console.table(Object.entries(_accounts).map(function (prop) {
                prop[1] = prop[1].toString();
                return prop;
              }));
              _context12.next = 68;
              return routerProgram.methods.createWrappedMint(0, Buffer.from(nativeAddressBytes), nativeTokenId) // TODO: Remove token decimals param from program
              .accounts(_accounts).transaction();
            case 68:
              initTx = _context12.sent;
              _context12.next = 71;
              return user.publicKey;
            case 71:
              initTx.feePayer = _context12.sent;
              _context12.next = 74;
              return connection.getRecentBlockhash();
            case 74:
              blockhashObj = _context12.sent;
              _context12.next = 77;
              return blockhashObj.blockhash;
            case 77:
              initTx.recentBlockhash = _context12.sent;
              _preTxs.push(initTx);
              // // Request creator to sign the transaction (allow the transaction)
              // let signed = await user.signTransaction(initTx);
              // // The signature is generated
              // let signature = await connection.sendRawTransaction(signed.serialize());
              // // Confirm whether the transaction went through or not
              // await connection.confirmTransaction(signature);
            case 79:
              _context12.next = 81;
              return getAssociatedTokenAddress(wrappedTokenMint, user.publicKey);
            case 81:
              _userTokenBag2 = _context12.sent;
              _context12.next = 84;
              return web3.PublicKey.findProgramAddress([Buffer.from("metadata"), MetadataProgram.PUBKEY.toBuffer(), wrappedTokenMint.toBuffer()], MetadataProgram.PUBKEY);
            case 84:
              _yield$anchor$web3$Pu = _context12.sent;
              tokenMetadata = _yield$anchor$web3$Pu[0];
              accounts = {
                routerStorage: routerStoragePDA,
                sourceChainInfo: chainInfoPDA,
                instructionSysvarAccount: web3.SYSVAR_INSTRUCTIONS_PUBKEY,
                payloadAccount: payloadAccountPDA,
                routerVault: routerVaultPDA,
                chainCurrencyInfo: chainCurrencyInfoPDA,
                tokenMint: wrappedTokenMint,
                tokenProgram: TOKEN_PROGRAM_ID,
                rent: SYSVAR_RENT_PUBKEY,
                user: user.publicKey,
                receiverTokenBag: _userTokenBag2,
                associatedTokenProgram: ASSOCIATED_TOKEN_PROGRAM_ID,
                tokenMetadataProgram: MetadataProgram.PUBKEY,
                metadata: tokenMetadata
              };
              console.table(Object.entries(accounts).map(function (prop) {
                prop[1] = prop[1].toString();
                return prop;
              }));
              _context12.t7 = _preTxs;
              _context12.next = 91;
              return routerProgram.methods.onTeleportMessageTokenMint({
                sourceChainId: transmission.sourceChainId,
                routerVaultBump: routerVaultBump,
                tokenDecimals: 0,
                nativeTokenAddress: Buffer.from(nativeAddressBytes),
                nativeTokenId: nativeTokenId
              }).accounts(accounts).instruction();
            case 91:
              _context12.t8 = _context12.sent;
              return _context12.abrupt("return", {
                pretxs: _context12.t7,
                onTeleportMessageInstruction: _context12.t8
              });
            case 93:
            case "end":
              return _context12.stop();
          }
        }
      }, _callee12);
    }));
    return function getOnTeleportMessageInstruction(_x19, _x20, _x21) {
      return _ref12.apply(this, arguments);
    };
  }();
  var getDAppId = /*#__PURE__*/function () {
    var _ref13 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee13() {
      var _yield$findRouterStor3, routerStoragePDA, routerStorage;
      return _regeneratorRuntime().wrap(function _callee13$(_context13) {
        while (1) {
          switch (_context13.prev = _context13.next) {
            case 0:
              _context13.next = 2;
              return findRouterStoragePDA();
            case 2:
              _yield$findRouterStor3 = _context13.sent;
              routerStoragePDA = _yield$findRouterStor3[0];
              _context13.next = 6;
              return routerProgram.account.routerStorage.fetch(routerStoragePDA);
            case 6:
              routerStorage = _context13.sent;
              return _context13.abrupt("return", routerStorage.dAppId);
            case 8:
            case "end":
              return _context13.stop();
          }
        }
      }, _callee13);
    }));
    return function getDAppId() {
      return _ref13.apply(this, arguments);
    };
  }();
  var isERC721Claim = /*#__PURE__*/function () {
    var _ref14 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee14(claim) {
      var expectedDAppId;
      return _regeneratorRuntime().wrap(function _callee14$(_context14) {
        while (1) {
          switch (_context14.prev = _context14.next) {
            case 0:
              if (!(claim.dAppId === "")) {
                _context14.next = 2;
                break;
              }
              return _context14.abrupt("return", false);
            case 2:
              if (!(ethers$1.utils.isHexString(claim.dAppId) === false)) {
                _context14.next = 4;
                break;
              }
              throw new ABridgeSDKError("dAppId needs to be an hex string");
            case 4:
              _context14.t0 = ethers$1.utils;
              _context14.next = 7;
              return getDAppId();
            case 7:
              _context14.t1 = _context14.sent;
              expectedDAppId = _context14.t0.hexlify.call(_context14.t0, _context14.t1);
              return _context14.abrupt("return", claim.dAppId === expectedDAppId);
            case 10:
            case "end":
              return _context14.stop();
          }
        }
      }, _callee14);
    }));
    return function isERC721Claim(_x22) {
      return _ref14.apply(this, arguments);
    };
  }();
  return {
    findRouterVaultPDA: findRouterVaultPDA,
    findEgressPayloadPDA: findEgressPayloadPDA,
    findRouterStoragePDA: findRouterStoragePDA,
    findChainInfoPDA: findChainInfoPDA,
    findRouterSigningPDA: findRouterSigningPDA,
    findWrappedTokenPDA: findWrappedTokenPDA,
    getInitEgressPayloadAccountTx: getInitEgressPayloadAccountTx,
    getEgressTxs: getEgressTxs,
    getOnTeleportMessageInstruction: getOnTeleportMessageInstruction,
    parsePayload: parsePayload,
    isERC721Claim: isERC721Claim,
    getDAppId: getDAppId
  };
};
var Payload$1 = function Payload(payloadBytes) {
  var _ethers$utils$default = ethers$1.utils.defaultAbiCoder.decode(["uint256", "bytes"], payloadBytes),
    header = _ethers$utils$default[0],
    envelopeBytes = _ethers$utils$default[1];
  this.header = header;
  this.envelope = new Envelope$1(envelopeBytes);
};
var Envelope$1 = function Envelope(envelopeBytes) {
  var _ethers$utils$default2 = ethers$1.utils.defaultAbiCoder.decode(["bytes", "bytes", "bytes[]"], envelopeBytes),
    senderBytes = _ethers$utils$default2[0],
    receiverBytes = _ethers$utils$default2[1],
    actionsBytes = _ethers$utils$default2[2];
  this.sender = senderBytes;
  this.receiver = receiverBytes;
  this.actions = actionsBytes.map(function (actionBytes) {
    return new Action$1(actionBytes);
  });
};
var Action$1 = /*#__PURE__*/function () {
  function Action(actionBytes) {
    var _ethers$utils$default3 = ethers$1.utils.defaultAbiCoder.decode(["uint8", "bytes", "bytes"], actionBytes),
      actionId = _ethers$utils$default3[0],
      nativeAddressBytes = _ethers$utils$default3[1],
      actionDataBytes = _ethers$utils$default3[2];
    this.actionId = actionId;
    this.nativeAddress = nativeAddressBytes;
    this.dataBytes = actionDataBytes;
  }
  var _proto = Action.prototype;
  _proto.getMintData = function getMintData() {
    var _ethers$utils$default4 = ethers$1.utils.defaultAbiCoder.decode(["uint256[]", "uint8", "string[]", "string", "string"], this.dataBytes),
      tokenIds = _ethers$utils$default4[0],
      // tokenIds
      nativeChainId = _ethers$utils$default4[1],
      // nativeChainId
      uris = _ethers$utils$default4[2],
      // uris
      tokenName = _ethers$utils$default4[3],
      // Token name
      tokenSymbol = _ethers$utils$default4[4];
    return {
      tokenIds: tokenIds == null ? void 0 : tokenIds.map(function (x) {
        return new BN(x.toString());
      }),
      nativeChainId: nativeChainId,
      uris: uris,
      tokenName: tokenName,
      tokenSymbol: tokenSymbol
    };
  };
  _proto.getUnlockData = function getUnlockData() {
    var _ethers$utils$default5 = ethers$1.utils.defaultAbiCoder.decode(["uint256[]"], this.dataBytes),
      tokenIds = _ethers$utils$default5[0];
    return {
      tokenIds: tokenIds == null ? void 0 : tokenIds.map(function (x) {
        return new BN(x.toString());
      })
    };
  };
  return Action;
}();

var SolanaRouterSDK = /*#__PURE__*/function (_RouterSDK) {
  _inheritsLoose(SolanaRouterSDK, _RouterSDK);
  function SolanaRouterSDK(signerOrProvider, optionalParams) {
    var _this;
    // Cluster provided by the user
    var connection = signerOrProvider.connection;
    var isMainnet = connection.rpcEndpoint.includes("mainnet");
    var configName = isMainnet ? "solana_mainnet" : "solana_devnet";
    _this = _RouterSDK.call(this, signerOrProvider, _extends({}, optionalParams, {
      configName: configName
    })) || this;
    _this.connection = connection;
    _this.metaplex = new Metaplex(connection);
    _this.setParams(optionalParams || {});
    return _this;
  }
  /**
   * @param optionalParams
   * @property teleportIDL: object
   * @property ERC20RouterIDL: object
   */
  var _proto = SolanaRouterSDK.prototype;
  _proto.setParams = function setParams(optionalParams) {
    // Call super.setParams to set common params for all routers
    _RouterSDK.prototype.setParams.call(this, optionalParams);
    // Teleport ERC20
    if (optionalParams["teleportIDL"]) {
      this.ITeleportIDL = optionalParams.teleportIDL;
    } else {
      this.ITeleportIDL = abridge_messaging_protocol_contracts_solana;
    }
    // Router ERC20
    if (optionalParams["ERC20RouterIDL"]) {
      this.ERC20RouterIDL = optionalParams.ERC20RouterIDL;
    } else {
      this.ERC20RouterIDL = abridge_erc20_solana;
    }
    // Router ERC721
    if (optionalParams["ERC721RouterIDL"]) {
      this.ERC721RouterIDL = optionalParams.ERC721RouterIDL;
    } else {
      this.ERC721RouterIDL = abridge_erc721_solana;
    }
  };
  _proto.allowance = /*#__PURE__*/function () {
    var _allowance = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(tokenAddress, userAddress) {
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              throw "allowance - Not implemented yet for Solana";
            case 1:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));
    function allowance(_x, _x2) {
      return _allowance.apply(this, arguments);
    }
    return allowance;
  }();
  _proto.allowanceLegacy = /*#__PURE__*/function () {
    var _allowanceLegacy = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2(tokenAddress, userAddress) {
      return _regeneratorRuntime().wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              throw "allowanceLegacy - There's no legacy bridge on Solana.";
            case 1:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));
    function allowanceLegacy(_x3, _x4) {
      return _allowanceLegacy.apply(this, arguments);
    }
    return allowanceLegacy;
  }();
  _proto.approve = /*#__PURE__*/function () {
    var _approve = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee3(tokenAddress, amount) {
      return _regeneratorRuntime().wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              throw new ABridgeSDKError("approve - There's no approval on solana. The approval is given when the user signs the operation");
            case 1:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    }));
    function approve(_x5, _x6) {
      return _approve.apply(this, arguments);
    }
    return approve;
  }();
  _proto.approveLegacy = /*#__PURE__*/function () {
    var _approveLegacy = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee4() {
      return _regeneratorRuntime().wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              throw new ABridgeSDKError("approveLegacy - There's no legacy bridge on Solana.");
            case 1:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4);
    }));
    function approveLegacy() {
      return _approveLegacy.apply(this, arguments);
    }
    return approveLegacy;
  }();
  _proto.approveMaxInt = /*#__PURE__*/function () {
    var _approveMaxInt = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee5(tokenAddress) {
      return _regeneratorRuntime().wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              throw new ABridgeSDKError("approveMaxInt - There's no approval on solana. The approval is given when the user signs the operation");
            case 1:
            case "end":
              return _context5.stop();
          }
        }
      }, _callee5);
    }));
    function approveMaxInt(_x7) {
      return _approveMaxInt.apply(this, arguments);
    }
    return approveMaxInt;
  }();
  _proto.approveMaxIntLegacy = /*#__PURE__*/function () {
    var _approveMaxIntLegacy = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee6() {
      return _regeneratorRuntime().wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              throw "approveMaxIntLegacy - There's no legacy bridge on Solana.";
            case 1:
            case "end":
              return _context6.stop();
          }
        }
      }, _callee6);
    }));
    function approveMaxIntLegacy() {
      return _approveMaxIntLegacy.apply(this, arguments);
    }
    return approveMaxIntLegacy;
  }();
  _proto.approveNfts = /*#__PURE__*/function () {
    var _approveNfts = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee7(collectionAddress) {
      return _regeneratorRuntime().wrap(function _callee7$(_context7) {
        while (1) {
          switch (_context7.prev = _context7.next) {
            case 0:
              throw new ABridgeSDKError("approveNfts - There's no approval on solana. The approval is given when the user signs the operation");
            case 1:
            case "end":
              return _context7.stop();
          }
        }
      }, _callee7);
    }));
    function approveNfts(_x8) {
      return _approveNfts.apply(this, arguments);
    }
    return approveNfts;
  }();
  _proto.balanceOf = /*#__PURE__*/function () {
    var _balanceOf = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee8(tokenAddress, userAddress) {
      var userAddressPK, tokenAddressPK, isNative, amount, decimals, associatedTokenAccount, data, _data$value, _amount, _decimals, balance, _decimals2;
      return _regeneratorRuntime().wrap(function _callee8$(_context8) {
        while (1) {
          switch (_context8.prev = _context8.next) {
            case 0:
              userAddressPK = this._getAddressPK(userAddress);
              tokenAddressPK = this._getAddressPK(tokenAddress); // Solana amount
              isNative = tokenAddressPK.toString() === PublicKey["default"].toString();
              if (!isNative) {
                _context8.next = 9;
                break;
              }
              _context8.next = 6;
              return this.connection.getBalance(userAddressPK);
            case 6:
              amount = _context8.sent;
              decimals = LAMPORTS_PER_SOL.toString().length - 1;
              return _context8.abrupt("return", {
                balance: BigNumber$1.from(amount),
                decimals: decimals
              });
            case 9:
              _context8.prev = 9;
              _context8.next = 12;
              return getAssociatedTokenAddress(tokenAddressPK, userAddressPK);
            case 12:
              associatedTokenAccount = _context8.sent;
              _context8.next = 15;
              return this.connection.getTokenAccountBalance(associatedTokenAccount);
            case 15:
              data = _context8.sent;
              _data$value = data.value, _amount = _data$value.amount, _decimals = _data$value.decimals;
              balance = BigNumber$1.from(_amount);
              return _context8.abrupt("return", {
                balance: balance,
                decimals: _decimals
              });
            case 21:
              _context8.prev = 21;
              _context8.t0 = _context8["catch"](9);
              if (!(_context8.t0.code === -32602)) {
                _context8.next = 28;
                break;
              }
              _context8.next = 26;
              return this.getTokenDecimals(tokenAddress);
            case 26:
              _decimals2 = _context8.sent;
              return _context8.abrupt("return", {
                balance: BigNumber$1.from(0),
                decimals: _decimals2
              });
            case 28:
              throw new ABridgeSDKError("balanceOf - Error:", _context8.t0);
            case 29:
            case "end":
              return _context8.stop();
          }
        }
      }, _callee8, this, [[9, 21]]);
    }));
    function balanceOf(_x9, _x10) {
      return _balanceOf.apply(this, arguments);
    }
    return balanceOf;
  }();
  _proto.balanceOfLegacy = /*#__PURE__*/function () {
    var _balanceOfLegacy = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee9(tokenAddress, userAddress) {
      return _regeneratorRuntime().wrap(function _callee9$(_context9) {
        while (1) {
          switch (_context9.prev = _context9.next) {
            case 0:
              throw "balanceOfLegacy - There's no legacy bridge on Solana.";
            case 1:
            case "end":
              return _context9.stop();
          }
        }
      }, _callee9);
    }));
    function balanceOfLegacy(_x11, _x12) {
      return _balanceOfLegacy.apply(this, arguments);
    }
    return balanceOfLegacy;
  }();
  _proto.balanceOfMulticall = /*#__PURE__*/function () {
    var _balanceOfMulticall = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee11(tokenAddresses, userAddress) {
      var _this2 = this;
      var allBalances, result, onlyBalances;
      return _regeneratorRuntime().wrap(function _callee11$(_context11) {
        while (1) {
          switch (_context11.prev = _context11.next) {
            case 0:
              allBalances = tokenAddresses.filter(function (isToken) {
                return Boolean(isToken);
              }).map( /*#__PURE__*/function () {
                var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee10(tokenAddress) {
                  return _regeneratorRuntime().wrap(function _callee10$(_context10) {
                    while (1) {
                      switch (_context10.prev = _context10.next) {
                        case 0:
                          return _context10.abrupt("return", _this2.balanceOf(tokenAddress, userAddress));
                        case 1:
                        case "end":
                          return _context10.stop();
                      }
                    }
                  }, _callee10);
                }));
                return function (_x15) {
                  return _ref.apply(this, arguments);
                };
              }());
              _context11.next = 3;
              return Promise.all(allBalances);
            case 3:
              result = _context11.sent;
              onlyBalances = result.map(function (_ref2) {
                var balance = _ref2.balance;
                return balance;
              });
              return _context11.abrupt("return", onlyBalances);
            case 6:
            case "end":
              return _context11.stop();
          }
        }
      }, _callee11);
    }));
    function balanceOfMulticall(_x13, _x14) {
      return _balanceOfMulticall.apply(this, arguments);
    }
    return balanceOfMulticall;
  }();
  _proto.balanceOfMulticallV2Legacy = /*#__PURE__*/function () {
    var _balanceOfMulticallV2Legacy = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee12(tokenAddresses, userAddress) {
      return _regeneratorRuntime().wrap(function _callee12$(_context12) {
        while (1) {
          switch (_context12.prev = _context12.next) {
            case 0:
              throw "balanceOfMulticallV2Legacy - There's no legacy bridge on Solana.";
            case 1:
            case "end":
              return _context12.stop();
          }
        }
      }, _callee12);
    }));
    function balanceOfMulticallV2Legacy(_x16, _x17) {
      return _balanceOfMulticallV2Legacy.apply(this, arguments);
    }
    return balanceOfMulticallV2Legacy;
  }();
  _proto.claim = /*#__PURE__*/function () {
    var _claim = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee13(transmission) {
      var teleportContract, user, teleportHelper, txsToSign, signed, deliverReceipt;
      return _regeneratorRuntime().wrap(function _callee13$(_context13) {
        while (1) {
          switch (_context13.prev = _context13.next) {
            case 0:
              teleportContract = getProgram({
                idl: this.ITeleportIDL,
                provider: this.signerOrProvider
              });
              user = teleportContract.provider.wallet;
              teleportHelper = teleportHelperConstructor(teleportContract);
              _context13.prev = 3;
              _context13.next = 6;
              return this.getDappClaimTxs(transmission, teleportHelper, user);
            case 6:
              txsToSign = _context13.sent;
              _context13.next = 9;
              return user.signAllTransactions(txsToSign);
            case 9:
              signed = _context13.sent;
              _context13.next = 12;
              return sendAndConfirmTxs(teleportContract, [signed[0]]);
            case 12:
              _context13.next = 14;
              return sendAndConfirmTxs(teleportContract, signed.slice(1, -1));
            case 14:
              _context13.next = 16;
              return sendAndConfirmTxs(teleportContract, signed.slice(-1));
            case 16:
              deliverReceipt = _context13.sent[0];
              return _context13.abrupt("return", deliverReceipt);
            case 20:
              _context13.prev = 20;
              _context13.t0 = _context13["catch"](3);
              if (_context13.t0.logs) {
                console.error("Solana Logs:", _context13.t0.logs);
              }
              throw new ABridgeSDKError("claim - Error:", _context13.t0);
            case 24:
            case "end":
              return _context13.stop();
          }
        }
      }, _callee13, this, [[3, 20]]);
    }));
    function claim(_x18) {
      return _claim.apply(this, arguments);
    }
    return claim;
  }();
  _proto.getDappClaimTxs = /*#__PURE__*/function () {
    var _getDappClaimTxs = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee14(transmission, teleportHelper, user) {
      var erc721RouterContract, connection, erc721Helper, erc20RouterContract, erc20Helper, txsToSign;
      return _regeneratorRuntime().wrap(function _callee14$(_context14) {
        while (1) {
          switch (_context14.prev = _context14.next) {
            case 0:
              erc721RouterContract = getProgram({
                idl: this.ERC721RouterIDL,
                provider: this.signerOrProvider
              });
              connection = erc721RouterContract.provider.connection;
              erc721Helper = ERC721RouterHelperConstructor(erc721RouterContract);
              erc20RouterContract = getProgram({
                idl: this.ERC20RouterIDL,
                provider: this.signerOrProvider
              });
              erc20Helper = ERC20RouterHelperConstructor(erc20RouterContract);
              _context14.next = 7;
              return erc721Helper.isERC721Claim(transmission);
            case 7:
              if (!_context14.sent) {
                _context14.next = 13;
                break;
              }
              _context14.next = 10;
              return this.getERC721ClaimTxsToSign(transmission, teleportHelper, erc721RouterContract, user, connection);
            case 10:
              txsToSign = _context14.sent;
              _context14.next = 22;
              break;
            case 13:
              _context14.next = 15;
              return erc20Helper.isERC20Claim(transmission);
            case 15:
              if (!_context14.sent) {
                _context14.next = 21;
                break;
              }
              _context14.next = 18;
              return this.getERC20ClaimTxsToSign(transmission, teleportHelper, erc20RouterContract, user, connection);
            case 18:
              txsToSign = _context14.sent;
              _context14.next = 22;
              break;
            case 21:
              throw new ABridgeSDKError("Dapp Claim type not implemented yet for solana");
            case 22:
              return _context14.abrupt("return", txsToSign);
            case 23:
            case "end":
              return _context14.stop();
          }
        }
      }, _callee14, this);
    }));
    function getDappClaimTxs(_x19, _x20, _x21) {
      return _getDappClaimTxs.apply(this, arguments);
    }
    return getDappClaimTxs;
  }();
  _proto.getERC20ClaimTxsToSign = /*#__PURE__*/function () {
    var _getERC20ClaimTxsToSign = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee15(transmission, teleportHelper, erc20RouterContract, user, connection) {
      var routerHelper, transmissionId, _yield$teleportHelper, payloadAccountPDA, routerInstructionAndPreTx;
      return _regeneratorRuntime().wrap(function _callee15$(_context15) {
        while (1) {
          switch (_context15.prev = _context15.next) {
            case 0:
              routerHelper = ERC20RouterHelperConstructor(erc20RouterContract);
              transmissionId = transmission.transmissionId;
              _context15.next = 4;
              return teleportHelper.findDeliverPayloadPDA(transmissionId);
            case 4:
              _yield$teleportHelper = _context15.sent;
              payloadAccountPDA = _yield$teleportHelper[0];
              _context15.next = 8;
              return routerHelper.getOnTeleportMessageInstruction(transmission, payloadAccountPDA, user);
            case 8:
              routerInstructionAndPreTx = _context15.sent;
              _context15.next = 11;
              return this.getTeleportTxsToSign(teleportHelper, payloadAccountPDA, transmission, user, routerInstructionAndPreTx, connection);
            case 11:
              return _context15.abrupt("return", _context15.sent);
            case 12:
            case "end":
              return _context15.stop();
          }
        }
      }, _callee15, this);
    }));
    function getERC20ClaimTxsToSign(_x22, _x23, _x24, _x25, _x26) {
      return _getERC20ClaimTxsToSign.apply(this, arguments);
    }
    return getERC20ClaimTxsToSign;
  }();
  _proto.getERC721ClaimTxsToSign = /*#__PURE__*/function () {
    var _getERC721ClaimTxsToSign = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee16(transmission, teleportHelper, routerContract, user, connection) {
      var routerHelper, transmissionId, _yield$teleportHelper2, payloadAccountPDA, routerInstructionAndPreTx;
      return _regeneratorRuntime().wrap(function _callee16$(_context16) {
        while (1) {
          switch (_context16.prev = _context16.next) {
            case 0:
              routerHelper = ERC721RouterHelperConstructor(routerContract);
              transmissionId = transmission.transmissionId;
              _context16.next = 4;
              return teleportHelper.findDeliverPayloadPDA(transmissionId);
            case 4:
              _yield$teleportHelper2 = _context16.sent;
              payloadAccountPDA = _yield$teleportHelper2[0];
              _context16.next = 8;
              return routerHelper.getOnTeleportMessageInstruction(transmission, payloadAccountPDA, user);
            case 8:
              routerInstructionAndPreTx = _context16.sent;
              _context16.next = 11;
              return this.getTeleportTxsToSign(teleportHelper, payloadAccountPDA, transmission, user, routerInstructionAndPreTx, connection);
            case 11:
              return _context16.abrupt("return", _context16.sent);
            case 12:
            case "end":
              return _context16.stop();
          }
        }
      }, _callee16, this);
    }));
    function getERC721ClaimTxsToSign(_x27, _x28, _x29, _x30, _x31) {
      return _getERC721ClaimTxsToSign.apply(this, arguments);
    }
    return getERC721ClaimTxsToSign;
  }();
  _proto.getTeleportTxsToSign = /*#__PURE__*/function () {
    var _getTeleportTxsToSign = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee17(teleportHelper, payloadAccountPDA, transmission, user, routerInstructionAndPreTx, connection) {
      var transmissionId, payload, txsToSign, initPayloadTxs, claimTx, latestBlockhash;
      return _regeneratorRuntime().wrap(function _callee17$(_context17) {
        while (1) {
          switch (_context17.prev = _context17.next) {
            case 0:
              transmissionId = transmission.transmissionId, payload = transmission.payload;
              txsToSign = []; //Get init payload txs
              _context17.next = 4;
              return teleportHelper.getInitClaimPayloadAccountTxs(payload, transmissionId, payloadAccountPDA);
            case 4:
              initPayloadTxs = _context17.sent;
              txsToSign.push.apply(txsToSign, initPayloadTxs);
              _context17.next = 8;
              return teleportHelper.getDeliverTx(transmission, payloadAccountPDA, user, routerInstructionAndPreTx.onTeleportMessageInstruction);
            case 8:
              claimTx = _context17.sent;
              if (routerInstructionAndPreTx.pretxs) {
                txsToSign.push.apply(txsToSign, routerInstructionAndPreTx.pretxs);
              }
              _context17.t0 = claimTx;
              _context17.next = 13;
              return teleportHelper.getClosePayloadAccountInstruction(transmissionId, payloadAccountPDA, user);
            case 13:
              _context17.t1 = _context17.sent;
              _context17.t0.add.call(_context17.t0, _context17.t1);
              txsToSign.push(claimTx);
              _context17.next = 18;
              return connection.getLatestBlockhash({
                commitment: CONFIRMED_COMMITMENT
              });
            case 18:
              latestBlockhash = _context17.sent.blockhash;
              txsToSign.forEach(function (element) {
                element.feePayer = user.publicKey;
                element.recentBlockhash = latestBlockhash;
              });
              return _context17.abrupt("return", txsToSign);
            case 21:
            case "end":
              return _context17.stop();
          }
        }
      }, _callee17);
    }));
    function getTeleportTxsToSign(_x32, _x33, _x34, _x35, _x36, _x37) {
      return _getTeleportTxsToSign.apply(this, arguments);
    }
    return getTeleportTxsToSign;
  }();
  _proto.claimLegacy = /*#__PURE__*/function () {
    var _claimLegacy = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee18(transfer) {
      return _regeneratorRuntime().wrap(function _callee18$(_context18) {
        while (1) {
          switch (_context18.prev = _context18.next) {
            case 0:
              throw "claimLegacy - There's no legacy bridge on Solana.";
            case 1:
            case "end":
              return _context18.stop();
          }
        }
      }, _callee18);
    }));
    function claimLegacy(_x38) {
      return _claimLegacy.apply(this, arguments);
    }
    return claimLegacy;
  }();
  _proto.estimateApproveNfts = /*#__PURE__*/function () {
    var _estimateApproveNfts = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee19(collectionAddress) {
      return _regeneratorRuntime().wrap(function _callee19$(_context19) {
        while (1) {
          switch (_context19.prev = _context19.next) {
            case 0:
              throw new ABridgeSDKError("estimateApproveNfts - There's no approval on solana. The approval is given when the user signs the operation");
            case 1:
            case "end":
              return _context19.stop();
          }
        }
      }, _callee19);
    }));
    function estimateApproveNfts(_x39) {
      return _estimateApproveNfts.apply(this, arguments);
    }
    return estimateApproveNfts;
  }();
  _proto.estimateClaim = /*#__PURE__*/function () {
    var _estimateClaim = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee21(transmission) {
      var teleportContract, connection, user, teleportHelper, txs;
      return _regeneratorRuntime().wrap(function _callee21$(_context21) {
        while (1) {
          switch (_context21.prev = _context21.next) {
            case 0:
              _context21.prev = 0;
              teleportContract = getProgram({
                idl: this.ITeleportIDL,
                provider: this.signerOrProvider
              });
              connection = teleportContract.provider.connection;
              user = teleportContract.provider.wallet;
              teleportHelper = teleportHelperConstructor(teleportContract);
              _context21.next = 7;
              return this.getDappClaimTxs(transmission, teleportHelper, user);
            case 7:
              txs = _context21.sent;
              _context21.next = 10;
              return Promise.all(txs.map( /*#__PURE__*/function () {
                var _ref3 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee20(tx) {
                  return _regeneratorRuntime().wrap(function _callee20$(_context20) {
                    while (1) {
                      switch (_context20.prev = _context20.next) {
                        case 0:
                          return _context20.abrupt("return", tx.getEstimatedFee(connection));
                        case 1:
                        case "end":
                          return _context20.stop();
                      }
                    }
                  }, _callee20);
                }));
                return function (_x41) {
                  return _ref3.apply(this, arguments);
                };
              }()));
            case 10:
              return _context21.abrupt("return", _context21.sent.reduce(function (prev, curr) {
                return prev + curr;
              }));
            case 13:
              _context21.prev = 13;
              _context21.t0 = _context21["catch"](0);
              console.error(_context21.t0);
              throw _context21.t0;
            case 17:
            case "end":
              return _context21.stop();
          }
        }
      }, _callee21, this, [[0, 13]]);
    }));
    function estimateClaim(_x40) {
      return _estimateClaim.apply(this, arguments);
    }
    return estimateClaim;
  }();
  _proto.estimateSendNftTokens = /*#__PURE__*/function () {
    var _estimateSendNftTokens = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee23(targetChainId, assets, userAddress, fee) {
      var routerProgram, _yield$this$getERC, txsToSign;
      return _regeneratorRuntime().wrap(function _callee23$(_context23) {
        while (1) {
          switch (_context23.prev = _context23.next) {
            case 0:
              if (assets) {
                _context23.next = 2;
                break;
              }
              throw "assets was not provided";
            case 2:
              if (targetChainId) {
                _context23.next = 4;
                break;
              }
              throw "targetChainId was not provided";
            case 4:
              if (userAddress) {
                _context23.next = 6;
                break;
              }
              throw "userAddress was not provided";
            case 6:
              if (!(assets.length == 0)) {
                _context23.next = 8;
                break;
              }
              throw "You have to send at least one asset.";
            case 8:
              if (!(assets.length > 1)) {
                _context23.next = 10;
                break;
              }
              throw "We currently only support sending one asset at a time.";
            case 10:
              routerProgram = getProgram({
                idl: this.ERC721RouterIDL,
                provider: this.signerOrProvider
              });
              _context23.next = 13;
              return this.getERC721EgressTxs(targetChainId, assets, userAddress);
            case 13:
              _yield$this$getERC = _context23.sent;
              txsToSign = _yield$this$getERC.txsToSign;
              _context23.next = 17;
              return Promise.all(txsToSign.map( /*#__PURE__*/function () {
                var _ref4 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee22(tx) {
                  return _regeneratorRuntime().wrap(function _callee22$(_context22) {
                    while (1) {
                      switch (_context22.prev = _context22.next) {
                        case 0:
                          return _context22.abrupt("return", tx.getEstimatedFee(routerProgram.provider.connection));
                        case 1:
                        case "end":
                          return _context22.stop();
                      }
                    }
                  }, _callee22);
                }));
                return function (_x46) {
                  return _ref4.apply(this, arguments);
                };
              }()));
            case 17:
              return _context23.abrupt("return", _context23.sent.reduce(function (prev, curr) {
                return prev + curr;
              }));
            case 18:
            case "end":
              return _context23.stop();
          }
        }
      }, _callee23, this);
    }));
    function estimateSendNftTokens(_x42, _x43, _x44, _x45) {
      return _estimateSendNftTokens.apply(this, arguments);
    }
    return estimateSendNftTokens;
  }();
  _proto.fixSignatures = function fixSignatures(signatures) {
    throw "fixSignatures - Not implemented yet for Solana";
  };
  _proto.getALBTToken = /*#__PURE__*/function () {
    var _getALBTToken = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee24() {
      var albtAddress, albtDetails;
      return _regeneratorRuntime().wrap(function _callee24$(_context24) {
        while (1) {
          switch (_context24.prev = _context24.next) {
            case 0:
              albtAddress = "HkgEuhAUXYiTbyo3kEPPwRyx4SiUAxir7dnijXfrgB41"; // TODO: Set this on the contract side
              _context24.next = 3;
              return this.getTokenDetails(albtAddress);
            case 3:
              albtDetails = _context24.sent;
              return _context24.abrupt("return", _extends({}, albtDetails));
            case 5:
            case "end":
              return _context24.stop();
          }
        }
      }, _callee24, this);
    }));
    function getALBTToken() {
      return _getALBTToken.apply(this, arguments);
    }
    return getALBTToken;
  }();
  _proto.getALBTTokenV1 = /*#__PURE__*/function () {
    var _getALBTTokenV = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee25() {
      return _regeneratorRuntime().wrap(function _callee25$(_context25) {
        while (1) {
          switch (_context25.prev = _context25.next) {
            case 0:
              throw "getALBTTokenV1 - Not implemented yet for Solana";
            case 1:
            case "end":
              return _context25.stop();
          }
        }
      }, _callee25);
    }));
    function getALBTTokenV1() {
      return _getALBTTokenV.apply(this, arguments);
    }
    return getALBTTokenV1;
  }();
  _proto.getALBTTokenLegacy = /*#__PURE__*/function () {
    var _getALBTTokenLegacy = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee26() {
      return _regeneratorRuntime().wrap(function _callee26$(_context26) {
        while (1) {
          switch (_context26.prev = _context26.next) {
            case 0:
              throw "getALBTTokenLegacy - There's no legacy bridge on Solana.";
            case 1:
            case "end":
              return _context26.stop();
          }
        }
      }, _callee26);
    }));
    function getALBTTokenLegacy() {
      return _getALBTTokenLegacy.apply(this, arguments);
    }
    return getALBTTokenLegacy;
  }();
  _proto.getExternalFeeLegacy = /*#__PURE__*/function () {
    var _getExternalFeeLegacy = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee27() {
      return _regeneratorRuntime().wrap(function _callee27$(_context27) {
        while (1) {
          switch (_context27.prev = _context27.next) {
            case 0:
              throw "getExternalFeeLegacy - There's no legacy bridge on Solana.";
            case 1:
            case "end":
              return _context27.stop();
          }
        }
      }, _callee27);
    }));
    function getExternalFeeLegacy() {
      return _getExternalFeeLegacy.apply(this, arguments);
    }
    return getExternalFeeLegacy;
  }();
  _proto.getERC721EgressTxs = /*#__PURE__*/function () {
    var _getERC721EgressTxs = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee28(targetChainId, assets, userAddress) {
      var _assets$, _assets$$asset_contra;
      var tokenAddress, teleportProgram, routerProgram, teleportHelper, routerHelper, user, _yield$routerHelper$f, payloadPDA, _yield$teleportHelper3, teleportFeeCollectorPDA, _yield$teleportHelper4, teleportFeeCalculatorStoragePDA, txsToSign, needToInitPayload, egressTxs, payloadAccountInfo;
      return _regeneratorRuntime().wrap(function _callee28$(_context28) {
        while (1) {
          switch (_context28.prev = _context28.next) {
            case 0:
              tokenAddress = (_assets$ = assets[0]) == null ? void 0 : (_assets$$asset_contra = _assets$.asset_contract) == null ? void 0 : _assets$$asset_contra.address;
              teleportProgram = getProgram({
                idl: this.ITeleportIDL,
                provider: this.signerOrProvider
              });
              routerProgram = getProgram({
                idl: this.ERC721RouterIDL,
                provider: this.signerOrProvider
              });
              teleportHelper = teleportHelperConstructor(teleportProgram);
              routerHelper = ERC721RouterHelperConstructor(routerProgram);
              user = routerProgram.provider.wallet; // Get router accounts
              _context28.next = 8;
              return routerHelper.findEgressPayloadPDA(user.publicKey);
            case 8:
              _yield$routerHelper$f = _context28.sent;
              payloadPDA = _yield$routerHelper$f[0];
              _context28.next = 12;
              return teleportHelper.findFeeCollectorPDA();
            case 12:
              _yield$teleportHelper3 = _context28.sent;
              teleportFeeCollectorPDA = _yield$teleportHelper3[0];
              _context28.next = 16;
              return teleportHelper.findFeeCalculatorStoragePDA();
            case 16:
              _yield$teleportHelper4 = _context28.sent;
              teleportFeeCalculatorStoragePDA = _yield$teleportHelper4[0];
              txsToSign = [];
              needToInitPayload = false;
              _context28.prev = 20;
              _context28.next = 23;
              return routerProgram.provider.connection.getAccountInfo(payloadPDA);
            case 23:
              payloadAccountInfo = _context28.sent;
              needToInitPayload = payloadAccountInfo ? payloadAccountInfo.data.readUintLE(0, 8) === 0 : true;
              if (!needToInitPayload) {
                _context28.next = 31;
                break;
              }
              _context28.t0 = txsToSign;
              _context28.next = 29;
              return routerHelper.getInitEgressPayloadAccountTx(payloadPDA, user.publicKey);
            case 29:
              _context28.t1 = _context28.sent;
              _context28.t0.push.call(_context28.t0, _context28.t1);
            case 31:
              _context28.next = 33;
              return routerHelper.getEgressTxs(new PublicKey(tokenAddress), targetChainId, 1, userAddress, user, teleportProgram.programId, teleportFeeCalculatorStoragePDA, teleportFeeCollectorPDA);
            case 33:
              egressTxs = _context28.sent;
              txsToSign.push.apply(txsToSign, egressTxs.preTxs);
              txsToSign.push(egressTxs.egressTx);
              _context28.next = 42;
              break;
            case 38:
              _context28.prev = 38;
              _context28.t2 = _context28["catch"](20);
              console.error(_context28.t2.logs);
              throw new ABridgeSDKError("sendErc721 - Error:", _context28.t2);
            case 42:
              return _context28.abrupt("return", {
                txsToSign: txsToSign,
                needToInitPayload: needToInitPayload,
                egressTxs: egressTxs
              });
            case 43:
            case "end":
              return _context28.stop();
          }
        }
      }, _callee28, this, [[20, 38]]);
    }));
    function getERC721EgressTxs(_x47, _x48, _x49) {
      return _getERC721EgressTxs.apply(this, arguments);
    }
    return getERC721EgressTxs;
  }();
  _proto.getFeeAmountByToken = /*#__PURE__*/function () {
    var _getFeeAmountByToken = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee29(tokenAddress) {
      return _regeneratorRuntime().wrap(function _callee29$(_context29) {
        while (1) {
          switch (_context29.prev = _context29.next) {
            case 0:
              throw "getFeeAmountByToken - Not implemented yet for Solana. For the moment fees are only payable in local currency";
            case 1:
            case "end":
              return _context29.stop();
          }
        }
      }, _callee29);
    }));
    function getFeeAmountByToken(_x50) {
      return _getFeeAmountByToken.apply(this, arguments);
    }
    return getFeeAmountByToken;
  }();
  _proto.getFeeTokens = /*#__PURE__*/function () {
    var _getFeeTokens = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee30() {
      return _regeneratorRuntime().wrap(function _callee30$(_context30) {
        while (1) {
          switch (_context30.prev = _context30.next) {
            case 0:
              console.warn("getFeeTokens - Not implemented yet for Solana, For the moment fees are only payable in local currency");
              return _context30.abrupt("return", []);
            case 2:
            case "end":
              return _context30.stop();
          }
        }
      }, _callee30);
    }));
    function getFeeTokens() {
      return _getFeeTokens.apply(this, arguments);
    }
    return getFeeTokens;
  }();
  _proto.getNativeTokenByWrappedAddress = /*#__PURE__*/function () {
    var _getNativeTokenByWrappedAddress = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee31(wrappedTokenAddress) {
      var erc20RouterProgram, CHAIN_CURRENCY_INFO_SEED, _yield$PublicKey$find, chainCurrencyInfoPDA, accountInfo, currencyInfoWithChain;
      return _regeneratorRuntime().wrap(function _callee31$(_context31) {
        while (1) {
          switch (_context31.prev = _context31.next) {
            case 0:
              _context31.prev = 0;
              erc20RouterProgram = getProgram({
                idl: this.ERC20RouterIDL,
                provider: this.signerOrProvider
              });
              CHAIN_CURRENCY_INFO_SEED = Seeds.CHAIN_CURRENCY_INFO_SEED;
              _context31.next = 5;
              return PublicKey.findProgramAddress([utils$1.bytes.utf8.encode(CHAIN_CURRENCY_INFO_SEED), Buffer.from(wrappedTokenAddress, "hex")], erc20RouterProgram.programId);
            case 5:
              _yield$PublicKey$find = _context31.sent;
              chainCurrencyInfoPDA = _yield$PublicKey$find[0];
              _context31.next = 9;
              return this.signerOrProvider.connection.getAccountInfo(chainCurrencyInfoPDA);
            case 9:
              accountInfo = _context31.sent;
              if (accountInfo) {
                _context31.next = 12;
                break;
              }
              return _context31.abrupt("return", {
                "0": 0,
                "1": "0x",
                chainId: 0,
                "contractAddress:": "0x"
              });
            case 12:
              _context31.next = 14;
              return erc20RouterProgram.account.currencyInfoWithChain.fetch(chainCurrencyInfoPDA);
            case 14:
              currencyInfoWithChain = _context31.sent;
              return _context31.abrupt("return", {
                "0": currencyInfoWithChain.native_chain_id,
                "1": currencyInfoWithChain.native_address,
                chainId: currencyInfoWithChain.native_chain_id,
                "contractAddress:": currencyInfoWithChain.native_address
              });
            case 18:
              _context31.prev = 18;
              _context31.t0 = _context31["catch"](0);
              throw new ABridgeSDKError("getNativeTokenByWrappedAddress - Error:", _context31.t0);
            case 21:
            case "end":
              return _context31.stop();
          }
        }
      }, _callee31, this, [[0, 18]]);
    }));
    function getNativeTokenByWrappedAddress(_x51) {
      return _getNativeTokenByWrappedAddress.apply(this, arguments);
    }
    return getNativeTokenByWrappedAddress;
  }();
  _proto.getNativeTokenByWrappedAddressLegacy = /*#__PURE__*/function () {
    var _getNativeTokenByWrappedAddressLegacy = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee32(wrappedTokenAddress) {
      return _regeneratorRuntime().wrap(function _callee32$(_context32) {
        while (1) {
          switch (_context32.prev = _context32.next) {
            case 0:
              return _context32.abrupt("return", {
                chainId: 0,
                token: "0x"
              });
            case 1:
            case "end":
              return _context32.stop();
          }
        }
      }, _callee32);
    }));
    function getNativeTokenByWrappedAddressLegacy(_x52) {
      return _getNativeTokenByWrappedAddressLegacy.apply(this, arguments);
    }
    return getNativeTokenByWrappedAddressLegacy;
  }();
  _proto.getNFTBridgeFee = /*#__PURE__*/function () {
    var _getNFTBridgeFee = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee33() {
      return _regeneratorRuntime().wrap(function _callee33$(_context33) {
        while (1) {
          switch (_context33.prev = _context33.next) {
            case 0:
              return _context33.abrupt("return", this.getServiceFee());
            case 1:
            case "end":
              return _context33.stop();
          }
        }
      }, _callee33, this);
    }));
    function getNFTBridgeFee() {
      return _getNFTBridgeFee.apply(this, arguments);
    }
    return getNFTBridgeFee;
  }();
  _proto.getProxyFeeLegacy = /*#__PURE__*/function () {
    var _getProxyFeeLegacy = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee34(address) {
      return _regeneratorRuntime().wrap(function _callee34$(_context34) {
        while (1) {
          switch (_context34.prev = _context34.next) {
            case 0:
              throw "getProxyFeeLegacy - There's no legacy bridge on Solana.";
            case 1:
            case "end":
              return _context34.stop();
          }
        }
      }, _callee34);
    }));
    function getProxyFeeLegacy(_x53) {
      return _getProxyFeeLegacy.apply(this, arguments);
    }
    return getProxyFeeLegacy;
  }();
  _proto.getServiceFee = /*#__PURE__*/function () {
    var _getServiceFee = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee35() {
      var teleportProgram, TELEPORT_CALCULATOR_STORAGE_SEED, _yield$PublicKey$find2, feeCalculatorStoragePDA, calculatorAccount;
      return _regeneratorRuntime().wrap(function _callee35$(_context35) {
        while (1) {
          switch (_context35.prev = _context35.next) {
            case 0:
              _context35.prev = 0;
              teleportProgram = getProgram({
                idl: this.ITeleportIDL,
                provider: this.signerOrProvider
              });
              TELEPORT_CALCULATOR_STORAGE_SEED = Seeds.TELEPORT_CALCULATOR_STORAGE_SEED;
              _context35.next = 5;
              return PublicKey.findProgramAddress([utils$1.bytes.utf8.encode(TELEPORT_CALCULATOR_STORAGE_SEED)], teleportProgram.programId);
            case 5:
              _yield$PublicKey$find2 = _context35.sent;
              feeCalculatorStoragePDA = _yield$PublicKey$find2[0];
              _context35.next = 9;
              return teleportProgram.account.calculatorStorage.fetchNullable(feeCalculatorStoragePDA);
            case 9:
              calculatorAccount = _context35.sent;
              if (!(calculatorAccount === null)) {
                _context35.next = 12;
                break;
              }
              throw new ABridgeSDKError("Calculator account not found. Is the Teleport initialized?");
            case 12:
              return _context35.abrupt("return", calculatorAccount == null ? void 0 : calculatorAccount.serviceFee);
            case 15:
              _context35.prev = 15;
              _context35.t0 = _context35["catch"](0);
              throw new ABridgeSDKError("getServiceFee - Error:", _context35.t0);
            case 18:
            case "end":
              return _context35.stop();
          }
        }
      }, _callee35, this, [[0, 15]]);
    }));
    function getServiceFee() {
      return _getServiceFee.apply(this, arguments);
    }
    return getServiceFee;
  }();
  _proto.getServiceFeeLegacy = /*#__PURE__*/function () {
    var _getServiceFeeLegacy = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee36() {
      return _regeneratorRuntime().wrap(function _callee36$(_context36) {
        while (1) {
          switch (_context36.prev = _context36.next) {
            case 0:
              throw "getServiceFeeLegacy - There's no legacy bridge on Solana.";
            case 1:
            case "end":
              return _context36.stop();
          }
        }
      }, _callee36);
    }));
    function getServiceFeeLegacy() {
      return _getServiceFeeLegacy.apply(this, arguments);
    }
    return getServiceFeeLegacy;
  }();
  _proto.getTokenDecimals = /*#__PURE__*/function () {
    var _getTokenDecimals = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee37(tokenAddress) {
      var mintPubkey, _yield$getMint, decimals;
      return _regeneratorRuntime().wrap(function _callee37$(_context37) {
        while (1) {
          switch (_context37.prev = _context37.next) {
            case 0:
              mintPubkey = this._getAddressPK(tokenAddress);
              _context37.prev = 1;
              _context37.next = 4;
              return getMint(this.connection, mintPubkey);
            case 4:
              _yield$getMint = _context37.sent;
              decimals = _yield$getMint.decimals;
              return _context37.abrupt("return", decimals);
            case 9:
              _context37.prev = 9;
              _context37.t0 = _context37["catch"](1);
              throw new ABridgeSDKError("getTokenDecimals - Error:", _context37.t0);
            case 12:
            case "end":
              return _context37.stop();
          }
        }
      }, _callee37, this, [[1, 9]]);
    }));
    function getTokenDecimals(_x54) {
      return _getTokenDecimals.apply(this, arguments);
    }
    return getTokenDecimals;
  }();
  _proto.getTokenDetails = /*#__PURE__*/function () {
    var _getTokenDetails = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee38(tokenAddress, userAddress) {
      var tokenAddressPK, metadata, name, symbol, decimals, balance, userAddressPK, balanceAndDecimals;
      return _regeneratorRuntime().wrap(function _callee38$(_context38) {
        while (1) {
          switch (_context38.prev = _context38.next) {
            case 0:
              tokenAddressPK = this._getAddressPK(tokenAddress);
              if (!(tokenAddressPK.toString() === PublicKey["default"].toString())) {
                _context38.next = 3;
                break;
              }
              throw new ABridgeSDKError("Invalid tokenAddress at getTokenDetails");
            case 3:
              _context38.next = 5;
              return this._getMetadata(tokenAddressPK);
            case 5:
              metadata = _context38.sent;
              name = metadata == null ? void 0 : metadata.name;
              symbol = metadata == null ? void 0 : metadata.symbol;
              if (tokenAddressPK.toBase58() === "HkgEuhAUXYiTbyo3kEPPwRyx4SiUAxir7dnijXfrgB41") {
                // TODO: Remove WALBT harcoded metadata when added to the contract
                name = "Wrapped AllianceBlock Token";
                symbol = "WALBT";
              }
              if (!userAddress) {
                _context38.next = 20;
                break;
              }
              userAddressPK = this._getAddressPK(userAddress);
              if (!(userAddressPK.toString() === PublicKey["default"].toString())) {
                _context38.next = 13;
                break;
              }
              throw new ABridgeSDKError("Invalid userAddressPK at getTokenDetails");
            case 13:
              _context38.next = 15;
              return this.balanceOf(tokenAddressPK, userAddressPK);
            case 15:
              balanceAndDecimals = _context38.sent;
              decimals = balanceAndDecimals.decimals;
              balance = balanceAndDecimals.balance;
              _context38.next = 23;
              break;
            case 20:
              _context38.next = 22;
              return this.getTokenDecimals(tokenAddressPK);
            case 22:
              decimals = _context38.sent;
            case 23:
              return _context38.abrupt("return", {
                address: tokenAddressPK.toString(),
                name: name,
                symbol: symbol,
                decimals: decimals,
                balance: balance
              });
            case 24:
            case "end":
              return _context38.stop();
          }
        }
      }, _callee38, this);
    }));
    function getTokenDetails(_x55, _x56) {
      return _getTokenDetails.apply(this, arguments);
    }
    return getTokenDetails;
  }();
  _proto.getTokenDetailsMulticall = /*#__PURE__*/function () {
    var _getTokenDetailsMulticall = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee40(tokenAddresses, userAddress) {
      var _this3 = this;
      var allTokensData, result;
      return _regeneratorRuntime().wrap(function _callee40$(_context40) {
        while (1) {
          switch (_context40.prev = _context40.next) {
            case 0:
              userAddress = userAddress || this.signerOrProvider.publicKey.toBase58();
              allTokensData = tokenAddresses.filter(function (isToken) {
                return Boolean(isToken);
              }).map( /*#__PURE__*/function () {
                var _ref5 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee39(tokenAddress) {
                  return _regeneratorRuntime().wrap(function _callee39$(_context39) {
                    while (1) {
                      switch (_context39.prev = _context39.next) {
                        case 0:
                          _context39.t0 = _extends;
                          _context39.t1 = {};
                          _context39.next = 4;
                          return _this3.getTokenDetails(tokenAddress, userAddress);
                        case 4:
                          _context39.t2 = _context39.sent;
                          return _context39.abrupt("return", (0, _context39.t0)(_context39.t1, _context39.t2));
                        case 6:
                        case "end":
                          return _context39.stop();
                      }
                    }
                  }, _callee39);
                }));
                return function (_x59) {
                  return _ref5.apply(this, arguments);
                };
              }());
              _context40.next = 4;
              return Promise.all(allTokensData);
            case 4:
              result = _context40.sent;
              return _context40.abrupt("return", result);
            case 6:
            case "end":
              return _context40.stop();
          }
        }
      }, _callee40, this);
    }));
    function getTokenDetailsMulticall(_x57, _x58) {
      return _getTokenDetailsMulticall.apply(this, arguments);
    }
    return getTokenDetailsMulticall;
  }();
  _proto.getTokenName = /*#__PURE__*/function () {
    var _getTokenName = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee41(tokenAddress) {
      var tokenAddressPK, metadata, tokenName;
      return _regeneratorRuntime().wrap(function _callee41$(_context41) {
        while (1) {
          switch (_context41.prev = _context41.next) {
            case 0:
              tokenAddressPK = this._getAddressPK(tokenAddress);
              if (!(tokenAddressPK.toString() === PublicKey["default"].toString())) {
                _context41.next = 4;
                break;
              }
              console.warn("Asked for solana TokenName. Is this correct? Maybe a native check failed?");
              return _context41.abrupt("return", "SOLANA");
            case 4:
              _context41.next = 6;
              return this._getMetadata(tokenAddressPK);
            case 6:
              metadata = _context41.sent;
              tokenName = metadata == null ? void 0 : metadata.name;
              return _context41.abrupt("return", tokenName != null ? tokenName : tokenAddressPK.toString());
            case 9:
            case "end":
              return _context41.stop();
          }
        }
      }, _callee41, this);
    }));
    function getTokenName(_x60) {
      return _getTokenName.apply(this, arguments);
    }
    return getTokenName;
  }();
  _proto.getTokenSymbol = /*#__PURE__*/function () {
    var _getTokenSymbol = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee42(tokenAddress) {
      var tokenAddressPK, metadata, tokenSymbol;
      return _regeneratorRuntime().wrap(function _callee42$(_context42) {
        while (1) {
          switch (_context42.prev = _context42.next) {
            case 0:
              tokenAddressPK = this._getAddressPK(tokenAddress);
              if (!(tokenAddressPK.toString() === PublicKey["default"].toString())) {
                _context42.next = 4;
                break;
              }
              console.warn("Asked for solana TokenSymbol. Is this correct? Maybe a native check failed?");
              return _context42.abrupt("return", "SOL");
            case 4:
              _context42.next = 6;
              return this._getMetadata(tokenAddressPK);
            case 6:
              metadata = _context42.sent;
              tokenSymbol = metadata == null ? void 0 : metadata.symbol;
              return _context42.abrupt("return", tokenSymbol);
            case 9:
            case "end":
              return _context42.stop();
          }
        }
      }, _callee42, this);
    }));
    function getTokenSymbol(_x61) {
      return _getTokenSymbol.apply(this, arguments);
    }
    return getTokenSymbol;
  }();
  _proto.getWrappedForNativeToken = /*#__PURE__*/function () {
    var _getWrappedForNativeToken = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee43(nativeChainId, nativeToken) {
      var program, helper, _yield$helper$findWra, pda;
      return _regeneratorRuntime().wrap(function _callee43$(_context43) {
        while (1) {
          switch (_context43.prev = _context43.next) {
            case 0:
              program = getProgram({
                idl: this.ERC20RouterIDL,
                provider: this.signerOrProvider
              });
              helper = ERC20RouterHelperConstructor(program);
              _context43.next = 4;
              return helper.findWrappedTokenPDA(ethers$1.utils.arrayify(nativeToken), nativeChainId);
            case 4:
              _yield$helper$findWra = _context43.sent;
              pda = _yield$helper$findWra[0];
              return _context43.abrupt("return", pda.toString());
            case 7:
            case "end":
              return _context43.stop();
          }
        }
      }, _callee43, this);
    }));
    function getWrappedForNativeToken(_x62, _x63) {
      return _getWrappedForNativeToken.apply(this, arguments);
    }
    return getWrappedForNativeToken;
  }();
  _proto.getWrappedTokenDetails = /*#__PURE__*/function () {
    var _getWrappedTokenDetails = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee44(nativeTokenAddress, nativeChainId) {
      return _regeneratorRuntime().wrap(function _callee44$(_context44) {
        while (1) {
          switch (_context44.prev = _context44.next) {
            case 0:
              throw "getWrappedTokenDetails - Not implemented yet for Solana";
            case 1:
            case "end":
              return _context44.stop();
          }
        }
      }, _callee44);
    }));
    function getWrappedTokenDetails(_x64, _x65) {
      return _getWrappedTokenDetails.apply(this, arguments);
    }
    return getWrappedTokenDetails;
  }();
  _proto.getWrappedTokenDetailsLegacy = /*#__PURE__*/function () {
    var _getWrappedTokenDetailsLegacy = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee45(nativeTokenAddress, nativeChainId) {
      return _regeneratorRuntime().wrap(function _callee45$(_context45) {
        while (1) {
          switch (_context45.prev = _context45.next) {
            case 0:
              throw "getWrappedTokenDetailsLegacy - There's no legacy bridge on Solana.";
            case 1:
            case "end":
              return _context45.stop();
          }
        }
      }, _callee45);
    }));
    function getWrappedTokenDetailsLegacy(_x66, _x67) {
      return _getWrappedTokenDetailsLegacy.apply(this, arguments);
    }
    return getWrappedTokenDetailsLegacy;
  }();
  _proto.isAddress = function isAddress(address, limitOnCurve) {
    if (limitOnCurve === void 0) {
      limitOnCurve = false;
    }
    if (address === "") {
      return false;
    }
    try {
      var pubkey = new PublicKey(address);
      var isSolana = limitOnCurve ? PublicKey.isOnCurve(pubkey.toBuffer()) : true;
      return isSolana;
    } catch (err) {
      // If an error occurred is because the address was not valid
      return false;
    }
  };
  _proto.isClaimedLegacy = /*#__PURE__*/function () {
    var _isClaimedLegacy = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee46(transfer) {
      return _regeneratorRuntime().wrap(function _callee46$(_context46) {
        while (1) {
          switch (_context46.prev = _context46.next) {
            case 0:
              throw "isClaimedLegacy - There's no legacy bridge on Solana.";
            case 1:
            case "end":
              return _context46.stop();
          }
        }
      }, _callee46);
    }));
    function isClaimedLegacy(_x68) {
      return _isClaimedLegacy.apply(this, arguments);
    }
    return isClaimedLegacy;
  }();
  _proto.isClaimedMulticallLegacy = /*#__PURE__*/function () {
    var _isClaimedMulticallLegacy = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee47(transfers) {
      return _regeneratorRuntime().wrap(function _callee47$(_context47) {
        while (1) {
          switch (_context47.prev = _context47.next) {
            case 0:
              throw "isClaimedMulticallLegacy - There's no legacy bridge on Solana.";
            case 1:
            case "end":
              return _context47.stop();
          }
        }
      }, _callee47);
    }));
    function isClaimedMulticallLegacy(_x69) {
      return _isClaimedMulticallLegacy.apply(this, arguments);
    }
    return isClaimedMulticallLegacy;
  }();
  _proto.isNftsApproved = /*#__PURE__*/function () {
    var _isNftsApproved = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee48(userAddress, collectionAddress) {
      return _regeneratorRuntime().wrap(function _callee48$(_context48) {
        while (1) {
          switch (_context48.prev = _context48.next) {
            case 0:
              return _context48.abrupt("return", true);
            case 1:
            case "end":
              return _context48.stop();
          }
        }
      }, _callee48);
    }));
    function isNftsApproved(_x70, _x71) {
      return _isNftsApproved.apply(this, arguments);
    }
    return isNftsApproved;
  }();
  _proto.isTokenApproved = /*#__PURE__*/function () {
    var _isTokenApproved = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee49(tokenAddress, userAddress, threshold /** optional */) {
      return _regeneratorRuntime().wrap(function _callee49$(_context49) {
        while (1) {
          switch (_context49.prev = _context49.next) {
            case 0:
              return _context49.abrupt("return", true);
            case 1:
            case "end":
              return _context49.stop();
          }
        }
      }, _callee49);
    }));
    function isTokenApproved(_x72, _x73, _x74) {
      return _isTokenApproved.apply(this, arguments);
    }
    return isTokenApproved;
  }();
  _proto.isTokenApprovedLegacy = /*#__PURE__*/function () {
    var _isTokenApprovedLegacy = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee50() {
      return _regeneratorRuntime().wrap(function _callee50$(_context50) {
        while (1) {
          switch (_context50.prev = _context50.next) {
            case 0:
              throw "isTokenApprovedLegacy - There's no legacy bridge on Solana.";
            case 1:
            case "end":
              return _context50.stop();
          }
        }
      }, _callee50);
    }));
    function isTokenApprovedLegacy() {
      return _isTokenApprovedLegacy.apply(this, arguments);
    }
    return isTokenApprovedLegacy;
  }();
  _proto.loadTokenByAddressAndId = /*#__PURE__*/function () {
    var _loadTokenByAddressAndId = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee51(collectionAddress, id, userAddress, skipOwnerCheck) {
      var _nft$collection, _nft$collection2, _tokenMetadata$collec, _tokenMetadata$collec2, _nft$collection3, _nft$collection4;
      var mintAddress, nft, tokenMetadata, collectionName;
      return _regeneratorRuntime().wrap(function _callee51$(_context51) {
        while (1) {
          switch (_context51.prev = _context51.next) {
            case 0:
              // TODO add owner check
              mintAddress = new PublicKey(collectionAddress); // Old tokens use a diferent standard
              _context51.next = 4;
              return this._getLegacyMetadata(collectionAddress);
            case 4:
              nft = _context51.sent;
              if (nft) {
                _context51.next = 9;
                break;
              }
              _context51.next = 8;
              return this.metaplex.nfts().findByMint({
                mintAddress: mintAddress,
                loadJsonMetadata: false
              });
            case 8:
              nft = _context51.sent;
            case 9:
              if (nft) {
                _context51.next = 11;
                break;
              }
              throw new Error("loadTokenByAddressAndId couldn't find collectionAddress:" + collectionAddress + " id:" + id);
            case 11:
              tokenMetadata = {};
              _context51.prev = 12;
              _context51.next = 15;
              return this.loadTokenMetadata(nft.uri);
            case 15:
              tokenMetadata = _context51.sent;
              _context51.next = 21;
              break;
            case 18:
              _context51.prev = 18;
              _context51.t0 = _context51["catch"](12);
              console.error("Token Metadata cannot be loaded");
            case 21:
              collectionName = (_nft$collection = nft.collection) != null && _nft$collection.name ? (_nft$collection2 = nft.collection) == null ? void 0 : _nft$collection2.name : (_tokenMetadata$collec = tokenMetadata.collection) != null && _tokenMetadata$collec.name ? (_tokenMetadata$collec2 = tokenMetadata.collection) == null ? void 0 : _tokenMetadata$collec2.name : nft.symbol;
              return _context51.abrupt("return", _extends({}, tokenMetadata, {
                name: nft.name ? nft.name : tokenMetadata.name,
                collectionName: collectionName,
                id: id,
                tokenURI: nft.uri,
                collectionAddress: (_nft$collection3 = nft.collection) != null && _nft$collection3.address ? (_nft$collection4 = nft.collection) == null ? void 0 : _nft$collection4.address : collectionAddress
              }));
            case 23:
            case "end":
              return _context51.stop();
          }
        }
      }, _callee51, this, [[12, 18]]);
    }));
    function loadTokenByAddressAndId(_x75, _x76, _x77, _x78) {
      return _loadTokenByAddressAndId.apply(this, arguments);
    }
    return loadTokenByAddressAndId;
  }();
  _proto.loadTokensByCollectionAddress = /*#__PURE__*/function () {
    var _loadTokensByCollectionAddress = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee52(collectionAddress) {
      return _regeneratorRuntime().wrap(function _callee52$(_context52) {
        while (1) {
          switch (_context52.prev = _context52.next) {
            case 0:
              throw "loadTokensByCollectionAddress - Not implemented yet for Solana";
            case 1:
            case "end":
              return _context52.stop();
          }
        }
      }, _callee52);
    }));
    function loadTokensByCollectionAddress(_x79) {
      return _loadTokensByCollectionAddress.apply(this, arguments);
    }
    return loadTokensByCollectionAddress;
  }();
  _proto.sendErc20 = /*#__PURE__*/function () {
    var _sendErc = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee54( /* control */
    estimateOnly,
    // boolean - true if we need to call estimate gas only
    /* egress mandatory-ish */
    targetChainId,
    // number
    tokenAddress,
    // address - could be AddressZero when bridging native chain currency
    amount,
    // ethers.BigNumber
    receiverAddress,
    // address
    feeTokenAddress,
    // address - could be AddressZero
    /* optional - auto-delivery */
    deliveryFeeEstimate,
    // ethers.BigNumber
    deliveryFeeExpiry,
    // number
    deliveryFeeSignature // hex string
    ) {
      var teleportProgram, routerProgram, teleportHelper, routerHelper, user, _yield$routerHelper$f2, payloadPDA, _yield$teleportHelper5, teleportFeeCollectorPDA, _yield$teleportHelper6, teleportFeeCalculatorStoragePDA, payloadAccountInfo, needToInitPayload, txsToSign, egressTxs, signed;
      return _regeneratorRuntime().wrap(function _callee54$(_context54) {
        while (1) {
          switch (_context54.prev = _context54.next) {
            case 0:
              if (!(deliveryFeeEstimate || deliveryFeeExpiry || deliveryFeeSignature)) {
                _context54.next = 2;
                break;
              }
              throw new ABridgeSDKError("sendErc20 - Autoclaim feature is not implemented yet for Solana");
            case 2:
              if (!feeTokenAddress) {
                _context54.next = 4;
                break;
              }
              throw new ABridgeSDKError("sendErc20 - Payments on fee tokens feature is not implemented yet for Solana");
            case 4:
              teleportProgram = getProgram({
                idl: this.ITeleportIDL,
                provider: this.signerOrProvider
              });
              routerProgram = getProgram({
                idl: this.ERC20RouterIDL,
                provider: this.signerOrProvider
              });
              teleportHelper = teleportHelperConstructor(teleportProgram);
              routerHelper = ERC20RouterHelperConstructor(routerProgram);
              user = routerProgram.provider.wallet; // Get router accounts
              _context54.next = 11;
              return routerHelper.findEgressPayloadPDA(user.publicKey);
            case 11:
              _yield$routerHelper$f2 = _context54.sent;
              payloadPDA = _yield$routerHelper$f2[0];
              _context54.next = 15;
              return teleportHelper.findFeeCollectorPDA();
            case 15:
              _yield$teleportHelper5 = _context54.sent;
              teleportFeeCollectorPDA = _yield$teleportHelper5[0];
              _context54.next = 19;
              return teleportHelper.findFeeCalculatorStoragePDA();
            case 19:
              _yield$teleportHelper6 = _context54.sent;
              teleportFeeCalculatorStoragePDA = _yield$teleportHelper6[0];
              _context54.prev = 21;
              _context54.next = 24;
              return routerProgram.provider.connection.getAccountInfo(payloadPDA);
            case 24:
              payloadAccountInfo = _context54.sent;
              needToInitPayload = payloadAccountInfo ? payloadAccountInfo.data.readUintLE(0, 8) === 0 : true;
              txsToSign = [];
              if (!needToInitPayload) {
                _context54.next = 33;
                break;
              }
              _context54.t0 = txsToSign;
              _context54.next = 31;
              return routerHelper.getInitEgressPayloadAccountTx(payloadPDA, user.publicKey);
            case 31:
              _context54.t1 = _context54.sent;
              _context54.t0.push.call(_context54.t0, _context54.t1);
            case 33:
              _context54.next = 35;
              return routerHelper.getEgressTxs(new PublicKey(tokenAddress), targetChainId, amount, receiverAddress, user, teleportProgram.programId, teleportFeeCalculatorStoragePDA, teleportFeeCollectorPDA);
            case 35:
              egressTxs = _context54.sent;
              txsToSign.push.apply(txsToSign, egressTxs.preTxs);
              txsToSign.push(egressTxs.egressTx);
              if (!estimateOnly) {
                _context54.next = 42;
                break;
              }
              _context54.next = 41;
              return Promise.all(txsToSign.map( /*#__PURE__*/function () {
                var _ref6 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee53(tx) {
                  return _regeneratorRuntime().wrap(function _callee53$(_context53) {
                    while (1) {
                      switch (_context53.prev = _context53.next) {
                        case 0:
                          return _context53.abrupt("return", tx.getEstimatedFee(routerProgram.provider.connection));
                        case 1:
                        case "end":
                          return _context53.stop();
                      }
                    }
                  }, _callee53);
                }));
                return function (_x89) {
                  return _ref6.apply(this, arguments);
                };
              }()));
            case 41:
              return _context54.abrupt("return", _context54.sent.reduce(function (prev, curr) {
                return prev + curr;
              }));
            case 42:
              _context54.next = 44;
              return user.signAllTransactions(txsToSign);
            case 44:
              signed = _context54.sent;
              if (!needToInitPayload) {
                _context54.next = 48;
                break;
              }
              _context54.next = 48;
              return sendAndConfirmTxs(routerProgram, [signed[0]]);
            case 48:
              if (!(egressTxs.preTxs.length > 0)) {
                _context54.next = 51;
                break;
              }
              _context54.next = 51;
              return sendAndConfirmTxs(routerProgram, signed.slice(-1 - egressTxs.preTxs.length, -1));
            case 51:
              _context54.next = 53;
              return sendAndConfirmTxs(routerProgram, signed.slice(-1));
            case 53:
              return _context54.abrupt("return", _context54.sent[0]);
            case 56:
              _context54.prev = 56;
              _context54.t2 = _context54["catch"](21);
              console.error(_context54.t2.logs);
              throw new ABridgeSDKError("sendErc20 - Error:", _context54.t2);
            case 60:
            case "end":
              return _context54.stop();
          }
        }
      }, _callee54, this, [[21, 56]]);
    }));
    function sendErc20(_x80, _x81, _x82, _x83, _x84, _x85, _x86, _x87, _x88) {
      return _sendErc.apply(this, arguments);
    }
    return sendErc20;
  }();
  _proto.sendLegacy = /*#__PURE__*/function () {
    var _sendLegacy = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee55() {
      return _regeneratorRuntime().wrap(function _callee55$(_context55) {
        while (1) {
          switch (_context55.prev = _context55.next) {
            case 0:
              throw "sendLegacy - There's no legacy bridge on Solana.";
            case 1:
            case "end":
              return _context55.stop();
          }
        }
      }, _callee55);
    }));
    function sendLegacy() {
      return _sendLegacy.apply(this, arguments);
    }
    return sendLegacy;
  }();
  _proto.sendNftTokens = /*#__PURE__*/function () {
    var _sendNftTokens = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee56(targetChainId, assets, userAddress, fee) {
      var routerProgram, user, _yield$this$getERC2, txsToSign, needToInitPayload, egressTxs, signed;
      return _regeneratorRuntime().wrap(function _callee56$(_context56) {
        while (1) {
          switch (_context56.prev = _context56.next) {
            case 0:
              if (assets) {
                _context56.next = 2;
                break;
              }
              throw "assets was not provided";
            case 2:
              if (targetChainId) {
                _context56.next = 4;
                break;
              }
              throw "targetChainId was not provided";
            case 4:
              if (userAddress) {
                _context56.next = 6;
                break;
              }
              throw "userAddress was not provided";
            case 6:
              if (!(assets.length == 0)) {
                _context56.next = 8;
                break;
              }
              throw "You have to send at least one asset.";
            case 8:
              if (!(assets.length > 1)) {
                _context56.next = 10;
                break;
              }
              throw "We currently only support sending one asset at a time.";
            case 10:
              routerProgram = getProgram({
                idl: this.ERC721RouterIDL,
                provider: this.signerOrProvider
              });
              user = routerProgram.provider.wallet;
              _context56.prev = 12;
              _context56.next = 15;
              return this.getERC721EgressTxs(targetChainId, assets, userAddress);
            case 15:
              _yield$this$getERC2 = _context56.sent;
              txsToSign = _yield$this$getERC2.txsToSign;
              needToInitPayload = _yield$this$getERC2.needToInitPayload;
              egressTxs = _yield$this$getERC2.egressTxs;
              _context56.next = 21;
              return user.signAllTransactions(txsToSign);
            case 21:
              signed = _context56.sent;
              if (!needToInitPayload) {
                _context56.next = 25;
                break;
              }
              _context56.next = 25;
              return sendAndConfirmTxs(routerProgram, [signed[0]]);
            case 25:
              if (!(egressTxs.preTxs.length > 0)) {
                _context56.next = 28;
                break;
              }
              _context56.next = 28;
              return sendAndConfirmTxs(routerProgram, signed.slice(-1 - egressTxs.preTxs.length, -1));
            case 28:
              _context56.next = 30;
              return sendAndConfirmTxs(routerProgram, signed.slice(-1));
            case 30:
              return _context56.abrupt("return", _context56.sent[0]);
            case 33:
              _context56.prev = 33;
              _context56.t0 = _context56["catch"](12);
              console.error(_context56.t0.logs);
              throw new ABridgeSDKError("sendErc721 - Error:", _context56.t0);
            case 37:
            case "end":
              return _context56.stop();
          }
        }
      }, _callee56, this, [[12, 33]]);
    }));
    function sendNftTokens(_x90, _x91, _x92, _x93) {
      return _sendNftTokens.apply(this, arguments);
    }
    return sendNftTokens;
  }();
  _proto.sendWithPermitLegacy = /*#__PURE__*/function () {
    var _sendWithPermitLegacy = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee57() {
      return _regeneratorRuntime().wrap(function _callee57$(_context57) {
        while (1) {
          switch (_context57.prev = _context57.next) {
            case 0:
              throw "sendWithPermitLegacy - There's no legacy bridge on Solana.";
            case 1:
            case "end":
              return _context57.stop();
          }
        }
      }, _callee57);
    }));
    function sendWithPermitLegacy() {
      return _sendWithPermitLegacy.apply(this, arguments);
    }
    return sendWithPermitLegacy;
  }() // Private functions
  ;
  _proto._configValidators =
  /*#__PURE__*/
  function () {
    var _configValidators2 = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee58(optionalParams) {
      var validatorArray, initialNFTValidatorVersion, initialNftValidatorMajorVersion, initialNftValidatorMinorVersion, optionalParamsNftValidatorMajorVersion, optionalParamsNftValidatorMinorVersion;
      return _regeneratorRuntime().wrap(function _callee58$(_context58) {
        while (1) {
          switch (_context58.prev = _context58.next) {
            case 0:
              validatorArray = [];
              _context58.prev = 1;
              if (!(this.frontEndVersion !== 1)) {
                _context58.next = 6;
                break;
              }
              _context58.next = 5;
              return axios$1.get(this.nftValidatorURL + "/status");
            case 5:
              initialNFTValidatorVersion = _context58.sent.data.version;
            case 6:
              _context58.next = 16;
              break;
            case 8:
              _context58.prev = 8;
              _context58.t0 = _context58["catch"](1);
              if (!(this.frontEndVersion !== 1)) {
                _context58.next = 14;
                break;
              }
              _context58.next = 13;
              return this._getDefaultConfiguredNftValidatorVersion();
            case 13:
              initialNFTValidatorVersion = _context58.sent;
            case 14:
              if (initialNFTValidatorVersion) {
                _context58.next = 16;
                break;
              }
              throw new Error("Messaging protocol validators are not accessible");
            case 16:
              if (this.frontEndVersion !== 1) {
                initialNftValidatorMajorVersion = parseInt(initialNFTValidatorVersion.split(".")[0]);
                initialNftValidatorMinorVersion = parseInt(initialNFTValidatorVersion.split(".")[1]);
              }
              if (this.frontEndVersion !== 1) {
                optionalParamsNftValidatorMajorVersion = parseInt(optionalParams["nftValidatorTargetVersion"].split(".")[0]);
                optionalParamsNftValidatorMinorVersion = parseInt(optionalParams["nftValidatorTargetVersion"].split(".")[1]);
              }
              this.nftAxios = axios$1.create({
                baseURL: this.nftValidatorURL
              });
              this.nftValidatorVersion = initialNFTValidatorVersion;
              // Check for passed nftValidatorTargetVersion
              if (!(this.frontEndVersion !== 1 && optionalParams && optionalParams["nftValidatorTargetVersion"] && (initialNftValidatorMajorVersion !== optionalParamsNftValidatorMajorVersion || !(initialNftValidatorMinorVersion >= optionalParamsNftValidatorMinorVersion)))) {
                _context58.next = 24;
                break;
              }
              if (optionalParams && optionalParams.nftValidators) {
                validatorArray = this._getAllValidators(optionalParams.nftValidators);
              } else {
                validatorArray = this._getAllValidators(this.config.nftValidators);
              }
              _context58.next = 24;
              return this._setValidatorBasedOnVersion(validatorArray, optionalParams["nftValidatorTargetVersion"]);
            case 24:
            case "end":
              return _context58.stop();
          }
        }
      }, _callee58, this, [[1, 8]]);
    }));
    function _configValidators(_x94) {
      return _configValidators2.apply(this, arguments);
    }
    return _configValidators;
  }();
  _proto._getAddressPK = function _getAddressPK(tokenAddress) {
    if (typeof tokenAddress === "string") {
      if (this.isAddress(tokenAddress)) {
        // Is a base58 string
        return new PublicKey(tokenAddress);
      }
      if (ethers$1.utils.isHexString(tokenAddress)) {
        return new PublicKey(ethers$1.utils.arrayify(tokenAddress));
      }
      throw new ABridgeSDKError("Invalid string provided for an address");
    }
    if (tokenAddress instanceof PublicKey) {
      return tokenAddress;
    }
    return new PublicKey(tokenAddress);
  };
  _proto._getAllUserTokens = /*#__PURE__*/function () {
    var _getAllUserTokens2 = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee59(userAddress) {
      var tokenAccounts, tokens;
      return _regeneratorRuntime().wrap(function _callee59$(_context59) {
        while (1) {
          switch (_context59.prev = _context59.next) {
            case 0:
              _context59.next = 2;
              return this.connection.getTokenAccountsByOwner(new PublicKey(userAddress), {
                programId: TOKEN_PROGRAM_ID
              });
            case 2:
              tokenAccounts = _context59.sent;
              tokens = tokenAccounts.value.map(function (tokenAccount) {
                var accountData = AccountLayout.decode(tokenAccount.account.data);
                return accountData;
              });
              return _context59.abrupt("return", tokens);
            case 5:
            case "end":
              return _context59.stop();
          }
        }
      }, _callee59, this);
    }));
    function _getAllUserTokens(_x95) {
      return _getAllUserTokens2.apply(this, arguments);
    }
    return _getAllUserTokens;
  }();
  _proto._getTokenList = /*#__PURE__*/function () {
    var _getTokenList2 = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee60() {
      var tokenListContainer;
      return _regeneratorRuntime().wrap(function _callee60$(_context60) {
        while (1) {
          switch (_context60.prev = _context60.next) {
            case 0:
              if (this._tokenList) {
                _context60.next = 5;
                break;
              }
              _context60.next = 3;
              return new TokenListProvider().resolve();
            case 3:
              tokenListContainer = _context60.sent;
              // TODO find a better way to filter
              this._tokenList = tokenListContainer.filterByChainId(ChainId$1.MainnetBeta).getList();
            case 5:
              return _context60.abrupt("return", this._tokenList);
            case 6:
            case "end":
              return _context60.stop();
          }
        }
      }, _callee60, this);
    }));
    function _getTokenList() {
      return _getTokenList2.apply(this, arguments);
    }
    return _getTokenList;
  }();
  _proto._getLegacyMetadata = /*#__PURE__*/function () {
    var _getLegacyMetadata2 = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee61(tokenAddress) {
      var tokenList, tokenInfo;
      return _regeneratorRuntime().wrap(function _callee61$(_context61) {
        while (1) {
          switch (_context61.prev = _context61.next) {
            case 0:
              _context61.next = 2;
              return this._getTokenList();
            case 2:
              tokenList = _context61.sent;
              tokenInfo = tokenList.find(function (item) {
                return item.address === tokenAddress;
              });
              if (!tokenInfo) {
                _context61.next = 6;
                break;
              }
              return _context61.abrupt("return", {
                name: tokenInfo.name,
                symbol: tokenInfo.symbol,
                uri: tokenInfo.logoURI,
                sellerFeeBasisPoints: 0,
                creators: null,
                collection: null
              });
            case 6:
              return _context61.abrupt("return", null);
            case 7:
            case "end":
              return _context61.stop();
          }
        }
      }, _callee61, this);
    }));
    function _getLegacyMetadata(_x96) {
      return _getLegacyMetadata2.apply(this, arguments);
    }
    return _getLegacyMetadata;
  }();
  _proto._getMetadata = /*#__PURE__*/function () {
    var _getMetadata2 = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee62(tokenAddressPK) {
      var tokenAddress, legacyMetadata, tokenMetaPubkey, _metadata$data, metadata;
      return _regeneratorRuntime().wrap(function _callee62$(_context62) {
        while (1) {
          switch (_context62.prev = _context62.next) {
            case 0:
              tokenAddress = tokenAddressPK.toBase58();
              _context62.next = 3;
              return this._getLegacyMetadata(tokenAddress);
            case 3:
              legacyMetadata = _context62.sent;
              if (!legacyMetadata) {
                _context62.next = 6;
                break;
              }
              return _context62.abrupt("return", legacyMetadata);
            case 6:
              _context62.next = 8;
              return programs.metadata.Metadata.getPDA(tokenAddressPK);
            case 8:
              tokenMetaPubkey = _context62.sent;
              _context62.prev = 9;
              _context62.next = 12;
              return programs.metadata.Metadata.load(this.connection, tokenMetaPubkey);
            case 12:
              metadata = _context62.sent;
              return _context62.abrupt("return", metadata == null ? void 0 : (_metadata$data = metadata.data) == null ? void 0 : _metadata$data.data);
            case 16:
              _context62.prev = 16;
              _context62.t0 = _context62["catch"](9);
              if (!_context62.t0.message.includes("Unable to find account")) {
                _context62.next = 20;
                break;
              }
              return _context62.abrupt("return", null);
            case 20:
              throw new ABridgeSDKError("_getMetadata - Error:", _context62.t0);
            case 21:
            case "end":
              return _context62.stop();
          }
        }
      }, _callee62, this, [[9, 16]]);
    }));
    function _getMetadata(_x97) {
      return _getMetadata2.apply(this, arguments);
    }
    return _getMetadata;
  }();
  _proto._loadNftsByCollectionAndIdMulticall = /*#__PURE__*/function () {
    var _loadNftsByCollectionAndIdMulticall2 = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee63(collections) {
      var nftData, _iterator, _step, collection, collectionAddress, tokenInfo, data;
      return _regeneratorRuntime().wrap(function _callee63$(_context63) {
        while (1) {
          switch (_context63.prev = _context63.next) {
            case 0:
              if (!(!collections || collections.length === 0)) {
                _context63.next = 2;
                break;
              }
              return _context63.abrupt("return", []);
            case 2:
              nftData = [];
              _iterator = _createForOfIteratorHelperLoose(collections);
            case 4:
              if ((_step = _iterator()).done) {
                _context63.next = 14;
                break;
              }
              collection = _step.value;
              collectionAddress = this._getAddressPK(collection.collectionAddress).toString(); // We cleanse the collection address to force a valid one in base58 string
              _context63.next = 9;
              return this.loadTokenByAddressAndId(collectionAddress, "",
              // Solana nfts don't have an id
              undefined);
            case 9:
              tokenInfo = _context63.sent;
              data = _extends({}, tokenInfo, collection.transmissionDetails, {
                receiver: collection.receiver
              });
              nftData.push(data);
            case 12:
              _context63.next = 4;
              break;
            case 14:
              return _context63.abrupt("return", nftData);
            case 15:
            case "end":
              return _context63.stop();
          }
        }
      }, _callee63, this);
    }));
    function _loadNftsByCollectionAndIdMulticall(_x98) {
      return _loadNftsByCollectionAndIdMulticall2.apply(this, arguments);
    }
    return _loadNftsByCollectionAndIdMulticall;
  }();
  return SolanaRouterSDK;
}(RouterSDK);

// Factory class to create a router SDK instance based on the chainId
var RouterFactorySDK = /*#__PURE__*/function () {
  function RouterFactorySDK() {}
  var _proto = RouterFactorySDK.prototype;
  _proto.create = function create(chainType, signerOrProvider, optionalParams) {
    var routersTypes = {
      SOLANA: SolanaRouterSDK,
      EVM: EvmRouterSDK
    };
    var Router = routersTypes[chainType];
    return new Router(signerOrProvider, optionalParams);
  };
  return RouterFactorySDK;
}();

export { ChainId, RouterFactorySDK, TransferType, index$2 as config, index$1 as constants, index as contracts, utils };
//# sourceMappingURL=abridge-sdk.esm.js.map
